// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


/** Document the purpose of this class.
 *
 * @version 1.0
 * @author Timo Stich
 */

package org.columba.coder;


import java.io.*;

public class QuotedPrintableEncoder extends Encoder {

    private Reader input;
    private Writer output;

    public QuotedPrintableEncoder()
    {
        super();
        coding = new String("quoted-printable");
        
    }
    
    public void setupEncoder(Reader input, Writer output)
    {
        this.input = input;
        this.output = output;
    }

    public void run()
    {
        int lineLength = 0;
        char aktChar;
        char[] buffer = new char[1];
        Integer convert = new Integer(0);
        String hexString;
        
        try {
        
            while( input.read( buffer ) != -1 )
            {
                aktChar = buffer[0];
                
                if( lineLength >= 73 )
                {
                    output.write("=\n");
                    lineLength = 0;
                }
                
                if( aktChar == '\n')
                {
                    output.write("\n");
                    lineLength = 0;
                    continue;
                }
                
                if( aktChar == ' ')
                {
                    output.write(" ");
                    lineLength++;
                    continue;
                }
                
                if( aktChar>=33 )
                {
                    if( aktChar<=60 )
                    {
                        output.write( aktChar );
                        lineLength++;
                        continue;
                    }
                }
                if( aktChar>=62 )
                {
                    if( aktChar<= 126)
                    {
                        output.write( aktChar );
                        lineLength++;
                        continue;
                    }
                }
                
                output.write("=");
                hexString = convert.toHexString(aktChar);
                if( hexString.length() == 1 )
                    hexString = "0"+hexString;
                output.write( hexString );
                lineLength+=3;
            }

            output.close();
        }
        catch( IOException e ) {
            System.out.println( e );
        }
    }
    

}
