// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.composer;

import org.columba.message.*;


import java.util.*;

public class SendableMessage extends Message
{
    private Vector recipients;
    private int accountUid;

    public SendableMessage()
    {
        super();
    }

    public SendableMessage( int accountUid, Vector recipients,
                            String message )
    {
        super();
        this.rawString = message;
        this.recipients = recipients;
        this.accountUid = accountUid;
    }

    public int getAccountUid()
    {
        return accountUid;
    }


    public Vector getRecipients()
    {
        return recipients;
    }

    public void setAccountUid( int uid )
    {
        accountUid = uid;
    }

    public void setRecipients( Vector rcpt )
    {
        recipients = rcpt;
    }

    public Object clone()
    {
        SendableMessage message = new SendableMessage();

        message.setHeader(  (ColumbaHeader) header.clone() );

        message.setRawString( new String( getRawString() ) );

	message.setRecipients( (Vector) recipients.clone() );

	message.setAccountUid( accountUid );
	
        return message;
    }

}








