package org.columba.config;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import java.util.Vector;
import org.w3c.dom.*;



public class AccountList
{
    private Vector list;

    private AdapterNode rootNode;

    private Document document;

    private AccountXmlConfig config;

    public AccountList( AccountXmlConfig config, AdapterNode rootNode, Document doc )
    {
        this.rootNode = rootNode;
        this.document = doc;
        this.config = config;


        list = new Vector();

        if ( rootNode != null )
        {
            AdapterNode child;

            for ( int i=0; i<rootNode.getChildCount(); i++)
            {
                child = (AdapterNode) rootNode.getChild( i );

                AccountItem item = new AccountItem( child, getDocument() );
                list.add( item );
            }
        }
    }

    public AdapterNode getRootNode()
    {
        return rootNode;
    }

    public Document getDocument()
    {
        return document;
    }

    public AccountItem get( int index )
    {
        AccountItem item = (AccountItem) list.get(index);

        return item;
    }

    public AccountItem uidGet( int uid )
    {
        for ( int i=0; i<count(); i++ )
        {
            AccountItem item = (AccountItem) get(i);
            int u = item.getUid();

            if ( uid == u ) return item;
        }

        return null;
    }

    public PGPItem getPGPItem( String to )
    {
        System.out.println("------>to: "+ to );

        int result = -1;

        for ( int i=0; i<count(); i++ )
        {
            AccountItem item = (AccountItem) get(i);
            PGPItem pgpItem = item.getPGPItem();
            String id = pgpItem.getId();
            to = to.toLowerCase();
            id = id.toLowerCase();

            if ( to.indexOf(id) != -1 ) return pgpItem;
            else if ( id.indexOf(to) != -1 ) return pgpItem;
        }

        return null;
    }

    public int hostGetAccountIndex( String host, String address )
    {
        System.out.println("------>host: "+ host );

        int result = -1;
        if ( address == null ) return -1;

        for ( int i=0; i<count(); i++ )
        {
            AccountItem item = (AccountItem) get(i);
            String s = null;


            if ( item.isPopAccount() )
            {
                PopItem pop = item.getPopItem();
                s = pop.getHost();
                System.out.println("string: "+ s );
            }
            else
            {
                ImapItem imap = item.getImapItem();
                s = imap.getHost();
                System.out.println("string: "+ s );
            }


            if ( s.equals( host ) ) result = i;

        }

        if ( result != -1 ) return result;

        for ( int i=0; i<count(); i++ )
        {
            AccountItem item = (AccountItem) get(i);
            String s = item.getIdentityItem().getAddress();

            if ( address.indexOf( s ) != -1 ) result = i;
        }


        return result;
    }

    public String hostGetAccountName( String host )
    {
        for ( int i=0; i<count(); i++ )
        {
            AccountItem item = (AccountItem) get(i);
            String s = null;
            if ( item.isPopAccount() )
            {
                PopItem pop = item.getPopItem();
                s = pop.getHost();
            }
            else
            {
                ImapItem imap = item.getImapItem();
                s = imap.getHost();
            }

            if ( s.equals( host ) ) return item.getName();
        }

        return null;
    }

    // p == true -> pop3, else imap4
    public AccountItem addEmptyAccount( boolean b )
    {
        AdapterNode node = config.add( b );
        AccountItem item = new AccountItem( node, getDocument() );

        add( item );

        return item;
    }



    public void add( AccountItem item )
    {
        list.add( item );
    }

    public AccountItem remove( int index )
    {
        AccountItem item = (AccountItem) list.remove( index );
        AdapterNode node = item.getRootNode();
        getRootNode().removeChild( node );

        return item;
    }

    public int count()
    {
        return list.size();
    }
}