// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.config;


import org.columba.message.*;



import javax.xml.parsers.*;
import org.xml.sax.*;
import org.w3c.dom.*;

//import com.sun.xml.tree.XmlDocument;


import java.io.*;
import java.util.Vector;


public class AccountXmlConfig extends DefaultXmlConfig
{
    private File file;


    public AccountXmlConfig( File file )
    {
        super( file );
    }

      // add new account
      // if b==true add pop3 account
      // else add imap4 account

    public AdapterNode add( boolean b )
    {
	Element parent = createElementNode("account");

	Element child = createTextElementNode("name", "New Account" );
	addElement( parent, child );

        child = createTextElementNode("uid", createUid()  );
	addElement( parent, child );

	// create identity
	child = createElementNode("identity");

	Element subChild = createTextElementNode("name","");
	addElement( child, subChild );
	subChild = createTextElementNode("organisation","");
	addElement( child, subChild );
	subChild = createTextElementNode("address","");
	addElement( child, subChild );
	subChild = createTextElementNode("replyaddress","");
	addElement( child, subChild );
        CDATASection cdataChild;
        subChild = createElementNode("signature");
	cdataChild = createCDATAElementNode("signature");
	addCDATASection( subChild, cdataChild );
        addElement( child, subChild );
        subChild = createTextElementNode("attachsignature","false");
	addElement( child, subChild );

	addElement( parent, child );

        if ( b )
        {

              // create popserver
            child = createElementNode("popserver");



            subChild = createElementNode("user");
            cdataChild = createCDATAElementNode("");
            addCDATASection( subChild, cdataChild );
            addElement( child, subChild );

            subChild = createElementNode("password");
            cdataChild = createCDATAElementNode("");
            addCDATASection( subChild, cdataChild );
            addElement( child, subChild );

            subChild = createTextElementNode("host","");
            addElement( child, subChild );
            subChild = createTextElementNode("port","110");
            addElement( child, subChild );
            subChild = createTextElementNode("foldername","");
            addElement( child, subChild );
            subChild = createTextElementNode("leave","true");
            addElement( child, subChild );
            subChild = createTextElementNode("savepassword","false");
            addElement( child, subChild );
            subChild = createTextElementNode("exclude","false");
            addElement( child, subChild );
            subChild = createTextElementNode("uid", new String("101" ) );
            addElement( child, subChild );
            subChild = createTextElementNode("mailcheck", "false" );
            addElement( child, subChild );
            subChild = createTextElementNode("interval", "60" );
            addElement( child, subChild );
            subChild = createTextElementNode("downloadlimit", "50" );
            addElement( child, subChild );
            subChild = createTextElementNode("limit", "false" );
            addElement( child, subChild );

            addElement( parent, child );
        }
        else
        {
                          // create imapserver
            child = createElementNode("imapserver");



            subChild = createElementNode("user");
            cdataChild = createCDATAElementNode("");
            addCDATASection( subChild, cdataChild );
            addElement( child, subChild );

            subChild = createElementNode("password");
            cdataChild = createCDATAElementNode("");
            addCDATASection( subChild, cdataChild );
            addElement( child, subChild );

            subChild = createTextElementNode("host","");
            addElement( child, subChild );
            subChild = createTextElementNode("port","143");
            addElement( child, subChild );
            subChild = createTextElementNode("savepassword","false");
            addElement( child, subChild );

            addElement( parent, child );
        }


          // create outgoingserver
        child = createElementNode("smtpserver");

	subChild = createElementNode("user");
	cdataChild = createCDATAElementNode("");
	addCDATASection( subChild, cdataChild );
	addElement( child, subChild );
        subChild = createElementNode("password");
	cdataChild = createCDATAElementNode("");
	addCDATASection( subChild, cdataChild );
	addElement( child, subChild );
        subChild = createTextElementNode("savepassword","false");
        addElement( child, subChild );
	subChild = createTextElementNode("host","");
	addElement( child, subChild );
	subChild = createTextElementNode("port","25");
	addElement( child, subChild );
	subChild = createTextElementNode("esmtp","");
	addElement( child, subChild );
        /*
	subChild = createTextElementNode("uid","104");
	addElement( child, subChild );
        */
	subChild = createTextElementNode("bccyourself","");
	addElement( child, subChild );
	subChild = createTextElementNode("bccanother","");
	addElement( child, subChild );


	addElement( parent, child );


        // create pgp section
        child = createElementNode("pgp");

        subChild = createTextElementNode("id","user-id");
        addElement( child, subChild );
	subChild = createTextElementNode("type","0");
	addElement( child, subChild );
	subChild = createTextElementNode("path","/usr/bin/gpg");
	addElement( child, subChild );
	subChild = createTextElementNode("alwayssign","false");
	addElement( child, subChild );
	subChild = createTextElementNode("alwaysencrypt","false");
	addElement( child, subChild );

	addElement( parent, child );

        // create special folders section
        child = createElementNode("specialfolders");

        subChild = createTextElementNode("trash","105");
        addElement( child, subChild );
	subChild = createTextElementNode("drafts","102");
	addElement( child, subChild );
	subChild = createTextElementNode("templates","107");
	addElement( child, subChild );
	subChild = createTextElementNode("sent","104");
	addElement( child, subChild );

	addElement( parent, child );

	AdapterNode node = new AdapterNode( getDocument() );

        AdapterNode rootNode = node.getChild( 0 );

          //System.out.println("account rootNode: "+ rootNode.getName() );

        rootNode.domNode.appendChild( parent );


        return new AdapterNode( parent );
    }


    /*
    public void remove()
    {}
    */


    public AccountList getAccountList()
    {
        AdapterNode node = new AdapterNode( getDocument() );
        AdapterNode parent = node.getChild( 0 );

        AccountList list = new AccountList( this, parent, getDocument() );

        return list;
    }


    /*
    public AccountItem get( int i )
    {
        AdapterNode accountNode = getAccountNode( i );

        AccountItem item = getAccountItem( accountNode );

        return item;
    }

    public AccountItem getAccountItem( int uid )
    {
          //System.out.println("uid: "+ uid );

        AdapterNode node = getAccountNodeWithUid( uid );

          //System.out.println("node: "+node );


        AccountItem item = getAccountItem( node );

        return item;
    }
    */

    /*
    protected AccountItem getAccountItem( AdapterNode accountNode )
    {
        AdapterNode child = accountNode;

        AccountItem item = new AccountItem( getDocument() );

        item.setNameNode( child.getChild("name") );
        item.setUidNode( child.getChild("uid") );

        if ( isPopAccount( child ) == true )
        {
            PopItem pop = getPopItem( child.getChild("popserver") );
            item.setPopItem( pop );
        }
        else
        {
            ImapItem imap = getImapItem( child.getChild("imapserver") );
            item.setImapItem( imap );
        }

        IdentityItem identity = getIdentityItem( child.getChild("identity") );
        item.setIdentityItem( identity );

        SmtpItem smtp = getSmtpItem( child.getChild("smtpserver") );
        item.setSmtpItem( smtp );


        return item;
    }


    protected AdapterNode getAccountNodeWithUid( int u )
    {
        AdapterNode node = new AdapterNode( getDocument() );
        AdapterNode child = node.getChild( 0 );

        for ( int i=0; i<child.getChildCount(); i++ )
        {
            AdapterNode subChild = child.getChild( i );

            AdapterNode uidNode  = subChild.getChild("uid");
            if ( uidNode != null )
            {
                Integer h = new Integer( uidNode.getValue() );
                int uid = h.intValue();


                if ( uid ==  u  )
                    return subChild;
            }
        }

	return null;
    }


    protected AdapterNode getAccountNode( int i )
    {
	AdapterNode node = new AdapterNode( getDocument() );
        AdapterNode parent = node.getChild( 0 );


        AdapterNode child = parent.getChild( i );

	return child;
    }
    */



      /**
       *
       * return name of account for hostname
       * this is for replying message with the right message-address
       *
       **/
    /*
    public String getAccountName( String s )
    {
        String accountName=null;

        for ( int i=0; i<count(); i++)
        {
            AdapterNode accountNode = getAccountNode( i );
            AdapterNode serverNode = accountNode.getChild("popserver");
            if( serverNode == null) serverNode = accountNode.getChild("imapserver");
            AdapterNode hostNode = serverNode.getChild("host");
            String hostName = hostNode.getValue();

            if( hostName.equals( s ) )
            {
                  //System.out.println("host found: "+ hostName +" - "+s);
                AdapterNode nameNode = accountNode.getChild("name");
                accountName = nameNode.getValue();
                break;
            }
        }

        return accountName;
    }
    */


    public int count()
    {
        AdapterNode node = new AdapterNode( getDocument() );
        AdapterNode parent = node.getChild( 0 );

        int count  = parent.getChildCount();

	return count;
    }

    /*
    public boolean isPopAccount( int i )
    {
        AdapterNode account = getAccountNode( i );

        AdapterNode child = account.getChild("popserver");

        if ( child != null ) return true;
        else return false;
    }



    protected boolean isPopAccount( AdapterNode parent )
    {
	if ( parent.getChild("popserver") != null ) return true;
	return false;
    }

    protected boolean isImapAccount( AdapterNode parent )
    {
	if ( parent.getChild("imapserver") != null ) return true;
	return false;
    }


    protected IdentityItem getIdentityItem( AdapterNode identityNode )
    {

	IdentityItem item = new IdentityItem( getDocument() );

	item.setNameNode( identityNode.getChild("name") );
	item.setAddressNode( identityNode.getChild("address") );
	item.setOrganisationNode( identityNode.getChild("organisation") );
	item.setReplyNode( identityNode.getChild("replyaddress") );
        item.setSignatureNode( identityNode.getChild("signature") );
        item.setAttachSignatureNode( identityNode.getChild("attachsignature") );

	return item;
    }

    protected PopItem getPopItem( AdapterNode popserverNode )
    {
	PopItem item = new PopItem( getDocument() );

	item.setUserNode( popserverNode.getChild( "user" ) );
	item.setPasswordNode( popserverNode.getChild(  "password" ) );
	item.setHostNode( popserverNode.getChild( "host" ) );
	item.setPortNode( popserverNode.getChild( "port" ) );
	item.setLeaveMessageNode( popserverNode.getChild( "leave" ) );
	item.setSavePasswordNode( popserverNode.getChild( "savepassword" ) );
        item.setExcludeNode( popserverNode.getChild( "exclude" ) );
	item.setUidNode( popserverNode.getChild(  "uid" ) );
        item.setMailCheckNode( popserverNode.getChild(  "mailcheck" ) );
        item.setDownloadLimitNode( popserverNode.getChild(  "downloadlimit" ) );
        item.setLimitNode( popserverNode.getChild(  "limit" ) );
        item.setIntervalNode( popserverNode.getChild(  "interval" ) );

	return item;
    }


    protected ImapItem getImapItem( AdapterNode imapserverNode )
    {
	ImapItem item = new ImapItem( getDocument() );

	item.setUserNode( imapserverNode.getChild( "user" ) );
	item.setPasswordNode( imapserverNode.getChild( "password" ) );
	item.setHostNode( imapserverNode.getChild( "host" ) );
	item.setPortNode( imapserverNode.getChild( "port" ) );
        item.setSavePasswordNode( imapserverNode.getChild( "savepassword" ) );


	return item;
    }

    protected SmtpItem getSmtpItem( AdapterNode smtpNode )
    {
	SmtpItem smtpItem = new SmtpItem( getDocument() );

        smtpItem.setUserNode( smtpNode.getChild("user") );
        smtpItem.setPasswordNode( smtpNode.getChild("password") );
        smtpItem.setSavePasswordNode( smtpNode.getChild( "savepassword" ) );
        smtpItem.setHostNode( smtpNode.getChild("host") );
        smtpItem.setPortNode( smtpNode.getChild("port") );
        smtpItem.setESmtpNode( smtpNode.getChild("esmtp") );
	smtpItem.setUidNode( smtpNode.getChild("uid") );
	smtpItem.setBccYourselfNode( smtpNode.getChild("bccyourself") );
	smtpItem.setBccAnotherNode( smtpNode.getChild("bccanother") );
	return smtpItem;
    }
    */

      // create uid list from all accounts
    protected void getUids( Vector v , AdapterNode parent )
    {

        int childCount = parent.getChildCount();

        if ( childCount > 0 )
        {
            for ( int i=0; i<childCount; i++ )
            {
                AdapterNode child = parent.getChild( i );
                  //System.out.println("name: "+ child.getName() );

                if ( child.getName().equals("account") )
                {
                    AdapterNode uidNode = child.getChild( "uid" );

                    Integer j = new Integer( uidNode.getValue() );

                    v.add( j );
                }

            }
        }
    }

      // find a free uid for a new account
    protected String createUid()
    {
        Vector v = new Vector();

        AdapterNode rootNode = new AdapterNode( getDocument() );
        AdapterNode accountNode = rootNode.getChild( 0 );


        getUids( v, accountNode );

        int result = -1;
        boolean hit;
        boolean exit=false;


        while ( exit == false )
        {
            hit = false;
            result++;
            for ( int i=0; i<v.size(); i++)
            {
                Integer j = (Integer) v.get(i);

                if ( j.intValue() == result )
                {
                    hit = true;
                }
            }
            if ( hit == false ) exit=true;
        }

        Integer newUid = new Integer(result);


        return newUid.toString();
    }

}



