// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.config;


import org.columba.message.*;



import javax.xml.parsers.*;
import org.xml.sax.*;
import org.w3c.dom.*;

//import com.sun.xml.tree.XmlDocument;


import java.io.*;
import java.util.Vector;


public class ComposerOptionsXmlConfig extends DefaultXmlConfig
{
    private File file;


    public ComposerOptionsXmlConfig( File file )
    {
        super( file );
    }

    public AdapterNode getRootNode()
    {
        AdapterNode node = new AdapterNode( getDocument() );

        AdapterNode rootNode = node.getChild( 0 );
        return rootNode;
    }

    /*
    public HeaderTableItem getHeaderTableItem()
    {
	HeaderTableItem headerTableItem = new HeaderTableItem();

        AdapterNode rootNode = getRootNode();
        AdapterNode guiNode = rootNode.getChild("gui");


        AdapterNode headerTableItemNode = guiNode.getChild("headertable");


        for ( int i=0; i< headerTableItemNode.getChildCount(); i++)
        {
            AdapterNode parent = headerTableItemNode.getChild(i);

            headerTableItem.addHeaderItem( parent.getChild(0),
                                           parent.getChild(3),
                                           parent.getChild(1),
                                           parent.getChild(2)
                                           );
        }

	return headerTableItem;
    }

    public HeaderTableItem getPop3HeaderTableItem()
    {
	HeaderTableItem headerTableItem = new HeaderTableItem();

        AdapterNode rootNode = getRootNode();
        AdapterNode guiNode = rootNode.getChild("gui");


        AdapterNode headerTableItemNode = guiNode.getChild("pop3headertable");


        for ( int i=0; i< headerTableItemNode.getChildCount(); i++)
        {
            AdapterNode parent = headerTableItemNode.getChild(i);

            headerTableItem.addHeaderItem( parent.getChild(0),
                                           parent.getChild(3),
                                           parent.getChild(1),
                                           parent.getChild(2)
                                           );
        }

	return headerTableItem;
    }
    */

    public WindowItem getWindowItem()
    {
        WindowItem item = new WindowItem( getDocument() );

        AdapterNode rootNode = getRootNode();
        AdapterNode guiNode = rootNode.getChild("gui");
        AdapterNode windowNode = guiNode.getChild("window");

        item.setXPositionNode( windowNode.getChild("xposition") );
        item.setYPositionNode( windowNode.getChild("yposition") );

        item.setWidthNode( windowNode.getChild("width") );
        item.setHeightNode( windowNode.getChild("height") );

        /*
        item.setShowToolbarNode( windowNode.getChild("showtoolbar") );
        item.setShowFilterToolbarNode( windowNode.getChild("showfiltertoolbar") );
        item.setShowFolderInfoNode( windowNode.getChild("showfolderinfo") );

        item.setThemeNode( windowNode.getChild("theme") );

        item.setMainSplitPaneNode( windowNode.getChild("mainsplitpane") );
        item.setRightSplitPaneNode( windowNode.getChild("headersplitpane") );

        item.setSelectedHeaderNode( windowNode.getChild("selectedheader") );
        item.setHeaderAscendingNode( windowNode.getChild("headerascending") );
        */


        return item;

    }

    /*
    public AdapterNode getMimeTypeNode()
    {
        AdapterNode rootNode = getRootNode();
        AdapterNode node = rootNode.getChild("mimetypes");

        return node;
    }
    */

/*
       public String getMainFontName()
    {
        AdapterNode window;
        AdapterNode mainFont;
        AdapterNode name;

        window = getXmlConfig().getSectionNode("window", 0);
        mainFont = window.getChild("mainfont");
        name = mainFont.getChild("name");

        return name.getValue();
    }

    public int getMainFontSize()
    {
        AdapterNode window;
        AdapterNode mainFont;
        AdapterNode size;

        window = getXmlConfig().getSectionNode("window", 0);
        mainFont = window.getChild("mainfont");
        size = mainFont.getChild("size");

        Integer dummy = new Integer( size.getValue()  );

        return dummy.intValue();
    }

    public String getTextFontName()
    {
        AdapterNode window;
        AdapterNode mainFont;
        AdapterNode name;

        window = getXmlConfig().getSectionNode("window", 0);
        mainFont = window.getChild("textfont");
        name = mainFont.getChild("name");

        return name.getValue();
    }

    public int getTextFontSize()
    {
        AdapterNode window;
        AdapterNode mainFont;
        AdapterNode size;

        window = getXmlConfig().getSectionNode("window", 0);
        mainFont = window.getChild("textfont");
        size = mainFont.getChild("size");

        Integer dummy = new Integer( size.getValue()  );

        return dummy.intValue();
    }


    public boolean getViewToolbar()
    {
        AdapterNode window;
        AdapterNode child;
        Boolean result = new Boolean(true);

        window = getXmlConfig().getSectionNode("window", 0);
        child = window.getChild("showtoolbar");

        if ( child != null )
            result = new Boolean( child.getValue()  );

        return result.booleanValue();
    }

    public boolean getViewFilterToolbar()
    {
        AdapterNode window;
        AdapterNode child;
        Boolean result = new Boolean(true);

        window = getXmlConfig().getSectionNode("window", 0);
        child = window.getChild("showfiltertoolbar");

        if ( child != null )
            result = new Boolean( child.getValue()  );

        return result.booleanValue();
    }

    public void setViewToolbar( String s )
    {
        AdapterNode window;
        AdapterNode child;
        Boolean result = new Boolean(true);

        window = getXmlConfig().getSectionNode("window", 0);
        child = window.getChild("showtoolbar");

        child.setValue( s );

    }

    public void setViewFilterToolbar( String s )
    {
        AdapterNode window;
        AdapterNode child;
        Boolean result = new Boolean(true);

        window = getXmlConfig().getSectionNode("window", 0);
        child = window.getChild("showfiltertoolbar");

        child.setValue( s );

    }


    public void saveWindowPosition( int x, int y, int width, int height )
    {
        AdapterNode window;
        AdapterNode child;

        window = getXmlConfig().getSectionNode("window", 0);

        child = window.getChild("xposition");
        child.setValue( (new Integer(x)).toString() );

        child = window.getChild("yposition");
        child.setValue( (new Integer(y)).toString() );

        child = window.getChild("xsize");
        child.setValue( (new Integer(width)).toString() );

        child = window.getChild("ysize");
        child.setValue( (new Integer(height)).toString() );
    }

    public java.awt.Point getWindowPosition()
    {
        java.awt.Point p = new java.awt.Point(0,0);


        AdapterNode window;
        AdapterNode child;
        Integer i;

        window = getXmlConfig().getSectionNode("window", 0);

        child = window.getChild("xposition");
        i = new Integer( child.getValue() );
        p.x = i.intValue();

        child = window.getChild("yposition");
        i = new Integer( child.getValue() );
        p.y = i.intValue();


        return p;

    }

    public java.awt.Dimension getWindowSize()
    {
        java.awt.Dimension d = new java.awt.Dimension(800,600);


        AdapterNode window;
        AdapterNode child;
        Integer i;

        window = getXmlConfig().getSectionNode("window", 0);

        child = window.getChild("xsize");
        i = new Integer( child.getValue() );
        d.width = i.intValue();

        child = window.getChild("ysize");
        i = new Integer( child.getValue() );
        d.height = i.intValue();


        return d;

    }
*/
}




