// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.config;

import org.w3c.dom.*;

public class IdentityItem extends DefaultItem
    {

	private AdapterNode name, organisation, address, reply, signature, attachsignature;

        private AdapterNode rootNode;

        public IdentityItem( AdapterNode rootNode, Document doc )
        {
            super( doc );
            this.rootNode = rootNode;

            parse();
	}


        protected void parse()
        {
            for ( int i=0; i<getRootNode().getChildCount(); i++ )
            {
                AdapterNode child = getRootNode().getChildAt(i);

                if ( child.getName().equals("name") )
                {
                    name = child;
                }
                else  if ( child.getName().equals("organisation") )
                {
                    organisation = child;
                }
                else  if ( child.getName().equals("address") )
                {
                    address = child;
                }
                else  if ( child.getName().equals("replyaddress") )
                {
                    reply = child;
                }
                else  if ( child.getName().equals("signature") )
                {
                    signature = child;
                }
                else  if ( child.getName().equals("attachsignature") )
                {
                    attachsignature = child;
                }
            }
        }

          /*************************************************************************/


        public AdapterNode getRootNode()
        {
            return rootNode;
        }

/*
        public void setNameNode( AdapterNode node )
	{
	    name = node;
	}

        public void setSignatureNode( AdapterNode node )
        {
            signature = node ;
        }

        public void setAttachSignatureNode( AdapterNode node )
        {
            attachsignature = node ;
        }

	public void setOrganisationNode( AdapterNode node )
	{
	    organisation = node;
	}

	public void setAddressNode( AdapterNode node )
	{
	    address = node;
	}


	public void setReplyNode( AdapterNode node )
	{
	    reply = node;
	}

*/

          /******************************** set ************************************/



        public void setName( String str )
	{
	    setTextValue( name, str );
	}

	public void setOrganisation( String str )
	{
            setTextValue( organisation, str );
	}

	public void setAddress( String str )
	{
            setTextValue( address, str );
	}

	public void setReplyAddress( String str )
	{
            setTextValue( reply, str );
	}

        public void setSignature( String str )
        {
            setCDATAValue( signature, str );
        }


        public void setAttachSignature( boolean b )
        {
            if ( b == true )
                setTextValue( attachsignature, "true" );
            else
                setTextValue( attachsignature, "false" );
        }




          /********************************** get ***************************************/




        public String getName()
	{
            return getTextValue( name );
        }


	public String getOrganisation()
	{
            return getTextValue( organisation );
	}

	public String getAddress()
	{
            return getTextValue( address );
	}

	public String getReplyAddress()
	{
            return getTextValue( reply );
	}

        public String getSignature()
        {
            return getCDATAValue( signature );
        }

        public boolean getAttachSignature()
        {
            String str = (String) getTextValue( attachsignature );

            Boolean b = new Boolean(str);


            return b.booleanValue();
        }



    }

