// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


/* -*-mode: java; compile-command:"javac PopItem.java -classpath ../"; -*- */
package org.columba.config;

import org.w3c.dom.*;

public class ImapItem extends DefaultItem
    {
        public AdapterNode user;
	public AdapterNode password;
	public AdapterNode host;
	public AdapterNode port;
        public AdapterNode savePassword;
        private AdapterNode rootNode;

        public ImapItem( AdapterNode rootNode, Document doc )
        {
            super( doc );

            this.rootNode = rootNode;

            parse();
        }


        protected void parse()
        {
             for ( int i=0; i<getRootNode().getChildCount(); i++ )
            {
                AdapterNode child = getRootNode().getChildAt(i);

            if ( child.getName().equals("user") )
                {
                    user = child;
                }
                else  if ( child.getName().equals("password") )
                {
                    password = child;
                }
                else  if ( child.getName().equals("host") )
                {
                    host = child;
                }
                else  if ( child.getName().equals("port") )
                {
                    port = child;
                }
                else  if ( child.getName().equals("savepassword") )
                {
                    savePassword = child;
                }
            }
        }

        public AdapterNode getRootNode()
        {
            return rootNode;
        }

        public void setUserNode( AdapterNode node )
	{
	    user = node;
	}

	public void setPortNode( AdapterNode node )
	{
	    port = node;
	}

	public void setHostNode( AdapterNode node )
	{
	    host = node;
	}

        public void setSavePasswordNode( AdapterNode node )
        {
            savePassword = node;
        }


        public void setPasswordNode( AdapterNode node )
	{
	    password = node;
	}





          /*************************************************************************/




	public void setUser( String str )
	{
            setCDATAValue( user, str );
	}

	public void setPort( String str )
	{
            setTextValue( port, str );
	}

	public void setPassword( String str )
	{
            setCDATAValue( password, str );
	}

	public void setHost( String str )
	{
            setTextValue( host, str );
	}

        public void setSavePassword( String str )
        {
            setTextValue( savePassword, str );
        }

        public void setSavePassword(boolean b )
        {
            Boolean bool = new Boolean(b);

            setTextValue( savePassword, bool.toString() );
        }




          /**********************************************************************/






	public String getUser()
	{
            return getCDATAValue( user );
	}

	public String getPort()
	{
            return getTextValue( port );
	}

	public String getPassword()
	{
            return getCDATAValue( password );
	}

	public String getHost()
	{
            return getTextValue( host );
	}


        public String getSavePassword()
        {
            return getTextValue( savePassword );
        }



        public boolean isSavePassword()
        {
            if ( getSavePassword().equals("true") )
                return true;
            else
                return false;
        }


    }

