// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.



package org.columba.config;

import java.util.Vector;
import java.awt.*;

import org.columba.folder.*;

import org.w3c.dom.*;

import org.columba.gui.themes.*;


public class WindowItem extends DefaultItem
{
    private AdapterNode mainFontName, mainFontSize, textFontName, textFontSize, xposition, yposition, width, height;
    private AdapterNode showToolbar, showFilterToolbar, showFolderInfo, theme, mainsplitpane, rightsplitpane,selectedheader, headerascending;
    private AdapterNode advancedviewer, htmlviewer;

    public WindowItem( Document doc )
    {
        super( doc );
    }

    public void setAdvancedViewer( AdapterNode node )
    {
        advancedviewer = node;
    }

    public void setHtmlViewer( AdapterNode node )
    {
        htmlviewer = node;
    }

    public void setHeaderAscendingNode( AdapterNode node )
    {
        headerascending = node;
    }


    public void setSelectedHeaderNode( AdapterNode node )
    {
        selectedheader = node;
    }

    public void setThemeNode( AdapterNode node )
    {
        theme = node;
    }

    public void setShowFolderInfoNode( AdapterNode node )
    {
        showFolderInfo = node;
    }

    public void setShowToolbarNode( AdapterNode node )
    {
        showToolbar = node;
    }

    public void setShowFilterToolbarNode( AdapterNode node )
    {
        showFilterToolbar = node;
    }

    public void setHeightNode( AdapterNode node )
    {
        height = node;
    }

    public void setWidthNode( AdapterNode node )
    {
        width = node;
    }

    public void setMainFontNameNode( AdapterNode node )
    {
        mainFontName = node;
    }

    public void setMainFontSizeNode( AdapterNode node )
    {
        mainFontSize = node;
    }

    public void setTextFontNameNode( AdapterNode node )
    {
        textFontName = node;
    }

    public void setTextFontSizeNode( AdapterNode node )
    {
        textFontSize = node;
    }

    public void setXPositionNode( AdapterNode node )
    {
        xposition = node;
    }

    public void setYPositionNode( AdapterNode node )
    {
        yposition = node;
    }

    public void setMainSplitPaneNode( AdapterNode node )
    {
        mainsplitpane = node;
    }
    public void setRightSplitPaneNode( AdapterNode node )
    {
        rightsplitpane = node;
    }




      /******************************************** set ***************************************/

    public void setHeaderAscending( boolean b )
    {
        Boolean bool = new Boolean( b );

        setTextValue( headerascending, bool.toString() );
    }

    public void setSelectedHeader( String s )
    {
        setTextValue( selectedheader, s );
    }


    public void setXPosition( int i )
    {
        Integer h = new Integer( i );

        setTextValue( xposition, h.toString() );
    }

    public void setYPosition( int i  )
    {
        Integer h = new Integer( i );

        setTextValue( yposition, h.toString() );
    }

    public void setMainFontName( String str )
    {
        setTextValue( mainFontName, str );
    }

    public void setMainFontSize( String str )
    {
        setTextValue( mainFontSize, str );
    }

    public void setTextFontSize( int i )
    {
        Integer size = new Integer( i );

        setTextFontSize( size.toString() );
    }

    public void setMainFontSize( int i )
    {
        Integer size = new Integer( i );

        setMainFontSize( size.toString() );
    }

    public void setTextFontName( String str )
    {
        setTextValue( textFontName, str );
    }

    public void setTextFontSize( String str )
    {
        setTextValue( textFontSize, str );
    }

    public void setWidth( int i )
    {
        Integer h = new Integer( i );

        setTextValue( width, h.toString() );
    }

    public void setHeight( int i )
    {
        Integer h = new Integer( i );

        setTextValue( height, h.toString() );
    }

    public void setShowToolbar( String str )
    {
        setTextValue( showToolbar, str );
    }

    public void setShowFilterToolbar( String str )
    {
        setTextValue( showFilterToolbar, str );
    }

    public void setShowFolderInfo( String str )
    {
        setTextValue( showFolderInfo, str );
    }

    public void setTheme( int i )
    {
        String str = ( new Integer(i) ).toString();
        setTextValue( theme, str );
    }

    public void setMainSplitPane( int i )
    {
        Integer h = new Integer( i );

        setTextValue( mainsplitpane, h.toString() );
    }


    public void setRightSplitPane( int i )
    {
        Integer h = new Integer( i );

        setTextValue( rightsplitpane, h.toString() );
    }

    public void setAdvancedViewer( boolean b )
    {
        Boolean bool = new Boolean( b );

        setTextValue( advancedviewer, bool.toString() );
    }

    public void setHtmlViewer( boolean b )
    {
        Boolean bool = new Boolean( b );

        setTextValue( htmlviewer, bool.toString() );
    }


      /**************************************************** get *********************************/

    public boolean getHeaderAscending()
    {
        String s = getTextValue( headerascending );

        Boolean bool = new Boolean( s );


        return bool.booleanValue();
    }

    public boolean getAdvancedViewer()
    {
        String s = getTextValue( advancedviewer );

        Boolean bool = new Boolean( s );

        return bool.booleanValue();
    }

    public boolean getHtmlViewer()
    {
        String s = getTextValue( htmlviewer );

        Boolean bool = new Boolean( s );

        return bool.booleanValue();
    }

    public String getSelectedHeader()
    {
        return getTextValue( selectedheader );
    }

    public int getTheme()
    {
        String str = getTextValue( theme );
        int i = Integer.parseInt( str );

        return i;
    }

    public String getMainFontName()
    {
        return getTextValue( mainFontName );
    }

      /*
        public String getMainFontSize()
        {
        return getTextValue( mainFontSize );
        }
      */

    public int getMainFontSize()
    {
        Integer i = new Integer(  getTextValue( mainFontSize ) );

        return i.intValue();
    }

    public String getTextFontName()
    {
        return getTextValue( textFontName );
    }

      /*
        public String getTextFontSize()
        {
        return getTextValue( textFontSize );
        }
      */

    public int getTextFontSize()
    {
        Integer i = new Integer(  getTextValue( textFontSize ) );

        return i.intValue();
    }

    public int getXPosition()
    {
        Integer i = new Integer(  getTextValue( xposition ) );

        return i.intValue();
    }

    public int getYPosition()
    {
        Integer i = new Integer(  getTextValue( yposition ) );

        return i.intValue();
    }

    public int getWidth()
    {
        Integer i = new Integer(  getTextValue( width ) );

        return i.intValue();
    }

    public int getHeight()
    {
        Integer i = new Integer(  getTextValue( height ) );

        return i.intValue();
    }

    public int getMainSplitPane()
    {
        Integer i = new Integer(  getTextValue( mainsplitpane ) );

        return i.intValue();
    }

    public int getRightSplitPane()
    {
        Integer i = new Integer(  getTextValue( rightsplitpane ) );

        return i.intValue();
    }

    public String getShowToolbar()
    {
        return getTextValue( showToolbar );
    }

    public boolean isShowToolbar()
    {
        if ( getShowToolbar().equals("true") )
	    return true;
	else
	    return false;
    }


    public String getShowFilterToolbar()
    {
        return getTextValue( showFilterToolbar );
    }


    public boolean isShowFilterToolbar()
    {
        if ( getShowFilterToolbar().equals("true") )
	    return true;
	else
	    return false;
    }

    public String getShowFolderInfo()
    {
        return getTextValue( showFolderInfo );
    }

    public boolean isShowFolderInfo()
    {
        if ( getShowFolderInfo().equals("true") )
	    return true;
	else
	    return false;
    }

    public Point getPoint()
    {
        Point point = new Point();

        point.x = getXPosition();
        point.y = getYPosition();

        return point;
    }

    public Dimension getDimension()
    {
        Dimension dim = new Dimension();

        dim.width=getWidth();
        dim.height=getHeight();

        return dim;
    }



}




