// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.filter;


import org.columba.config.*;
import org.columba.message.*;
import org.columba.folder.*;
import org.columba.main.*;

import javax.swing.*;
import java.util.Vector;
import org.w3c.dom.*;

public class FilterAction extends DefaultItem
{
        // move = 0, copy = 1, delete = 2, markasread = 3, ...
    //private String action;
    private AdapterNode actionNode;
    private AdapterNode uidNode;

    private AdapterNode node;
    private AdapterNode treeNode;
    //private int uid;


    public FilterAction( AdapterNode node, Document doc)
    {
        super( doc );

        this.node = node;
          //list = new TreeNodeList();
        if ( node != null ) parseNode();

    }

    public AdapterNode getRootNode()
    {
        return node;
    }



    protected void parseNode()
    {
        AdapterNode child;
          //System.out.println("parsing actionnode: ");

        child = node.getChild("name");
        actionNode = child;

        String action = getTextValue( actionNode );

        if ( (  action.equals("move") ) || ( action.equals("copy") ) )
        {
            AdapterNode subChild = node.getChild("uid");
            uidNode = subChild;

        }
    }

    public int getUid()
    {
        uidNode = node.getChild("uid");

        if ( uidNode == null )
        {
            addUidNode();
        }

        Integer value = new Integer( getTextValue( uidNode ) );

        int uid = value.intValue();

        return uid;
    }

    public void removeUidNode()
    {
        AdapterNode parent = node;

        AdapterNode treePathNode = parent.getChild("uid");


        treePathNode.remove();
    }

    public void addUidNode()
    {
        AdapterNode parent = node;

        org.w3c.dom.Element treePathNode = createTextElementNode("uid", "101");

        parent.domNode.appendChild( treePathNode );

        uidNode = node.getChild("uid");
    }

    public void setUid( int i )
    {
        Integer value = new Integer( i );

        setTextValue( uidNode, value.toString() );
    }

    public String getAction()
    {
        return getTextValue( actionNode );
    }

    public void setAction( String s )
    {
        setTextValue( actionNode, s );
    }

    public int getActionInt()
    {
        if ( getAction().equals("move") ) return 0;
        if ( getAction().equals("copy") ) return 1;
        if ( getAction().equals("markasread") ) return 2;
        if ( getAction().equals("delete") ) return 3;
        return -1;
    }


    protected void printList( Vector v )
        {
            for ( int i=0; i<v.size(); i++ )
            {
                System.out.println( i+"->"+ v.get(i) );
            }
        }

    public boolean processAction(Folder folder, Vector v, MainInterface mainInterface)
    {
        Folder srcFolder = folder;

        printList( v );

        Object[] uids = v.toArray();

        if ( srcFolder == null )
        {
            System.out.println("folder == null");
            JOptionPane.showMessageDialog(
                mainInterface.mainFrame,
                "Unable to find source folder!" );
            return false;
        }

        int uid = getUid();

        switch( getActionInt() )
        {


            case 0:
            {
                    // move


                if ( uids.length == 0 ) break;

                System.out.println("moving messages");

                Folder destFolder = mainInterface.treeViewer.getFolderTree().getFolder( uid );

                if ( destFolder == null )
                {
                    JOptionPane.showMessageDialog(
                        mainInterface.mainFrame,
                        "Unable to find destination folder, please correct the destination folder path for this filter" );
                    return false;
                }


                /*
                if ( srcFolder.exists( messageUid ) )
                {
                    mainInterface.folderOperator.operate(
                        new FolderOp( FolderOp.MOVE, srcFolder,
                                      destFolder, uids));
                }
                else
                    System.out.println(" message doesnot exist");
                */

                FolderOperation op = new FolderOperation( Operation.MOVE, 0, uids, srcFolder, destFolder );
                mainInterface.crossbar.operate( op );
                    /*
                  mainInterface.folderOperator.operate(
                                                        new FolderOp( FolderOp.MOVE, srcFolder,
                                                                      destFolder, uids)
                                                       );
                            */

                return true;
            }
            case 1:
            {
                if ( uids.length == 0 ) break;

                    // copy
                  System.out.println("copying messages");

                  //System.out.println("treepath: "+ treePath );



                Folder destFolder = mainInterface.treeViewer.getFolderTree().getFolder( uid );

                if ( destFolder == null )
                {
                    JOptionPane.showMessageDialog(
                        mainInterface.mainFrame,
                        "Unable to find destination folder, please correct the destination folder path for this filter" );
                    return false;
                }

                /*
                if ( srcFolder.exists( messageUid ) )
                {
                    mainInterface.folderOperator.operate(
                        new FolderOp( FolderOp.COPY, srcFolder,
                                      destFolder, uids));
                }
                */

                FolderOperation op = new FolderOperation( Operation.COPY, 0, uids, srcFolder, destFolder );
                mainInterface.crossbar.operate( op );
                /*
                  mainInterface.folderOperator.operate(
                                                        new FolderOp( FolderOp.COPY, srcFolder,
                                                                      destFolder, uids)
                                                       );
                                                       */
                break;
            }
            case 2:
            {

                if ( uids.length == 0 ) break;

                /*
                    // mark as read
                System.out.println("mark message as read");

                if ( srcFolder.exists( messageUid ) )
                {

                    FolderOp op = new FolderOp( FolderOp.MARK, FolderOp.READ, srcFolder,  uids );
                    mainInterface.folderOperator.operate( op );
                }

                */

                FolderOperation op = new FolderOperation( Operation.MARK_READ, 0, uids, srcFolder);
                mainInterface.crossbar.operate( op );
                /*
                FolderOp op = new FolderOp( FolderOp.MARK, FolderOp.READ, srcFolder,  uids );
                mainInterface.folderOperator.operate( op );
                */

                break;
            }
            case 3:
            {
                if ( uids.length == 0 ) break;
                    // delete

                    /*
                if ( srcFolder.exists( messageUid ) )
                {
                    mainInterface.folderOperator.operate(
                        new FolderOp( FolderOp.REMOVE, srcFolder, uids));

                }

                */

                FolderOperation op = new FolderOperation( Operation.DELETE, 0, uids, srcFolder);
                mainInterface.crossbar.operate( op );

                /*
                mainInterface.folderOperator.operate(
                        new FolderOp( FolderOp.REMOVE, srcFolder, uids));
                */
                return true;
            }

        }


        return false;

    }


}
