// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.filter;

import org.columba.config.*;
import org.columba.message.*;
import org.columba.main.*;
import org.columba.folder.*;

import org.w3c.dom.*;
import java.util.Vector;

public class FilterCriteria extends DefaultItem
{
        // criteria: contains = 0, contains not=1, is=2, is not=3, begins with=4 , ends with=5
    private AdapterNode criteriaNode;
    private AdapterNode headerItemNode;
    private AdapterNode patternNode;
    private AdapterNode typeNode;

    private AdapterNode node;



    public  FilterCriteria( AdapterNode node, Document doc)
    {
        super( doc );

        this.node = node;
        if ( node != null ) parseNode();
    }

    protected void parseNode()
    {
        AdapterNode child;

        for ( int i=0; i<node.getChildCount(); i++)
        {
            child = node.getChild(i);

            if ( child.getName().equals("headeritem") )
                headerItemNode = child;
            else if ( child.getName().equals("criteria") )
                criteriaNode = child;
            else if ( child.getName().equals("pattern") )
                patternNode = child;
            else if ( child.getName().equals("type") )
                 typeNode = child;
        }
    }

    public String getCriteria()
    {
        return getTextValue( criteriaNode );
    }

    public String getHeaderItem()
    {
        return getTextValue( headerItemNode );
    }

    public String getType()
    {
        return getTextValue( typeNode );
    }

    public String getPattern()
    {

        return getTextValue( patternNode );
    }

    public void setCriteria( String s )
    {
        setTextValue( criteriaNode, s );
    }

    public void setHeaderItem( String s )
    {
        setTextValue( headerItemNode, s );
    }

    public void setType( String s )
    {
        setTextValue( typeNode, s );
    }

    public void setPattern( String s )
    {
        setTextValue( patternNode, s.trim() );
    }


    /*
    protected int getCriteriaInt()
    {
        if ( getCriteria().equals("contains") ) return 0;
        if ( getCriteria().equals("containsnot") ) return 1;
        if ( getCriteria().equals("is") ) return 2;
        if ( getCriteria().equals("isnot") ) return 3;
        if ( getCriteria().equals("beginswith") ) return 4;
        if ( getCriteria().equals("endswith") ) return 5;
        return -1;
    }
    */

    public Vector process( Folder folder )
    {
          //System.out.println("key: "+ header );

          //Vector v = folder.processCriteria( this );

          return new Vector();
          /*
        String headerStr = (String) h.get( getHeaderItem() );


        if ( headerStr == null ) return false;

        String helper = headerStr.toLowerCase();
        String pattern = getPattern();


        switch ( getCriteriaInt() )
        {
            case 0:
                if ( helper.indexOf( pattern.toLowerCase() ) != -1 ) return true;
                break;
            case 1:
                if ( helper.indexOf( pattern.toLowerCase() ) == -1 ) return true;
                break;
            case 2:
                if ( headerStr.equalsIgnoreCase( pattern ) ) return true;
                break;
            case 3:
                if ( !(headerStr.equalsIgnoreCase( pattern )) ) return true;
                break;
            case 4:
                if ( helper.startsWith( pattern.toLowerCase() ) ) return true;
                break;
            case 5:
                if ( helper.endsWith( pattern.toLowerCase() ) ) return true;
                break;
        }

        return false;
        */
    }

}
