// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.folder;

import org.columba.message.*;
import org.columba.filter.*;
import org.columba.util.*;
import org.columba.gui.tree.util.*;
import org.columba.gui.tree.*;
import org.columba.config.*;
import org.columba.gui.header.*;
import java.io.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Date;
import java.util.Calendar;
import java.util.Enumeration;
import java.lang.reflect.Array;
import javax.swing.tree.TreeNode;
import java.util.Stack;
import javax.swing.tree.TreePath;

/**
 *    Description of the Class Folder
 *
 *@author       freddy
 *@created      19. Juni 2001
 */
public class Folder implements TreeNode
{
	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected Operator operator_;
	/**
	 *    Description of the Field
	 *
	 *@since
	 */

	protected Vector viewableMessages;
	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected Hashtable uidTable;
	/**
	 *    Description of the Field
	 *
	 *@since
	 */


	// this file contains all parsed header information
	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected File headerFile;
	// currently selected message of this folder
	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected int selected = 0;
	/**
	 *    Description of the Field
	 *
	 *@since
	 */

        protected String oldName = new String();

	//protected TreeNodeList nodeList;
	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected MessageFolderInfo messageFolderInfo;
	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected FilterList filterList;

	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected int uid;

	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected boolean changed;

	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected int nextUid;

	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected Vector folderListeners;
	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected Vector treeNodeListeners;

	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	//protected FolderTreeNode treeNode;

	/**
	 *    Description of the Field
	 *
	 *@since
	 */
	protected boolean mutex;


        protected AdapterNode node;

        protected FolderItem item;

        protected Folder parentFolder;
	/**
	 *    constructor
	 *
	 *@since
	 */

         /*
	public Folder( AdapterNode node, FolderItem item )
	{

            children = new Vector();

            this.node = node;
            this.item = item;
            this.uid = item.getUid();

		viewableMessages = new Vector();
		uidTable = new Hashtable();

		selected = 0;

		//nodeList = new TreeNodeList();
		messageFolderInfo = new MessageFolderInfo();

		filterList = new FilterList();
		changed = false;

		folderListeners = new Vector();

		treeNodeListeners = new Vector();

		nextUid = 0;

                mutex = false;
	}
        */

	/**
	 *    Constructor for the Folder object
	 *
	 *@param    v    Description of Parameter
	 *@param    uid  Description of Parameter
	 *@since
	 */
	public Folder( AdapterNode node , FolderItem item )
	{


            children = new Vector();

            this.node = node;
            this.item = item;

            if ( item != null )
               this.uid = item.getUid();

		viewableMessages = new Vector();
		uidTable = new Hashtable();

		this.uid = uid;
		selected = 0;

		//name = v.lastElement();
		//nodeList = v;
		messageFolderInfo = new MessageFolderInfo();

		//filterList = new FilterList();

		changed = false;

		folderListeners = new Vector();

		treeNodeListeners = new Vector();

		nextUid = 0;

                mutex = false;
	}

    // use this constructor only for tempfolders
    public Folder( String name )
    {
	children = new Vector();

            this.node = null;
            this.item = null;


		viewableMessages = new Vector();
		uidTable = new Hashtable();

		this.uid = -1;
		selected = 0;

		//name = v.lastElement();
		//nodeList = v;
		messageFolderInfo = new MessageFolderInfo();

		//filterList = new FilterList();

		changed = false;

		folderListeners = new Vector();

		treeNodeListeners = new Vector();

		nextUid = 0;

                mutex = false;
    }

    protected synchronized void getMutex()
    {
        while( mutex ) {
            try {
                wait();
            }
            catch( InterruptedException e )
            {
            }
        }

        mutex = true;
    }



    protected synchronized void releaseMutex()
    {
        mutex = false;
        notify();
    }



	/**
	 *    Sets the Changed attribute of the Folder object
	 *
	 *@param    b  The new Changed value
	 *@since
	 */
	public void setChanged( boolean b )
	{
		changed = b;
	}


	/**
	 *    Sets the MessageFolderInfo attribute of the Folder object
	 *
	 *@param    i  The new MessageFolderInfo value
	 *@since
	 */
	public void setMessageFolderInfo( MessageFolderInfo i )
	{
		messageFolderInfo = i;
	}


	/**
	 *    Sets the FilterList attribute of the Folder object
	 *
	 *@param    list  The new FilterList value
	 *@since
	 */
	public void setFilterList( FilterList list )
	{
		filterList = list;
	}


	/**
	 *    Sets the TreeNode attribute of the Folder object
	 *
	 *@param    n  The new TreeNode value
	 *@since
	 */
         /*
	public void setTreeNode( FolderTreeNode n )
	{
		this.treeNode = n;
	}
        */


	/**
	 *    informational
	 *
	 *@return      The Uid value
	 *@since
	 */

	public int getUid()
	{
		return uid;
	}


	/**
	 *    Gets the Changed attribute of the Folder object
	 *
	 *@return      The Changed value
	 *@since
	 */
	public boolean getChanged()
	{
		return changed;
	}


	/**
	 *    Gets the MessageFolderInfo attribute of the Folder object
	 *
	 *@return      The MessageFolderInfo value
	 *@since
	 */
	public MessageFolderInfo getMessageFolderInfo()
	{
		return messageFolderInfo;
	}


	/**
	 *    Gets the Unseen attribute of the Folder object
	 *
	 *@return      The Unseen value
	 *@since
	 */
	public int getUnseen()
	{
		return messageFolderInfo.getUnseen();
	}


	/**
	 *    message viewer methods
	 *
	 *@param    number         Description of Parameter
	 *@return                  The MimePartCount value
	 *@exception    Exception  Description of Exception
	 *@since
	 */

	// return number of mime parts of message with <number>
	public int getMimePartCount( int number ) throws Exception
	{
		return -1;
	}


	// if imap or news folder get headerlist from server
	// local folders do not this - they already have the header list ready for action
	// this is only for headerTableViewer
	/**
	 *    Gets the HeaderList attribute of the Folder object
	 *
	 *@param    worker         Description of Parameter
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public HeaderList getHeaderList( SwingWorker worker ) throws Exception
	{
		//fireTreeNodeUpdate();
		return null;
	}


	// return body text
	/**
	 *    Gets the BodyText attribute of the Folder object
	 *
	 *@param    index          Description of Parameter
	 *@param    worker         Description of Parameter
	 *@return                  The BodyText value
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public String getBodyText( int index, SwingWorker worker ) throws Exception
	{
		return new String();
	}


	// return mime part <number>
	/**
	 *    Gets the MimePart attribute of the Folder object
	 *
	 *@param    index          Description of Parameter
	 *@param    number         Description of Parameter
	 *@return                  The MimePart value
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public MimePart getMimePart( int index, int number ) throws Exception
	{
		return null;
	}



	/**
	 *    Gets the MessageCollection attribute of the Folder object
	 *
	 *@return      The MessageCollection value
	 *@since
	 */
	public MessageCollection getMessageCollection()
	{
		return new MessageCollection( uidTable.values() );
	}


	/**
	 *    Description of the Method
	 *
	 *@param    i  Description of Parameter
	 *@return      Description of the Returned Value
	 *@since
	 */
	public Message get( int i ) throws Exception
	{
            getMutex();

            Object o=null;
            if ( (i>=0 ) && ( i<viewableMessages.size() ) )
		o = viewableMessages.get( i );
	    else
	    {
		System.out.println("folder->get(i) == index out of bounds exception");
		throw new Exception("index out of bounds");
	    }

            Message message = null;
            if ( uidTable.containsKey( o ) )
            message = ( Message ) uidTable.get( o );

            releaseMutex();

            return message;
	}


	/**
	 *    Gets the Uids attribute of the Folder object
	 *
	 *@param    rows  Description of Parameter
	 *@return         The Uids value
	 *@since
	 */
	public Object[] getUids( int[] rows )
	{

		int size = Array.getLength( rows );
		Object[] output = new Object[size];

                getMutex();

		for ( int i = 0; i < size; i++ )
		{
			output[i] = ( Object ) viewableMessages.get( rows[i] );
		}

                releaseMutex();

		return output;
	}


	/**
	 *    Gets the Uids attribute of the Folder object
	 *
	 *@param    row  Description of Parameter
	 *@return        The Uids value
	 *@since
	 */
	public Object[] getUids( int row )
	{

		Object[] output = new Object[1];

                getMutex();

		output[0] = ( Object ) viewableMessages.get( row );

                releaseMutex();


		return output;
	}


	/**
	 *    Gets the Uids attribute of the Folder object
	 *
	 *@return      The Uids value
	 *@since
	 */
	public Object[] getUids()
	{
	    getMutex();

		int size = viewableMessages.size();
		Object[] output = new Object[size];

                


		for ( int i = 0; i < size; i++ )
		{
			output[i] = ( Object ) viewableMessages.get( i );
		}

                releaseMutex();


		return output;

	}


	/**
	 *    Gets the Uid attribute of the Folder object
	 *
	 *@param    index  Description of Parameter
	 *@return          The Uid value
	 *@since
	 */
	public Object getUid( int index )
	{
            getMutex();

		Object uid = ( Object ) viewableMessages.get( index );

                releaseMutex();

		return uid;
	}


	/**
	 *    Gets the Index attribute of the Folder object
	 *
	 *@param    uid  Description of Parameter
	 *@return        The Index value
	 *@since
	 */
	public int getIndex( Object uid )
	{
                int output;

                getMutex();

		for ( int i = 0; i < viewableMessages.size(); i++ )
		{
			Object idInt = viewableMessages.get( i );
			if ( uid.equals( idInt ) )
			{
				releaseMutex();

				return i;
			}

		}

                releaseMutex();

		return -1;
	}


	/**
	 *    misc
	 *
	 *@return      The FilterList value
	 *@since
	 */


	public FilterList getFilterList()
	{
		return filterList;
	}


	/**
	 *    Gets the TreeNodeList attribute of the Folder object
	 *
	 *@return      The TreeNodeList value
	 *@since
	 */
         /*
	public TreeNodeList getTreeNodeList()
	{
		return nodeList;
	}
        */



	/**
	 *    Description of the Method
	 *
	 *@return      Description of the Returned Value
	 *@since
	 */
	public boolean hasMessages()
	{
            getMutex();

            boolean output = (viewableMessages.size()>=0);

            releaseMutex();

            return output;
	}


	/**
	 *    Description of the Method
	 *
	 *@return      Description of the Returned Value
	 *@since
	 */
	public boolean hasFilters()
	{
            if ( getFilterList() == null ) return false;

		if ( getFilterList().count() > 0 )
		{
			return true;
		}
		else
		{
			return false;
		}
	}


	/**
	 *    Description of the Method
	 *
	 *@param    i  Description of Parameter
	 *@return      Description of the Returned Value
	 *@since
	 */
	public boolean exists( int i )
	{
            getMutex();

            boolean output = ( ( i >= 0 ) && ( i < viewableMessages.size() ) );

            releaseMutex();

            return output;
	}


	/**
	 *    Description of the Method
	 *
	 *@param    uid  Description of Parameter
	 *@return        Description of the Returned Value
	 *@since
	 */
	public boolean exists( Object uid ) throws Exception
	{
            Message m = uidGet( uid );
            if ( m == null ) return false;
               else return true;
	}


	/**
	 *    Description of the Method
	 *
	 *@return      Description of the Returned Value
	 *@since
	 */
	public int count()
	{
            getMutex();

            int output = viewableMessages.size();

            releaseMutex();

            return output;
	}




	/**
	 *    Description of the Method
	 *
	 *@since
	 */
	public void unmarkRecent() throws Exception
	{
		for ( int i = 0; i < count(); i++ )
		{
			Message message = get( i );
                        if ( message != null )
			   message.getFlags().setRecent( false );
		}
	}


	/**
	 *    Description of the Method
	 *
	 *@param    uid  Description of Parameter
	 *@since
	 */
	public void markAsAnswered( Object uid ) throws Exception
	{
		getMutex();
                setChanged( true );
                releaseMutex();
		Message message = uidGet( uid );

		message.getFlags().setAnswered( true );
	}


	/**
	 *    Description of the Method
	 *
	 *@param    uid  Description of Parameter
	 *@since
	 */
	public void markAsRead( Object uid ) throws Exception
	{
            getMutex();
            setChanged( true );
            releaseMutex();

		Message message = uidGet( uid );
		if ( message.getHeader().getFlags().getRecent() == true )
		{
                    message.getHeader().getFlags().setRecent( false );
                    getMessageFolderInfo().decRecent();
		}

		if ( message.getFlags().getSeen() == false )
		{

			getMessageFolderInfo().decUnseen();
			message.getHeader().getFlags().setSeen( true );
		}
	}


	/**
	 *    Description of the Method
	 *
	 *@param    uid  Description of Parameter
	 *@since
	 */
	public void markAsFlagged( Object uid ) throws Exception
	{
            getMutex();
            setChanged( true );
            releaseMutex();


		Message message = uidGet( uid );
		message.getHeader().getFlags().setFlagged( true );
	}



	/**
	 *    Description of the Method
	 *
	 *@param    uid  Description of Parameter
	 *@since
	 */
	public void markAsExpunged( Object uid ) throws Exception
	{
            getMutex();
            setChanged( true );
            releaseMutex();


		Message message = uidGet( uid );
		message.getHeader().getFlags().setDeleted( true );
	}




	/**
	 *    Description of the Method
	 *
	 *@since
	 */
	public void removeAll()
	{
		setChanged( true );

                getMutex();

		viewableMessages.clear();
		uidTable.clear();

                releaseMutex();

		messageFolderInfo = new MessageFolderInfo();

                nextUid = 0;
	}



	// add message

	/**
	 *    Description of the Method
	 *
	 *@param    message        Description of Parameter
	 *@param    s              Description of Parameter
	 *@return                  Description of the Returned Value
	 *@exception    Exception  Description of Exception
	 *@since
	 */

	public Object add( Message message, String s ) throws Exception
	{
		System.out.println( "Use of deprecated method Folder.add( Message, String)!!" );

		return null;
	}

	/**
	 *    Description of the Method
	 *
	 *@param    message        Description of Parameter
	 *@param    s              Description of Parameter
	 *@param    uid            Description of Parameter
	 *@return                  Description of the Returned Value
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public Object add( Message message, String s, Object uid ) throws Exception
	{
		setChanged( true );

		if ( uid == null )
		{
		    System.out.println("---------------folder->add(m,s,uid)  uid is null");
		    throw new Exception("uid is null");
		}

		message.setUID( uid );


		getMessageFolderInfo().incExists();
		if ( message.getFlags().getSeen() == false )
		{
			getMessageFolderInfo().incUnseen();
		}
		if ( message.getFlags().getRecent() == true )
		{
			getMessageFolderInfo().incRecent();
		}

                getMutex();

		uidTable.put( message.getUID(), message );
		viewableMessages.add( message.getUID() );

                releaseMutex();

		return message.getUID();
	}


	/*
	 * public int add(Message message, String s, SwingWorker worker) throws Exception
	 * {
	 * return add( message, s, null  );
	 * }
	 */

	/**
	 *    Worker Methods
	 *
	 *@param    uid            Description of Parameter
	 *@return                  Description of the Returned Value
	 *@exception    Exception  Description of Exception
	 *@since
	 */

	public Message workerGet( Object uid ) throws Exception
	{
		Message output = uidGet( uid );
		output.setRawString( uidToString( uid, null ) );

		return output;
	}


	/**
	 *    Description of the Method
	 *
	 *@param    uids  Description of Parameter
	 *@since
	 */
	public void workerViewRemove( Object[] uids ) throws Exception
	{
            getMutex();


		for ( int i = 0; i < Array.getLength( uids ); i++ )
		{
                    //Message message = ( Message ) uidTable.get( uids[i] );
                    //MessageNode node = new MessageNode( message, uids[i] );


                    viewableMessages.remove( uids[i] );
		}

                releaseMutex();


                //fireFolderRemove( uids );
		//fireTreeNodeUpdate();

	}


	/**
	 *    Description of the Method
	 *
	 *@param    uids     Description of Parameter
	 *@param    variant  Description of Parameter
	 *@since
	 */
	public void workerViewMark( Object[] uids, int variant ) throws Exception
	{
		switch ( variant )
		{
			case FolderOp.READ:
			{
				for ( int i = 0; i < Array.getLength( uids ); i++ )
				{
                                    System.out.println("folder->markasread: "+ uids[i] );

					markAsRead( uids[i] );
				}
				break;
			}
			case FolderOp.EXPUNGED:
			{
				for ( int i = 0; i < Array.getLength( uids ); i++ )
				{
					markAsExpunged( uids[i] );
				}
				break;
			}
			case FolderOp.FLAGGED:
			{
				for ( int i = 0; i < Array.getLength( uids ); i++ )
				{
					markAsFlagged( uids[i] );
				}
				break;
			}
			case FolderOp.ANSWERED:
			{
				for ( int i = 0; i < Array.getLength( uids ); i++ )
				{
					markAsAnswered( uids[i] );
				}
				break;
			}

		}

		//fireTreeNodeUpdate();
	}


	/**
	 *    Description of the Method
	 *
	 *@param    uid            Description of Parameter
	 *@param    variant        Description of Parameter
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public void workerMark( Object uid, int variant ) throws Exception
	{
		// imap must overwrite this methode to synchronize with server
	}


	/**
	 *    Description of the Method
	 *
	 *@param    uid            Description of Parameter
	 *@return                  Description of the Returned Value
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public Message workerRemove( Object uid ) throws Exception
	{
            getMutex();

	    Message output = ( Message ) uidTable.remove( uid );

	    getMessageFolderInfo().decExists( 1 );

            if ( output.getFlags().getRecent() == true )
            {
                getMessageFolderInfo().decRecent();
            }

            if ( output.getFlags().getSeen() == false )
            {
                getMessageFolderInfo().decUnseen();
            }

	    releaseMutex();

	    return output;
	}


	// i made a second workerAdd message, just to indicate that you
	// need the rawString of the message for this method to work
	/**
	 *    Description of the Method
	 *
	 *@param    message        Description of Parameter
	 *@return                  Description of the Returned Value
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public Object workerAdd( Message message ) throws Exception
	{
		Object uid = add( message, message.getRawString() );

		// !!!!!!!!!! stop
		//
		// do not put the following update methods in the regular add method
		//
		//



		//fireFolderAdd();

		//fireTreeNodeUpdate();

		return uid;
	}


	/**
	 *    Description of the Method
	 *
	 *@param    message        Description of Parameter
	 *@param    rawString      Description of Parameter
	 *@return                  Description of the Returned Value
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public Object workerAdd( Message message, String rawString ) throws Exception
	{
		Object uid = add( message, rawString );

		// !!!!!!!!!! stop
		//
		// do not put the following update methods in the regular add method
		//
		//


		//fireFolderAdd();

		//fireTreeNodeUpdate();

		return uid;
	}


	// what does this method?
	//  we already update the viewableMessages list in
	//  the workerAdd method
	//
	// why the keySet()-method?
	//  because of the duplication check?
	/**
	 *    Description of the Method
	 *
	 *@since
	 */
	public void workerUpdate()
	{

            getMutex();

		viewableMessages = new Vector( uidTable.keySet() );

                releaseMutex();

		// we do not need this here, because
		// the workerAdd and workerRemove method
		// do this already for us

		// UPDATE:
		//   we need this method to restore folder settings
		//   if the user cancelled a folder operation like removing messages
		//fireFolderUpdate();

		//fireTreeNodeUpdate();

	}


	/**
	 *    Description of the Method
	 *
	 *@param    uid            Description of Parameter
	 *@return                  Description of the Returned Value
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public int uidgetMimePartCount( Object uid ) throws Exception
	{
		return -1;
	}


	/**
	 *    Description of the Method
	 *
	 *@param    uid            Description of Parameter
	 *@param    worker         Description of Parameter
	 *@return                  Description of the Returned Value
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public String uidgetBodyText( Object uid, SwingWorker worker ) throws Exception
	{
		return new String();
	}


	/**
	 *    Description of the Method
	 *
	 *@param    uid            Description of Parameter
	 *@param    number         Description of Parameter
	 *@return                  Description of the Returned Value
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public MimePart uidgetMimePart( Object uid, int number, SwingWorker worker ) throws Exception
	{
		return null;
	}


	// return complete message as string
	/**
	 *    Description of the Method
	 *
	 *@param    i       Description of Parameter
	 *@param    worker  Description of Parameter
	 *@return           Description of the Returned Value
	 *@since
	 */
	public String toString( int i, SwingWorker worker )
	{
		return new String( "" );
	}


	/**
	 *    Description of the Method
	 *
	 *@param    uid            Description of Parameter
	 *@param    worker         Description of Parameter
	 *@return                  Description of the Returned Value
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public String uidToString( Object uid, SwingWorker worker ) throws Exception
	{
		return ( ( Message ) uidTable.get( uid ) ).getRawString();
	}


	/**
	 *    Description of the Method
	 *
	 *@param    i  Description of Parameter
	 *@return      Description of the Returned Value
	 *@since
	 */
	public String toString( int i )
	{
		return new String( "" );
	}

	public MimePartCollection uidgetMimePartCollection( Object uid ) throws Exception
	{
		return null;
	}

        public void uidSetMimePartCollection( Object uid, MimePartCollection mc ) throws Exception
        {
            Message message = uidGet( uid );
            message.setMimePartCollection( mc );

        }

	/**
	 *    Description of the Method
	 *
	 *@param    uid  Description of Parameter
	 *@return        Description of the Returned Value
	 *@since
	 */
	public ColumbaHeader uidGetHeader( Object uid ) throws Exception
	{
            //System.out.println("---------->folder->uidGet");

            getMutex();

            Message message = ( Message ) uidTable.get( uid );
            ColumbaHeader header = (ColumbaHeader) message.getHeader();

            releaseMutex();

            return header;
	}


        public Message uidGet( Object uid ) throws Exception
        {
            getMutex();

            Message message = ( Message ) uidTable.get( uid );

            releaseMutex();

            return message;
        }


        // columbafolder has to overwrite this
        public Message uidGetParsedMessage( Object uid ) throws Exception
        {
            return new Message( uidGetHeader( uid ) );
        }


        /*
        public Message uidMessageGet( Object uid )
	{
            getMutex();

		Message message = ( Message ) uidTable.get( uid );

                releaseMutex();
		if ( message == null )
		{
                    System.out.println( "message is null" );
                    return null;
		}

		return message;
	}
        */

	// save headers for caching
	/**
	 *    Description of the Method
	 *
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public void save() throws Exception
	{
	}


	// load headers
	/**
	 *    Description of the Method
	 *
	 *@exception    Exception  Description of Exception
	 *@since
	 */
	public void load() throws Exception
	{
	}


	/**
	 *    FolderListener
	 *
	 *@param    listener  The feature to be added to the FolderListener attribute
	 *@since
	 */

	public void addFolderListener( FolderChangeListener listener )
	{
		folderListeners.add( listener );
	}


	/**
	 *    Description of the Method
	 *
	 *@param    listener  Description of Parameter
	 *@since
	 */
	public void removeFolderListener( FolderChangeListener listener )
	{
		folderListeners.remove( listener );
	}


	/**
	 *    Description of the Method
	 *
	 *@since
	 */

         /*
	public void fireFolderUpdate()
	{
		FolderEvent updateEvent = new FolderEvent( this, FolderEvent.UPDATE );

		for ( int i = 0; i < folderListeners.size(); i++ )
		{
			( ( FolderChangeListener ) folderListeners.get( i ) ).folderChanged( updateEvent );
		}
	}

        public void fireFolderAdd()
	{
		FolderEvent updateEvent = new FolderEvent( this, FolderEvent.ADD );

		for ( int i = 0; i < folderListeners.size(); i++ )
		{
			( ( FolderChangeListener ) folderListeners.get( i ) ).folderChanged( updateEvent );
		}
	}

        public void fireFolderRemove( Object[] uids)
	{
		FolderEvent updateEvent = new FolderEvent( this, uids, FolderEvent.REMOVE );

		for ( int i = 0; i < folderListeners.size(); i++ )
		{
			( ( FolderChangeListener ) folderListeners.get( i ) ).folderChanged( updateEvent );
		}
	}
        */


	/**
	 *    TreeNode Listener
	 *
	 *@param    listener  The feature to be added to the TreeNodeListener attribute
	 *@since
	 */

         /*
	public void addTreeNodeListener( TreeNodeChangeListener listener )
	{
		treeNodeListeners.add( listener );
	}
        */


	/**
	 *    Description of the Method
	 *
	 *@param    listener  Description of Parameter
	 *@since
	 */
         /*
	public void removeTreeNodeListener( TreeNodeChangeListener listener )
	{
		treeNodeListeners.remove( listener );
	}
        */

	/**
	 *    Description of the Method
	 *
	 *@since
	 */

         /*
	public void fireTreeNodeUpdate()
	{
		TreeNodeEvent updateEvent = new TreeNodeEvent( this, TreeNodeEvent.UPDATE );

		for ( int i = 0; i < treeNodeListeners.size(); i++ )
		{
                    TreeNodeChangeListener listener = (TreeNodeChangeListener) treeNodeListeners.get(i);
                    if ( listener != null ) listener.treeNodeChanged( updateEvent );
                    else System.out.println( "listener is null: "+i);
		}
	}

        public void fireTreeNodeStructureUpdate()
	{
		TreeNodeEvent updateEvent = new TreeNodeEvent( this, TreeNodeEvent.STRUCTURE_CHANGED );

		for ( int i = 0; i < treeNodeListeners.size(); i++ )
		{
                    TreeNodeChangeListener listener = (TreeNodeChangeListener) treeNodeListeners.get(i);
                    if ( listener != null ) listener.treeNodeChanged( updateEvent );
                    else System.out.println( "listener is null: "+i);
		}
	}
        */

	/**
	 *    message operations
	 *
	 *@return      Description of the Returned Value
	 *@since
	 */

	protected Object calculateNewUid()
	{
		return new Integer( nextUid++ );
	}


	// remove message
	/**
	 *    Description of the Method
	 *
	 *@param    start          Description of Parameter
	 *@exception    Exception  Description of Exception
	 *@since
	 */
        public void remove( int start ) throws Exception
	{
		int range = 1;

		setChanged( true );

		getMessageFolderInfo().decExists( range );

		for ( int index = start; index <= start + range; index++ )
		{
			if ( get( index ).getFlags().getRecent() == true )
			{
				getMessageFolderInfo().decRecent();
			}

			if ( get( index ).getFlags().getSeen() == false )
			{
				getMessageFolderInfo().decUnseen();
			}

                        getMutex();

			viewableMessages.remove( index );

                        releaseMutex();
		}
	}

	// remove message
	/**
	 *    Description of the Method
	 *
	 *@param    start          Description of Parameter
	 *@exception    Exception  Description of Exception
	 *@since
	 */
    protected Message uidRemove( Object uid ) throws Exception
    {
        setChanged( true );

        Message removed = uidGet( uid );

        getMessageFolderInfo().decExists( 1 );


            if ( removed.getFlags().getRecent() == true )
            {
                getMessageFolderInfo().decRecent();
            }

            if ( removed.getFlags().getSeen() == false )
            {
                getMessageFolderInfo().decUnseen();
            }

            getMutex();
            viewableMessages.remove( uid );
            uidTable.remove( uid );
            releaseMutex();

            return removed;
    }

    protected TreeNode[] getPathToRoot(TreeNode aNode, int depth) {
	TreeNode[]              retNodes;

	if(aNode == null) {
	    if(depth == 0)
		return null;
	    else
		retNodes = new TreeNode[depth];
	}
	else {
	    depth++;
	    retNodes = getPathToRoot(aNode.getParent(), depth);
	    retNodes[retNodes.length - depth] = aNode;
	}
	return retNodes;
    }



    public String getTreePath()
    {
        TreeNode[] treeNode = getPathToRoot( this, 0);

        StringBuffer path = new StringBuffer();

        for ( int i=1; i<treeNode.length; i++ )
        {
            Folder folder = (Folder) treeNode[i];
            path.append("/"+folder.getName() );
        }


        return path.toString();
    }

    public TreePath getSelectionTreePath()
    {
        //TreeNodeList list = new TreeNodeList( getTreePath() );
        TreeNode[] treeNodes = getPathToRoot( this, 0 );
        TreePath path = new TreePath( treeNodes[0] );

        for ( int i=1; i<treeNodes.length; i++ )
        {
            Folder folder = (Folder) treeNodes[i];
            path.pathByAddingChild( folder );
        }

        return path;
    }

    /************************************ treenode implementation ***********/

    private Vector children;

    public TreeNode getChildAt(int index)
    {
        Folder child = (Folder) children.get( index );
        return child;
    }

    public int getIndex(TreeNode treeNode)
    {
        int index = children.indexOf( (Folder) treeNode );
        return index;
    }

    public TreeNode getChild( String str )
    {
        for ( int i=0; i<getChildCount(); i++ )
        {
            Folder child = (Folder) getChildAt( i );
            String name = child.getName();

            if ( name.equals( str ) ) return child;
        }
        return null;
    }


    public int getChildCount()
    {
        int count = children.size();

        return count;
    }

    public TreeNode getParent()
    {
        return parentFolder;
    }



    public boolean isLeaf()
    {
        if ( getChildCount() == 0 )
            return true;
        else
            return false;
    }

    public boolean getAllowsChildren()
    {
        return true;
    }

    public Enumeration children()
    {
        return children.elements();
    }

    public void setParent( Folder parentFolder )
    {
        this.parentFolder = parentFolder;
    }

    public void add( Folder child )
    {
        child.setParent( this );
        children.add( child );
       // fireTreeNodeStructureUpdate();
    }

    public Vector getChildren()
    {
        return children;
    }

    public void insert( Folder newFolder, int newIndex )
    {

        Folder oldParent = (Folder) newFolder.getParent();
        int oldIndex = oldParent.getIndex( newFolder );
        oldParent.getChildren().removeElementAt( oldIndex );

        AdapterNode oldParentNode = oldParent.getNode();
        AdapterNode newChildNode = newFolder.getNode();
        oldParentNode.removeChild( newChildNode );


        newFolder.setParent( this );
        children.insertElementAt( newFolder, newIndex);

        AdapterNode newParentNode = this.getNode();


        int j=-1;
        for ( int i=0; i<newParentNode.getChildCount(); i++ )
        {
            AdapterNode n = newParentNode.getChildAt( i );
            String name = n.getName();

            if ( name.equals("folder") )
            {
                j++;
            }

            if ( j==newIndex )
            {
                newParentNode.insert( newChildNode, i );
            }
        }


        //oldParent.fireTreeNodeStructureUpdate();
        //fireTreeNodeStructureUpdate();
    }

    public void removeFromParent()
    {
        Folder parentFolder = (Folder) getParent();
        parentFolder.remove( this );
    }

    public Folder remove( TreeNode childNode )
    {
        Folder childFolder = (Folder) childNode;
        AdapterNode childAdapterNode = childFolder.getNode();
        childAdapterNode.remove();

        int index = getIndex( childFolder );
        children.removeElementAt( index );
        //fireTreeNodeStructureUpdate();

        return childFolder;
    }

    public void moveUp()
    {
        Folder parentFolder = (Folder) getParent();
        if ( parentFolder == null ) return;

        AdapterNode parentNode = parentFolder.getNode();

        int childCount = parentFolder.getChildCount();

        int childIndex = parentFolder.getIndex( (Folder) this );
        if ( childIndex == -1 ) return;
        if ( childIndex == 0 ) return;


        parentFolder.insert( this, childIndex-1 );

    }

    public void moveDown()
    {
        Folder parentFolder = (Folder) getParent();
        if ( parentFolder == null ) return;

        AdapterNode parentNode = parentFolder.getNode();

        int childCount = parentFolder.getChildCount();

        int childIndex = parentFolder.getIndex( (Folder) this );
        if ( childIndex == -1 ) return;
        if ( childIndex >=childCount-1 ) return;


        parentFolder.insert( this, childIndex+1 );
    }

    public void append( Folder newFolder )
    {
        Folder oldParent = (Folder) newFolder.getParent();
        int oldIndex = oldParent.getIndex( newFolder );
        oldParent.getChildren().removeElementAt( oldIndex );

        AdapterNode oldParentNode = oldParent.getNode();
        AdapterNode newChildNode = newFolder.getNode();
        oldParentNode.removeChild( newChildNode );


        newFolder.setParent( this );
        children.add( newFolder );

        AdapterNode newParentNode = this.getNode();
        newParentNode.appendChild( newChildNode );

       // oldParent.fireTreeNodeStructureUpdate();
       // fireTreeNodeStructureUpdate();
    }

    public boolean isParent( Folder folder  )
    {

        Folder parent = (Folder) folder.getParent();

        while ( parent.getUid() != 100 )
        {

            if ( parent.getUid() == getUid() )
            {

                 return true;
            }

            parent = (Folder) parent.getParent();
        }

        return false;
    }

    public Enumeration getPreorderEnumeration()
    {
        return new PreorderEnumeration( this );
    }

    final class PreorderEnumeration implements Enumeration {
	protected Stack	stack;

	public PreorderEnumeration(Folder rootNode) {
	    super();
	    Vector v = new Vector(1);
	    v.addElement(rootNode);
	    stack = new Stack();
	    stack.push(v.elements());
	}

	public boolean hasMoreElements() {
	    return (!stack.empty() &&
		    ((Enumeration)stack.peek()).hasMoreElements());
	}

	public Object nextElement() {
	    Enumeration	enumer = (Enumeration)stack.peek();
	    Folder	node = (Folder) enumer.nextElement();
	    Enumeration	children = node.children();

	    if (!enumer.hasMoreElements()) {
		stack.pop();
	    }
	    if (children.hasMoreElements()) {
		stack.push(children);
	    }
	    return node;
	}

    }

    public AdapterNode getNode()
    {
      return node;
    }

    public String getName()
    {
        String name=null;

        /*
        AdapterNode nameNode = getNode().getChild("name");
        if ( nameNode != null )
           name = nameNode.getCDATAValue();
           */

        FolderItem item = getFolderItem();
        name = item.getName();

        /*
        if ( getMessageFolderInfo().getUnseen() > 0 )
           name = name+" ("+getMessageFolderInfo().getUnseen()+") ";

        if ( !oldName.equals( name ) )
        {
            oldName = name;
            fireTreeNodeUpdate();
        }
        */

        return name;
    }

    public void setName( String newName )
    {
        /*
        AdapterNode nameNode = getNode().getChild("name");
        if ( nameNode != null )
        {
           nameNode.setCDATAValue( newName );
           fireTreeNodeUpdate();
        }
        */
        FolderItem item = getFolderItem();
        item.setName( newName );
        //fireTreeNodeUpdate();

    }


    /************************* FolderItem ****************************/

    public FolderItem getFolderItem()
    {
        return item;
    }


    /************************* this is for imap ***********************/


    public boolean addFolder( String name ) throws Exception
    {
        return true;
    }

    public boolean renameFolder( String name ) throws Exception
    {
        return true;
    }

    public boolean removeFolder() throws Exception
    {
        return true;
    }

    public void expunge() throws Exception
    {}










    /**************************** filter methods ***********************/








    /**
	 *    Description of the Method
	 *
	 *@param    uid  Description of Parameter
	 *@return        Description of the Returned Value
	 *@since
	 */
	public boolean applyFilter( Object[] uids ) throws Exception
	{
		boolean result = false;

                /*
		Message message = uidGet( uid );
		ColumbaHeader header = message.getHeader();
                */

		result = getFilterList().processAll( uids );

		return result;
	}

        public Vector processHeaderCriteria( Object[] uids, String headerField, String pattern, String condition ) throws Exception
        {
            Vector v = new Vector();


            for ( int i=0; i<uids.length; i++ )
            {
                if ( exists(uids[i]) == false ) continue;

                Message message = (Message) uidGet( uids[i] );
                ColumbaHeader header = message.getHeader();

                String headerItem = (String) header.get( headerField );
                if ( headerItem == null ) continue;

                headerItem = headerItem.toLowerCase();

                if ( condition.equalsIgnoreCase("contains") )
                {
                    if ( headerItem.indexOf( pattern.toLowerCase() ) != -1 ) v.add( uids[i] );
                }
                else if ( condition.equalsIgnoreCase("contains not") )
                {
                    if ( headerItem.indexOf( pattern.toLowerCase() ) == -1 ) v.add( uids[i] );
                }
                else if ( condition.equalsIgnoreCase("is") )
                {
                    if ( headerItem.equalsIgnoreCase( pattern ) ) v.add( uids[i] );
                }
                else if ( condition.equalsIgnoreCase("is not") )
                {
                    if ( !headerItem.equalsIgnoreCase( pattern ) ) v.add( uids[i] );
                }
                else if ( condition.equalsIgnoreCase("begins with") )
                {
                    if ( headerItem.startsWith( pattern.toLowerCase() ) ) v.add( uids[i] );
                }
                else if ( condition.equalsIgnoreCase("ends with") )
                {
                    if ( headerItem.endsWith( pattern.toLowerCase() ) ) v.add( uids[i] );
                }

            }

            return v;
        }


        public Vector processDateCriteria( Object[] uids, String pattern, String condition ) throws Exception
        {
            Vector v = new Vector();

            java.text.DateFormat df = java.text.DateFormat.getDateTimeInstance( java.text.DateFormat.SHORT,
                                                                                java.text.DateFormat.SHORT );
            Date searchPattern = null;
            try
            {
                searchPattern = df.parse( pattern );
            }
            catch ( java.text.ParseException ex )
            {
                System.out.println("exception: "+ ex.getMessage() );
                ex.printStackTrace();

                return new Vector();
            }

            for ( int i=0; i<uids.length; i++ )
            {
                if ( exists(uids[i]) == false ) continue;

                Message message = (Message) uidGet( uids[i] );
                ColumbaHeader header = message.getHeader();

                Date date = (Date) header.get( "columba.date" );
                if ( date == null ) continue;

                if ( condition.equalsIgnoreCase("before") )
                {
                    if ( date.before( searchPattern ) ) v.add( uids[i] );
                }
                else if ( condition.equalsIgnoreCase("after") )
                {
                    if ( date.after( searchPattern ) ) v.add( uids[i] );
                }
            }

            return v;
        }




        public Vector processSizeCriteria( Object[] uids, String pattern, String condition ) throws Exception
        {
            Vector v = new Vector();

            Integer searchPattern = new Integer( pattern );


            for ( int i=0; i<uids.length; i++ )
            {
                if ( exists(uids[i]) == false ) continue;

                Message message = (Message) uidGet( uids[i] );
                ColumbaHeader header = message.getHeader();

                Integer size = (Integer) header.get("columba.size");
                if ( size == null ) continue;

                if ( condition.equalsIgnoreCase("smaller") )
                {
                    if ( size.compareTo(searchPattern) < 0 ) v.add( uids[i] );
                }
                else if ( condition.equalsIgnoreCase("bigger") )
                {
                    if ( size.compareTo(searchPattern) > 0 ) v.add( uids[i] );
                }
            }


            return v;
        }










        public Vector processFlagsCriteria( Object[] uids, String pattern, String condition ) throws Exception
        {
            Vector v = new Vector();

            String headerField = pattern;

            String searchHeaderField=null;

            if ( headerField.equalsIgnoreCase("Answered") )
            {
                searchHeaderField = new String("columba.flags.answered");
            }
            else if ( headerField.equalsIgnoreCase("Deleted") )
            {
                searchHeaderField = new String("columba.flags.deleted");
            }
            else if ( headerField.equalsIgnoreCase("Flagged") )
            {
                searchHeaderField = new String("columba.flags.flagged");
            }
            else if ( headerField.equalsIgnoreCase("Recent") )
            {
                searchHeaderField = new String("columba.flags.recent");
            }
            else if ( headerField.equalsIgnoreCase("Draft") )
            {
                searchHeaderField = new String("columba.flags.draft");
            }
            else if ( headerField.equalsIgnoreCase("Seen") )
            {
                searchHeaderField = new String("columba.flags.seen");
            }

            if ( searchHeaderField == null ) return new Vector();


            for ( int i=0; i<uids.length; i++ )
            {
                if ( exists(uids[i]) == false ) continue;

                Message message = (Message) uidGet( uids[i] );
                ColumbaHeader header = message.getHeader();

                Boolean flags = (Boolean) header.get( searchHeaderField );
                if ( flags == null ) continue;

                if ( condition.equalsIgnoreCase("is") )
                {
                    if ( flags.equals( Boolean.TRUE ) ) v.add( uids[i] );
                }
                else if ( condition.equalsIgnoreCase("is not") )
                {
                    if ( flags.equals( Boolean.FALSE ) ) v.add( uids[i] );
                }

            }

            return v;
        }


        public Vector processPriorityCriteria( Object[] uids, String pattern, String condition ) throws Exception
        {
            Vector v = new Vector();

            Integer searchPattern = null;
            if ( pattern.equalsIgnoreCase("Highest") )
            {
                searchPattern = new Integer(1);
            }
            else if ( pattern.equalsIgnoreCase("High") )
            {
                searchPattern = new Integer(2);
            }
            else if ( pattern.equalsIgnoreCase("Normal") )
            {
                searchPattern = new Integer(3);
            }
            else if ( pattern.equalsIgnoreCase("Low") )
            {
                searchPattern = new Integer(4);
            }
            else if ( pattern.equalsIgnoreCase("Lowest") )
            {
                searchPattern = new Integer(5);
            }

            if ( searchPattern == null ) return new Vector();


            for ( int i=0; i<uids.length; i++ )
            {
                if ( exists(uids[i]) == false ) continue;

                Message message = (Message) uidGet( uids[i] );
                ColumbaHeader header = message.getHeader();

                Integer priority = (Integer) header.get("columba.priority");
                if ( priority == null ) continue;

                if ( condition.equalsIgnoreCase("is") )
                {
                    if ( priority.compareTo( searchPattern ) == 0 ) v.add( uids[i] );
                }
                else if ( condition.equalsIgnoreCase("is not") )
                {
                    if ( priority.compareTo( searchPattern ) != 0 ) v.add( uids[i] );
                }

            }

            return v;
        }




        public Vector processBodyCriteria( Object[] uids, String pattern, String condition ) throws Exception
        {
            Vector v = new Vector();

            String bodyText = pattern;


            for ( int i=0; i<uids.length; i++ )
            {
                if ( exists(uids[i]) == false ) continue;

                Message message = (Message) uidGet( uids[i] );
                String body = message.getRawString();
                if ( body == null )
                {
                    try
                    {
                        body = uidToString( uids[i], null );
                    }
                    catch ( Exception ex )
                    {
                        System.out.println("exception: "+ ex.getMessage() );
                        ex.printStackTrace();
                    }
                }

                if ( body == null ) continue;


                if ( condition.equalsIgnoreCase("contains") )
                {
                    if ( body.indexOf( bodyText ) != -1 ) v.add( uids[i] );
                }
                else if ( condition.equalsIgnoreCase("contains not") )
                {
                    if ( body.indexOf( bodyText ) == -1 ) v.add( uids[i] );
                }

            }

            return v;
        }


    public Operator getOperator()
    {
	return operator_;
    }

    public void setOperator(Operator operator)
    {
	this.operator_ = operator;
    }


    public MimePart uidgetBodyPart( Object uid, SwingWorker worker ) throws Exception
    {
	MimePartCollection mimeCollection = uidgetMimePartCollection( uid );
	
	int bodyPartIndex=0;

	String contentType;

	for( int i=0; i<mimeCollection.count(); i++ ) {
	    contentType = mimeCollection.get(i).getHeader().contentType;
	    if( contentType.equals("text") ) {
			bodyPartIndex = i;
			break;
	    }
	}

	return uidgetMimePart( uid, bodyPartIndex,worker );
    }

}




