// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package org.columba.folder;


import org.columba.gui.config.subscribe.*;

public class FolderOperation extends Operation
{
	public Object[] uidList;
	public Object uid;
	public Channel channel;
	public Folder source;
	public Folder drain;
	public boolean destructive = false;
	public String name;
	public int part;
	public SubscribeTreeNode node;
	
	public SubscribeDialog dialog;
	public FolderOperation(
		int mode,
		int priority,
		Object[] uidList,
		Folder source,
		Folder drain)
	{
		type = Operation.FOLDER;

		this.mode = mode;
		this.priority = priority;
		this.uidList = uidList;
		this.source = source;
		this.drain = drain;
	}

	public FolderOperation(int mode, int priority, Object[] uidList, Folder source)
	{
		type = Operation.FOLDER;

		this.mode = mode;
		this.priority = priority;
		this.uidList = uidList;
		this.source = source;
	}

	public FolderOperation(
		int mode,
		int priority,
		Object[] uidList,
		Folder source,
		Channel channel)
	{
		type = Operation.FOLDER;

		this.mode = mode;
		this.priority = priority;
		this.uidList = uidList;
		this.source = source;
		this.channel = channel;
	}

	public FolderOperation(
		int mode,
		int priority,
		Object uid,
		Folder source,
		Channel channel)
	{
		type = Operation.FOLDER;

		this.mode = mode;
		this.priority = priority;
		this.uid = uid;
		this.source = source;
		this.channel = channel;
	}

	public FolderOperation(
		int mode,
		int priority,
		Object uid,
		Folder source,
		int part,
		Channel channel)
	{
		type = Operation.FOLDER;

		this.mode = mode;
		this.priority = priority;
		this.uid = uid;
		this.source = source;
		this.channel = channel;
		this.part = part;
	}

	public FolderOperation(int mode, int priority, Folder source, Channel channel)
	{
		type = Operation.FOLDER;

		this.mode = mode;
		this.priority = priority;
		this.source = source;
		this.channel = channel;
	}

	public FolderOperation(
		int mode,
		int priority,
		Folder source,
		String name,
		Channel channel)
	{
		type = Operation.FOLDER;

		this.mode = mode;
		this.priority = priority;
		this.source = source;
		this.channel = channel;
		this.name = name;
	}

	public FolderOperation(int mode, int priority, Folder source)
	{
		type = Operation.FOLDER;

		this.mode = mode;
		this.priority = priority;
		this.source = source;

	}

	
	public FolderOperation( int mode, int priority,  Folder source, SubscribeDialog dialog )
	{
	type = Operation.FOLDER;
	
	    this.mode = mode;
	this.priority = priority;
	this.source = source;
		this.dialog = dialog;
	}
	
	public FolderOperation( int mode, int priority,  Folder source, SubscribeTreeNode node, SubscribeDialog dialog )
	{
	type = Operation.FOLDER;
	
	    this.mode = mode;
	this.priority = priority;
	this.source = source;
		this.dialog = dialog;
		this.node = node;
	}
	

	/*
	public FolderOperation( int mode, int priority, Folder drain,  Channel channel  )
	{
	type = Operation.FOLDER;
	
	    this.mode = mode;
	this.priority = priority;
	this.drain = drain;
	this.channel = channel;
	}
	*/

	public boolean isIO()
	{
		if ((mode & 0x0000) == 0x0000)
			return true;
		else
			return false;
	}

	public boolean isOperation()
	{
		if ((mode & 0x0100) == 0x0100)
			return true;
		else
			return false;
	}

	public boolean isMark()
	{
		if ((mode & 0x0200) == 0x0200)
			return true;
		else
			return false;
	}

}