// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package org.columba.folder;

import org.columba.gui.statusbar.*;

import org.columba.message.*;

import org.columba.gui.message.*;
import org.columba.gui.attachment.*;
import org.columba.gui.header.*;
import org.columba.gui.util.*;

import java.util.*;
import java.lang.reflect.*;

public class FolderWorkerIO extends Worker
{
	Message message;
	FolderOperation folderOp;

	public Object construct()
	{
		int opLength = 0;

		System.out.println("FolderWorkerIO started...");

		if (op.type == Operation.FOLDER)
		{
			folderOp = (FolderOperation) op;
			channel = folderOp.channel;
		}

		if (folderOp.channel != null)
		{
			opLength = folderOp.channel.getTransVolume();
		}

		//        setText( folderOp.toString() );
		setText(op.toString() + " : Volume=" + opLength);

		setProgressBarMaximum(opLength);
		setProgressBarValue(0);

		//System.out.println( folderOp.mode );

		switch (folderOp.mode)
		{
			case (Operation.SEND) :
				{
					System.out.println("folderop.destructive:"+folderOp.destructive);
					
					if (folderOp.destructive)
					{
						FolderEvent event =
							new FolderEvent(folderOp.source, folderOp.uidList, FolderEvent.REMOVE);
						root.mainInterface.crossbar.fireFolderChanged(event, folderOp.source);

						TreeNodeEvent updateEvent =
							new TreeNodeEvent(folderOp.source, TreeNodeEvent.UPDATE);

						root.mainInterface.crossbar.fireTreeNodeChanged(updateEvent);
					}

					for (int i = 0; i < opLength; i++)
					{

						System.out.print("Send Message " + i + "...");

						System.out.println("uidlist: " + folderOp.uidList[i]);
						try
						{
							if (folderOp.destructive)
							{
								Message message = (Message) folderOp.source.workerGet(folderOp.uidList[i]);
								folderOp.source.workerRemove(folderOp.uidList[i]);

								//folderOp.channel.write( folderOp.source.workerRemove( folderOp.uidList[i] ));
								if( waitForWrite() ) folderOp.channel.write(message);
							}
							else
							{
								Message message = (Message) folderOp.source.workerGet(folderOp.uidList[i]);
								
								if( waitForWrite() ) folderOp.channel.write(message);
								
							}

							setProgressBarValue(i);

						}
						catch (Exception e)
						{
							ExceptionDialog dialog = new ExceptionDialog(root.mainInterface);
							dialog.showDialog(e);

							setCancel(true);

							e.printStackTrace();
						}

						System.out.println("done");
					}
					break;
				}
			case (Operation.RECEIVE) :
				{

					for (int i = 0; i < opLength; i++)
					{

						try
						{

							// folderOp.drain == null !!!!!
							// see constructor of FolderOperation:
							// we use source, but we mean drain
							Message message = null; 
							if( waitForRead() ) message = (Message) folderOp.channel.read();
							
							if( message != null ) {
							folderOp.source.workerAdd(message);

							FolderEvent event = new FolderEvent(folderOp.source, message, FolderEvent.ADD);
							root.mainInterface.crossbar.fireFolderChanged(event, folderOp.drain);

							TreeNodeEvent updateEvent =
								new TreeNodeEvent(folderOp.source, TreeNodeEvent.UPDATE);
							root.mainInterface.crossbar.fireTreeNodeChanged(updateEvent);
							
							}
							
							setProgressBarValue(i);
							System.out.println("Received Message");
						}
						catch (Exception e)
						{
							ExceptionDialog dialog = new ExceptionDialog(root.mainInterface);
							dialog.showDialog(e);
							
							setCancel( true );
							
							e.printStackTrace();
						}
					}
					break;
				}
			case (Operation.RECEIVE_POP3) :
				{

					int count = 0;

					for (int i = 0; i < opLength; i++)
					{

						try
						{

							// folderOp.drain == null !!!!!
							// see constructor of FolderOperation:
							// we use source, but we mean drain
							Message message = null;
							if( waitForRead() ) message = (Message) folderOp.channel.read();
							
							if( message != null ) {

							Object uid = folderOp.source.workerAdd(message);

							FolderEvent event = new FolderEvent(folderOp.source, message, FolderEvent.ADD);
							root.mainInterface.crossbar.fireFolderChanged(event, folderOp.source);

							TreeNodeEvent updateEvent =
								new TreeNodeEvent(folderOp.source, TreeNodeEvent.UPDATE);
							root.mainInterface.crossbar.fireTreeNodeChanged(updateEvent);
							
							root.mainInterface.headerTableViewer.backupSelection();
							
							//setProgressBarValue( i );

							Object[] uids = new Object[1];
							uids[0] = uid;

							FolderOperation op1 =
								new FolderOperation(Operation.FOLDER_APPLYFILTER, 0, uids, folderOp.source);
							root.mainInterface.crossbar.operate(op1);

							}
							
							setProgressBarValue(i);

						}
						catch (Exception e)
						{
							ExceptionDialog dialog = new ExceptionDialog(root.mainInterface);
							dialog.showDialog(e);

							setCancel(true);

							e.printStackTrace();
						}
					}
					break;

				}

			
		}

		unregister();

		return null;
	}

	public void setCancel(boolean val)
	{
		super.setCancel(val);

		System.out.println(this +" Cancel set to " + getCancel());

	}

}