// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.folder;

public class GuiOperation extends Operation
{
    public static final int HEADERLIST = 0x0300;
    public static final int MESSAGEBODY = 0x0301;
    public static final int ATTACHMENTLIST = 0x0302;
    public static final int ATTACHMENT = 0x0303;


    public Object uid;
    public int id;
    public Channel channel;
    public Folder source;
    public String name;
    public int part;
    public int submode;

    public GuiOperation( int mode, int priority, Object uid, Channel channel )
    {
	type = Operation.GUI;

        this.mode = mode;
	this.priority = priority;
	this.uid = uid;
	this.channel = channel;
    }

    public GuiOperation( int mode, int priority, Folder source, Object uid )
    {
	type = Operation.GUI;

        this.mode = mode;
	this.priority = priority;
	this.uid = uid;
	this.source = source;
    }

    public GuiOperation( int mode, int submode, int priority, Folder source, Object uid, int part )
    {
	type = Operation.GUI;

        this.mode = mode;
        this.submode = submode;
	this.priority = priority;
	this.uid = uid;
	this.source = source;
        this.part = part;
    }

    public GuiOperation( int mode, int priority, Folder source  )
    {
	type = Operation.GUI;

        this.mode = mode;
	this.priority = priority;
	this.source = source;
    }

    public GuiOperation( int mode, int priority, Folder source, String name, Channel channel )
    {
	type = Operation.GUI;

        this.mode = mode;
	this.priority = priority;
	this.source = source;
	this.name = name;
	this.channel = channel;
    }

    public GuiOperation( int mode, int priority, Folder source, Object uid, Channel channel )
    {
	type = Operation.GUI;

        this.mode = mode;
	this.priority = priority;
	this.source = source;
	//this.name = name;
        this.uid = uid;
	this.channel = channel;
    }

    public GuiOperation( int mode, int priority, Folder source, Channel channel )
    {
	type = Operation.GUI;

        this.mode = mode;
	this.priority = priority;
	this.source = source;
	this.channel = channel;
    }

    public GuiOperation( int mode, int priority, Channel channel )
    {
	type = Operation.GUI;

        this.mode = mode;
	this.priority = priority;
	this.uid = uid;
	this.channel = channel;
    }

    public GuiOperation( int mode, int submode, int priority, Channel channel )
    {
	type = Operation.GUI;

        this.mode = mode;
	this.priority = priority;
	this.submode = submode;
	this.channel = channel;
    }



}



