// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.folder;

import java.io.*;

import org.columba.message.*;
import java.util.Vector;
import org.columba.filter.*;
import org.columba.main.*;
import org.columba.gui.tree.util.*;
import org.columba.config.*;

public class LocalFolder extends Folder
{
    protected File directoryFile; // directory

     public LocalFolder( AdapterNode node, FolderItem item )
        {
	    super( node, item );
        }

    public LocalFolder( AdapterNode node, FolderItem item,   MainInterface mainInterface)
        {
	    super( node, item );

              //directoryFile = v.getFile( mainInterface.config.configDirectory );
            String dir = mainInterface.config.configDirectory + "/" + new Integer( uid ).toString();

            directoryFile = new File( dir);


            if ( !directoryFile.exists() )
            {
                boolean success = directoryFile.mkdirs();
                if ( success )
                    System.out.println("created directory successfully: "+ directoryFile.toString() );
                else
                    System.out.println("failed while trying to create directory: "+ directoryFile.toString() );
            }

        }


    // use this constructor only with tempfolders
    public LocalFolder( String name, MainInterface mainInterface )
    {
	super( name );

	String dir = mainInterface.config.configDirectory + "/" + name;

            directoryFile = new File( dir);


            if ( !directoryFile.exists() )
            {
                boolean success = directoryFile.mkdirs();
                if ( success )
                    System.out.println("created directory successfully: "+ directoryFile.toString() );
                else
                    System.out.println("failed while trying to create directory: "+ directoryFile.toString() );
            }
    }

    public static void  saveStringInFile(File toFile, String insertString) throws Exception
        {
            int lineNumber=0;


            BufferedWriter out = new BufferedWriter( new FileWriter( toFile ) );

	    
	 
	    
            out.write( insertString );
	    out.flush();
            out.close();

        }

    public void save() throws Exception {}
    public void load() throws Exception {}




}


