// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package org.columba.folder;

import java.util.*;

public class Operation
{
	/*********** Type Definitions *************/

	public static final int FOLDER = 0x0000;
	public static final int GUI = 0x0001;
	public static final int POP3 = 0x0002;
	public static final int SMTP = 0x0003;
	public static final int ENCRYPTION = 0x0004;
	public static final int COMPOSER = 0x0005;

	/*********** Mode Definitions *************/

	public static final int SEND = 0x0000;
	public static final int RECEIVE = 0x0001;
	public static final int RECEIVE_POP3 = 0x0002;
	public static final int SEND_COMPOSER = 0x0003;

	public static final int COPY = 0x0100;
	public static final int MOVE = 0x0101;
	public static final int DELETE = 0x0102;

	public static final int MARK_READ = 0x0200;
	public static final int MARK_EXPUNGED = 0x0201;
	public static final int MARK_FLAGGED = 0x0202;
	public static final int MARK_ANSWERED = 0x0203;

	public static final int HEADERLIST = 0x0300;
	public static final int MESSAGEBODY = 0x0301;
	public static final int ATTACHMENTLIST = 0x0302;
	public static final int ATTACHMENT = 0x0303;
	public static final int HEADERLIST_ADD = 0x0304;
	public static final int HEADERLIST_REMOVE = 0x0305;
	public static final int MESSAGESOURCE = 0x0306;

	public static final int CLIP_COPY = 0x0400;
	public static final int CLIP_CUT = 0x0401;
	public static final int CLIP_PASTE = 0x0402;

	public static final int FOLDER_ADD = 0x0500;
	public static final int FOLDER_REMOVE = 0x0501;
	public static final int FOLDER_RENAME = 0x0502;
	public static final int FOLDER_SUBSCRIBE = 0x0503;
	public static final int FOLDER_UNSUBSCRIBE = 0x0504;
	public static final int FOLDER_APPLYFILTER = 0x0505;
	public static final int FOLDER_LIST = 0x0506;

	public static final int POP3_FETCHALL = 0x0600;
	public static final int POP3_AUTHENTICATE = 0x0601;
	public static final int POP3_CHECK = 0x0602;
	public static final int POP3_MANAGE_SYNCHRONIZE = 0x0603;
	public static final int POP3_MANAGE_FETCH = 0x0604;
	public static final int POP3_MANAGE_REMOVE = 0x0605;

	public static final int SMTP_SEND = 0x0700;
	public static final int SMTP_SENDALL = 0x0701;
	public static final int SMTP_SENDCOMPOSED = 0x0702;

	public static final int DECRYPT = 0x0800;
	public static final int VERIFY = 0x0801;
	public static final int ENCRYPT = 0x0802;
	public static final int SIGN = 0x0803;

	public static final int COMPOSER_REPLY = 0x0901;
	public static final int COMPOSER_REPLY_ALL = 0x0902;
	public static final int COMPOSER_REPLY_MAILINGLIST = 0x0903;
	public static final int COMPOSER_REPLY_AS_ATTACHMENT = 0x0904;

	public static final int COMPOSER_FORWARD = 0x0905;
	public static final int COMPOSER_FORWARD_INLINE = 0x0906;

	public static final int COMPOSER_OPEN = 0x0907;

	public static final int COMPOSER_SEND = 0x0908;
	public static final int COMPOSER_SENDLATER = 0x0909;
	public static final int COMPOSER_SAVEDRAFT = 0x0910;
	public static final int COMPOSER_SAVETEMPLATE = 0x0911;

	/*********** imap folder specific modes ******/

	public static final int FOLDER_REFRESHLIST = 0x0507;
	public static final int FOLDER_SUBLIST = 0x0508;

	/*********** Submode Definitions *************/

	public static final int OPEN = 0x0001;
	public static final int OPEN_WITH = 0x0002;
	public static final int SAVE_AS = 0x0003;

	/*********** misc *************/

	public static final Comparator COMPARATOR = new OperationComparator();

	public int priority;
	public int type;
	public int mode;

	public String toString()
	{
		return new String(
			"Operation:: Type=" + type + " : Mode=" + mode + " : Priority=" + priority);
	}
}