// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.folder;

import org.columba.message.*;
import org.columba.pop3.*;

public class Pop3Operation extends Operation
{
    public Object[] uidList;
    public Object uid;
    public Channel channel;
    public Folder source;
    public Folder drain;
    public boolean destructive = false;
    public String rawString;
    public Message message;
    public PopServer popServer;
    public boolean mailcheck;

    public Pop3Operation( int mode, int priority, Folder source, PopServer server, boolean mailcheck)
    {
	type = Operation.POP3;

        this.mode = mode;
        //this.rawString = raw;
	this.priority = priority;
	this.source = source;
        //this.message = message;
        this.popServer = server;
        this.mailcheck = mailcheck;
    }

    public Pop3Operation( int mode, int priority, Folder source, PopServer popServer, Channel channel )
    {
        type = Operation.POP3;

        this.mode = mode;
	this.priority = priority;
	this.source = source;
        this.popServer = popServer;
        this.channel = channel;
    }

    public Pop3Operation( int mode, int priority, PopServer popServer )
    {
        type = Operation.POP3;

        this.mode = mode;
	this.priority = priority;

	//this.source = source;
        this.popServer = popServer;
        //this.channel = channel;
    }

    public Pop3Operation( int mode, int priority, Object[] uidList, Folder source, PopServer popServer )
    {
        type = Operation.POP3;

        this.mode = mode;
	this.priority = priority;
        this.uidList = uidList;
	this.source = source;
        this.popServer = popServer;
        //this.channel = channel;
    }

     public Pop3Operation( int mode, int priority, Object[] uidList, PopServer popServer, Channel channel )
    {
        type = Operation.POP3;

        this.mode = mode;
	this.priority = priority;
        this.uidList = uidList;
	//this.source = source;
        this.popServer = popServer;
        this.channel = channel;
    }

     public Pop3Operation( int mode, int priority, Object[] uidList, PopServer popServer )
    {
        type = Operation.POP3;

        this.mode = mode;
	this.priority = priority;
        this.uidList = uidList;
	//this.source = source;
        this.popServer = popServer;
        //this.channel = channel;
    }


}
