// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.folder.gui;

import org.columba.gui.statusbar.*;
import org.columba.main.*;

import org.columba.gui.message.*;
import org.columba.gui.attachment.*;
import org.columba.gui.header.*;
import org.columba.gui.header.util.*;
import org.columba.gui.mainframe.util.*;
import org.columba.gui.tree.*;

import org.columba.folder.*;


import java.util.*;

public class GuiOperator extends Operator
{
    public MarkAsReadTimer markAsReadTimer;

    public GuiOperator(MainInterface mainInterface)
    {
	super( mainInterface );
	maxOut = 1; // Only 1 Thread parallel

	// WorkerTable

	try {
	workerTable.put( new Integer( 0x0000 ), Class.forName( "org.columba.folder.gui.GuiWorker" ));
	workerTable.put( new Integer( 0x0100 ), Class.forName( "org.columba.folder.gui.GuiWorker" ));
	workerTable.put( new Integer( 0x0200 ), Class.forName( "org.columba.folder.gui.GuiWorker" ));
	workerTable.put( new Integer( 0x0300 ), Class.forName( "org.columba.folder.gui.GuiWorker" ));
	workerTable.put( new Integer( 0x0500 ), Class.forName( "org.columba.folder.gui.GuiWorker" ));
        workerTable.put( new Integer( 0x0800 ), Class.forName( "org.columba.folder.gui.GuiWorker" ));

	}
	catch( ClassNotFoundException e )
	{
	    System.out.println( e );
	}

        markAsReadTimer = new MarkAsReadTimer( mainInterface );
    }

    public MessageViewer getMessageViewer()
    {
	return mainInterface.messageViewer;
    }

    public HeaderTableViewer getHeaderTableViewer()
    {
	return mainInterface.headerTableViewer;
    }

    public AttachmentViewer getAttachmentViewer()
    {
	return mainInterface.attachmentViewer;
    }

    public TreeViewer getTreeViewer()
    {
        return mainInterface.treeViewer;
    }

    public void showAttachmentViewer(boolean value)
    {
	SplitPane splitPane = mainInterface.mainFrame.rightSplitPane;

	if( value )
	    splitPane.showAttachmentViewer();
	else
	    splitPane.hideAttachmentViewer();

    }


}

