// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.folder.imap;

import org.columba.gui.statusbar.*;
import org.columba.main.*;

import org.columba.folder.*;

import org.columba.gui.message.*;
import org.columba.gui.attachment.*;
import org.columba.gui.header.*;

import java.util.*;

public class ImapOperator extends Operator
{
    public ImapOperator(MainInterface mainInterface)
    {
	super( mainInterface );
	maxOut = 1; // 1 Thread parallel

	// WorkerTable

	try {
	workerTable.put( new Integer( 0x0000 ), Class.forName( "org.columba.folder.FolderWorkerIO" ));
	workerTable.put( new Integer( 0x0100 ), Class.forName( "org.columba.folder.imap.ImapWorkerIntern" ));
	workerTable.put( new Integer( 0x0200 ), Class.forName( "org.columba.folder.imap.ImapWorkerFolder" ));
	workerTable.put( new Integer( 0x0300 ), Class.forName( "org.columba.folder.imap.ImapWorkerGui" ));
	workerTable.put( new Integer( 0x0500 ), Class.forName( "org.columba.folder.imap.ImapWorkerFolder" ));
	}
	catch( ClassNotFoundException e )
	{
	    System.out.println( e );
	}
   }



}
