// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package org.columba.folder.outbox;

import org.columba.gui.statusbar.*;
import org.columba.main.*;

import org.columba.folder.*;

import org.columba.gui.message.*;
import org.columba.gui.attachment.*;
import org.columba.gui.header.*;
import org.columba.config.*;

import java.util.*;

public class OutboxOperator extends Operator
{
	public Folder outboxFolder;

	public OutboxOperator(MainInterface mainInterface, OutboxFolder outbox)
	{
		super(mainInterface);
		maxOut = 1; // 1 Thread parallel

		// WorkerTable

		try
		{
			workerTable.put(
				new Integer(0x0000),
				Class.forName("org.columba.folder.FolderWorkerIO"));
			workerTable.put(
				new Integer(0x0100),
				Class.forName("org.columba.folder.columba.ColumbaWorkerIntern"));
			workerTable.put(
				new Integer(0x0200),
				Class.forName("org.columba.folder.columba.ColumbaWorkerIntern"));
			workerTable.put(
				new Integer(0x0300),
				Class.forName("org.columba.folder.columba.ColumbaWorkerGui"));
			workerTable.put(
				new Integer(0x0700),
				Class.forName("org.columba.folder.outbox.OutboxWorkerIntern"));
		}
		catch (ClassNotFoundException e)
		{
			System.out.println(e);
		}

		// Private Attributes

		//System.out.println( outbox );
		outboxFolder = outbox;
	}

	public AccountItem getAccountItem(int accountUid)
	{
		return mainInterface.config.getAccountList().uidGet(accountUid);
	}

	public void moveSent(Object[] uids, int drainUid)
	{
		Folder drain = mainInterface.treeViewer.getFolderTree().getFolder(drainUid);
		//System.out.println("drain: "+drain);
		//System.out.println("outbox:"+outboxFolder );
		mainInterface.crossbar.operate(
			new FolderOperation(Operation.MOVE, 0, uids, outboxFolder, drain));
	}

}