// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.action;

import javax.swing.Action;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

import org.columba.main.MainInterface;
import org.columba.gui.mainframe.*;
import org.columba.gui.mainframe.action.*;
import org.columba.gui.util.*;


public class GlobalActionCollection
{

    public BasicAction cutAction;
    public BasicAction copyAction;
    public BasicAction pasteAction;
    public BasicAction selectAllAction;
    public BasicAction deleteAction;
    public BasicAction newMessageAction;
    public BasicAction searchMessageAction;
    public BasicAction viewFilterToolbarAction;
    public BasicAction viewToolbarAction;
    public BasicAction viewFolderInfoAction;
    public BasicAction printSetupAction;
    public BasicAction addressbookAction;
    public BasicAction receiveSendAction;
    public BasicAction cancelAction;
    //public BasicAction useAdvancedViewerAction;



    protected MainInterface mainInterface;

    public GlobalActionCollection ( MainInterface mainInterface )
    {
        this.mainInterface = mainInterface;

        

        cutAction = new BasicAction(
				    ResourceLoader.getString("action/global","menu_edit_cut"),
				    ResourceLoader.getString("action/global","menu_edit_cut"),
				    "CUT_FOR_FUN",
                                    ImageLoader.getImageIcon("cut_small", "Cut16"),
                                    ImageLoader.getImageIcon("cut", "Cut24"),
				    'T',
				    KeyStroke.getKeyStroke( KeyEvent.VK_X, ActionEvent.CTRL_MASK )
				    );
	cutAction.setEnabled( false );



	copyAction = new BasicAction(
					ResourceLoader.getString("action/global","menu_edit_copy"),
				    ResourceLoader.getString("action/global","menu_edit_copy"),
				    "COPY_FOR_FUN",
                                    ImageLoader.getImageIcon("copy_small", "Copy16"),
                                    ImageLoader.getImageIcon("copy", "Copy24"),
				    'C',
				    KeyStroke.getKeyStroke( KeyEvent.VK_C, ActionEvent.CTRL_MASK )
				    );
        copyAction.setEnabled( false );

	pasteAction = new BasicAction(
				    ResourceLoader.getString("action/global","menu_edit_paste"),
				    ResourceLoader.getString("action/global","menu_edit_paste"),
				    "PASTE",
                                    ImageLoader.getImageIcon("paste_small", "Paste16"),
                                    ImageLoader.getImageIcon("paste", "Paste24"),
				    'V',
				    KeyStroke.getKeyStroke( KeyEvent.VK_V, ActionEvent.CTRL_MASK )
				    );
        pasteAction.setEnabled( false );

        deleteAction = new BasicAction(
        			ResourceLoader.getString("action/global","menu_edit_delete"),
				    ResourceLoader.getString("action/global","menu_edit_delete"),
				    "DELETE",
                                    ImageLoader.getImageIcon("delete_small", "Delete16"),
                                    ImageLoader.getImageIcon("delete", "Delete24"),
                                    'D',
				    KeyStroke.getKeyStroke( KeyEvent.VK_D, ActionEvent.CTRL_MASK )
				    );
        deleteAction.setEnabled( false );

        selectAllAction = new BasicAction(
        			ResourceLoader.getString("action/global","menu_edit_selectall"),
				    ResourceLoader.getString("action/global","menu_edit_selectall"),
				    
				    "SELECTALL",
				    ImageLoader.getImageIcon("selectall_small", ""),
				    ImageLoader.getImageIcon("selectall", ""),
				    'A',
				    KeyStroke.getKeyStroke( KeyEvent.VK_A, ActionEvent.CTRL_MASK )
				    );
        selectAllAction.setEnabled( false );


	newMessageAction = new BasicAction(
					ResourceLoader.getString("action/mail","menu_message_new"),
				    ResourceLoader.getString("action/mail","toolbar_message_new"),
				    ResourceLoader.getString("action/mail","tooltip_menu_message_new"),
				    "NEW_MESSAGE",
                                    ImageLoader.getImageIcon("compose_small", "ComposeMail16"),
                                    ImageLoader.getImageIcon("compose", "ComposeMail24"),
				    'N',
				    KeyStroke.getKeyStroke( KeyEvent.VK_M, ActionEvent.CTRL_MASK )
				    );
        searchMessageAction = new BasicAction(
        			ResourceLoader.getString("action/mail","menu_edit_searchmessages"),
				    ResourceLoader.getString("action/mail","menu_edit_searchmessages"),
				    
				    "SEARCH_MESSAGE",
                                    ImageLoader.getImageIcon("searchmessage_small", "Zoom16"),
                                    ImageLoader.getImageIcon("searchmessage", "Zoom24"),
				    'S',
				    KeyStroke.getKeyStroke( KeyEvent.VK_S, ActionEvent.CTRL_MASK )
				    );

        viewFilterToolbarAction = new BasicAction(
        	ResourceLoader.getString("action/mail","menu_view_showfiltertoolbar"),
				    ResourceLoader.getString("action/mail","menu_view_showfiltertoolbar"),

            "SHOW_FILTERTOOLBAR",
            null,
            null,
            '1',
            null
            );

        viewToolbarAction = new BasicAction(
        	ResourceLoader.getString("action/global","menu_view_viewtoolbar"),
			ResourceLoader.getString("action/global","menu_view_viewtoolbar"),
            "SHOW_TOOLBAR",
            null,
            null,
            '1',
            null
            );

        viewFolderInfoAction = new BasicAction(
        	ResourceLoader.getString("action/global","menu_view_showfolderinfo"),
			ResourceLoader.getString("action/global","menu_view_showfolderinfo"),
            "SHOW_FOLDERINFO",
            null,
            null,
            '1',
            null
            );

        printSetupAction = new BasicAction(
        	ResourceLoader.getString("action/global","menu_file_printsetup"),
			ResourceLoader.getString("action/global","menu_file_printsetup"),
            
            "PRINT_SETUP",
            ImageLoader.getImageIcon("printsetup_small", "History16"),
            ImageLoader.getImageIcon("printsetup", "History16"),
            '0',
            null
            );

        printSetupAction.setEnabled( false );

        addressbookAction = new BasicAction(
        	ResourceLoader.getString("action/mail","menu_preferences_addressbook"),
			ResourceLoader.getString("action/mail","menu_preferences_addressbook"),
            "ADDRESSBOOK",
            ImageLoader.getImageIcon("addressbook_small", "History16"),
            ImageLoader.getImageIcon("addressbook", "History24"),
            '0',
            null
            );


        receiveSendAction = new BasicAction(
        	ResourceLoader.getString("action/mail","menu_file_receivesend"),
        	ResourceLoader.getString("action/mail","toolbar_file_receivesend"),
        	ResourceLoader.getString("action/mail","tooltip_menu_file_receivesend"),
            "RECEIVESEND",
            ImageLoader.getImageIcon("receivesend_small", "SendMail16"),
            ImageLoader.getImageIcon("receivesend", "SendMail24"),
            '0',
            null
            );

        cancelAction = new BasicAction(
        	ResourceLoader.getString("action/global","menu_file_cancel"),
            ResourceLoader.getString("action/global","menu_file_cancel"),
            "CANCEL_ACTION",
            ImageLoader.getImageIcon("stop_small", "Stop16"),
            ImageLoader.getImageIcon("stop", "Stop24"),
            '0',
            null
            );

        cancelAction.setEnabled( false );


    }


    public void addActionListeners()
    {
        cutAction.addActionListener( mainInterface.headerTableViewer.getActionListener() );

        copyAction.addActionListener( mainInterface.headerTableViewer.getActionListener() );
        copyAction.addActionListener( mainInterface.messageViewer.getActionListener() );

        pasteAction.addActionListener( mainInterface.headerTableViewer.getActionListener() );

        deleteAction.addActionListener( mainInterface.headerTableViewer.getActionListener() );

        selectAllAction.addActionListener( mainInterface.headerTableViewer.getActionListener() );
        selectAllAction.addActionListener( mainInterface.messageViewer.getActionListener() );

        searchMessageAction.addActionListener( new MainActionListener( mainInterface ) );

        viewFilterToolbarAction.addActionListener( new MainActionListener( mainInterface ) );
        viewToolbarAction.addActionListener( new MainActionListener( mainInterface ) );
        viewFolderInfoAction.addActionListener( new MainActionListener( mainInterface ) );

        printSetupAction.addActionListener( new MainActionListener( mainInterface ) );

        addressbookAction.addActionListener( new MainActionListener( mainInterface ) );

        receiveSendAction.addActionListener( new MainActionListener( mainInterface ) );

        cancelAction.addActionListener( mainInterface.taskManager );

        //useAdvancedViewerAction.addActionListener( new MainActionListener( mainInterface ) );
    }


}













