package org.columba.gui.addressbook;

import javax.swing.*;
import java.awt.*;
import org.columba.gui.themes.*;
import javax.swing.plaf.metal.*;

import org.columba.main.*;

import org.columba.gui.addressbook.action.*;
import org.columba.gui.addressbook.menu.*;
import org.columba.gui.addressbook.util.*;

import org.columba.gui.statusbar.*;


public class AddressbookFrame extends JFrame
{
    private MainInterface mainInterface;
    private AddressbookInterface addressbookInterface;
    private AddressbookTree tree;
    private AddressbookTable table;
    
    public AddressbookFrame( MainInterface i )
    {
        super( "Addressbook" );
        mainInterface = i;
        
        
        addressbookInterface = new AddressbookInterface();
        addressbookInterface.mainInterface = i;
        addressbookInterface.frame = this;
        addressbookInterface.actionListener = new AddressbookActionListener( addressbookInterface );
        addressbookInterface.menu = new AddressbookMenu( addressbookInterface );
        
        
        
        init();
        
    }

    public void init()
    {
        
        Container c = getContentPane();
        c.setLayout( new BorderLayout() );


          //JPanel top = new JPanel();
          //top.setBorder( null );
        
          //top.setLayout( new BoxLayout( top, BoxLayout.Y_AXIS ) );

          //JPanel top = new JPanel();
          //top.setLayout( new BoxLayout( top, BoxLayout.Y_AXIS ) );

          //top.add(  addressbookInterface.menu.getMenuBar() );
        setJMenuBar( addressbookInterface.menu.getMenuBar() );
        

        AddressbookToolbar toolbar = new AddressbookToolbar( addressbookInterface );
          //toolbar.setAlignmentX( 0 );
          //top.add( toolbar );
        
        c.add( toolbar, BorderLayout.NORTH );
        
        
        tree = new AddressbookTree( addressbookInterface );
        addressbookInterface.tree = tree;
        table = new AddressbookTable( addressbookInterface );
        addressbookInterface.table = table;
        
        JSplitPane splitPane = new JSplitPane( JSplitPane.HORIZONTAL_SPLIT, tree.scrollPane, table.scrollPane );
        splitPane.setBorder( null );
        
        c.add( splitPane, BorderLayout.CENTER );

        StatusBar statusbar = new StatusBar();
        addressbookInterface.statusbar = statusbar;
        
        c.add( statusbar, BorderLayout.SOUTH );


          /*
            MetalLookAndFeel.setCurrentTheme ( new ColumbaTheme(mainInterface.mainFontName,
            mainInterface.mainFontSize) );             
            try
            {
            
            UIManager.setLookAndFeel(new javax.swing.plaf.metal.MetalLookAndFeel());
            
            }
            catch (Exception ex)
            {
            System.out.println("failure while trying to load theme: "+ex.getMessage());
            }
=======
         MetalLookAndFeel.setCurrentTheme ( mainInterface.columbaTheme );             
         try
         {
                          
             UIManager.setLookAndFeel(new javax.swing.plaf.metal.MetalLookAndFeel());
             
         }
         catch (Exception ex)
         {
             System.out.println("failure while trying to load theme: "+ex.getMessage());
         }
         
        SwingUtilities.updateComponentTreeUI(this);
>>>>>>> 1.4
        
            SwingUtilities.updateComponentTreeUI(this);
          */
                
        pack();

        setVisible(true);
    }
    
}

    
