package org.columba.gui.addressbook;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;

import org.columba.config.*;
import org.columba.gui.util.*;
import org.columba.gui.addressbook.util.*;


public class SelectAddressDialog extends JDialog implements ActionListener
{
    private AddressbookXmlConfig config;
    private JList toList;
    private JList ccList;
    private JList bccList;
    private JList addressbook;

    private JButton toButton;
    private JButton ccButton;
    private JButton bccButton;
    private JButton toRemoveButton;
    private JButton ccRemoveButton;
    private JButton bccRemoveButton;
    
    private DefaultListModel[] list, dialogList;
    

    private JButton cancelButton;
    private JButton okButton;
    
    
    public SelectAddressDialog( JFrame frame, AddressbookXmlConfig config, DefaultListModel[] list)
    {
        super( frame, true );
        
        this.config = config;
        this.list = list;

        dialogList = new DefaultListModel[3];
        

        init();
        
    }

    protected void init()
    {
        getContentPane().setLayout( new BorderLayout() );
        

        JPanel panel = new JPanel();
        panel.setLayout( new BoxLayout( panel, BoxLayout.X_AXIS ) );

        CPanel leftPanel = new CPanel( " Addressbook " );
        Vector v = config.getList();
        
        
        addressbook = new JList( v );
        addressbook.setCellRenderer( new AddressbookListRenderer() );
        
        JScrollPane scrollPane = new JScrollPane( addressbook );
        leftPanel.add( scrollPane );
        
        panel.add( leftPanel );

        JPanel middlePanel = new JPanel();
        middlePanel.setLayout( new BoxLayout( middlePanel, BoxLayout.Y_AXIS ) );

        middlePanel.add( Box.createVerticalGlue() );
        
        toButton = new JButton("To ->");
        toButton.addActionListener( this );
        toButton.setActionCommand( "TO" );
        middlePanel.add( toButton );
        toRemoveButton = new JButton("<- To");
        toRemoveButton.addActionListener( this );
        toRemoveButton.setActionCommand( "TO_REMOVE" );
        middlePanel.add( toRemoveButton );

          //middlePanel.add( Box.createRigidArea( new java.awt.Dimension(0,20) ) );
        middlePanel.add( Box.createVerticalGlue() );
        
        ccButton = new JButton("Cc ->");
        ccButton.addActionListener( this );
        ccButton.setActionCommand( "CC" );
        middlePanel.add( ccButton );
        ccRemoveButton = new JButton("<- Cc");
        ccRemoveButton.addActionListener( this );
        ccRemoveButton.setActionCommand( "CC_REMOVE" );
        middlePanel.add( ccRemoveButton );

          //middlePanel.add( Box.createRigidArea( new java.awt.Dimension(0,20) ) );
        middlePanel.add( Box.createVerticalGlue() );
        
        bccButton = new JButton("Bcc ->");
        bccButton.addActionListener( this );
        bccButton.setActionCommand( "BCC" );
        middlePanel.add( bccButton );
        bccRemoveButton = new JButton("<- Bcc");
        bccRemoveButton.addActionListener( this );
        bccRemoveButton.setActionCommand( "BCC_REMOVE" );
        middlePanel.add( bccRemoveButton );
        

        middlePanel.add( Box.createVerticalGlue() );

        panel.add( Box.createRigidArea( new java.awt.Dimension(20,0) ) );
        
        panel.add( middlePanel );
        
        CPanel rightPanel = new CPanel( " Message Header " );
          //rightPanel.setLayout( new BoxLayout( rightPanel, BoxLayout.Y_AXIS ) );

        rightPanel.add( Box.createVerticalGlue() );

        dialogList[0] = new DefaultListModel();
        toList = new JList( dialogList[0] );
        toList.setCellRenderer( new AddressbookListRenderer() );
        JScrollPane toPane = new JScrollPane( toList );
        rightPanel.add( toPane );

        rightPanel.add( Box.createRigidArea( new java.awt.Dimension(0,20) ) );
        
        dialogList[1] = new DefaultListModel();
        ccList = new JList( dialogList[1] );
        ccList.setCellRenderer( new AddressbookListRenderer() );
        JScrollPane ccPane = new JScrollPane( ccList );
        rightPanel.add( ccPane );

        rightPanel.add( Box.createRigidArea( new java.awt.Dimension(0,20) ) );
        
        dialogList[2] = new DefaultListModel();
        bccList = new JList( dialogList[2] );
        bccList.setCellRenderer( new AddressbookListRenderer() );
        JScrollPane bccPane = new JScrollPane( bccList );
        rightPanel.add( bccPane );

        for ( int i=0; i<3; i++ )
        {
            Object[] array = list[i].toArray();
            
            for ( int j=0; j<array.length; j++)
            {
                dialogList[i].addElement( array[j] );
            }
            
        }
        
        rightPanel.add( Box.createVerticalGlue() );

        panel.add( Box.createRigidArea( new java.awt.Dimension(20,0) ) );
                
        panel.add( rightPanel );

        getContentPane().add( panel, BorderLayout.CENTER );
        
        JPanel bottomPanel = new JPanel();
        cancelButton = new JButton( "Cancel" );
        cancelButton.setActionCommand("CANCEL");
        cancelButton.addActionListener( this );
        okButton = new JButton( "Ok" );
        okButton.setActionCommand("OK");
        okButton.addActionListener( this );

        bottomPanel.add( cancelButton );
        bottomPanel.add( okButton );

        
        getContentPane().add( bottomPanel, BorderLayout.SOUTH );

        setSize( new Dimension( 640, 480 ) );
        
        

        java.awt.Dimension dim = new Dimension( 640, 480 );
        
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

        setLocation(screenSize.width/2 - dim.width/2, screenSize.height/2 - dim.height/2);
    }
    

     public void actionPerformed( ActionEvent e )
        {
            String command;

            command = e.getActionCommand();

            if ( command.equals("CANCEL") )
            {
                setVisible( false );
            }
            else if ( command.equals("OK") )
            {
                setVisible( false );

                for ( int i=0; i<3; i++ )
                {
                    Object[] array = dialogList[i].toArray();
                    list[i].clear();
                    
                    for ( int j=0; j<array.length; j++)
                    {
                        list[i].addElement( array[j] );
                    }
                              
                }       
            }
            else  if ( command.equals("TO") )
            {
                int[] array = addressbook.getSelectedIndices();
                ListModel model = addressbook.getModel();
                AdapterNode node;
                
                for ( int j=0; j<array.length; j++)
                    {
                        node = (AdapterNode) model.getElementAt( array[j] );
                        
                        dialogList[0].addElement( node );
                    }
            }
            else  if ( command.equals("CC") )
            {
                int[] array = addressbook.getSelectedIndices();
                ListModel model = addressbook.getModel();
                AdapterNode node;
                
                for ( int j=0; j<array.length; j++)
                    {
                        node = (AdapterNode)  model.getElementAt( array[j] );
                        
                        dialogList[1].addElement( node );
                    }
            }
            else  if ( command.equals("BCC") )
            {
                int[] array = addressbook.getSelectedIndices();
                ListModel model = addressbook.getModel();
                AdapterNode node;
                
                for ( int j=0; j<array.length; j++)
                    {
                        node = (AdapterNode) model.getElementAt( array[j] );
                        
                        dialogList[2].addElement( node );
                    }
            }
            else  if ( command.equals("TO_REMOVE") )
            {
                Object[] array = toList.getSelectedValues();
                for ( int j=0; j<array.length; j++)
                    {
                        dialogList[0].removeElement( array[j] );
                    }
            }
            else  if ( command.equals("CC_REMOVE") )
            {
               Object[] array = ccList.getSelectedValues();
                for ( int j=0; j<array.length; j++)
                    {
                        dialogList[1].removeElement( array[j] );
                    }
            }
            else  if ( command.equals("BCC_REMOVE") )
            {
                Object[] array = bccList.getSelectedValues();
                for ( int j=0; j<array.length; j++)
                    {
                        dialogList[2].removeElement( array[j] );
                    }
               
            }
            
            
                
        }
    
        
}
