package org.columba.gui.addressbook.action;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import org.columba.gui.addressbook.*;
import org.columba.gui.addressbook.util.*;
import org.columba.main.*;
import org.columba.gui.action.*;
import org.columba.config.*;
import org.columba.gui.util.*;



public class AddressbookActionListener implements ActionListener
{
    public BasicAction cutAction;
    public BasicAction copyAction;
    public BasicAction pasteAction;
    public BasicAction selectAllAction;
    public BasicAction deleteAction;
    public BasicAction closeAction;
    public BasicAction addContactAction;
    public BasicAction addGroupAction;
    public BasicAction removeAction;
    public BasicAction propertiesAction;


    private AddressbookInterface addressbookInterface;
    private MainInterface mainInterface;

    public AddressbookActionListener( AddressbookInterface i )
    {
        this.addressbookInterface = i;

        mainInterface = addressbookInterface.mainInterface;

        initAction();

    }

    public void initAction()
    {
        

        cutAction = new BasicAction(
				    ResourceLoader.getString("action/global","menu_edit_cut"),
				    ResourceLoader.getString("action/global","menu_edit_cut"),
				    "CUT_FOR_FUN",
                                    ImageLoader.getImageIcon("cut_small", "Cut16"),
                                    ImageLoader.getImageIcon("cut", "Cut24"),
				    'T',
				    KeyStroke.getKeyStroke( KeyEvent.VK_X, ActionEvent.CTRL_MASK )
				    );
	cutAction.setEnabled( false );



	copyAction = new BasicAction(
				    ResourceLoader.getString("action/global","menu_edit_copy"),
				    ResourceLoader.getString("action/global","menu_edit_copy"),
				    "COPY_FOR_FUN",
                                    ImageLoader.getImageIcon("copy_small", "Copy16"),
                                    ImageLoader.getImageIcon("copy", "Copy24"),
				    'C',
				    KeyStroke.getKeyStroke( KeyEvent.VK_C, ActionEvent.CTRL_MASK )
				    );
        copyAction.setEnabled( false );

	pasteAction = new BasicAction(
					ResourceLoader.getString("action/global","menu_edit_paste"),
				    ResourceLoader.getString("action/global","menu_edit_paste"),
				    
				    "PASTE",
                                    ImageLoader.getImageIcon("paste_small", "Paste16"),
                                    ImageLoader.getImageIcon("paste", "Paste24"),
				    'V',
				    KeyStroke.getKeyStroke( KeyEvent.VK_V, ActionEvent.CTRL_MASK )
				    );
        pasteAction.setEnabled( false );

        deleteAction = new BasicAction(
				    ResourceLoader.getString("action/global","menu_edit_delete"),
				    ResourceLoader.getString("action/global","menu_edit_delete"),
				    "DELETE",
                                    ImageLoader.getImageIcon("delete_small","Delete16"),
                                    ImageLoader.getImageIcon("delete", "Delete24"),
                                    'D',
				    KeyStroke.getKeyStroke( KeyEvent.VK_D, ActionEvent.CTRL_MASK )
				    );
        deleteAction.setEnabled( false );

        selectAllAction = new BasicAction(
				    ResourceLoader.getString("action/global","menu_edit_selectall"),
				    ResourceLoader.getString("action/global","menu_edit_selectall"),
				    "SELECTALL",
				    null,null,
				    'A',
				    KeyStroke.getKeyStroke( KeyEvent.VK_A, ActionEvent.CTRL_MASK )
				    );
        selectAllAction.setEnabled( false );

        closeAction = new BasicAction(
        			ResourceLoader.getString("action/global","menu_file_close"),
				    ResourceLoader.getString("action/global","menu_file_close"),
				   
				    "CLOSE",
                                    ImageLoader.getImageIcon("close_small", "Home16"),
                                    ImageLoader.getImageIcon("close", "Home24"),
				    '0',
				    null
				    );
        closeAction.setEnabled( true );
        closeAction.addActionListener( this );

        addContactAction = new BasicAction(
        			ResourceLoader.getString("action/addressbook","menu_file_addcontact"),
				    ResourceLoader.getString("action/addressbook","menu_file_addcontact"),
				    "ADDCONTACT",
                                    ImageLoader.getImageIcon("contact_small", "Add16"),
                                    ImageLoader.getImageIcon("contact", "Add24"),
				    '0',
				    null
				    );
        addContactAction.setEnabled( true );
        addContactAction.addActionListener( this );

        addGroupAction = new BasicAction(
        			ResourceLoader.getString("action/addressbook","menu_file_addgroup"),
        			ResourceLoader.getString("action/addressbook","menu_file_addgroup"),
        			
				    
				    "ADDGROUP",
                                    ImageLoader.getImageIcon("group_small", "Bookmarks16"),
                                    ImageLoader.getImageIcon("group", "Bookmarks24"),
				    '0',
				    null
				    );
        addGroupAction.setEnabled( true );
        addGroupAction.addActionListener( this );

        removeAction = new BasicAction(
        			ResourceLoader.getString("action/addressbook","menu_file_remove"),
        			ResourceLoader.getString("action/addressbook","menu_file_remove"),
				    
				    "REMOVE",
                                    ImageLoader.getImageIcon("delete_small", "Delete16"),
                                    ImageLoader.getImageIcon("delete", "Delete24"),
				    '0',
				    null
				    );
        removeAction.setEnabled( true );
        removeAction.addActionListener( this );

        propertiesAction = new BasicAction(
        			ResourceLoader.getString("action/addressbook","menu_file_properties"),
        			ResourceLoader.getString("action/addressbook","menu_file_properties"),
				    
				    "PROPERTIES",
                                    ImageLoader.getImageIcon("properties_small", "Edit16"),
                                    ImageLoader.getImageIcon("properties", "Edit24"),
				    '0',
				    null
				    );
        propertiesAction.setEnabled( true );
        propertiesAction.addActionListener( this );



    }

    public void actionPerformed( ActionEvent e )
    {
        String command;

        command = e.getActionCommand();

        if ( command.equals( closeAction.getActionCommand() ) )
        {
            addressbookInterface.frame.setVisible( false );
        }
        else if ( command.equals( addContactAction.getActionCommand() ) )
        {
            EditContactDialog dialog = new EditContactDialog(  addressbookInterface, null );
            //dialog.showDialog();

        }
        else if ( command.equals( addGroupAction.getActionCommand() ) )
        {
            AddressbookXmlConfig config = addressbookInterface.mainInterface.config.getAddressbookConfig();

            EditGroupDialog dialog = new EditGroupDialog(  addressbookInterface, config, null );
            //dialog.showDialog();

        }
        else if ( command.equals( removeAction.getActionCommand() ) )
        {
            addressbookInterface.table.remove();
        }
        else if ( command.equals( propertiesAction.getActionCommand() ) )
        {
            AdapterNode node = addressbookInterface.table.getPropertiesNode();

            if ( node == null ) return;

            String name = node.getName();

            if ( name.equals("contact") )
            {
                EditContactDialog dialog = new EditContactDialog(  addressbookInterface, node );
                //dialog.showDialog();
            }
            else
            {
                AddressbookXmlConfig config = addressbookInterface.mainInterface.config.getAddressbookConfig();

                EditGroupDialog dialog = new EditGroupDialog(  addressbookInterface, config, node );
                //dialog.showDialog();
            }



        }


    }

}

