// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.




package org.columba.gui.addressbook.menu;

import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;

import org.columba.gui.mainframe.action.*;
import org.columba.gui.statusbar.*;

import org.columba.gui.mainframe.*;
import org.columba.main.*;
import org.columba.message.*;
import org.columba.pop3.*;
import org.columba.config.*;
import org.columba.gui.action.*;
import org.columba.gui.util.CMenuItem;
import org.columba.gui.util.*;


import org.columba.gui.addressbook.*;

public class AddressbookMenu
{
    JMenuBar menuBar;
   

    private AddressbookInterface addressbookInterface;
    private MouseAdapter handler;

    private JMenu fetchMessageSubmenu;
    private JMenu manageSubmenu;
    private JMenu sortSubMenu;


    public AddressbookMenu( AddressbookInterface i )
        {
	    this.addressbookInterface = i;


               
            init();
        }



            // create the menu
    private void init()
        {
              //handler = mainInterface.statusBar.getHandler();

            JMenu menu,subMenu;
            JMenuItem menuItem;
            JRadioButtonMenuItem rbMenuItem;
            ButtonGroup group;




            menuBar = new JMenuBar();


            menu = new JMenu( ResourceLoader.getString("action/global","menu_file") );
	    menu.setMnemonic(KeyEvent.VK_F);
	    menuBar.add(menu);


            menuItem = new JMenuItem( addressbookInterface.actionListener.addContactAction );
            menuItem.addMouseListener( handler );
	    menu.add(menuItem);

            menuItem = new JMenuItem( addressbookInterface.actionListener.addGroupAction );
            menuItem.addMouseListener( handler );
	    menu.add(menuItem);

            menuItem = new JMenuItem( "New Addressbook..." );
            menuItem.setEnabled(false);
	    menu.add(menuItem);

            menu.addSeparator();

            menuItem = new JMenuItem( "New Directory..." );
            menuItem.setEnabled(false);
	    menu.add(menuItem);

            menu.addSeparator();

            menuItem = new JMenuItem( addressbookInterface.actionListener.removeAction );
            menuItem.addMouseListener( handler );
	    menu.add(menuItem);

            menu.addSeparator();

            menuItem = new CMenuItem( addressbookInterface.actionListener.closeAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );


            menu = new JMenu( ResourceLoader.getString("action/global","menu_edit") );
	    menu.setMnemonic(KeyEvent.VK_E);
            menuBar.add(menu);


	    menuItem = new CMenuItem( addressbookInterface.actionListener.cutAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

	    menuItem = new CMenuItem( addressbookInterface.actionListener.copyAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

	    menuItem = new CMenuItem( addressbookInterface.actionListener.pasteAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );


            menuItem = new CMenuItem( addressbookInterface.actionListener.deleteAction );
            menuItem.addMouseListener( handler );
            menu.add( menuItem );


	    menuItem = new CMenuItem( addressbookInterface.actionListener.selectAllAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menu.addSeparator();

            menuItem = new JMenuItem( "Search for..." );
            menuItem.setEnabled(false);
	    menu.add(menuItem);

            menu.addSeparator();

            menuItem = new JMenuItem( addressbookInterface.actionListener.propertiesAction );
            menuItem.addMouseListener( handler );
	    menu.add(menuItem);

            menu = new JMenu( ResourceLoader.getString("action/global","menu_view") );
	    menu.setMnemonic(KeyEvent.VK_V);
            menuBar.add(menu);




            sortSubMenu = new JMenu( "Sort by..." );
            sortSubMenu.setEnabled( false );
            menu.add( sortSubMenu );





            menu = new JMenu("Preferences");
            menu.setMnemonic('P');
            menuBar.add(menu);

              /*
                JCheckBoxMenuItem cbMenuItem = new JCheckBoxMenuItem( addressbookInterface.viewToolbarAction );
                cbMenuItem.addActionListener( addressbookInterface.actionListener );
                cbMenuItem.setActionCommand("VIEW_TOOLBAR");
                if ( addressbookInterface.mainInterface.windowItem.getShowToolbar().equals("true")  )
                cbMenuItem.setSelected( true );
                menu.add( cbMenuItem );
              */


	    menuItem = new JMenuItem( ResourceLoader.getString("action/global","menu_edit_preferences") ,
				      ImageLoader.getImageIcon("org/columba/images/Preferences16.gif") );
	    menuItem.setMnemonic(KeyEvent.VK_P);
            menuItem.setEnabled( false );
            menu.add(menuItem);



            menu = new JMenu("Help");
            menu.setMnemonic('H');
            menuBar.add(menu);

            menuItem = new JMenuItem("About", ImageLoader.getImageIcon("org/columba/images/About16.gif") );

            menuItem.setActionCommand("ABOUT");
            menu.add(menuItem);
            menuItem = new JMenuItem("Help", ImageLoader.getImageIcon("org/columba/images/Help16.gif") );
            menuItem.setEnabled(false);
            menu.add(menuItem);


        }

    public JMenuBar getMenuBar()
        {
            return menuBar;

        }


    public void updateSortMenu()
    {
    }


}
