package org.columba.gui.addressbook.util;

import java.awt.*;
import javax.swing.*;

import org.columba.config.*;
import org.columba.gui.util.ImageLoader;



public class AddressbookListRenderer extends JLabel implements ListCellRenderer
{
    
    ImageIcon image1 = ImageLoader.getImageIcon("contact_small","org/columba/images/Add16.gif");
    ImageIcon image2 = ImageLoader.getImageIcon("group_small","org/columba/images/Bookmarks16.gif");
    
    public AddressbookListRenderer()
    {
        setOpaque(true);
        setHorizontalAlignment(LEFT);
        setVerticalAlignment(CENTER);
    }
    public Component getListCellRendererComponent (
                                                    JList list,
                                                    Object value,
                                                    int index,
                                                    boolean isSelected,
                                                    boolean cellHasFocus)
    {
        if (isSelected) {
            setBackground(list.getSelectionBackground());
            setForeground(list.getSelectionForeground());
        } else {
            setBackground(list.getBackground());
            setForeground(list.getForeground());
        }

        AdapterNode node = (AdapterNode) value;
            
        if ( node.getName().equals("contact") )
        {
            AdapterNode displayName = node.getChild("displayname");
            AdapterNode address = node.getChild("address");
            
            String test = displayName.getValue()+" <"+address.getCDATAValue()+">";
            
            setText( test );
            
            setIcon( image1 );
        }
        else
        {
            AdapterNode name = node.getChild("name");
            if ( name != null )
                setText( name.getValue() );
            
            setIcon( image2 );
        }
                
                
        return this;
    }
} 
