package org.columba.gui.addressbook.util;

import javax.swing.*;
import javax.swing.table.*;

import org.columba.config.*;


public class AddressbookTableModel extends AbstractTableModel
{
    private AdapterNode node;
        
    private String[] columnNames = {"Display Name",
                                    "Address",
                                    "First Name",
                                    "Last Name"
                                    };

    private int count;
    
    public AddressbookTableModel()
    {
        super();
        count=0;
                
    }

    public void setNode( AdapterNode n )
    {
        node = n.getChild("list");
        
        count = node.getChildCount();
                
    }

    public void update()
    {
        count = node.getChildCount();
        
        fireTableDataChanged();
    }
    
    public int getColumnCount()
    {
        return columnNames.length;
    }
    
    public int getRowCount()
    {        
        return count;
    }
    
    public String getColumnName(int col)
    {
        String s = (String) columnNames[col];
            
        return s;
    }
    
    protected int getColumnNumber(String str)
    {
        for ( int i=0; i<getColumnCount(); i++)
        {
            if ( str.equals( getColumnName(i) ) )
            {
                return i;
            }
        }
        return -1;
    }
    
    
    public Object getValueAt(int row, int col)
    {
        AdapterNode contact;

        contact = node.getChild(row);
        if ( contact == null ) return "";

        AdapterNode child = null;        
        String str = new String("");

        if ( contact.getName().equals("contact") )
        {
            
            if ( col == 0 )
            {
                child = contact.getChild("displayname");
                
                str = child.getValue();
            }
            else if ( col == 1 )
            {
                child = contact.getChild("address");
                
                str = child.getCDATAValue();
            } 
            else if ( col == 2)
            {
                child = contact.getChild("firstname");
                str = child.getValue();
            }
            if ( col == 3 )
            {
                child = contact.getChild("lastname");
                str = child.getValue();
            }
        }
        
        else
        {
            if ( col == 0 )
            {
                child = contact.getChild("name");
                
                str = child.getValue();
            } 
        }
         
         
        
          
        
        return str;
    }

    
    public Class getColumnClass(int c)
        {
            return getValueAt(0, c).getClass();
        }
        
}







