package org.columba.gui.addressbook.util;


import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

import java.awt.*;
import java.awt.event.*;

import org.columba.gui.util.*;
import org.columba.config.*;
import org.columba.gui.addressbook.*;


public class EditContactDialog implements ActionListener, DocumentListener
{
    private JDialog dialog;

    private JLabel firstNameLabel;
    private JTextField firstNameTextField;
    private JLabel addressLabel;
    private JTextField addressTextField;
    private JLabel lastNameLabel;
    private JTextField lastNameTextField;

    private JLabel displayNameLabel;
    private JTextField displayNameTextField;
    private JButton displayButton;


    private JButton okButton;
    private JButton cancelButton;
    private JButton helpButton;

    private AddressbookInterface addressbookInterface;
    private AdapterNode contactNode;

    private AddressbookXmlConfig config;


    public EditContactDialog( AddressbookInterface i, AdapterNode contactNode )
    {
        dialog = DialogStore.getDialog();

        this.addressbookInterface = i;
        this.contactNode = contactNode;

        config = addressbookInterface.mainInterface.config.getAddressbookConfig();

        init();

    }

    public EditContactDialog(  AddressbookXmlConfig config, AdapterNode contactNode )
    {
        dialog = DialogStore.getDialog();

        //this.addressbookXmlConfig = config;
        this.contactNode = contactNode;

        this.config = config;

        init();

    }

    protected void init()
    {
        JPanel panel = new JPanel();
        panel.setBorder( BorderFactory.createEmptyBorder( 10,0,0,0 ) );
        panel.setLayout( new BorderLayout() );
          //panel.setLayout( new BoxLayout( panel, BoxLayout.Y_AXIS ) );

        //panel.add( Box.createRigidArea( new java.awt.Dimension(0,10) ) );


        JPanel displayNamePanel = new JPanel();
          //Border border = new BeveledBorder(5,5,5,5);
          //displayNamePanel.setBorder( BorderFactory.createTitledBorder( border, " Display Name " ) );

        displayNamePanel.setLayout( new BoxLayout( displayNamePanel, BoxLayout.X_AXIS ) );

	displayNamePanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
	displayNameLabel = new JLabel ("Display Name:");
        displayNamePanel.add( displayNameLabel );

        displayNamePanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
	displayNamePanel.add( Box.createHorizontalGlue() );

	displayNameTextField = new JTextField ( 26 );
        //displayNameTextField.setMaximumSize( new java.awt.Dimension( 150, 25 ) );

	displayNamePanel.add( displayNameTextField );

        displayNamePanel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );

        displayButton = new JButton("Create");
        displayButton.setActionCommand("CREATE");
        displayButton.addActionListener( this );

        displayNamePanel.add( displayButton );

	displayNamePanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );

	panel.add( displayNamePanel, BorderLayout.NORTH );


        //panel.add( Box.createRigidArea( new java.awt.Dimension(0,10) ) );


        CPanel identityPanel = new CPanel(" Identity ");

        JPanel firstNamePanel = new JPanel();
        firstNamePanel.setLayout( new BoxLayout( firstNamePanel, BoxLayout.X_AXIS ) );
	firstNamePanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
	firstNameLabel = new JLabel ("First Name:");
        firstNamePanel.add( firstNameLabel );

	firstNamePanel.add( Box.createHorizontalGlue() );
        firstNamePanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );

	firstNameTextField = new JTextField ( 26);
        //firstNameTextField.setMaximumSize( new java.awt.Dimension( 150, 25 ) );

	firstNamePanel.add( firstNameTextField );

	firstNamePanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );

	identityPanel.add( firstNamePanel );

	identityPanel.add( Box.createRigidArea( new java.awt.Dimension(0,10) ) );


	JPanel lastNamePanel = new JPanel();
	lastNamePanel.setLayout( new BoxLayout( lastNamePanel, BoxLayout.X_AXIS ) );
	lastNamePanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
	lastNameLabel = new JLabel ("Last Name:");
	lastNamePanel.add( lastNameLabel );
        lastNamePanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
	lastNamePanel.add( Box.createHorizontalGlue() );
        lastNameTextField = new JTextField ( 26 );
        //lastNameTextField.setMaximumSize( new java.awt.Dimension( 150,25) );

	lastNamePanel.add( lastNameTextField );
	lastNamePanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );


        identityPanel.add( lastNamePanel );

	identityPanel.add( Box.createRigidArea( new java.awt.Dimension(0,10) ) );


	JPanel addressPanel = new JPanel();
	addressPanel.setLayout( new BoxLayout( addressPanel, BoxLayout.X_AXIS ) );
	addressPanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
        addressLabel = new JLabel ( "E-Message:");
	addressPanel.add( addressLabel );
        addressPanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
	addressPanel.add( Box.createHorizontalGlue() );
        addressTextField = new JTextField ( 26 );
        //addressTextField.setMaximumSize( new java.awt.Dimension( 150,25) );
        addressTextField.getDocument().addDocumentListener( this );


	addressPanel.add( addressTextField );
	addressPanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );

        identityPanel.add( addressPanel );

        panel.add( identityPanel, BorderLayout.CENTER );

        Container c = dialog.getContentPane();
        c.setLayout( new BorderLayout() );


        c.add( panel, BorderLayout.CENTER );


        JPanel bottom = new JPanel();
        bottom.setBorder( BorderFactory.createEmptyBorder( 10,10,10,10 ) );

	bottom.setLayout( new javax.swing.BoxLayout(bottom, javax.swing.BoxLayout.X_AXIS) );


	bottom.add( javax.swing.Box.createRigidArea( new java.awt.Dimension(10,0) ) );

	helpButton = new JButton("Help");
	helpButton.setEnabled( false );
	bottom.add( helpButton );

	bottom.add( javax.swing.Box.createHorizontalGlue() );

	cancelButton = new JButton("Cancel");
	cancelButton.addActionListener( this  );
	cancelButton.setActionCommand("CANCEL");
	bottom.add( cancelButton );

	bottom.add( javax.swing.Box.createRigidArea( new java.awt.Dimension(20,0) ) );

	okButton = new JButton("Ok");
	okButton.addActionListener( this  );
	okButton.setActionCommand("OK");
        okButton.setEnabled( false );
	bottom.add( okButton );

	bottom.add( javax.swing.Box.createRigidArea( new java.awt.Dimension(10,0) ) );

        c.add( bottom, BorderLayout.SOUTH );


        dialog.setSize( new Dimension( 400, 400 ) );
        dialog.pack();

        //java.awt.Dimension dim = new Dimension( 400, 400 )  ;
        java.awt.Dimension dim = dialog.getSize() ;

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

        dialog.setLocation(screenSize.width/2 - dim.width/2, screenSize.height/2 - dim.height/2);

        if ( contactNode != null )
        {
            ContactItem item = config.getContactItem( contactNode );

            firstNameTextField.setText( item.getFirstName() );
            lastNameTextField.setText( item.getLastName());
            addressTextField.setText( item.getAddress());
            displayNameTextField.setText( item.getDisplayName() );

        }

	dialog.setVisible(true);
    }


    public void actionPerformed( ActionEvent e )
    {
        String command;

        command = e.getActionCommand();

        if ( command.equals("CANCEL") )
        {
            if ( addressbookInterface == null )
            {
                // EditContactDialog was instantiated by MessageHeader
                // remove contact

                contactNode.remove();
            }

            dialog.setVisible( false );
        }
        else if ( command.equals("OK") )
        {
            if ( contactNode != null )
            {
                  // edit contact
                if ( contactNode != null )
                {
                    ContactItem item = config.getContactItem( contactNode );

                    item.setFirstName( firstNameTextField.getText() );
                    item.setLastName( lastNameTextField.getText() );
                    item.setAddress( addressTextField.getText());
                    item.setDisplayName( displayNameTextField.getText() );
                }

            }
            else
            {
                  // create new contact

                AddressbookXmlConfig config = addressbookInterface.mainInterface.config.getAddressbookConfig();

                String firstName = firstNameTextField.getText();
                String lastName = lastNameTextField.getText();
                String address = addressTextField.getText();
                String displayName = displayNameTextField.getText();

                AdapterNode node = config.addContact( displayName, firstName, lastName, address );


            }

            if ( addressbookInterface != null )
            {
                addressbookInterface.table.update();
            }

            dialog.setVisible( false );
        }
        else if ( command.equals("CREATE") )
        {
            String firstName = firstNameTextField.getText();
            String lastName = lastNameTextField.getText();
            String address = addressTextField.getText();

            String displayName = firstName+" "+lastName;
            if ( displayName.length() <= 1 ) displayName = address;

            displayNameTextField.setText( displayName );
        }

    }

    public void showDialog()
    {
        dialog.setVisible(true);
    }

    public void insertUpdate(DocumentEvent e)
    {
        update();
    }

    public void removeUpdate(DocumentEvent e)
    {
        update();
    }

    public void changedUpdate(DocumentEvent e)
    {
        update();
    }

    public void update()
    {
        String str;

        str =  addressTextField.getText();

        if ( str.length()==0 )
            okButton.setEnabled( false );
        else
            okButton.setEnabled( true );

    }

}
