package org.columba.gui.addressbook.util;

import javax.swing.*;
import javax.swing.table.*;
import java.util.Vector;

import org.columba.config.*;
import org.columba.gui.addressbook.*;


public class GroupTableModel extends AbstractTableModel
{
    private AdapterNode node;
    
    private Vector groupList;
    
    private String[] columnNames = {"Display Name",
                                    "Address",
                                    "First Name",
                                    "Last Name"
                                    };
    

    private int count;

    private AddressbookXmlConfig config;
    
    public GroupTableModel( AddressbookXmlConfig config)
    {
        super();
        this.config = config;
        
        count=0;
        groupList = new Vector();
        
        
    }

    public void setNode( AdapterNode n )
    {
        node = n;
                
        update();
        
    }

    public void update()
    {
        AdapterNode listNode = node.getChild("grouplist");
        count = listNode.getChildCount();

        GroupItem item = config.getGroupItem( node );
        if ( item != null ) System.out.println("item found") ;
        
        Vector ve = item.getListNodes();
        int uid;
        AdapterNode n, itemNode;
        
        groupList.clear();
        
        for ( int i=0; i<ve.size(); i++ )
        {
            n = ( AdapterNode ) ve.get(i);
            uid = (new Integer( n.getValue() ) ).intValue();
            itemNode = config.getNode( uid );
            groupList.addElement( itemNode );
        }
        
        fireTableDataChanged();
    }
    
    public int getColumnCount()
    {
        return columnNames.length;
    }
    
    public int getRowCount()
    {        
        return count;
    }
    
    public String getColumnName(int col)
    {
        String s = (String) columnNames[col];
            
        return s;
    }
    
    protected int getColumnNumber(String str)
    {
        for ( int i=0; i<getColumnCount(); i++)
        {
            if ( str.equals( getColumnName(i) ) )
            {
                return i;
            }
        }
        return -1;
    }
    
    
    public Object getValueAt(int row, int col)
    {
        AdapterNode contact;

        contact = (AdapterNode) groupList.get(row);
        if ( contact == null ) return "";

        AdapterNode child = null;        
        String str = new String("");

        if ( contact.getName().equals("contact") )
        {
            if ( col == 0 )
            {
                child = contact.getChild("displayname");
                
                str = child.getValue();
            }
            else if ( col == 1 )
            {
                child = contact.getChild("address");
                
                str = child.getCDATAValue();
            } 
            else if ( col == 2)
            {
                child = contact.getChild("firstname");
                str = child.getValue();
            }
            if ( col == 3 )
            {
                child = contact.getChild("lastname");
                str = child.getValue();
            }
              /*
                
            if ( col == 1 )
            {
                child = contact.getChild("firstname");
                
                str = child.getValue();
            } 
            else if ( col == 0 )
            {
                child = contact.getChild("lastname");
                str = child.getValue();
            }
            if ( col == 2 )
            {
                child = contact.getChild("address");
                str = child.getCDATAValue();
            }
              */
        }
                
        return str;
    }

    
    public Class getColumnClass(int c)
        {
            return getValueAt(0, c).getClass();
        }
        
}







