/*
 * (c) Copyright 2001 MyCorporation.
 * All Rights Reserved.
 */
package org.columba.gui.addressbook.util;

import org.columba.config.*;

import  java.util.Vector;



/**
 * @version 	1.0
 * @author
 */
public class ListParser
{
	
	
	public ListParser()
	{}
	
	public static Vector parseVector( AddressbookXmlConfig config, AddressbookListModel listModel )
	{
		Vector result = new Vector();
		
		int size = listModel.getSize();

            for( int i = 0; i<size; i++ )
            {
                AdapterNode child = (AdapterNode) listModel.get(i);

                if ( child.getName().equals("contact") )
                {
                      // contact item

                    ContactItem contactItem = config.getContactItem( child );
                    String address = contactItem.getAddress();
                    
                    result.add( address );

                    System.out.println("added address fround contact: "+address);
                    
                }
                else
                {
                      // group item

                    GroupItem item = config.getGroupItem( child );
                    if ( item != null ) System.out.println("item found") ;
                    
                    Vector v = item.getListNodes();
                    int uid;
                    AdapterNode n, itemNode;

                                        
                    for ( int j=0; j<v.size(); j++ )
                    {
                        n = ( AdapterNode ) v.get(j);
                        uid = Integer.parseInt( n.getValue() );
                        itemNode = config.getNode( uid );
                        ContactItem contactItem = config.getContactItem( itemNode );
                        String address = contactItem.getAddress();
                        
                        result.add( address );

                        System.out.println("added address fround group: "+address);
                    }
                }
                
                
                
                
                
            }
            
            return result;
	}
	
	public static String parse( AddressbookXmlConfig config, AddressbookListModel listModel )
	{	
		 
		 
		StringBuffer output = new StringBuffer();
		
		int size = listModel.getSize();

            for( int i = 0; i<size; i++ )
            {
                AdapterNode child = (AdapterNode) listModel.get(i);

                if ( child.getName().equals("contact") )
                {
                      // contact item

                    ContactItem contactItem = config.getContactItem( child );
                    String address = contactItem.getAddress();
                    
                    output.append( address );

                    System.out.println("added address fround contact: "+address);
                    
                }
                else
                {
                      // group item

                    GroupItem item = config.getGroupItem( child );
                    if ( item != null ) System.out.println("item found") ;
                    
                    Vector v = item.getListNodes();
                    int uid;
                    AdapterNode n, itemNode;

                                        
                    for ( int j=0; j<v.size(); j++ )
                    {
                        n = ( AdapterNode ) v.get(j);
                        uid = Integer.parseInt( n.getValue() );
                        itemNode = config.getNode( uid );
                        ContactItem contactItem = config.getContactItem( itemNode );
                        String address = contactItem.getAddress();
                        
                        output.append( address );

                        System.out.println("added address fround group: "+address);
                    }
                }
                
                
                
                if ( i != size-1 ) output.append( ",");
                
            }
            
            
            return output.toString();
	}
	
}
