package org.columba.gui.attachment.action;

import org.columba.gui.attachment.*;
import org.columba.folder.*;
import org.columba.main.*;
import org.columba.gui.action.*;
import org.columba.gui.util.*;


import java.awt.*;
import java.awt.event.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class AttachmentActionListener implements ActionListener
{
    private MainInterface mainInterface;
    private AttachmentViewer attachmentViewer;

    public BasicAction saveAsAction;
    public BasicAction openAction;
    public BasicAction openWithAction;
    public BasicAction viewHeaderAction;

    public AttachmentActionListener( MainInterface mainInterface, AttachmentViewer attachmentViewer )
    {
        this.mainInterface = mainInterface;
        this.attachmentViewer = attachmentViewer;

        initActions();
    }

    protected void initActions()
    {
            openAction = new BasicAction( "Open",
                                          "Open this File with the designated program",
                                          "OPEN",
                                          ImageLoader.getImageIcon("open16", "Open16"),
                                          ImageLoader.getImageIcon("open24", "Open24"),
                                          0,
                                          null);

            openAction.addActionListener( this );

            openWithAction = new BasicAction( "Open with",
                                            "Open this File with a Program to choose",
                                            "OPEN_WITH",
                                              ImageLoader.getImageIcon("open16", "Open16"),
                                              ImageLoader.getImageIcon("open24", "Open24"),
                                            0,
                                            null);

            openWithAction.addActionListener( this );

            saveAsAction = new BasicAction( "Save As ...",
                                            "Save this Attachment to disk",
                                            "SAVE_AS",
                                            ImageLoader.getImageIcon("saveas16", "SaveAs16"),
                                          ImageLoader.getImageIcon("saveas24", "SaveAs24"),
                                            0,
                                            null);

            saveAsAction.addActionListener( this );


            viewHeaderAction = new BasicAction( "View Mime-Header",
                                                "View the Mime-Header of this Attachment",
                                                "VIEW_HEADER",
                                                ImageLoader.getImageIcon("search16", "Search16"),
                                                ImageLoader.getImageIcon("search24", "Search24"),
                                                0,
                                                null);

            viewHeaderAction.addActionListener( this );


    }

    protected int[] getSelection()
    {
        return attachmentViewer.getSelection();
    }

    protected Folder getFolder()
    {
        return attachmentViewer.getFolder();
    }

    protected Object getUid()
    {
        return attachmentViewer.getUid();
    }

    public void actionPerformed( ActionEvent e )
    {

        if( e.getActionCommand().equals("SAVE_AS") )
        {

            int[] selection = getSelection();
            mainInterface.crossbar.operate(
                new GuiOperation(Operation.ATTACHMENT, Operation.SAVE_AS, 4, getFolder(), getUid(), selection[0]) );


        }
        else if( e.getActionCommand().equals("OPEN_WITH") )
        {

            int[] selection;

            selection = getSelection();

            mainInterface.crossbar.operate(
                        new GuiOperation(Operation.ATTACHMENT, Operation.OPEN_WITH, 4, getFolder(), getUid(), selection[0]) );

        }
        else if( e.getActionCommand().equals("OPEN") )
        {
             int[] selection;

            selection = getSelection();

            mainInterface.crossbar.operate(
                        new GuiOperation(Operation.ATTACHMENT, Operation.OPEN, 4, getFolder(), getUid(), selection[0]) );


        }

    }


}