package org.columba.gui.composer.util;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import java.awt.dnd.*;
import java.awt.datatransfer.*;

import java.io.*;
import javax.swing.JTree;


import org.columba.main.*;
import org.columba.config.*;
import org.columba.gui.util.ImageLoader;


public class IdentityInfoPanel extends JPanel
{
    private JLabel label;
    private int exists;
    private int unseen;
    private int recent;

    private ImageIcon image1;
    private ImageIcon image2;
    private ImageIcon image3;
    private ImageIcon image4;
    private ImageIcon image5;
    private ImageIcon image6;
    
    public IdentityInfoPanel( )
    {
        
        image1 = ImageLoader.getImageIcon("pop", "Host24");
        image2 = ImageLoader.getImageIcon("imap", "WebComponent24" );
       
        initComponents();
    }

    public void initComponents()
    {
        removeAll();

        GridBagLayout gridbagLayout = new GridBagLayout();
        setLayout( gridbagLayout );
        GridBagConstraints gridbagConstraints = new GridBagConstraints();
        
        setLayout( gridbagLayout );
        
        setBackground( UIManager.getColor("controlShadow") );

        

        gridbagConstraints.gridwidth = GridBagConstraints.RELATIVE;
        gridbagConstraints.gridx = 0;
        gridbagConstraints.weightx = 0.5;
        Box box = Box.createHorizontalBox();
        gridbagLayout.setConstraints( box, gridbagConstraints );
        add( box );

          //Font font = mainInterface.columbaTheme.getControlTextFont();
          //font = font.deriveFont( font.BOLD );
        Font font = UIManager.getFont("Label.font");
        int size = font.getSize();
        font = font.deriveFont( font.BOLD, size+2 );
        
        
        label = new JLabel("Identity");
        label.setForeground( Color.white );
        label.setBorder( BorderFactory.createEmptyBorder( 2,2,2,2 ) );
        label.setFont( font );
        label.setIconTextGap( 10 );
        label.setIcon(image1);
        label.setText("Identity");
        
        gridbagConstraints.gridwidth = GridBagConstraints.REMAINDER;
        gridbagConstraints.gridx = 1;
        gridbagConstraints.insets = new Insets( 0, 0, 0, 20 );
        gridbagConstraints.anchor = GridBagConstraints.EAST;
        gridbagLayout.setConstraints( label, gridbagConstraints );
        
        add( label );

        setBorder( UIManager.getBorder("FolderInfoPanel.border") );
    }
    
    
    public void updateUI()
    {
        super.updateUI();
        setBorder( UIManager.getBorder("FolderInfoPanel.border") );
    }

    public void resetRenderer()
    {
        initComponents();
    }
    

    public void set( AccountItem item )
    {
        String accountName = item.getName();

        IdentityItem identity = item.getIdentityItem();
        String address = identity.getAddress();
        String name = identity.getName();
        

        if ( item.isPopAccount() )
            label.setIcon( image1 );
        else
            label.setIcon( image2 );
        
        label.setText( accountName+ ":    "+ name +" <"+ address + ">" );
        
        
    }
    
    
        
    
}











