// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.config.account;

import org.columba.config.*;
import org.columba.message.*;
import org.columba.folder.*;
import org.columba.main.*;
import org.columba.gui.header.util.*;
import org.columba.gui.header.*;
import org.columba.gui.config.account.util.*;


import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.util.Vector;
import org.columba.gui.util.*;

class AccountListTable extends JTable
{
    private AccountListDataModel model;
    private MainInterface mainInterface;
    private Config config;
    private AccountList AccountList;

    public AccountListTable(MainInterface mainInterface, AccountList accountList, ConfigFrame frame)
    {
        super();

	this.AccountList = accountList;
        this.mainInterface = mainInterface;
        config = mainInterface.config;

        setSelectionMode( ListSelectionModel.SINGLE_SELECTION );


        model = new AccountListDataModel( mainInterface, AccountList );
        //update();

        setModel( model );

        setShowGrid(false);
        setIntercellSpacing(new java.awt.Dimension(0, 0));


        TableColumn tc = getColumn( ResourceLoader.getString("dialog/mail/account/accountlisttable", "accountname") ); //$NON-NLS-1$
        tc.setCellRenderer( new StringAccountRenderer(false) );
        tc.setHeaderRenderer( new AccountHeaderRenderer( ResourceLoader.getString("dialog/mail/account/accountlisttable", "accountname") ) ); //$NON-NLS-1$


        tc = getColumn( ResourceLoader.getString("dialog/mail/account/accountlisttable", "type") ); //$NON-NLS-1$
        tc.setMaxWidth(100);
        tc.setMinWidth(100);
        tc.setCellRenderer( new StringAccountRenderer(true) );
        tc.setHeaderRenderer( new AccountHeaderRenderer( ResourceLoader.getString("dialog/mail/account/accountlisttable", "type") ) ); //$NON-NLS-1$


        sizeColumnsToFit( AUTO_RESIZE_NEXT_COLUMN );
    }

    public void update()
    {
        model.fireTableDataChanged();

    }



}


