// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.config.account;

import org.columba.config.*;
import org.columba.main.*;
import org.columba.gui.util.*;
import org.columba.folder.*;
import org.columba.gui.tree.*;
import org.columba.gui.themes.*;
import org.columba.gui.tree.util.*;
import org.columba.gui.util.ImageLoader;


import javax.swing.tree.*;
import javax.swing.event.*;
import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public class ConfigFrame implements ActionListener, ListSelectionListener//, TreeSelectionListener
{
    /*
    private JTextField textField;
    private JPanel leftPanel;
    private JPanel rightPanel;
    private JButton addpopButton;
    private JButton addimapButton;
    private JButton removeButton;
    private JButton defaultButton;
    private JButton wizardButton;
    private JButton closeButton;
    private JDialog frame;
    private AccountTree tree;
    */

    private JDialog dialog;

    public MainInterface mainInterface;

    private Config config;


    //private AccountTreeNode selected;

    private IdentityPanel identityPanel;
    private IncomingServerPanel incomingPanel;
    private OutgoingServerPanel outgoingServerPanel;
    private boolean newAccount = false;


    private AccountListTable listView;
    //private JSplitPane splitPane;

    private AccountList accountList;
    private AccountItem accountItem;

    //private int panel = -1;


    JPanel centerPanel = new JPanel();
    JPanel eastPanel = new JPanel();
    JPanel jPanel1 = new JPanel();

    JTextField nameTextField = new JTextField();
    JLabel nameLabel = new JLabel();


    JButton closeButton = new JButton();

    JButton addButton = new JButton();
    //JButton enableButton = new JButton();
    //JButton disableButton = new JButton();
    JButton removeButton = new JButton();
    JButton editButton = new JButton();

    //JButton moveupButton = new JButton();
    //JButton movedownButton = new JButton();

    private int index;

    BorderLayout borderLayout3 = new BorderLayout();
    GridLayout gridLayout1 = new GridLayout();

    public ConfigFrame( MainInterface mainInterface )
    {
        dialog = DialogStore.getDialog();


        this.mainInterface = mainInterface;

        config = mainInterface.config;

        accountList = config.getAccountList();

        dialog.addWindowListener(
            new WindowAdapter()
                {
                    public void windowClosing(WindowEvent e)
                    {
			dialog.setVisible(false);
                    }
                }
            );

	initComponents();

        dialog.pack();

        java.awt.Dimension dim = dialog.getSize();


        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

        dialog.setLocation(screenSize.width/2 - dim.width/2, screenSize.height/2 - dim.height/2);

        dialog.setVisible(true);
		//dialogsetVisible( true );
        //setSize( new Dimension( 500,400 ) );

    }




     public AccountItem getSelected()
    {
	return accountItem;
    }

    public void setSelected( AccountItem item )
    {
	accountItem = item;
    }

    public void initComponents()
    {
        JPanel mainPanel = new JPanel();
        mainPanel.setLayout( new BorderLayout() );
        mainPanel.setBorder( BorderFactory.createEmptyBorder( 10,10,10,10 ) );
        dialog.getContentPane().add( mainPanel );

        closeButton.setText(ResourceLoader.getString("dialog/global", "close")); //$NON-NLS-1$ //$NON-NLS-2$
        closeButton.setActionCommand("CLOSE"); //$NON-NLS-1$
        closeButton.addActionListener( this );

        addButton.setText(ResourceLoader.getString("dialog/mail/account/configframe", "addaccount")); //$NON-NLS-1$
        addButton.setActionCommand("ADD"); //$NON-NLS-1$
        addButton.setEnabled( true );
        addButton.addActionListener( this );

        removeButton.setText(ResourceLoader.getString("dialog/mail/account/configframe", "removeaccount")); //$NON-NLS-1$
        removeButton.setActionCommand("REMOVE"); //$NON-NLS-1$
        removeButton.setEnabled( false );
        removeButton.addActionListener( this );

        editButton.setText(ResourceLoader.getString("dialog/mail/account/configframe", "editsettings")); //$NON-NLS-1$
        editButton.setActionCommand("EDIT"); //$NON-NLS-1$
        editButton.setEnabled( false );
        editButton.addActionListener( this );

        /*
        enableButton.setText("Enable");
        enableButton.setActionCommand("ENABLE");
        enableButton.addActionListener( this );

        disableButton.setText("Disable");
        disableButton.setActionCommand("DISABLE");
        disableButton.addActionListener( this );
        */

        /*
        moveupButton.setText("Move up");
        moveupButton.setActionCommand("MOVEUP");
        moveupButton.setEnabled( false );
        moveupButton.addActionListener( this );

        movedownButton.setText("Move down");
        movedownButton.setActionCommand("MOVEDOWN");
        movedownButton.setEnabled( false );
        movedownButton.addActionListener( this );
        */


        // top panel

        JPanel topPanel = new JPanel();
        topPanel.setLayout( new BoxLayout( topPanel, BoxLayout.X_AXIS ) );
        GridBagLayout gridBagLayout = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        //topPanel.setLayout( );

        JPanel topBorderPanel = new JPanel();
        topBorderPanel.setLayout( new BorderLayout() );
        topBorderPanel.setBorder( BorderFactory.createEmptyBorder( 0,0,10,0 ) );
        topBorderPanel.add( topPanel, BorderLayout.CENTER );

        //mainPanel.add( topBorderPanel, BorderLayout.NORTH );



        nameLabel.setText(ResourceLoader.getString("dialog/mail/account/configframe", "name")); //$NON-NLS-1$
        nameLabel.setEnabled( false );
        topPanel.add(nameLabel);

        topPanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
        topPanel.add( Box.createHorizontalGlue() );

        nameTextField.setText(ResourceLoader.getString("dialog/mail/account/configframe", "name")); //$NON-NLS-1$
        nameTextField.setEnabled( false );
        topPanel.add(nameTextField);



        Component glue = Box.createVerticalGlue();
        c.anchor = GridBagConstraints.EAST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        //c.fill = GridBagConstraints.HORIZONTAL;
        gridBagLayout.setConstraints( glue, c );



        gridBagLayout = new GridBagLayout();
        c = new GridBagConstraints();
        eastPanel.setLayout( gridBagLayout );
        mainPanel.add( eastPanel, BorderLayout.EAST );


        c.fill = GridBagConstraints.HORIZONTAL;
        c.weightx = 1.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridBagLayout.setConstraints( addButton, c );
        eastPanel.add( addButton );

        Component strut1 = Box.createRigidArea( new Dimension(30,5) );
        gridBagLayout.setConstraints( strut1, c );
        eastPanel.add( strut1 );

        gridBagLayout.setConstraints( removeButton, c );
        eastPanel.add( removeButton );

        Component strut = Box.createRigidArea( new Dimension(30,5) );
        gridBagLayout.setConstraints( strut, c );
        eastPanel.add( strut );

        gridBagLayout.setConstraints( editButton, c );
        eastPanel.add( editButton );

        strut = Box.createRigidArea( new Dimension(30,20) );
        gridBagLayout.setConstraints( strut, c );
        eastPanel.add( strut );



        glue = Box.createVerticalGlue();
        c.fill = GridBagConstraints.BOTH;
        c.weighty = 1.0;
        gridBagLayout.setConstraints( glue, c );
        eastPanel.add( glue );

        c.gridheight = GridBagConstraints.REMAINDER;
        c.fill = GridBagConstraints.HORIZONTAL;
        c.weighty = 0;
        gridBagLayout.setConstraints( closeButton, c );
        eastPanel.add( closeButton );


        // centerpanel

        centerPanel = new JPanel();
        centerPanel.setLayout( new BorderLayout() );
        centerPanel.setBorder( BorderFactory.createEmptyBorder( 0,0,0,10 ) );

        listView = new AccountListTable( mainInterface, accountList, this );
	listView.getSelectionModel().addListSelectionListener( this );
        JScrollPane scrollPane = new JScrollPane( listView );
        scrollPane.setPreferredSize( new Dimension( 300,300 ) );
        scrollPane.getViewport().setBackground( Color.white );
        centerPanel.add( scrollPane );

        mainPanel.add( centerPanel, BorderLayout.CENTER );




    }


    public void valueChanged(ListSelectionEvent e)
    {

        if (e.getValueIsAdjusting())
            return;

        DefaultListSelectionModel theList = (DefaultListSelectionModel) e.getSource();
        if (theList.isSelectionEmpty())
        {
            removeButton.setEnabled( false );
            editButton.setEnabled( false );
        }
        else
        {
            removeButton.setEnabled( true );
            editButton.setEnabled( true );

            //String value = (String) theList.getSelectedValue();
            index = theList.getAnchorSelectionIndex();



	    System.out.println(ResourceLoader.getString("dialog/mail/account/configframe", "index")+ index ); //$NON-NLS-1$

	    setSelected( accountList.get( index ) );
        }

    }

    public void showAccountDialog()
    {

	AccountItem parent = getSelected();

	if ( parent != null )
	    {

		AccountDialog dialog = new AccountDialog( mainInterface,  parent );

                /*
                java.awt.Dimension dim = dialog.getSize();

                Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

                dialog.setLocation(screenSize.width/2 - dim.width/2, screenSize.height/2 - dim.height/2);


		dialog.showDialog();
                */


	    }

    }


    public void actionPerformed(ActionEvent e)
    {
	String action  = e.getActionCommand();



	if ( action.equals("CLOSE") ) //$NON-NLS-1$
	    {
                mainInterface.config.saveConfiguration();



		dialog.setVisible(false);
	    }
	else if ( action.equals("ADD") ) //$NON-NLS-1$
	    {
		System.out.println( ResourceLoader.getString("dialog/mail/account/configframe", "add") ); //$NON-NLS-1$


                org.columba.gui.config.accountwizard.AccountWizard wizard =
                new org.columba.gui.config.accountwizard.AccountWizard( mainInterface, true );

                listView.update();

                //AccountItem item = accountList.a
                /*
                Filter filter = filterList.addEmtpyFilter();


		listView.update();

                setSelected( filter );

                showFilterDialog();


                listView.update();
                */

	    }
	else if ( action.equals("REMOVE") ) //$NON-NLS-1$
	    {
		System.out.println( ResourceLoader.getString("dialog/mail/account/configframe", "remove") ); //$NON-NLS-1$


                AccountItem item = accountList.remove( index );

                if ( item.isPopAccount() == true )
                {
                    mainInterface.popServerCollection.removePopServer( item.getUid() );
                    mainInterface.mainFrame.getMenu().updatePopServerMenu();
                }
                else
                {
                    Folder folder = mainInterface.treeViewer.getFolderTree().getImapFolder( item.getUid() );
                    folder.removeFromParent();
                }


                removeButton.setEnabled( false );
                editButton.setEnabled( false );

		listView.update();



	    }
	else if ( action.equals("EDIT") ) //$NON-NLS-1$
	    {

		showAccountDialog();

                listView.update();

	    }
    }



    /*
    public AccountTreeNode getSelected()
    {
	return selected;
    }

    public void setSelected( AccountTreeNode node )
    {
	selected = node;
    }

    public void setSelectedPanel( int i )
    {
        panel = i;
    }

    public int getSelectedPanel()
    {
        return panel;
    }


    public void showDialog()
    {
        frame = new JDialog( mainInterface.mainFrame, "Message Account Settings", true);
        frame.addWindowListener(
            new WindowAdapter()
                {
                    public void windowClosing(WindowEvent e)
                    {
                        boolean result = tree.getFinished();

                        if ( result == true )
                        {

                            mainInterface.config.saveConfiguration();
                            frame.setVisible(false);
                        }
                        else
                        {
                            JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                           "You are not finished yet, please correct the marked configuration nodes!");
                        }
                    }
                }
            );



        leftPanel = new JPanel();
        leftPanel.setLayout( new BorderLayout() );
        leftPanel.setBorder( BorderFactory.createEmptyBorder( 5,5,5,5 ) );


        tree = new AccountTree( mainInterface, this );
        tree.getTree().addTreeSelectionListener( this );

        leftPanel.add( tree.scrollPane, BorderLayout.CENTER );

        JPanel buttonPanel = new JPanel();
        buttonPanel.setBorder( BorderFactory.createEmptyBorder( 10,0,5,0 ) );
        buttonPanel.setLayout( new GridLayout( 5, 1,5,5 )   );


        addpopButton = new JButton("Add POP3 Account");
	addpopButton.addActionListener( this );
	addpopButton.setActionCommand("ADDPOP");
        addpopButton.setPreferredSize( new Dimension( 200,30 ) );

        addimapButton = new JButton("Add Imap Account");
	addimapButton.addActionListener( this );
	addimapButton.setActionCommand("ADDImap");
        addimapButton.setPreferredSize( new Dimension( 200,30 ) );

        removeButton = new JButton("Remove");
        removeButton.setPreferredSize( new Dimension( 200,30 ) );
	removeButton.addActionListener( this );
	removeButton.setActionCommand("REMOVE");
        closeButton = new JButton("Close", ImageLoader.getImageIcon("org/columba/images/Home16.gif"));
        closeButton.setPreferredSize( new Dimension( 200,30 ) );
	closeButton.addActionListener( this );
	closeButton.setActionCommand("CLOSE");

        wizardButton = new JButton("Account Wizard");
        wizardButton.setPreferredSize( new Dimension( 200,30 ) );
        wizardButton.addActionListener( this );
	wizardButton.setActionCommand("WIZARD");

        buttonPanel.add( addpopButton );
        buttonPanel.add( addimapButton );
        buttonPanel.add( wizardButton );
	buttonPanel.add( removeButton );
        buttonPanel.add( closeButton );


        leftPanel.add( buttonPanel, BorderLayout.SOUTH );



        rightPanel = new JPanel();
        rightPanel.setLayout( new BoxLayout( rightPanel, BoxLayout.Y_AXIS ) );
        rightPanel.setBorder( null );



        splitPane = new JSplitPane( JSplitPane.HORIZONTAL_SPLIT,
                                               leftPanel,
                                               rightPanel);
        splitPane.setDividerSize(1);
        splitPane.setBorder( null );


        frame.getContentPane().setLayout( new BorderLayout() );
        frame.getContentPane().add("Center", splitPane );
        frame.setSize( 800,600 );

        java.awt.Dimension dim = new java.awt.Dimension( 800,600 );

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

        frame.setLocation(screenSize.width/2 - dim.width/2, screenSize.height/2 - dim.height/2);

	frame.setVisible(true);

    }

            // this method is called when the user selects another folder
    public void valueChanged(TreeSelectionEvent e)
    {
        AccountTreeNode node = (AccountTreeNode) tree.getTree().getLastSelectedPathComponent();
        if (node == null) return;

        if ( node.getName().equals("Root") ) return;


        if ( panel != -1 )
        {
            switch( panel )
            {
            case 0:
            {
                boolean result = identityPanel.save( newAccount );

                if ( result )
                {
                    getSelected().setFinished( true );

                    rightPanel.removeAll();
                    rightPanel.validate();
                    rightPanel.repaint();

                    if ( newAccount )
                    {

                        AccountTreeNode child0 = (AccountTreeNode) getSelected().getChildAt(0);
                        AccountTreeNode child1 = (AccountTreeNode) getSelected().getChildAt(1);

                        child0.setFinished( false );
                        tree.nodeChanged( child0, child0.getName() );
                        child1.setFinished( false );
                        tree.nodeChanged( child1, child1.getName() );

                        newAccount = false;
                    }

                    tree.nodeChanged( getSelected(), getSelected().getName() );

                }
                else
                {
                    if ( newAccount )
                    {

                        AccountTreeNode child0 = (AccountTreeNode) getSelected().getChildAt(0);
                        AccountTreeNode child1 = (AccountTreeNode) getSelected().getChildAt(1);

                        child0.setFinished( false );
                        tree.nodeChanged( child0, child0.getName() );
                        child1.setFinished( false );
                        tree.nodeChanged( child1, child1.getName() );

                        newAccount = false;
                    }

                    setSelected( getSelected() );
                    tree.nodeChanged( getSelected(), getSelected().getName() );

                    return;
                }

                break;
            }
            case 1:
            {
                  //incoming
                boolean result = incomingPanel.save( newAccount );

                if ( result )
                {
                    AccountTreeNode child0 = (AccountTreeNode) getSelected().getChildAt(0);
                    child0.setFinished( true );
                    tree.nodeChanged( child0, child0.getName() );

                    rightPanel.removeAll();
                    rightPanel.validate();
                    rightPanel.repaint();
                }
                else
                {
                    setSelected( getSelected() );

                    tree.nodeChanged( getSelected(), getSelected().getName() );

                    return;
                }

                break;
            }
            case 2:
            {
                  //outgoing
                boolean result = outgoingServerPanel.save( newAccount );

                if ( result )
                {
                    AccountTreeNode child0 = (AccountTreeNode) getSelected().getChildAt(1);
                    child0.setFinished( true );
                    tree.nodeChanged( child0, child0.getName() );


                    rightPanel.removeAll();
                    rightPanel.validate();
                    rightPanel.repaint();
                }
                else
                {
                    setSelected( getSelected() );

                    tree.nodeChanged( getSelected(), getSelected().getName() );
                    return;
                }
                break;
            }
            }
        }


        if  ( node.getName().indexOf("Incoming") != -1 )
        {
            AccountTreeNode parent = (AccountTreeNode) node.getParent();

            setSelected( parent  );
            updateRightPanel( 1 );
        }
        else if ( node.getName().indexOf("Outgoing") != -1)
        {
            AccountTreeNode parent = (AccountTreeNode) node.getParent();

            setSelected( parent );
            updateRightPanel( 2 );
        }
        else
        {

            setSelected( node );
            updateRightPanel( 0 );
        }



    }


    public void updateRightPanel( int i )
    {
        panel = i;

          //AdapterNode accountNode = getSelected().getNode();

          //AdapterNode accountNameNode = accountNode.getChild("name");

        AccountItem accountItem = getSelected().getItem();

        rightPanel.removeAll();

        switch ( i )
        {

        case 0:
        {
              //AccountItem accountItem = mainInterface.config.getAccountItem( accountNode );
            IdentityItem identityItem = accountItem.getIdentityItem();

            identityPanel = new IdentityPanel( this, accountItem, identityItem );

            JScrollPane scrollPane = new JScrollPane( identityPanel );
            scrollPane.setBorder( null );
            rightPanel.add( scrollPane );

            break;

        }
        case 1:
        {
              //AccountItem accountItem = mainInterface.config.getAccountItem( accountNode );


            if ( accountItem.isPopAccount() == true )
            {
                PopItem item = accountItem.getPopItem();

                incomingPanel = new IncomingServerPanel( this, accountItem, item );
            }
            else
                {
                    ImapItem item = accountItem.getImapItem();
                    incomingPanel = new IncomingServerPanel( this, accountItem, item );
                }

            JScrollPane scrollPane2 = new JScrollPane( incomingPanel );
            scrollPane2.setBorder( null );
            rightPanel.add( scrollPane2 );


            break;
        }
        case 2:
        {
              //AccountItem accountItem = mainInterface.config.getAccountItem( accountNode );

            SmtpItem smtpItem = accountItem.getSmtpItem();

            outgoingServerPanel = new OutgoingServerPanel( this, smtpItem );

            JScrollPane scrollPane3 = new JScrollPane( outgoingServerPanel );
            scrollPane3.setBorder( null );
            rightPanel.add( scrollPane3 );


            break;
        }
        }

        rightPanel.validate();
        rightPanel.repaint();

    }









    public void actionPerformed(ActionEvent e)
    {
	String action  = e.getActionCommand();


	if ( action.equals("IDENTITY") )
        {
            boolean result = identityPanel.save( newAccount );

            if ( result )
            {
                getSelected().setFinished( true );

                newAccount = false;

                rightPanel.removeAll();
                rightPanel.validate();
                rightPanel.repaint();

                tree.nodeChanged( getSelected(), getSelected().getName() );
            }


        }
        else if ( action.equals("INCOMING") )
        {
            boolean result = incomingPanel.save( newAccount );

            if ( result )
            {
                newAccount = false;

                rightPanel.removeAll();
                rightPanel.validate();
                rightPanel.repaint();

                AccountTreeNode child0 = (AccountTreeNode) getSelected().getChildAt(0);
                child0.setFinished( true );
                tree.nodeChanged( child0, child0.getName() );

            }


        }
        else if ( action.equals("OUTGOING") )
        {
            boolean result = outgoingServerPanel.save( newAccount );

            if ( result )
            {
                newAccount = false;

                rightPanel.removeAll();
                rightPanel.validate();
                rightPanel.repaint();

                AccountTreeNode child1 = (AccountTreeNode) getSelected().getChildAt(1);
                child1.setFinished( true );
                tree.nodeChanged( child1, child1.getName() );

            }
        }
	else if ( action.equals("CANCEL") )
        {
            if ( newAccount == true )
            {
                newAccount = false;
                panel = -1;
                getSelected().setFinished( true );
                tree.remove( getSelected() );
            }

            rightPanel.removeAll();
            rightPanel.validate();
            rightPanel.repaint();
        }
	else if ( action.equals("CLOSE") )
        {
            boolean result = tree.getFinished();

            if ( result == true )
            {

                mainInterface.config.saveConfiguration();
                frame.setVisible(false);
            }
            else
            {
                JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                               "You are not finished yet, please correct the marked configuration nodes!");
            }


        }
	else if ( action.equals("ADDPOP") )
        {
            System.out.println( "ADD" );

            AccountXmlConfig config = mainInterface.config.getAccountConfig();
            AccountItem item = config.add( true );

            AccountTreeNode treeNode = tree.add( item );

            treeNode.setFinished( false );
            tree.nodeChanged( treeNode, treeNode.getName() );
            AccountTreeNode child0 = (AccountTreeNode) treeNode.getChildAt(0);
            AccountTreeNode child1 = (AccountTreeNode) treeNode.getChildAt(1);
            child0.setFinished( false );
            tree.nodeChanged( child0, child0.getName() );
            child1.setFinished( false );
            tree.nodeChanged( child1, child1.getName() );


            setSelected( treeNode );

            updateRightPanel(0);



            newAccount = true;

        }
        else if ( action.equals("ADDImap") )
        {

            System.out.println( "ADD Imap" );

            AccountXmlConfig config = mainInterface.config.getAccountConfig();
            AccountItem item = config.add( false );

            AccountTreeNode treeNode = tree.add( item );

            treeNode.setFinished( false );
            tree.nodeChanged( treeNode, treeNode.getName() );
            AccountTreeNode child0 = (AccountTreeNode) treeNode.getChildAt(0);
            AccountTreeNode child1 = (AccountTreeNode) treeNode.getChildAt(1);
            child0.setFinished( false );
            tree.nodeChanged( child0, child0.getName() );
            child1.setFinished( false );
            tree.nodeChanged( child1, child1.getName() );

            setSelected( treeNode );

            updateRightPanel(0);

            newAccount = true;

        }
	else if ( action.equals("REMOVE") )
        {
            System.out.println( "REMOVE" );

            AccountTreeNode node = getSelected();

            AccountItem item = node.getItem();
            String folderName = item.getName();

            if ( newAccount == false )
            {

                if ( item.isPopAccount() == true )
                {

                    mainInterface.popServerCollection.removePopServer( item.getUid() );



                    mainInterface.mainFrame.getMenu().updatePopServerMenu();
                }
                else
                {

                    TreeNodeList list = new TreeNodeList( "/"+folderName );
                    Folder folder = mainInterface.treeViewer.getFolder( list );
                    folder.removeFromParent();



                }
            }



            AccountTreeNode treeNode = getSelected();



            tree.remove( treeNode );

            rightPanel.removeAll();
            rightPanel.validate();
            rightPanel.repaint();

            item.remove();

            panel = -1;

        }
        else if ( action.equals("WIZARD") )
        {
            org.columba.gui.config.accountwizard.AccountWizard wizard =
                new org.columba.gui.config.accountwizard.AccountWizard( mainInterface, true );

            tree.update();

        }

    }

    */

}


