// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.config.account;

/*
 * PopAttributPanel.java
 *
 * Created on 2. November 2000, 00:12
 */


import javax.swing.*;
import javax.swing.border.*;

import java.awt.*;
import java.awt.event.*;


import org.columba.config.*;
import org.columba.gui.util.*;
import org.columba.main.MainInterface;

/**
 *
 * @author  freddy
 * @version
 */
public class ImapAttributPanel extends JPanel
{

    private ImapItem item;

    private JCheckBox secureCheckBox;
    private JCheckBox storePasswordCheckBox;

    private JCheckBox intervalCheckingCheckBox;
    private JPanel jPanel1;
    private JLabel intervalCheckingLabel;
    private JLabel intervalCheckingLabel2;
    private JTextField intervalCheckingTextField;

    private JCheckBox cleanupCheckBox;
    private JPanel cleanupPanel;

    private JCheckBox emptyTrashCheckBox;
    private JPanel emptyTrashPanel;

    private MainInterface mainInterface;
    //private ConfigFrame frame;

    public ImapAttributPanel( MainInterface mainInterface, ImapItem item )
    {
        //super( " Imap4 Settings " );

	this.item = item;
        this.mainInterface = mainInterface;

        initComponents ();
    }


    public void updateComponents( boolean b )
    {
        /*
        if ( b )
        {

            if ( item.isSavePassword() )
                storePasswordCheckBox.setSelected(true);


        }
        else
        {

            if ( storePasswordCheckBox.isSelected() == true )
                item.setSavePassword("true");
            else
                item.setSavePassword("false");


        }
        */
    }


    private void initComponents()
    {

        setLayout( new BorderLayout() );
        setBorder( javax.swing.BorderFactory.createTitledBorder(
                   javax.swing.BorderFactory.createEtchedBorder(),
                   ResourceLoader.getString("dialog/mail/account/imapattributpanel", "imapsettings") ) ); //$NON-NLS-1$

        JPanel innerPanel = new JPanel();
        GridBagLayout layout = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        innerPanel.setLayout( layout );
        innerPanel.setBorder( BorderFactory.createEmptyBorder(10,10,10,10) );

        add( innerPanel, BorderLayout.NORTH );


        JPanel intervalCheckingPanel = new JPanel();
	//intervalCheckingPanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
	intervalCheckingPanel.setLayout( new BoxLayout( intervalCheckingPanel, BoxLayout.X_AXIS ) );
        intervalCheckingCheckBox = new JCheckBox ();
	intervalCheckingCheckBox.setEnabled(false);
	intervalCheckingCheckBox.setText (ResourceLoader.getString("dialog/mail/account/imapattributpanel", "Enable_interval_message_checking")); //$NON-NLS-1$
	intervalCheckingCheckBox.setAlignmentX(Component.LEFT_ALIGNMENT);
	intervalCheckingPanel.add (intervalCheckingCheckBox);
	intervalCheckingPanel.add( Box.createHorizontalGlue() );
        c.gridx = 0;
        c.weightx = 1.0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints( intervalCheckingPanel, c);
        innerPanel.add( intervalCheckingPanel );



        jPanel1 = new JPanel ();
	jPanel1.setLayout (new BoxLayout( jPanel1, BoxLayout.X_AXIS ) );
	jPanel1.add( Box.createRigidArea( new java.awt.Dimension(30,0) ) );
        intervalCheckingLabel = new JLabel ();
	intervalCheckingLabel.setEnabled(false);
	intervalCheckingLabel.setText (ResourceLoader.getString("dialog/mail/account/imapattributpanel", "Check_for_new_messages_every")); //$NON-NLS-1$
	jPanel1.add( intervalCheckingLabel );
        jPanel1.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
        intervalCheckingTextField = new JTextField (5);
	intervalCheckingTextField.setEnabled(false);
	intervalCheckingTextField.setText ("18"); //$NON-NLS-1$
        intervalCheckingTextField.setMaximumSize( new java.awt.Dimension( 50, 25 ) );
	jPanel1.add( intervalCheckingTextField );
	jPanel1.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
        intervalCheckingLabel2 = new JLabel ();
	intervalCheckingLabel2.setEnabled(false);
	intervalCheckingLabel2.setText (ResourceLoader.getString("dialog/mail/account/imapattributpanel", "minutes")); //$NON-NLS-1$
	jPanel1.add( intervalCheckingLabel2 );
        jPanel1.add( Box.createHorizontalGlue() );
        c.gridx = 0;
        c.weightx = 1.0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints( jPanel1, c);
        innerPanel.add( jPanel1 );





        JPanel cleanupPanel = new JPanel();
	//cleanupPanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
	cleanupPanel.setLayout( new BoxLayout( cleanupPanel, BoxLayout.X_AXIS ) );
        cleanupCheckBox = new JCheckBox ();
	cleanupCheckBox.setEnabled(false);
	cleanupCheckBox.setText (ResourceLoader.getString("dialog/mail/account/imapattributpanel", "Expunge_Inbox_on_Exit")); //$NON-NLS-1$
	cleanupCheckBox.setAlignmentX(Component.LEFT_ALIGNMENT);
	cleanupPanel.add (cleanupCheckBox);
	cleanupPanel.add( Box.createHorizontalGlue() );
        c.gridx = 0;
        c.weightx = 1.0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints( cleanupPanel, c);
        innerPanel.add( cleanupPanel );


        JPanel emptyTrashPanel = new JPanel();
	//emptyTrashPanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
	emptyTrashPanel.setLayout( new BoxLayout( emptyTrashPanel, BoxLayout.X_AXIS ) );
        emptyTrashCheckBox = new JCheckBox ();
	emptyTrashCheckBox.setEnabled(false);
	emptyTrashCheckBox.setText (ResourceLoader.getString("dialog/mail/account/imapattributpanel", "Empty_Trash_on_Exit")); //$NON-NLS-1$
	emptyTrashCheckBox.setAlignmentX(Component.LEFT_ALIGNMENT);
	emptyTrashPanel.add (emptyTrashCheckBox);
	emptyTrashPanel.add( Box.createHorizontalGlue() );
        c.gridx = 0;
        c.weightx = 1.0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints( emptyTrashPanel, c);
        innerPanel.add( emptyTrashPanel );



    }


}
