// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.config.account;

/*
 * PopAttributPanel.java
 *
 * Created on 2. November 2000, 00:12
 */


import javax.swing.*;
import javax.swing.border.*;

import java.awt.event.*;
import java.awt.*;


import org.columba.config.*;
import org.columba.gui.util.*;
import org.columba.gui.tree.util.*;
import org.columba.main.*;
import org.columba.folder.*;
import org.columba.main.MainInterface;


/**
 *
 * @author  freddy
 * @version
 */

public class PopAttributPanel extends JPanel implements ActionListener
{

    private PopItem item;

    private JCheckBox secureCheckBox;
    private JCheckBox leaveOnServerCheckBox;
    private JCheckBox storePasswordCheckBox;
    private JCheckBox excludeCheckBox;
    private JCheckBox intervalCheckingCheckBox;
    private JCheckBox downloadnewCheckBox;
      //private JCheckBox limitMessageDownloadCheckBox;

    private JCheckBox limitMessageDownloadCheckBox;
    private JLabel limitMessageDownloadLabel2;
    private JTextField limitMessageDownloadTextField;

    private JPanel jPanel1;
    private JPanel jPanel4;
    private JLabel intervalCheckingLabel;
    private JLabel intervalCheckingLabel2;
    private JPanel deleteLocallyPanel;
    private JCheckBox deleteLocallyCheckBox;
    private JTextField intervalCheckingTextField;
    private JPanel jPanel2;
    private JPanel jPanel3;
    //private JLabel destinationLabel;
    //private JTextField destinationTextField;
    private JButton selectButton;
    
    private JCheckBox playsoundCheckBox;
    private JCheckBox autodownloadCheckBox;
    
   // private ConfigFrame frame;

   private MainInterface mainInterface;

    public PopAttributPanel( MainInterface mainInterface, PopItem item)
    {
        super();

        this.mainInterface = mainInterface;

	this.item = item;
        //this.frame = frame;

        initComponents ();

    }

    /*
    public String getDestinationFolder()
    {
        return destinationTextField.getText();
    }
    */

    public void updateComponents( boolean b )
    {
        if ( b )
        {
            if ( item.getLeaveMessage().equals("true") ) //$NON-NLS-1$
                leaveOnServerCheckBox.setSelected( true );



            /*
            int uid = item.getUid();
            Folder folder = mainInterface.treeViewer.getFolder( uid );
            String treepath = folder.getTreePath();
            destinationTextField.setText( treepath );
            */

            if ( item.getExclude().equals("true") ) //$NON-NLS-1$
                excludeCheckBox.setSelected( true );
            else
                excludeCheckBox.setSelected( false );

            if ( item.getMailCheck().equals("true") ) //$NON-NLS-1$
            {
                intervalCheckingCheckBox.setSelected(true);

                intervalCheckingLabel.setEnabled( true );
                intervalCheckingLabel2.setEnabled( true );
                intervalCheckingTextField.setEnabled( true );
                playsoundCheckBox.setEnabled(true);
                autodownloadCheckBox.setEnabled(true);
            }
            else
            {
                intervalCheckingCheckBox.setSelected(false);
                intervalCheckingLabel.setEnabled( false );
                intervalCheckingLabel2.setEnabled( false );
                intervalCheckingTextField.setEnabled( false );
                playsoundCheckBox.setEnabled(false);
                autodownloadCheckBox.setEnabled(false);
            }

            intervalCheckingTextField.setText( item.getInterval() );
           
            playsoundCheckBox.setSelected( item.isPlaysound() );
            
            autodownloadCheckBox.setSelected( item.isAutoDownload() );

            if ( item.getLimit().equals("true") ) //$NON-NLS-1$
            {
                limitMessageDownloadCheckBox.setSelected( true );
            }
            else
                limitMessageDownloadCheckBox.setSelected( false );

            limitMessageDownloadTextField.setText( item.getDownloadLimit() );


        }
        else
        {
            if ( leaveOnServerCheckBox.isSelected() == true )
                item.setLeaveMessage( "true" ); //$NON-NLS-1$
            else
                item.setLeaveMessage("false"); //$NON-NLS-1$

                /*
            if ( storePasswordCheckBox.isSelected() == true )
                item.setSavePassword("true");
            else
                item.setSavePassword("false");
                */
                
            if ( playsoundCheckBox.isSelected() == true )
            	item.setPlaysound(true);
            else
            	item.setPlaysound(false);
            
			if ( autodownloadCheckBox.isSelected() == true )
				item.setAutodownload(true);
			else
				item.setAutodownload(false);
				
            if ( excludeCheckBox.isSelected() == true )
                item.setExclude( "true" ); //$NON-NLS-1$
            else
                item.setExclude( "false" ); //$NON-NLS-1$

            /*
            String treepath = destinationTextField.getText();
            TreeNodeList list = new TreeNodeList( treepath );
            Folder folder = mainInterface.treeViewer.getFolder( list );
            int uid = folder.getUid();

            item.setUid( uid );
            */

            if ( intervalCheckingCheckBox.isSelected() )
               item.setMailCheck("true"); //$NON-NLS-1$
            else
               item.setMailCheck("false"); //$NON-NLS-1$

            if ( limitMessageDownloadCheckBox.isSelected() )
               item.setLimit("true"); //$NON-NLS-1$
            else
                item.setLimit("false"); //$NON-NLS-1$

            item.setInterval( intervalCheckingTextField.getText() );

            item.setDownloadLimit( limitMessageDownloadTextField.getText() );
        }
    }


    private void initComponents()
    {
        setLayout( new BorderLayout() );
        setBorder( javax.swing.BorderFactory.createTitledBorder(
                   javax.swing.BorderFactory.createEtchedBorder(),
                   ResourceLoader.getString("dialog/mail/account/popattributpanel", "_POP3_Settings") ) ); //$NON-NLS-1$

        JPanel innerPanel = new JPanel();
        GridBagLayout layout = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        innerPanel.setLayout( layout );
        innerPanel.setBorder( BorderFactory.createEmptyBorder(10,10,10,10) );

        add( innerPanel, BorderLayout.NORTH );


        JPanel panel = new JPanel();
        panel.setLayout( new BoxLayout( panel, BoxLayout.X_AXIS ) );
        c.gridx = 0;
        c.weightx = 1.0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints( panel, c);
        innerPanel.add( panel );

        /*
	destinationLabel = new JLabel ("Destination Folder:");
        panel.add( destinationLabel );
        panel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );

	destinationTextField = new JTextField(30);
        panel.add( destinationTextField );
        panel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );

        selectButton = new JButton(" .. ");
        selectButton.setMargin( new Insets( 0,0,0,0 ) );
        selectButton.addActionListener( this );
        selectButton.setActionCommand("SELECT");
        panel.add( selectButton );
        */

        intervalCheckingCheckBox = new JCheckBox ();
	intervalCheckingCheckBox.setEnabled(true);
        intervalCheckingCheckBox.setActionCommand("INTERVAL_CHECKING");
        intervalCheckingCheckBox.addActionListener( this );
	intervalCheckingCheckBox.setText (ResourceLoader.getString("dialog/mail/account/popattributpanel", "Enable_interval_message_checking")); //$NON-NLS-1$
        c = new GridBagConstraints();
        c.gridwidth = GridBagConstraints.REMAINDER;
        c.gridx = 0;
        c.anchor = GridBagConstraints.WEST;
        c.weightx = 1.0;
        c.anchor = GridBagConstraints.WEST;
        layout.setConstraints( intervalCheckingCheckBox, c);
        innerPanel.add( intervalCheckingCheckBox );



        JPanel intervalCheckingPanel = new JPanel();
        intervalCheckingPanel.setLayout( new BoxLayout( intervalCheckingPanel, BoxLayout.X_AXIS ) );
        c.gridx = 0;
        c.weightx = 1.0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints( intervalCheckingPanel, c);
        innerPanel.add( intervalCheckingPanel );

        intervalCheckingPanel.add( Box.createRigidArea( new java.awt.Dimension(20,0) ) );

        intervalCheckingLabel = new JLabel ();
	intervalCheckingLabel.setEnabled(false);
	intervalCheckingLabel.setText (ResourceLoader.getString("dialog/mail/account/popattributpanel", "Check_for_new_messages_every")); //$NON-NLS-1$
        intervalCheckingPanel.add( intervalCheckingLabel );
        intervalCheckingPanel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );

        intervalCheckingTextField = new JTextField (5);
	intervalCheckingTextField.setEnabled(false);
	intervalCheckingTextField.setText ("18");
        intervalCheckingPanel.add( intervalCheckingTextField );
        intervalCheckingPanel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );




        intervalCheckingLabel2 = new JLabel ();
	intervalCheckingLabel2.setEnabled(false);
	intervalCheckingLabel2.setText (ResourceLoader.getString("dialog/mail/account/popattributpanel", "minutes")); //$NON-NLS-1$
        intervalCheckingPanel.add( intervalCheckingLabel2 );

	JPanel soundPanel = new JPanel();
    soundPanel.setLayout( new BoxLayout( soundPanel, BoxLayout.X_AXIS ) );
    c.gridx = 0;
    c.weightx = 1.0;
    c.anchor = GridBagConstraints.WEST;
    c.gridwidth = GridBagConstraints.REMAINDER;
    layout.setConstraints( soundPanel, c);
    innerPanel.add( soundPanel );
 
 	soundPanel.add( Box.createRigidArea( new java.awt.Dimension(20,0) ) );
 	playsoundCheckBox = new JCheckBox(ResourceLoader.getString("dialog/mail/account/popattributpanel", "Play_sound_when_new_messages_arrive")); //$NON-NLS-1$
 	soundPanel.add( playsoundCheckBox );    
 	
 	JPanel autodownloadPanel = new JPanel();
    autodownloadPanel.setLayout( new BoxLayout( autodownloadPanel, BoxLayout.X_AXIS ) );
    c.gridx = 0;
    c.weightx = 1.0;
    c.anchor = GridBagConstraints.WEST;
    c.gridwidth = GridBagConstraints.REMAINDER;
    layout.setConstraints( autodownloadPanel, c);
    innerPanel.add( autodownloadPanel );
 
 	autodownloadPanel.add( Box.createRigidArea( new java.awt.Dimension(20,0) ) );
 	autodownloadCheckBox = new JCheckBox(ResourceLoader.getString("dialog/mail/account/popattributpanel", "Automatically_download_new_messages")); //$NON-NLS-1$
 	autodownloadPanel.add( autodownloadCheckBox );       


        leaveOnServerCheckBox = new JCheckBox ();
	leaveOnServerCheckBox.setText (ResourceLoader.getString("dialog/mail/account/popattributpanel", "Leave_messages_on_server")); //$NON-NLS-1$
        c = new GridBagConstraints();
        c.gridx = 0;
        c.weightx = 1.0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints( leaveOnServerCheckBox, c);
        innerPanel.add( leaveOnServerCheckBox );


        JPanel limitMessageDownloadPanel = new JPanel();
        limitMessageDownloadPanel.setLayout( new BoxLayout( limitMessageDownloadPanel, BoxLayout.X_AXIS ) );
        c.gridx = 0;
        c.weightx = 1.0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints( limitMessageDownloadPanel, c);
        innerPanel.add( limitMessageDownloadPanel );

        limitMessageDownloadCheckBox = new JCheckBox();
	limitMessageDownloadCheckBox.setEnabled(true);
	limitMessageDownloadCheckBox.setText (ResourceLoader.getString("dialog/mail/account/popattributpanel", "Limit_Message_download_to")); //$NON-NLS-1$
        limitMessageDownloadPanel.add( limitMessageDownloadCheckBox );
        limitMessageDownloadPanel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );


        limitMessageDownloadTextField = new JTextField (5);
	limitMessageDownloadTextField.setEnabled(true);
	limitMessageDownloadTextField.setText ("18");
        limitMessageDownloadPanel.add( limitMessageDownloadTextField );
        limitMessageDownloadPanel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );

        limitMessageDownloadLabel2 = new JLabel ();
	limitMessageDownloadLabel2.setEnabled(true);
	limitMessageDownloadLabel2.setText (ResourceLoader.getString("dialog/mail/account/popattributpanel", "KB_per_message")); //$NON-NLS-1$
        limitMessageDownloadPanel.add( limitMessageDownloadLabel2 );


        excludeCheckBox = new JCheckBox ();
	excludeCheckBox.setText (ResourceLoader.getString("dialog/mail/account/popattributpanel", "Exclude_from_Fetch_All")); //$NON-NLS-1$
        c = new GridBagConstraints();
        c.gridx = 0;
        c.weightx = 1.0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints( excludeCheckBox, c);
        innerPanel.add( excludeCheckBox );



    }


    public void actionPerformed(ActionEvent e)
    {
	String action  = e.getActionCommand();

        /*
        if ( action.equals("SELECT") )
        {
            SelectFolderDialog dialog = mainInterface.treeViewer.getSelectFolderDialog();
            //SelectFolderDialog dialog = new SelectFolderDialog( frame.mainInterface );
            dialog.show();

            if ( dialog.success() )
            {
                Folder selectedFolder = dialog.getSelectedFolder();
                String path = selectedFolder.getTreePath();

                destinationTextField.setText( path );

                int uid = selectedFolder.getUid();
                //int uid = frame.mainInterface.treeViewer.getUid( path );
                item.setUid( uid );
            }

        }
        */

        if ( action.equals("INTERVAL_CHECKING") )
        {
            if ( intervalCheckingCheckBox.isSelected() )
            {
                intervalCheckingLabel.setEnabled( true );
                intervalCheckingLabel2.setEnabled( true );
                intervalCheckingTextField.setEnabled( true );
                playsoundCheckBox.setEnabled(true);
                autodownloadCheckBox.setEnabled(true);
            }
            else
            {
                intervalCheckingLabel.setEnabled( false );
                intervalCheckingLabel2.setEnabled( false );
                intervalCheckingTextField.setEnabled( false );
                playsoundCheckBox.setEnabled(false);
                autodownloadCheckBox.setEnabled(false);
            }
        }

    }


}
