// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.config.account.util;

import org.columba.gui.util.*;
import org.columba.message.*;
import org.columba.gui.header.util.*;


import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.tree.*;


public class StringAccountRenderer extends JLabel implements TableCellRenderer
    {
	private Border unselectedBorder = null;
	private Border selectedBorder = null;
	private boolean isBordered = true;

        private Font plainFont,boldFont;

        private ImageIcon image1 = ImageLoader.getImageIcon("tree.local", "Host16");
        private ImageIcon image2 = ImageLoader.getImageIcon("tree.remote", "WebComponent16");

        private boolean b;

	public StringAccountRenderer( boolean b )
	{
	    super();
            this.b = b;

	    this.isBordered = true;

	    setOpaque(true); //MUST do this for background to show up.

            boldFont = UIManager.getFont("Label.font");
            boldFont = boldFont.deriveFont( Font.BOLD );

            plainFont = UIManager.getFont("Label.font");

	}

	public Component getTableCellRendererComponent(
						       JTable table, Object value,
						       boolean isSelected, boolean hasFocus,
						       int row, int column)
	{

            //super.getTableCellRendererComponent( table, value, isSelected, hasFocus, row, column );






	    if (isBordered)
		{
		    if (isSelected)
			{
			    if (selectedBorder == null)
				{
				    selectedBorder = BorderFactory.createMatteBorder(2,5,2,5,table.getSelectionBackground() );
				}
                              //setBorder(selectedBorder);
			    setBackground( table.getSelectionBackground() );
			    setForeground( table.getSelectionForeground() );
			} else
			    {
				if (unselectedBorder == null)
				    {
					unselectedBorder = BorderFactory.createMatteBorder(2,5,2,5,
											   table.getBackground() );
				    }

                                setBackground( table.getBackground() );
				//setBorder(unselectedBorder);
				setForeground( table.getForeground() );
			    }
		}





            String str = null;
            try
            {
                str = (String) value;
            }
            catch ( ClassCastException ex )
            {
                System.out.println(" filter renderer: "+ ex.getMessage() );
                str = new String();
            }

            if ( b==true )
            {
            if ( str.equalsIgnoreCase("POP3") )
            {
                setIcon( image1 );
            }
            else if ( str.equalsIgnoreCase("IMAP4") )
            {
                setIcon( image2 );
            }
            }

	    setText( str );
	    return this;
	}
    }


