/*
 * (c) Copyright 2001 MyCorporation.
 * All Rights Reserved.
 */
package org.columba.gui.config.accountwizard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

import org.columba.gui.util.*;
/**
 * @version 	1.0
 * @author
 */
public class AdvancedPanel extends DefaultWizardPanel
{

	private JLabel nameLabel;
	private JTextField nameTextField;

	public AdvancedPanel(
		JDialog dialog,
		ActionListener listener,
		String title,
		String description,
		ImageIcon icon)
	{
		super(dialog, listener, title, description, icon, DefaultWizardPanel.MIDDLE);
	}

	public AdvancedPanel(
		JDialog dialog,
		ActionListener listener,
		String title,
		String description,
		ImageIcon icon,
		boolean b)
	{
		super(dialog, listener, title, description, icon, DefaultWizardPanel.LAST);
	}

	protected JTextField getAddressTextField()
	{
		IdentityPanel p = (IdentityPanel) prevPanel.prevPanel.prevPanel;

		JTextField address = p.getAddressTextField();

		return address;
	}

	public void select()
	{		
		nameTextField.setCaretPosition( nameTextField.getText().length() );
		nameTextField.selectAll();		
	}
	
	
	public String getAccountName()
	{
		return getAddressTextField().getText();
	}
	
	public void setPrev(DefaultWizardPanel panel)
	{
		prevPanel = panel;

		getAddressTextField().getDocument().addDocumentListener(new DocumentListener()
		{
			public void insertUpdate(DocumentEvent e)
			{
				update();
			}

			public void removeUpdate(DocumentEvent e)
			{
				update();
			}

			public void changedUpdate(DocumentEvent e)
			{
				update();
				//Plain text components don't fire these events
			}
			public void update()
			{

				nameTextField.setText(getAddressTextField().getText());
			}
		});
	}

	protected JPanel createPanel(ActionListener listener)
	{
		JPanel panel = new JPanel();
		panel.setBorder(BorderFactory.createEmptyBorder(30, 30, 20, 30));
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));

		MultiLineLabel label =
			new MultiLineLabel("Enter the name by which you like to refer to this account.");

		panel.add(label);

		//panel.add(Box.createRigidArea(new java.awt.Dimension(0, 40)));

		WizardTextField middlePanel = new WizardTextField();

		JLabel nameLabel = new JLabel("Account Name:");
		middlePanel.addLabel(nameLabel);
		nameTextField = new JTextField("");
		register(nameTextField);
		middlePanel.addTextField(nameTextField);
		JLabel nameExampleLabel = new JLabel("Example: Bill's Private Mail");
		middlePanel.addExample(nameExampleLabel);

		panel.add(middlePanel);
		
		MultiLineLabel label2 =
			new MultiLineLabel("If you want to, you can directly edit your advanced account preferences now.");
			
		panel.add( label2 );
		
		JButton button = new JButton("Advanced Preferences ...");
		button.setActionCommand("ACCOUNT");
		button.addActionListener( listener );
		button.setAlignmentX(1);
		panel.add( button );
			

		return panel;
	}

}