package org.columba.gui.config.accountwizard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;

import org.columba.gui.util.*;

public class IdentityPanel extends DefaultWizardPanel {
	private JLabel nameLabel;
	private JTextField nameTextField;
	private JLabel addressLabel;
	private JTextField addressTextField;

	private JLabel accountnameLabel;
	private JTextField accountnameTextField;

	public IdentityPanel(
		JDialog dialog,
		ActionListener listener,
		String title,
		String description,
		ImageIcon icon) {
		super(dialog, listener, title, description, icon, DefaultWizardPanel.MIDDLE);
	}

	public IdentityPanel(
		JDialog dialog,
		ActionListener listener,
		String title,
		String description,
		ImageIcon icon,
		boolean b) {
		super(dialog, listener, title, description, icon, DefaultWizardPanel.FIRST);
	}

	

	public String getName() {
		return nameTextField.getText();
	}

	public String getAddress() {
		return addressTextField.getText();
	}
	
	public JTextField getAddressTextField()
	{
		return addressTextField;
	}

	protected JPanel createPanel(ActionListener listener) {
		JPanel panel = new JPanel();
		panel.setBorder(BorderFactory.createEmptyBorder(30, 30, 20, 30));
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));

		MultiLineLabel label =
			new MultiLineLabel("If you send a message, your name and address are visible in the From-Field of the message.\nPlease enter your name as you want it to appear.");

		panel.add(label);

		panel.add(Box.createRigidArea(new java.awt.Dimension(0, 40)));

		WizardTextField middlePanel = new WizardTextField();
		JLabel nameLabel = new JLabel("Your Name:");
		middlePanel.addLabel(nameLabel);
		nameTextField = new JTextField("");
		register( nameTextField );
		middlePanel.addTextField(nameTextField);
		JLabel exampleLabel = new JLabel("Example: Bill Gates");
		middlePanel.addExample(exampleLabel);

		JLabel addressLabel = new JLabel("E-Mail Address:");
		middlePanel.addLabel(addressLabel);
		addressTextField = new JTextField("");
		register( addressTextField );
		middlePanel.addTextField(addressTextField);
		JLabel addressExampleLabel = new JLabel("Example: BillGates@microsoft.com");
		middlePanel.addExample(addressExampleLabel);

		panel.add(middlePanel);

		return panel;
	}

}