package org.columba.gui.config.accountwizard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import org.columba.gui.util.*;

public class IncomingServerPanel
	extends DefaultWizardPanel
	implements ActionListener
{
	private JLabel loginLabel;
	private JTextField loginTextField;

	private JLabel hostLabel;
	private JTextField hostTextField;

	private JLabel addressLabel;

	private JLabel typeLabel;
	private JComboBox typeComboBox;

	public IncomingServerPanel(
		JDialog dialog,
		ActionListener listener,
		String title,
		String description,
		ImageIcon icon)
	{
		super(dialog, listener, title, description, icon, DefaultWizardPanel.MIDDLE);
	}

	public boolean isPopAccount()
	{
		if (typeComboBox.getSelectedIndex() == 0)
			return true;
		else
			return false;
	}
	
	public JTextField getIncomingHostTextField()
	{
		return hostTextField;
	}

	public String getHost()
	{
		return hostTextField.getText();
	}

	public String getLogin()
	{
		return loginTextField.getText();
	}

	protected JPanel createPanel(ActionListener listener)
	{
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		panel.setBorder(BorderFactory.createEmptyBorder(30, 30, 20, 30));

		MultiLineLabel label =
			new MultiLineLabel("Please specify your incoming mail server properties. If you are unsure please\nask your system administrator or internet service provider for help.");

		panel.add(label);

		panel.add(Box.createRigidArea(new java.awt.Dimension(0, 40)));

		WizardTextField middlePanel = new WizardTextField();
		JLabel nameLabel = new JLabel("Login (user):");
		middlePanel.addLabel(nameLabel);
		loginTextField = new JTextField("");
		register(loginTextField);
		middlePanel.addTextField(loginTextField);
		JLabel exampleLabel = new JLabel("Example: billgates");
		middlePanel.addExample(exampleLabel);

		addressLabel = new JLabel("Host (POP3 Server):");
		middlePanel.addLabel(addressLabel);
		hostTextField = new JTextField("");
		register(hostTextField);
		middlePanel.addTextField(hostTextField);
		JLabel addressExampleLabel = new JLabel("Example: mail.microsoft.com");
		middlePanel.addExample(addressExampleLabel);

		JLabel typeLabel = new JLabel("Type:");
		middlePanel.addLabel(typeLabel);
		typeComboBox = new JComboBox();
		typeComboBox.addItem("POP3");
		typeComboBox.addItem("IMAP4");
		typeComboBox.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				if (typeComboBox.getSelectedIndex() == 0)
					addressLabel.setText("Host (POP3 Server):");

				else
					addressLabel.setText("Host (IMAP Server):");
			}
		});

		middlePanel.addTextField(typeComboBox);
		middlePanel.addEmptyExample();
		panel.add(middlePanel);

		return panel;
	}

}