package org.columba.gui.config.accountwizard;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;

import org.columba.gui.util.*;

public class OutgoingServerPanel extends DefaultWizardPanel
{
	private JLabel hostLabel;
	private JTextField hostTextField;

	public OutgoingServerPanel(
		JDialog dialog,
		ActionListener listener,
		String title,
		String description,
		ImageIcon icon)
	{
		super(dialog, listener, title, description, icon, DefaultWizardPanel.MIDDLE);
	}

	public OutgoingServerPanel(
		JDialog dialog,
		ActionListener listener,
		String title,
		String description,
		ImageIcon icon,
		boolean b)
	{
		super(dialog, listener, title, description, icon, DefaultWizardPanel.MIDDLE);
	}

	public String getHost()
	{
		return hostTextField.getText();
	}

	public JTextField getIncomingHostTextField()
	{
		IncomingServerPanel p = (IncomingServerPanel) prevPanel;

		JTextField host = p.getIncomingHostTextField();

		return host;
	}
	
	public void select()
	{		
		hostTextField.setCaretPosition( hostTextField.getText().length() );
		hostTextField.selectAll();
	}

	public void setPrev(DefaultWizardPanel panel)
	{
		prevPanel = panel;

		getIncomingHostTextField()
			.getDocument()
			.addDocumentListener(new DocumentListener()
		{
			public void insertUpdate(DocumentEvent e)
			{
				update();
			}

			public void removeUpdate(DocumentEvent e)
			{
				update();
			}

			public void changedUpdate(DocumentEvent e)
			{
				update();
				//Plain text components don't fire these events
			}
			public void update()
			{

				hostTextField.setText(getIncomingHostTextField().getText());
			}
		});
	}

	protected JPanel createPanel(ActionListener listener)
	{
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		panel.setBorder(BorderFactory.createEmptyBorder(30, 30, 20, 30));

		MultiLineLabel label =
			new MultiLineLabel("Please specify your outgoing mail server properties. If you are unsure please\nask your system administrator or internet service provider for help.");

		panel.add(label);

		panel.add(Box.createRigidArea(new java.awt.Dimension(0, 40)));

		WizardTextField middlePanel = new WizardTextField();

		JLabel addressLabel = new JLabel("Host (SMTP Server):");
		middlePanel.addLabel(addressLabel);
		hostTextField = new JTextField("");
		register(hostTextField);
		middlePanel.addTextField(hostTextField);
		JLabel addressExampleLabel = new JLabel("Example: mail.microsoft.com");
		middlePanel.addExample(addressExampleLabel);

		panel.add(middlePanel);

		return panel;
	}

}