// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.config.filter;

import org.columba.config.*;
import org.columba.message.*;
import org.columba.main.*;
import org.columba.filter.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;

import java.awt.*;
import java.awt.event.*;


import java.util.Vector;

public class BodyCriteriaRow extends DefaultCriteriaRow
{

    private JComboBox matchComboBox;
    private JTextField textField;


    public BodyCriteriaRow( MainInterface main, CriteriaList criteriaList, FilterCriteria c )
    {
        super( main, criteriaList, c );

    }

    protected void updateComponents( boolean b )
    {
        super.updateComponents(b);


        if ( b )
        {
            matchComboBox.setSelectedItem( criteria.getCriteria() );
            textField.setText( criteria.getPattern() );
        }
        else
        {
            criteria.setCriteria( (String) matchComboBox.getSelectedItem() );
            criteria.setPattern( (String) textField.getText() );
        }

    }


    public void initComponents()
    {
        super.initComponents();

	matchComboBox = new JComboBox();
	matchComboBox.addItem( "contains" );
	matchComboBox.addItem( "contains not" );
        c.gridx = 1;
        gridbag.setConstraints(matchComboBox, c);
        add( matchComboBox );

        textField = new JTextField("body text", 12);
        c.gridx = 2;
        gridbag.setConstraints( textField, c);
        add( textField );

        finishRow();


    }


}





