// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.config.filter;

import org.columba.config.*;
import org.columba.message.*;
import org.columba.main.*;
import org.columba.gui.tree.util.*;
import org.columba.folder.*;
import org.columba.filter.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;

import java.awt.*;
import java.awt.event.*;


import java.util.Vector;

public class DefaultActionRow extends JPanel
{
    protected FilterAction filterAction;

    protected MainInterface mainInterface;

    private JComboBox actionComboBox;

    protected GridBagLayout gridbag = new GridBagLayout();
    protected GridBagConstraints c = new GridBagConstraints();

    protected ActionList actionList;

    public DefaultActionRow( MainInterface main, ActionList list, FilterAction action )
    {
        this.filterAction = action;
        this.mainInterface = main;
        this.actionList = list;

        initComponents();

        updateComponents( true );

        actionComboBox.addActionListener( actionList );
    }

    protected void updateComponents( boolean b )
    {

        if ( b )
        {

            String name = (String) filterAction.getAction();
            actionComboBox.setSelectedItem( name );


        }
        else
        {
            String name = (String) actionComboBox.getSelectedItem();
            filterAction.setAction( name );



        }

    }


    public void initComponents()
    {
        removeAll();


        setLayout(gridbag);


        actionComboBox = new JComboBox();
        actionComboBox.addItem( "move" );
	actionComboBox.addItem( "copy" );
	actionComboBox.addItem( "markasread" );
	actionComboBox.addItem( "delete" );

        c.fill = GridBagConstraints.NONE;
        c.weightx = 1.0;
        c.insets = new Insets(2,5,2,5);
        c.gridx = 0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = 1 ;

        gridbag.setConstraints(actionComboBox, c);
        add( actionComboBox );

        validate();
        repaint();
    }






}












