package org.columba.gui.header.action;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import javax.swing.JTable;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class HeaderTableDnd implements DragGestureListener, DragSourceListener
{
    private JTable table;
    private DragSource dragSource;

    public HeaderTableDnd( JTable table )
    {
        this.table = table;

        dragSource = DragSource.getDefaultDragSource();
                // creating the recognizer is all that?s necessary - it
                // does not need to be manipulated after creation

        dragSource.createDefaultDragGestureRecognizer(
                table, // component where drag originates
                DnDConstants.ACTION_COPY_OR_MOVE, // actions
                this); // drag gesture listener
    }

    public void dragGestureRecognized(DragGestureEvent e)
    {
        InputEvent event =  e.getTriggerEvent();
        int mod = event.getModifiers();




        if ( (mod & InputEvent.BUTTON2_MASK) == InputEvent.BUTTON2_MASK )
        {
                //System.out.println("middle button pressed");

            if ( table.getSelectedRowCount() > 0 )
            {
                //mainInterface.treeViewer.saveTreePath();
                //messageNodes = getSelectedNodes();
                if ( ( mod & InputEvent.CTRL_MASK) == InputEvent.CTRL_MASK )
                {

                    //setSelection( getUidList() );
                    e.startDrag(DragSource.DefaultCopyDrop, // cursor
                                new StringSelection("message"), // transferable
                                this); // drag source listener


                }
                else
                {


                    e.startDrag(DragSource.DefaultMoveDrop, // cursor
                                new StringSelection("message"), // transferable
                                this); // drag source listener



                }

                //setSelection( oldMessageNodes );

            }

        }

            //System.out.println("draggesturerecognized");
    }

    public void dragDropEnd(DragSourceDropEvent e)
    {
            //System.out.println("dragdropend");
    }

    public void dragEnter(DragSourceDragEvent e)
    {
            //System.out.println("start enter");
    }

    public void dragExit(DragSourceEvent e)
    {
            //System.out.println("dragexit");
    }
    public void dragOver(DragSourceDragEvent e)
    {
        //System.out.println("dragover");
    }
    public void dropActionChanged(DragSourceDragEvent e)
    {
          //      System.out.println("dragactioncahnged");
    }
}