package org.columba.gui.header.util;

import javax.swing.*;
import java.awt.event.*;

import org.columba.main.MainInterface;
import org.columba.folder.*;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class MarkAsReadTimer implements ActionListener
{
    private Timer timer;

    private MainInterface mainInterface;

    private final static int ONE_SECOND = 1000;

    private int value;
    private int maxValue;

    private Folder folder;
    private Object[] uids;

    public MarkAsReadTimer( MainInterface mainInterface )
    {
        this.mainInterface = mainInterface;

        this.maxValue = mainInterface.config.getOptionsConfig().getIntegerGuiOptions("markasreaddelay",2);



        timer = new Timer( ONE_SECOND*maxValue, this );

    }

    public void setMaxValue( int i )
    {
        maxValue = i;
    }

    public synchronized void stopTimer()
    {
        value = 0;

        System.out.println("timer stopped--------->");

        timer.stop();
    }

    public synchronized void restart( Folder f, Object uid )
    {
        folder = f;
        uids = new Object[1];
        uids[0] = uid;

        System.out.println("timer started--------->");

        value = 0;
        timer.restart();
    }

    public void actionPerformed( ActionEvent e )
    {
        System.out.println("value: "+ value);

        timer.stop();

        System.out.println("timer starts markasread operation");

        FolderOperation op = new FolderOperation( Operation.MARK_READ, 0, uids, folder);
        mainInterface.crossbar.operate( op );

       
        value++;
    }
}