// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.header.util;

import javax.swing.*;
import java.awt.*;
import org.columba.gui.header.util.*;
import javax.swing.border.*;
import javax.swing.table.*;

import org.columba.gui.util.*;

import org.columba.message.*;


public class PriorityRenderer extends JLabel implements TableCellRenderer
{
    private Border unselectedBorder = null;
    private Border selectedBorder = null;
    private boolean isBordered = true;
    //private HeaderTable headerTable;

    private ImageIcon image1 = ImageLoader.getImageIcon("highestpriority","Highest16");
    private ImageIcon image2 = ImageLoader.getImageIcon("highpriority", "High16.jpeg");
    private ImageIcon image3 = ImageLoader.getImageIcon("lowpriority","Low16.jpeg");
    private ImageIcon image4 = ImageLoader.getImageIcon("lowestpriority","Lowest16.jpeg");

    public PriorityRenderer(boolean isBordered)
    {
        super();
	//this.headerTable = headerTable;
        this.isBordered = isBordered;


        setOpaque(true); //MUST do this for background to show up.

       
    }

        

    public Component getTableCellRendererComponent(
        JTable table, Object value,
        boolean isSelected, boolean hasFocus,
        int row, int column)
    {
        if (isBordered)
        {
            if (isSelected)
            {
                if (selectedBorder == null)
                {
                    selectedBorder = BorderFactory.createMatteBorder(2,5,2,5,table.getSelectionBackground() );
                }
                  //setBorder(selectedBorder);
                setBackground( table.getSelectionBackground() );
                setForeground( table.getSelectionForeground() );
            } else
            {
                if (unselectedBorder == null)
                {
                    unselectedBorder = BorderFactory.createMatteBorder(2,5,2,5,
                                                                       table.getBackground() );
                }
                setBackground( table.getBackground() );
                  //setBorder(unselectedBorder);
                setForeground( table.getForeground() );
            }
        }




        Integer in = (Integer) value;
        if ( in == null ) return this;

        int i = in.intValue();

        if ( i==1 )
        {
              //setForeground( Color.red );
              //setText("!!");
            setIcon( image1 );

        }

        else if ( i==2 )
        {
              //setForeground( Color.red );
            setIcon( image2 );
              //setText("!");
        }

        else if ( i==3 )
            setIcon(null);
        else if ( i==4 )
        {
            //eteTextForeground( Color.blue );
            setIcon( image3 );
              //setText("!");
        }

        else if ( i==5 )
        {
              //setForeground( Color.blue );
            setIcon( image4 );
              //setText("!!");
        }



        return this;
    }
}
