// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.header.util;


import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import javax.swing.table.*;
import org.columba.gui.util.*;
import org.columba.message.Flags;
import org.columba.gui.util.ImageLoader;


public class StatusRenderer extends JLabel implements TableCellRenderer
{
    Border unselectedBorder = null;
    Border selectedBorder = null;
    boolean isBordered = true;
    boolean bool;

    ImageIcon image1;
    ImageIcon image2;
    ImageIcon image4;
    ImageIcon image3;
    ImageIcon image5;
    ImageIcon image6;


    public StatusRenderer()
    {
        super();
        this.bool = bool;

        setHorizontalAlignment( SwingConstants.CENTER );
        setOpaque(true);


        image1 = ImageLoader.getImageIcon("replyflag","Redo16");
        image2 = ImageLoader.getImageIcon("newflag","unreadmail");
        image3 = ImageLoader.getImageIcon("expungeflag","Delete16");
        image4 = ImageLoader.getImageIcon("flaggedflag","Bookmarks16");
        image5 = ImageLoader.getImageIcon("readflag","readmail");
        image6 = ImageLoader.getImageIcon("unreadflag", "unreadmail" );

    }


    public Component getTableCellRendererComponent(
        JTable table, Object value,
        boolean isSelected, boolean hasFocus,
        int row, int column)
    {
        if (isBordered)
        {
            if (isSelected)
            {
                if (selectedBorder == null)
                {
                    selectedBorder = BorderFactory.createMatteBorder(2,5,2,5,table.getSelectionBackground() );
                }
                  //setBorder(selectedBorder);
                setBackground( table.getSelectionBackground() );
                setForeground( table.getSelectionForeground() );
            } else
            {
                if (unselectedBorder == null)
                {
                    unselectedBorder = BorderFactory.createMatteBorder(2,5,2,5,
                                                                       table.getBackground() );
                }
                setBackground( table.getBackground() );
                  //setBorder(unselectedBorder);
                setForeground( table.getForeground() );
            }
        }


        if ( value instanceof String ) return this;


	    Flags flags = ( Flags ) value;


	    /*
            if ( flags.getFlagged() )
            {
                setIcon( image4 );
            }
	    */

            if ( flags.getDeleted() )
            {
                setIcon( image3 );
            }
            else if ( flags.getAnswered() )
            {
                setIcon( image1 );
            }
	    else if ( !flags.getSeen() )
            {
                setIcon( image6 );

            }
	    else if ( flags.getSeen() )
            {
                  //setIcon( image5 );
                setIcon( image5 );
            }
	    else
            {
                setIcon( null );

            }


            return this;
    }
}






