package org.columba.gui.header.util;


import javax.swing.*;
import java.awt.*;
import javax.swing.tree.*;


import org.columba.gui.header.*;
import org.columba.gui.util.*;
import org.columba.message.*;


/**
 * TITLE:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class SubjectTreeCellRenderer extends DefaultTreeCellRenderer
{
    private ImageIcon image1;
    private ImageIcon image2;
    private Font plainFont,boldFont;

    private HeaderTable headerTable;

    private JTree tree1;


    public SubjectTreeCellRenderer( JTree tree )
    {
        super();
        this.tree1 = tree;

        this.headerTable = headerTable;

	    image1 = ImageLoader.getImageIcon("", "folder1");

	    //image2 = ImageLoader.getImageIcon("table.unread", "");
	    image2 = null;

            boldFont = UIManager.getFont("Label.font");
            boldFont = boldFont.deriveFont( Font.BOLD );

            plainFont = UIManager.getFont("Label.font");

    }

    public Component getTreeCellRendererComponent(
						      JTree tree, Object value,
						      boolean isSelected, boolean expanded,
						      boolean leaf, int row,
						      boolean hasFocus)
       {

	   super.getTreeCellRendererComponent(tree, value, isSelected, expanded, leaf, row, hasFocus);

           TreePath path = tree1.getPathForRow( row );
           if ( path == null ) return this;

           MessageNode messageNode =  (MessageNode) path.getLastPathComponent();


            ColumbaHeader header = messageNode.getHeader();
            if ( header == null )
            {
                System.out.println("header is null");
                return this;
            }

	    if ( header.getFlags() != null )
                {
                    if ( header.getFlags().getRecent() )
                    {
                        setFont( boldFont );
                    }
                    else
                    {
                        setFont( plainFont );
                    }
                }

            String subject = (String) header.get("subject");
            if ( subject != null )
            setText( subject );

            setIcon( null );

	   return this;
       }
}
