// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.mainframe;


import javax.swing.*;

import org.columba.gui.mainframe.*;
import org.columba.gui.util.*;
import org.columba.message.*;
import org.columba.gui.themes.*;
import org.columba.gui.action.*;
import org.columba.gui.statusbar.*;

import java.util.*;

import java.awt.event.*;
import java.awt.*;

import org.columba.main.*;


class Toolbar extends JToolBar
{
      /*
      private CButton getMessageButton;
    private CButton newMessageButton;
    private CButton replyButton;
    private CButton replytoallButton;
    private CButton forwardButton;
    private CButton exitButton;
      */

    private CheckButton check;

    private MainInterface mainInterface;

    ResourceBundle toolbarLabels;
    GridBagConstraints gridbagConstraints;
    GridBagLayout gridbagLayout;
    int i;


    public Toolbar(MainInterface mainInterface)
        {
            super();
	    this.mainInterface = mainInterface;



            addCButtons();

	    putClientProperty("JToolBar.isRollover",Boolean.TRUE);


            setFloatable(false);
        }



    public void addButton( CButton button )
    {
	
	button.setRolloverEnabled(true);

        add( button  );

    }


    public void addCButtons()
        {
	    MouseAdapter handler = StatusBar.getHandler();
	    CButton button;


            i=0;


              addSeparator();

	    button = new CButton( mainInterface.globalActionCollection.newMessageAction );

	    addButton( button );






              addSeparator();

            button = new CButton( mainInterface.globalActionCollection.receiveSendAction );


            addButton( button );


              addSeparator();

	    button = new CButton( mainInterface.headerTableViewer.getActionListener().replyAction );
            addButton( button  );

              /*
                button = new CButton( mainInterface.headerTableViewer.getActionListener().replyToAllAction );
                addButton( button  );
              */

	    button = new CButton( mainInterface.headerTableViewer.getActionListener().forwardAction );
	    addButton( button  );

              addSeparator();
              addSeparator();


            button = new CButton( mainInterface.globalActionCollection.addressbookAction );
            addButton( button );

              addSeparator();
              addSeparator();


            button = new CButton( mainInterface.globalActionCollection.cancelAction );
            mainInterface.taskManager.setCancelButton( button );
            addButton( button );


            /*
            addSeparator();
              addSeparator();


	    button = new CButton( mainInterface.mainFrame.exitAction );


            addButton( button );
            */

            add( Box.createHorizontalGlue() );

            mainInterface.imageSequenceTimer.setAlignmentX( SwingConstants.RIGHT );
            //mainInterface.imageSequenceTimer.setAlignmentY( SwingConstants.BOTTOM );

            add( mainInterface.imageSequenceTimer );

            addSeparator();


        }


}


