// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.mainframe.action;

import org.columba.gui.mainframe.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;
import java.awt.Font;


import org.columba.message.*;

import org.columba.main.*;

import org.columba.gui.composer.*;
import org.columba.gui.tree.*;
import org.columba.gui.tree.util.*;
import org.columba.gui.addressbook.*;
import org.columba.folder.*;
import org.columba.folder.outbox.*;
import org.columba.config.*;
import org.columba.gui.config.search.*;
import org.columba.gui.util.*;
import org.columba.gui.themes.*;
import javax.swing.plaf.metal.*;
import org.columba.gui.config.themes.*;
import org.columba.gui.themes.thincolumba.*;
import org.columba.gui.themes.contrastcolumba.*;


public class MainActionListener implements ActionListener
{
    private MainInterface mainInterface;

    public MainActionListener(MainInterface mainInterface)
    {
	this.mainInterface = mainInterface;
    }

    public void actionPerformed(ActionEvent e)
    {
	String action  = e.getActionCommand();




        if ( action.equals("ACCOUNT_PREFERENCES") )
        {
	    org.columba.gui.config.account.ConfigFrame frame =
		new org.columba.gui.config.account.ConfigFrame( mainInterface );

        }

        else if ( action.equals( mainInterface.globalActionCollection.searchMessageAction.getActionCommand() ) )
        {
            System.out.println("search messages");

            Folder searchFolder = mainInterface.treeViewer.getFolderTree().getFolder( 106 );

            //AdapterNode searchNode = searchFolder.getNode();


              //TreeNodeList destList = new TreeNodeList( "/Local Message/Search Result" );
              //VirtualFolder destFolder = (VirtualFolder) searchFolder.getFolder();

            org.columba.gui.config.search.SearchFrame frame =
		new org.columba.gui.config.search.SearchFrame(
                    mainInterface, searchFolder  );


        }
        else if ( action.equals("RECEIVESEND") )
        {
            System.out.println("receive and send messages");
            mainInterface.popServerCollection.fetchAllServers();

	    mainInterface.crossbar.operate( new OutboxOperation( Operation.SMTP_SENDALL ) );

        }
        else if ( action.equals("RECEIVE") )
        {
            System.out.println("receive messages");
            mainInterface.popServerCollection.fetchAllServers();

        }
        else if ( action.equals("SEND") )
        {
            System.out.println("send messages");
	    mainInterface.crossbar.operate( new OutboxOperation( Operation.SMTP_SENDALL ) );
        }
        else if ( action.equals("VIEW_TOOLBAR") )
        {
            System.out.println("show toolbar");

            boolean folderInfo = mainInterface.mainFrameWindowItem.isShowFolderInfo();

            if ( mainInterface.mainFrameWindowItem.isShowToolbar() == true  )
            {

                mainInterface.mainFrame.hideToolbar( folderInfo);
                mainInterface.mainFrameWindowItem.setShowToolbar( "false" );
            }
            else
            {

                mainInterface.mainFrame.showToolbar( folderInfo );
                mainInterface.mainFrameWindowItem.setShowToolbar( "true" );
            }

        }
        else if ( action.equals("VIEW_FILTERTOOLBAR") )
        {
            System.out.println("show filtertoolbar");

            if ( mainInterface.mainFrameWindowItem.isShowFilterToolbar() == true   )
            {

                mainInterface.headerTableViewer.hideToolbar();
                mainInterface.mainFrameWindowItem.setShowFilterToolbar( "false" );
            }
            else
            {

                mainInterface.headerTableViewer.showToolbar();
                mainInterface.mainFrameWindowItem.setShowFilterToolbar( "true" );
            }
        }
        else if ( action.equals("VIEW_FOLDERINFO") )
        {
            System.out.println("show folderinfo");

            boolean toolbar = mainInterface.mainFrameWindowItem.isShowToolbar();

            if ( mainInterface.mainFrameWindowItem.isShowFolderInfo() == true  )
            {

                mainInterface.mainFrame.hideFolderInfo( toolbar );
                mainInterface.mainFrameWindowItem.setShowFolderInfo( "false" );
            }
            else
            {

                mainInterface.mainFrame.showFolderInfo( toolbar );
                mainInterface.mainFrameWindowItem.setShowFolderInfo( "true" );
            }

        }
        else if ( action.equals("USE_ADVANCEDVIEWER") )
        {
            System.out.println("advance dviewer");

            boolean b = mainInterface.mainFrameWindowItem.getAdvancedViewer();

            if ( b == true  )
            {

                mainInterface.messageViewer.createTextPane( false, false );
                mainInterface.mainFrameWindowItem.setAdvancedViewer( false );
            }
            else
            {

                mainInterface.messageViewer.createTextPane( true, false );
                mainInterface.mainFrameWindowItem.setAdvancedViewer( true );
            }



        }
        else if ( action.equals("ABOUT") )
        {
            AboutDialog dialog = new AboutDialog(mainInterface);


        }
        else if ( action.equals("ADDRESSBOOK") )
        {
            AddressbookFrame frame = new AddressbookFrame( mainInterface );


        }
        else if ( action.equals("MAIN_PREFERENCES") )
        {
            ThemeDialog dialog = new ThemeDialog( mainInterface );
                                                  

            if ( dialog.getStatus() == 0 )
            {               				
		ThemeSwitcher.setTheme( mainInterface );
		ThemeSwitcher.updateFrame( mainInterface.mainFrame );
            }

        }





    }
}












