// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.



package org.columba.gui.mainframe.menu;

import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.*;

import org.columba.gui.mainframe.action.*;
import org.columba.gui.statusbar.*;

import org.columba.gui.mainframe.*;
import org.columba.main.*;
import org.columba.message.*;
import org.columba.pop3.*;
import org.columba.config.*;
import org.columba.gui.action.*;
import org.columba.gui.util.CMenuItem;

import org.columba.gui.util.*;

public class Menu
{
    JMenuBar menuBar;
   

    private MainInterface mainInterface;
    private MouseAdapter handler;

    private JMenu fetchMessageSubmenu;
    private JMenu manageSubmenu;
    private JMenu sortSubMenu;


    public Menu( MainInterface mainInterface)
        {
	    this.mainInterface = mainInterface;


          

	    handler = StatusBar.getHandler();
            init();
        }

   

    public void updatePopServerMenu()
    {
	CMenuItem menuItem;

	fetchMessageSubmenu.removeAll();
        for ( int i=0; i<mainInterface.popServerCollection.count(); i++ )
        {
            PopServer server = mainInterface.popServerCollection.get(i);
            server.updateAction();
            fetchMessageSubmenu.add( new CMenuItem( server.getCheckAction() ) );
        }



	manageSubmenu.removeAll();
        for ( int i=0; i<mainInterface.popServerCollection.count(); i++ )
        {
            PopServer server = mainInterface.popServerCollection.get(i);
            server.updateAction();
            menuItem = new CMenuItem(server.getManageAction() );
            manageSubmenu.add( menuItem );
        }

    }




            // create the menu
    private void init()
        {
	    handler = mainInterface.statusBar.getHandler();

            JMenu menu,subMenu;
            JMenuItem menuItem;
            JRadioButtonMenuItem rbMenuItem;
            ButtonGroup group;




            menuBar = new JMenuBar();


            menu = new JMenu(ResourceLoader.getString("action/mail","menu_file") );
	    menu.setMnemonic(KeyEvent.VK_F);
	    menuBar.add(menu);



	    fetchMessageSubmenu = new JMenu(ResourceLoader.getString("action/mail","menu_file_checkmessage") );


            for ( int i=0; i<mainInterface.popServerCollection.count(); i++ )
            {
                fetchMessageSubmenu.add( new CMenuItem( mainInterface.popServerCollection.get(i).getCheckAction() ) );
            }


	    menu.add( fetchMessageSubmenu );


            menu.addSeparator();

              /*
                JMenuItem item = new JMenuItem("Receive and Send Messages");
                item.setActionCommand("RECEIVE_SEND");
                item.addActionListener( new MainActionListener( mainInterface ) );
              */

            menuItem = new CMenuItem( mainInterface.globalActionCollection.receiveSendAction );
            menuItem.addMouseListener( handler );
            menu.add( menuItem );

              //menu.addSeparator();

            JMenuItem item = new JMenuItem(ResourceLoader.getString("action/mail","menu_file_receive") );
            item.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_T, ActionEvent.CTRL_MASK ) );
            item.setActionCommand("RECEIVE");
            item.addActionListener( new MainActionListener( mainInterface ) );
            menu.add( item );

            item = new JMenuItem(ResourceLoader.getString("action/mail","menu_file_send") );
            item.setActionCommand("SEND");
            item.addActionListener( new MainActionListener( mainInterface ) );
            menu.add( item );


            menu.addSeparator();

            manageSubmenu = new JMenu(ResourceLoader.getString("action/mail","menu_file_manage") );


            for ( int i=0; i<mainInterface.popServerCollection.count(); i++ )
            {
                menuItem = new CMenuItem(mainInterface.popServerCollection.get(i).getManageAction() );
                menuItem.setEnabled( true );
                manageSubmenu.add( menuItem );
            }


            menu.add(manageSubmenu);

            menu.addSeparator();


            /*
            menuItem = new JMenuItem("Print Message...");
            menuItem.setEnabled( false );
            menu.add( menuItem );
            menu.addSeparator();
            */




            menuItem = new CMenuItem( mainInterface.mainFrame.exitAction ) ;
	    menuItem.addMouseListener( handler );
	    menu.add(  menuItem );


            menu = new JMenu(ResourceLoader.getString("action/global","menu_edit") );
	    menu.setMnemonic(KeyEvent.VK_E);
            menuBar.add(menu);


	    menuItem = new CMenuItem( mainInterface.globalActionCollection.cutAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

	    menuItem = new CMenuItem( mainInterface.globalActionCollection.copyAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

	    menuItem = new CMenuItem( mainInterface.globalActionCollection.pasteAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );


            menuItem = new CMenuItem( mainInterface.globalActionCollection.deleteAction );
            menuItem.addMouseListener( handler );
            menu.add( menuItem );


	    menuItem = new CMenuItem( mainInterface.globalActionCollection.selectAllAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menu.addSeparator();

            menuItem = new JMenuItem(ResourceLoader.getString("action/global","menu_edit_find"), 
				      ImageLoader.getImageIcon("search_small", "Find16" ) );
	    menuItem.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_F, ActionEvent.CTRL_MASK ) );
	    menuItem.setMnemonic(KeyEvent.VK_F);

            menuItem.setEnabled(false);
	    menu.add(menuItem);

            menuItem = new JMenuItem(ResourceLoader.getString("action/global","menu_edit_findagain") );

	    menuItem.setMnemonic(KeyEvent.VK_G);
	    menuItem.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_G, ActionEvent.CTRL_MASK ) );
            menuItem.setEnabled(false);
	    menu.add(menuItem);

            menu.addSeparator();

            menuItem = new CMenuItem( mainInterface.globalActionCollection.searchMessageAction );
            menuItem.addMouseListener( handler );
            menu.add( menuItem );




            menu = new JMenu(ResourceLoader.getString("action/global","menu_view") );
	    menu.setMnemonic(KeyEvent.VK_V);
            menuBar.add(menu);


            subMenu = new JMenu("Show/Hide Panel");

            JCheckBoxMenuItem cbMenuItem = new JCheckBoxMenuItem( mainInterface.globalActionCollection.viewToolbarAction );
            cbMenuItem.addActionListener( new MainActionListener( mainInterface ) );
            cbMenuItem.setActionCommand("VIEW_TOOLBAR");
            if ( mainInterface.mainFrameWindowItem.isShowToolbar()   ) cbMenuItem.setSelected( true );
            subMenu.add( cbMenuItem );

            cbMenuItem = new JCheckBoxMenuItem( mainInterface.globalActionCollection.viewFilterToolbarAction );
            cbMenuItem.addActionListener( new MainActionListener( mainInterface ) );
            cbMenuItem.setActionCommand("VIEW_FILTERTOOLBAR");
            if ( mainInterface.mainFrameWindowItem.isShowFilterToolbar()  ) cbMenuItem.setSelected( true );
            subMenu.add( cbMenuItem );

            cbMenuItem = new JCheckBoxMenuItem( mainInterface.globalActionCollection.viewFolderInfoAction );
            cbMenuItem.addActionListener( new MainActionListener( mainInterface ) );
            cbMenuItem.setActionCommand("VIEW_FOLDERINFO");
            if ( mainInterface.mainFrameWindowItem.isShowFolderInfo()  ) cbMenuItem.setSelected( true );
            subMenu.add( cbMenuItem );

            menu.add( subMenu );

            menu.addSeparator();

	    /*
            cbMenuItem = new JCheckBoxMenuItem( mainInterface.globalActionCollection.useAdvancedViewerAction );
            //cbMenuItem.addActionListener( new MainActionListener( mainInterface ) );
            cbMenuItem.setActionCommand("USE_ADVANCEDVIEWER");
            if ( mainInterface.mainFrameWindowItem.getAdvancedViewer()  ) cbMenuItem.setSelected( true );
            menu.add( cbMenuItem );

            menu.addSeparator();
	    */

            sortSubMenu = new JMenu(ResourceLoader.getString("action/mail","menu_view_sort") );
            updateSortMenu();
            menu.add( sortSubMenu );

            subMenu = new JMenu( "Messages Filter" );

            group = new ButtonGroup();
            menuItem = new JRadioButtonMenuItem("Show All Messages");
            menuItem.setSelected( true );
            menuItem.setActionCommand("ALL");
            menuItem.addActionListener( mainInterface.headerTableViewer.getFilterActionListener() );
            group.add( menuItem );
            subMenu.add( menuItem );
            menuItem = new JRadioButtonMenuItem("Show Unread Messages");
            group.add( menuItem );
            menuItem.setActionCommand("UNREAD");
            menuItem.addActionListener( mainInterface.headerTableViewer.getFilterActionListener() );
            subMenu.add( menuItem );
            menu.add( subMenu );

            menu.addSeparator();

            cbMenuItem = new JCheckBoxMenuItem(
                       mainInterface.headerTableViewer.getActionListener().viewThreadedAction );

            menu.add( cbMenuItem );

            menu.addSeparator();

	    subMenu = new JMenu(ResourceLoader.getString("action/mail","menu_view_next") );
	    subMenu.setIcon( ImageLoader.getImageIcon("nextmessage_small", "Down16" ) );
	    subMenu.setMnemonic(KeyEvent.VK_N);


	    menuItem = new CMenuItem(mainInterface.headerTableViewer.getActionListener().nextAction);
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem  );
	    menuItem = new CMenuItem(mainInterface.headerTableViewer.getActionListener().nextUnreadAction);
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );
	    menuItem = new JMenuItem(ResourceLoader.getString("action/mail","menu_view_nextflaggedmessage"), KeyEvent.VK_M);
	    menuItem.setEnabled(false);
	    menuItem.setMnemonic(KeyEvent.VK_F);
	    subMenu.add( menuItem );
	    subMenu.addSeparator();
	    menuItem = new JMenuItem(ResourceLoader.getString("action/mail","menu_view_nextunreadthread"), KeyEvent.VK_M);
	    menuItem.setEnabled(false);
	    menuItem.setAccelerator( KeyStroke.getKeyStroke("T") );
	    menuItem.setMnemonic(KeyEvent.VK_T);
	    subMenu.add( menuItem );

	    menu.add( subMenu );

	    subMenu = new JMenu(ResourceLoader.getString("action/mail","menu_view_prev") );
	    subMenu.setIcon( ImageLoader.getImageIcon("prevmessage_small", "Up16" ) );
	    subMenu.setMnemonic(KeyEvent.VK_P);


	    menuItem = new CMenuItem(mainInterface.headerTableViewer.getActionListener().prevAction);
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem  );
	    menuItem = new CMenuItem(mainInterface.headerTableViewer.getActionListener().prevUnreadAction);
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );
	    menuItem = new JMenuItem(ResourceLoader.getString("action/mail","menu_view_prevflaggedmessage"), KeyEvent.VK_M);
	    menuItem.setMnemonic(KeyEvent.VK_F);
	    menuItem.setEnabled(false);
	    subMenu.add( menuItem );
	    subMenu.addSeparator();
	    menuItem = new JMenuItem(ResourceLoader.getString("action/mail","menu_view_prevunreadthread"), KeyEvent.VK_M);
	    menuItem.setMnemonic(KeyEvent.VK_T);
	    menuItem.setEnabled(false);
	    subMenu.add( menuItem );

	    menu.add( subMenu );


	    menu.addSeparator();

            menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().viewSourceAction);
            menuItem.addMouseListener( handler );
            menu.add( menuItem );

            /*
            menu.addSeparator();

	    menuItem = new JMenuItem("View With Browser", ImageLoader.getImageIcon("", "WebComponent16" ) );
	    menuItem.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_V, ActionEvent.CTRL_MASK ) );
	    menuItem.setMnemonic(KeyEvent.VK_B);
	    menuItem.setEnabled( false );
	    menu.add( menuItem );
            */

            menu = new JMenu(ResourceLoader.getString("action/mail","menu_folder") );
	    menu.setMnemonic(KeyEvent.VK_F);
            menuBar.add(menu);

            menuItem = new CMenuItem(mainInterface.treeViewer.getActionListener().addAction);
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
            menuItem = new CMenuItem(mainInterface.treeViewer.getActionListener().addVirtualAction);
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
	    menuItem =  new CMenuItem(mainInterface.treeViewer.getActionListener().renameAction);
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
	    menuItem =  new CMenuItem(mainInterface.treeViewer.getActionListener().removeAction);
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
            menu.addSeparator();
            menuItem =  new org.columba.gui.util.CMenuItem(mainInterface.treeViewer.getActionListener().moveupAction);
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
            menuItem =  new org.columba.gui.util.CMenuItem(mainInterface.treeViewer.getActionListener().movedownAction);
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
	    menu.addSeparator();
	    menuItem =  new CMenuItem(mainInterface.treeViewer.getActionListener().expungeAction);
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
	    menuItem =  new CMenuItem(mainInterface.treeViewer.getActionListener().emptyAction);
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
	    menuItem =  new CMenuItem(mainInterface.treeViewer.getActionListener().compactAction);
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
            menu.addSeparator();

            menuItem =  new CMenuItem(mainInterface.treeViewer.getActionListener().applyFilterAction);
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
            menuItem = new CMenuItem( mainInterface.treeViewer.getActionListener().filterPreferencesAction );
            menuItem.addMouseListener( handler );
            menu.add( menuItem );
            menu.addSeparator();
            menuItem = new CMenuItem( mainInterface.treeViewer.getActionListener().subscribeAction );
            menuItem.addMouseListener( handler );
            menu.add( menuItem );



            menu = new JMenu(ResourceLoader.getString("action/mail","menu_message") );
	    menu.setMnemonic(KeyEvent.VK_M);
            menuBar.add(menu);

            menuItem = new CMenuItem( mainInterface.globalActionCollection.newMessageAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().openMessageWithComposerAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().printAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

	    menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().saveAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menu.addSeparator();

	    menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().replyAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );



	    menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().replyToAllAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().replyToAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
	    
	    
            menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().replyAsAttachmentAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

	    menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().forwardAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().forwardInlineAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );
	    


	    menu.addSeparator();

	    menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().moveMessageAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

	    menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().copyMessageAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().deleteMessageAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menu.addSeparator();

            menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().addSenderAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menuItem = new CMenuItem( mainInterface.headerTableViewer.getActionListener().addAllSendersAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );

            menu.addSeparator();

	    subMenu = new JMenu(ResourceLoader.getString("action/mail","menu_message_mark") );
	    subMenu.setMnemonic( KeyEvent.VK_K );

	    menuItem = new CMenuItem(mainInterface.headerTableViewer.getActionListener().markAsReadAction);
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );
	    menuItem = new JMenuItem(ResourceLoader.getString("action/mail","menu_message_markthreadasread"), KeyEvent.VK_T);
	    menuItem.setEnabled(false);
	    subMenu.add( menuItem );
	    menuItem = new JMenuItem(ResourceLoader.getString("action/mail","menu_message_markallasread"), KeyEvent.VK_A);
	    menuItem.setAccelerator( KeyStroke.getKeyStroke("A") );
	    menuItem.setEnabled(false);
	    subMenu.add( menuItem );
	    subMenu.addSeparator();
	    menuItem = new CMenuItem(mainInterface.headerTableViewer.getActionListener().markAsFlaggedAction);
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );
	    menuItem = new CMenuItem(mainInterface.headerTableViewer.getActionListener().markAsExpungedAction);
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );

	    menu.add( subMenu );

            //menu.addSeparator();



            menu.add( subMenu );



            menu = new JMenu(ResourceLoader.getString("action/global","menu_utilities") );
            menu.setMnemonic('W');
            menuBar.add(menu);





            subMenu = new JMenu(ResourceLoader.getString("action/mail","menu_message_filteronmessage") );
            menuItem = new CMenuItem(
                mainInterface.headerTableViewer.getActionListener().filterSubjectAction );
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );
            menuItem = new CMenuItem(
                mainInterface.headerTableViewer.getActionListener().filterFromAction );
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );
            menuItem = new CMenuItem(
                mainInterface.headerTableViewer.getActionListener().filterToAction );
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );

            menu.add( subMenu );

            subMenu = new JMenu(ResourceLoader.getString("action/mail","menu_message_vfolderonmessage") );
            menuItem = new CMenuItem(
                mainInterface.headerTableViewer.getActionListener().vFolderSubjectAction );
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );
            menuItem = new CMenuItem(
                mainInterface.headerTableViewer.getActionListener().vFolderFromAction );
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );
            menuItem = new CMenuItem(
                mainInterface.headerTableViewer.getActionListener().vFolderToAction );
	    menuItem.addMouseListener( handler );
	    subMenu.add( menuItem );

            menu.add( subMenu );

            menu.addSeparator();

	    menuItem = new CMenuItem( mainInterface.globalActionCollection.addressbookAction );
	    menuItem.addMouseListener( handler );
            menu.add( menuItem );

            menu.addSeparator();

            menuItem = new JMenuItem( "Forget PGP Passphrase" );
            menu.add( menuItem );

            menu.addSeparator();

            menuItem = new JMenuItem("Import Mailbox...");
            menuItem.setEnabled( false );
            menu.add( menuItem );




            menu = new JMenu(ResourceLoader.getString("action/global","menu_preferences") );
            menu.setMnemonic('P');
            menuBar.add(menu);



            //menu.addSeparator();




            menuItem = new CMenuItem( mainInterface.globalActionCollection.printSetupAction );
	    menuItem.addMouseListener( handler );
	    menu.add( menuItem );



            //menu.addSeparator();

            menuItem = new JMenuItem(ResourceLoader.getString("action/mail","menu_edit_accountconfig"),
                           ImageLoader.getImageIcon("preferences_small", "Preferences16" ));
            menuItem.setMnemonic(KeyEvent.VK_U);
            menuItem.setActionCommand("ACCOUNT_PREFERENCES");
            menuItem.addActionListener( new MainActionListener( mainInterface ));
            menu.add(menuItem);


            //menu.addSeparator();

	    menuItem = new JMenuItem(ResourceLoader.getString("action/mail","menu_edit_preferences") );
				      //ImageLoader.getImageIcon("", "Preferences16" ) );
	    menuItem.setMnemonic(KeyEvent.VK_P);
            menuItem.setActionCommand("MAIN_PREFERENCES");
            menuItem.addActionListener( new MainActionListener( mainInterface ));
            menu.add(menuItem);

            //menu.addSeparator();




            menu = new JMenu(ResourceLoader.getString("action/global","menu_help") );
            menu.setMnemonic('H');
            menuBar.add(menu);

            menuItem = new JMenuItem(ResourceLoader.getString("action/global","menu_help_about"), 
				      ImageLoader.getImageIcon("about_small", "About16" ) );
            menuItem.setActionCommand("ABOUT");
            menuItem.setEnabled( true );
            menuItem.addActionListener(new MainActionListener( mainInterface ));
            menu.add(menuItem);

            menu.addSeparator();

            menuItem = new JMenuItem(ResourceLoader.getString("action/global","menu_help_help"), 
				      ImageLoader.getImageIcon("help_small", "Help16" ) );
            menuItem.setEnabled(false);
            menu.add(menuItem);
            menuItem = new JMenuItem(ResourceLoader.getString("action/global","menu_help_homepage"), KeyEvent.VK_P);
            menuItem.setEnabled(false);
            menu.add(menuItem);
            menuItem = new JMenuItem(ResourceLoader.getString("action/global","menu_help_faq"), KeyEvent.VK_P);
            menuItem.setEnabled(false);
            menu.add(menuItem);
            menuItem = new JMenuItem(ResourceLoader.getString("action/global","menu_help_bug"), KeyEvent.VK_P);
            menuItem.setEnabled(false);
            menu.add(menuItem);


        }

    public JMenuBar getMenuBar()
        {
            return menuBar;

        }


    public void updateSortMenu()
    {
	//FIXME


        HeaderTableItem v = mainInterface.headerTableItem;
        

        sortSubMenu.removeAll();

        ButtonGroup group = new ButtonGroup();
        JRadioButtonMenuItem menuItem;
        String c;

        for ( int i=0; i< v.count(); i++ )
        {
            c = (String) v.getName(i);



            boolean enabled = v.getEnabled(i);

            if ( enabled == true )
            {
                String str = null;
                try
                {
                    str = ResourceLoader.getString("header/mail",c.toLowerCase());
                }
                catch ( Exception ex )
                {
                    //ex.printStackTrace();
                    System.out.println("exeption: "+ex.getMessage());
                    str = c;
                }

                menuItem = new JRadioButtonMenuItem( str );
                menuItem.setActionCommand( c );
                menuItem.addActionListener( mainInterface.headerTableViewer.getHeaderItemActionListener() );
                if ( c.equals( mainInterface.headerTableViewer.getTableModelSorter().getSortingColumn() ) )
                    menuItem.setSelected( true );

                  //menuItem.addActionListener( new MainActionListener( mainInterface ));

                sortSubMenu.add(menuItem);
                group.add(menuItem);
            }

        }

        menuItem = new JRadioButtonMenuItem( "In Order Received" );
        menuItem.addActionListener( mainInterface.headerTableViewer.getHeaderItemActionListener() );
        sortSubMenu.add(menuItem);
        group.add(menuItem);



        sortSubMenu.addSeparator();

        group = new ButtonGroup();

        menuItem = new JRadioButtonMenuItem( "Ascending" );
        menuItem.addActionListener( mainInterface.headerTableViewer.getHeaderItemActionListener() );
        if ( mainInterface.headerTableViewer.getTableModelSorter().getSortingOrder() == true )
        menuItem.setSelected(true);

        sortSubMenu.add(menuItem);
        group.add(menuItem);
        menuItem = new JRadioButtonMenuItem( "Descending" );
        menuItem.addActionListener( mainInterface.headerTableViewer.getHeaderItemActionListener() );
        if ( mainInterface.headerTableViewer.getTableModelSorter().getSortingOrder() == false )
        menuItem.setSelected(true);
        sortSubMenu.add(menuItem);
        group.add(menuItem);

    }


}
