// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package org.columba.gui.message;

import javax.swing.JEditorPane;
import java.io.File;
import java.awt.Insets;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.text.html.*;


import org.columba.util.*;
import org.columba.folder.LocalFolder;
import org.columba.main.MainInterface;
import org.columba.gui.util.*;

public class HtmlViewer extends JTextPane implements AbstractDocumentViewer, HyperlinkListener
{
    boolean active;

    private JMenuItem menuItem;
    private JPopupMenu popup;

    private MainInterface mainInterface;

    private File tempFile = null;

    public HtmlViewer( MainInterface mainInterface )
    {
        super();

        this.mainInterface = mainInterface;


        setMargin( new Insets(5,5,5,5) );
        setEditable(false);
        addHyperlinkListener( this );

        active = false;
    }

    public void clearDoc()
    {
    }

    public void setDoc( String str )
    {	
     
	try
	{
	    tempFile = TempFileStore.createTempFile();
            LocalFolder.saveStringInFile( tempFile, str);
	    setPage( tempFile.toURL() );
	}
        catch ( Exception ex )
        {
            ex.printStackTrace();
        }	
	
    }

    public String getDoc()
    {
        return super.getText();
    }

    public void setActive( boolean b )
    {
        active = true;
    }

    public boolean isActive()
    {
        return active;
    }


    public void hyperlinkUpdate( HyperlinkEvent e )
    {
        if ( isEnabled() == false ) return;

         if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
         {
            JEditorPane pane = (JEditorPane) e.getSource();
            if (e instanceof HTMLFrameHyperlinkEvent)
            {
                HTMLFrameHyperlinkEvent evt = (HTMLFrameHyperlinkEvent)e;
                HTMLDocument doc = (HTMLDocument)pane.getDocument();
                doc.processHTMLFrameHyperlinkEvent(evt);
            }
            else
            {
                String str =  e.getURL().toString();

                if ( str.indexOf("@") != -1 )
                {
                    // found email address

                    System.out.println("found email address");
                }
                else
                {

		    UrlController c = new UrlController(mainInterface);
		    c.open( e.getURL().toString() );
		    

		    
		    
		    /*
                try
                {
                    pane.setPage(e.getURL());
                }
                catch (Exception ex)
                {
                    ex.printStackTrace();

                    if ( ex instanceof java.net.UnknownHostException )
                    {
                        JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                           "Unknown host exception: "+ex.getMessage() );
                    }
                    else
                    {
                        JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                           "Browser exception: "+ex.getMessage() );
                    }

                }
		    */
                }
            }
        }


    }
}
