// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.message;

import javax.swing.JTextArea;
import java.awt.Font;
import java.awt.Insets;

import org.columba.main.MainInterface;

public class SimpleTextViewer extends JTextArea implements AbstractDocumentViewer
{
    boolean active;

    public MainInterface mainInterface;

    public SimpleTextViewer( MainInterface mainInterface )
    {
        super();

        this.mainInterface = mainInterface;
        setLineWrap( true );

	Font font = new Font( mainInterface.themeItem.getTextFontName(), 
			      Font.PLAIN, 
			      mainInterface.themeItem.getTextFontSize() );
        setFont( font );

        setMargin( new Insets(5,5,5,5) );
        setEditable(false);

        active = false;
    }

    public void setDoc( String str )
    {
        if ( str.length() > 0 )
        {
            super.setText( str );
        }
        else
            setText("");

    }

    public String getDoc()
    {
        return super.getText();
    }

    public void clearDoc()
    {
        setText("");
    }

    public void setActive( boolean b )
    {
        active = true;
    }

    public boolean isActive()
    {
        return active;
    }

}

