// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package org.columba.gui.message.util;

import org.columba.gui.message.*;
import org.columba.gui.util.*;
import org.columba.gui.addressbook.*;
import org.columba.gui.addressbook.util.*;
import org.columba.config.*;
import org.columba.main.*;
import org.columba.folder.*;
import org.columba.gui.composer.*;

import javax.swing.tree.*;
import javax.swing.*;
import javax.swing.event.*;

import java.awt.*;
import java.awt.event.*;

import java.util.StringTokenizer;

public class HeaderFieldTree extends JPanel implements  MouseListener, ActionListener
{
    private String s;
    private DefaultTreeModel model;

    private JTree tree;
    private DefaultMutableTreeNode rootNode;

    private MessageHeader messageHeader;

    private JScrollPane scrollPane;

    private JPopupMenu popup;
    private JMenuItem menuItem;

    private int size;

    private String contact;
    private MainInterface mainInterface;

    public HeaderFieldTree( MainInterface mainInterface, String s )
    {

        super();
        this.mainInterface = mainInterface;

        this.s = s;


        parse( s );

        addMouseListener( this );

        setBorder( null );


        setLayout( new BoxLayout( this, BoxLayout.X_AXIS ) );

    }

    protected void parse( String str )
    {
        int index = str.indexOf(",");

        if ( index != -1 )
        {
            String label = str.substring( 0, index );
            label = label.trim();
            label = label+", ..";
            AddressLabel jLabel = new AddressLabel(
                                                mainInterface,
                                                label );

            jLabel.setIcon( ImageLoader.getImageIcon("","TipOfTheDay16") );
            add( jLabel );
        }


    }



    public void mousePressed(MouseEvent e)
    {
    }

    public void mouseReleased(MouseEvent e)
    {

    }

    public void mouseEntered(MouseEvent e)
    {

    }

    public void mouseExited(MouseEvent e)
    {

    }

    public void mouseClicked(MouseEvent e)
    {
        System.out.println("mouse clicked");



        popup = createMenu();

        Point point = e.getPoint();

        popup.show( e.getComponent(),
                    e.getX(), e.getY() );
    }


    protected JPopupMenu createMenu()
    {
        String address = s;

        JPopupMenu popup = new JPopupMenu();
        menuItem = new JMenuItem( "Reply to All" );
        menuItem.addActionListener(this);
        menuItem.setActionCommand("REPLY_ALL");
        menuItem.setEnabled( false );
        popup.add(menuItem);
        menuItem = new JMenuItem( "Add all Contacts to Addressbook" );
        menuItem.addActionListener(this);
        menuItem.setActionCommand("CONTACT_ALL");
        menuItem.setEnabled( false );
        popup.add(menuItem);
        popup.addSeparator();

        StringTokenizer tk = new StringTokenizer( s, "," );

        while ( tk.hasMoreTokens() )
        {
            String str = (String) tk.nextElement();
            str = str.trim();

            menuItem = new JMenuItem( str );
            menuItem.addActionListener(this);
            popup.add(menuItem);

        }

        return popup;
    }


    public void setContact( String s )
    {
        contact = s;
    }

    public void actionPerformed( ActionEvent e )
    {

        String action = e.getActionCommand();


        if ( action.equals("CONTACT") )
        {
            UrlController controller = new UrlController( mainInterface );
            controller.contact( contact );

        }
        else if ( action.equals("COMPOSE") )
        {
            UrlController controller = new UrlController( mainInterface );
            controller.compose( contact );


        }
        else
        {
            System.out.println("contact: "+ action );
            setContact( action );
            popup.setVisible( false );

            UrlController controller = new UrlController( mainInterface );
            controller.setAddress( action );
            popup = controller.createContactMenu( action );
            popup.show( this, 0, 0);


        }



    }
}
