package org.columba.gui.mimetype;


import org.columba.main.MainInterface;
import org.columba.parser.*;
import org.columba.message.*;
import org.columba.gui.message.*;

import javax.swing.*;
import java.io.*;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class ColumbaViewer extends DefaultViewer
{

    public ColumbaViewer( MainInterface mainInterface )
    {
        super( mainInterface );
    }

    


    public void openWith( MimeHeader header, File tempFile )
    {

        boolean save = false;
        ChooseViewerDialog viewerDialog = new ChooseViewerDialog(mainInterface.mainFrame,
                                                          header.contentType,
                                                          header.contentSubtype,
                                                          save );
        String viewer = viewerDialog.getViewer();
        save = viewerDialog.saveViewer();

        if(save) MimeRouter.setViewer( header, viewer );

	//System.out.println("tempfile:"+tempFile);
	
	String cmd = new String( viewer+" "+tempFile.toString() );

	//System.out.println("cmd:"+cmd);

        try {
            Runtime.getRuntime().exec( cmd );
        }
        catch( IOException e ) {
            JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                           "Error: "+e.getMessage() );
              //System.out.println( e );
        }
    }

    public void open( MimeHeader header, File tempFile )
    {
        String viewer = MimeRouter.getViewer( header );

        if( viewer == null )
        {
            boolean save = false;
            ChooseViewerDialog viewerDialog = new ChooseViewerDialog(mainInterface.mainFrame,
                                                          header.contentType,
                                                          header.contentSubtype,
                                                          save );
            viewer = viewerDialog.getViewer();
            save = viewerDialog.saveViewer();

            if(save) MimeRouter.setViewer( header, viewer );
        }



        try {
            Runtime.getRuntime().exec( viewer+" "+tempFile.toString() );
        }
        catch( IOException e ) {
            JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                           "Error: "+e.getMessage() );
              //System.out.println( e );
        }
    }


    public void openUrl( String url )
    {
        boolean save = false;
        String viewer;
        ChooseViewerDialog viewerDialog;

        viewer = MimeRouter.getViewer( "text", "html" );
        if( viewer == null )
        {

            viewerDialog = new ChooseViewerDialog(mainInterface.mainFrame,
                                                          "text",
                                                          "html",
                                                          save);

            viewer = viewerDialog.getViewer();
            save = viewerDialog.saveViewer();

            if(save) MimeRouter.setViewer( "text", "html", viewer );
        }

        try
        {
            Runtime.getRuntime().exec( viewer+" "+url );
        }
        catch( Exception ex )
        {
            ex.printStackTrace();
            JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                   "Error: "+ex.getMessage() );
        }
    }

    public void openWithUrl( String url )
    {
        boolean save = false;
        String viewer;
        ChooseViewerDialog viewerDialog;

        viewerDialog = new ChooseViewerDialog(mainInterface.mainFrame,
                                                          "text",
                                                          "html",
                                                          save);

        viewer = viewerDialog.getViewer();
        save = viewerDialog.saveViewer();

        if(save) MimeRouter.setViewer( "text", "html", viewer );


        try
        {
            Runtime.getRuntime().exec( viewer+" "+url );
        }
        catch( Exception ex )
        {
            ex.printStackTrace();
            JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                   "Error: "+ex.getMessage() );
        }
    }



}
