package org.columba.gui.mimetype;

import org.columba.main.MainInterface;
import org.columba.parser.*;
import org.columba.message.*;
import org.columba.gui.message.*;

import javax.swing.*;
import java.io.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class MimeTypeViewer
{
    private MainInterface mainInterface;
    private String osName;

    public MimeTypeViewer( MainInterface mainInterface )
    {
        this.mainInterface = mainInterface;

        osName = new String( System.getProperty("os.name") );
        //System.out.println("-----> OS Name: "+osName );
    }

    protected boolean isWindowsPlatform()
    {
     
        if ( osName.equals("Windows 95") ) return true;
        if ( osName.equals("Windows 98") ) return true;
        if ( osName.equals("Windows NT") ) return true;
        if ( osName.equals("Windows 2000") ) return true;
     

        return false;
    }

    public void openWith( MimeHeader header, File tempFile )
    {
        if ( isWindowsPlatform() == true )
        {
            WindowsViewer viewer = new WindowsViewer( mainInterface );
            viewer.open( header, tempFile );
        }
        else
        {
            ColumbaViewer viewer = new ColumbaViewer( mainInterface );
            viewer.openWith( header, tempFile );
        }
    }

    public void open( MimeHeader header, File tempFile )
    {
        if ( isWindowsPlatform() == true )
        {
            WindowsViewer viewer = new WindowsViewer( mainInterface );
            viewer.open( header, tempFile );
        }
        else
        {
            ColumbaViewer viewer = new ColumbaViewer( mainInterface );
            viewer.open( header, tempFile );
        }
    }


    public void openUrl( String url )
    {
        if ( isWindowsPlatform() == true )
        {
            WindowsViewer viewer = new WindowsViewer( mainInterface );
            viewer.openUrl( url );
        }
        else
        {
            ColumbaViewer viewer = new ColumbaViewer( mainInterface );
            viewer.openUrl( url );
        }
    }

    public void openWithUrl( String url )
    {
         if ( isWindowsPlatform() == true )
        {
            WindowsViewer viewer = new WindowsViewer( mainInterface );
            viewer.openUrl( url );
        }
        else
        {
            ColumbaViewer viewer = new ColumbaViewer( mainInterface );
            viewer.openWithUrl( url );
        }

    }


    public void openWithBrowserUrl( String url )
    {
        boolean b = mainInterface.messageViewer.getDocumentOperator().enableViewer( DocumentOperator.HTML );
        mainInterface.messageViewer.update(b);

        HtmlViewer viewer = (HtmlViewer) mainInterface.messageViewer.getDocumentOperator().getViewer( DocumentOperator.HTML );


        if ( viewer != null )
        {
            try
            {
                viewer.setPage( url );
            }
            catch ( Exception ex )
            {
                ex.printStackTrace();
                if ( ex instanceof java.net.UnknownHostException )
                {
                    JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                           "Unknown host exception: "+ex.getMessage() );
                }
                else
                {
                    JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                           "Browser exception: "+ex.getMessage() );
                }
            }
        }

    }



}
