package org.columba.gui.mimetype;

import org.columba.main.MainInterface;
import org.columba.parser.*;
import org.columba.message.*;
import org.columba.gui.message.*;

import javax.swing.*;
import java.io.*;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class WindowsViewer extends DefaultViewer
{

    public WindowsViewer(MainInterface mainInterface)
    {
        super( mainInterface );
    }

    public void openWith( MimeHeader header, File tempFile )
    {
        openDocument( tempFile.getPath() );
    }

    public void open( MimeHeader header, File tempFile )
    {
        openDocument( tempFile.getPath() );
    }

    public void openUrl( String url )
    {
        openDocument( url );
    }

    public void openWithUrl( String url )
    {
        openDocument( url );
    }



    protected void openDocument( String filename )
    {
        try
        {
            String osName = System.getProperty("os.name" );

	    Process proc = null;
            if ( ( osName.equals( "Windows NT" ) ) || ( osName.equals( "Windows 2000" ) ) )
            {
                String[] cmd = new String[3];
                cmd[0] = "cmd.exe" ;
                cmd[1] = "/C" ;
                cmd[2] = filename;

                Runtime rt = Runtime.getRuntime();
                System.out.println("Executing " + cmd[0] + " " + cmd[1] + " " + cmd[2]);

                proc = rt.exec(cmd);
            }
            else if ( ( osName.equals( "Windows 95" ) ) || ( osName.equals( "Windows 98" ) ) )
            {
                String[] cmd = new String[2];
                cmd[0] = "start";
                cmd[1] = filename;

                Runtime rt = Runtime.getRuntime();
                System.out.println("Executing " + cmd[0] + " " + cmd[1]);

                proc = rt.exec(cmd);
            }

            // any error message?
            StreamGobbler errorGobbler = new
                StreamGobbler(proc.getErrorStream(), "ERROR");

            // any output?
            StreamGobbler outputGobbler = new
                StreamGobbler(proc.getInputStream(), "OUTPUT");

            errorGobbler.start();
            outputGobbler.start();

            // any error?
            int exitVal = proc.waitFor();

            System.out.println("ExitValue: " + exitVal);

        }
        catch (Throwable t)
        {
            t.printStackTrace();
        }
    }

    class StreamGobbler extends Thread
    {
        InputStream is;
        String type;

        StreamGobbler(InputStream is, String type)
        {
            this.is = is;
            this.type = type;
        }

        public void run()
        {
            try
            {
                InputStreamReader isr = new InputStreamReader(is);
                BufferedReader br = new BufferedReader(isr);
                String line=null;
                while ( (line = br.readLine()) != null)
                      System.out.println(type + ">" + line);
            } catch (IOException ioe)
            {
                ioe.printStackTrace();
            }
        }
    }

}
