package org.columba.gui.pop3.action;


import org.columba.gui.pop3.*;
import org.columba.gui.action.*;
import org.columba.pop3.*;
import org.columba.gui.util.*;
import org.columba.gui.header.*;
import org.columba.gui.header.util.*;
import org.columba.message.*;

import java.awt.event.*;
import java.util.Vector;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class ManageActionListener implements ActionListener
{
    private ManageHeaderTableViewer headerTableViewer;
    private ManageFrame frame;

    public BasicAction synchronizeAction;
    public BasicAction fetchAction;
    public BasicAction deleteAction;
    public BasicAction closeAction;
    public BasicAction threadedViewAction;

    public ManageActionListener( ManageFrame frame, ManageHeaderTableViewer headerTableViewer)
    {
        this.headerTableViewer = headerTableViewer;
        this.frame = frame;
        initActions();
    }

    protected void initActions()
    {


	synchronizeAction = new BasicAction(
					   "Synchronize",
					   "Synchronize",
					   "SYNCHRONIZE",
                                           ImageLoader.getImageIcon("", "Host16"),
                                           ImageLoader.getImageIcon("", "Host24"),
					   '0',
					   null
					   );
        synchronizeAction.setEnabled( true );
        synchronizeAction.addActionListener( this );

        fetchAction = new BasicAction(
					   "Fetch",
					   "Fetch",
					   "FETCH",
                                           ImageLoader.getImageIcon("", "WebComponent16"),
                                           ImageLoader.getImageIcon("", "WebComponent24"),
					   '0',
					   null
					   );
        fetchAction.setEnabled( true );
        fetchAction.addActionListener( this );

        deleteAction = new BasicAction(
					   "Delete",
					   "Delete",
					   "DELETE",
                                           ImageLoader.getImageIcon("", "Delete16"),
                                           ImageLoader.getImageIcon("", "Delete24"),
					   '0',
					   null
					   );
        deleteAction.setEnabled( true );
        deleteAction.addActionListener( this );

        closeAction = new BasicAction(
					   "Close",
					   "Close",
					   "CLOSE",
                                           ImageLoader.getImageIcon("", "Home16"),
                                           ImageLoader.getImageIcon("", "Home24"),
					   '0',
					   null
					   );
        closeAction.setEnabled( true );
        closeAction.addActionListener( this );

        threadedViewAction = new BasicAction(
					   "Threaded View",
					   "Threaded View",
					   "THREADED_VIEW",
                                           null,null,
					   '0',
					   null
					   );
        threadedViewAction.setEnabled( true );
        threadedViewAction.addActionListener( this );
    }

    public void changeMessageActions()
    {
    }


    /*
    private Object[] getUids()
    {
        Object uids[] = headerTableViewer.getUids();

        return uids;
    }
*/

    private PopServer getPopServer()
    {
        return headerTableViewer.getPopServer();
    }


    public void actionPerformed(ActionEvent evt)
    {
        String command = evt.getActionCommand();



        if ( command.equals( synchronizeAction.getActionCommand() ) )
        {
            System.out.println("synchronize");

            PopServer popserver = getPopServer();
            popserver.synchronize();


        }
        else if ( command.equals( fetchAction.getActionCommand() ) )
        {
            System.out.println("fetch");


            MessageNode[] nodes = headerTableViewer.getSelectedNodes();
            Vector uidList = new Vector();
            for ( int i=0; i<nodes.length; i++ )
            {
                MessageNode node = nodes[i];
                ColumbaHeader header = node.getHeader();
                Object uid = header.get("columba.pop3uid");
                System.out.println("node:"+i+"  uid: "+ uid );

                boolean alreadyFetched = ( (Boolean) header.get("columba.fetchstate") ).booleanValue();

                if ( alreadyFetched == false ) uidList.add( uid );
            }

            PopServer popserver = getPopServer();
            popserver.fetch( uidList );

        }
        else if ( command.equals( deleteAction.getActionCommand() ) )
        {
            System.out.println("delete");


            MessageNode[] nodes = headerTableViewer.getSelectedNodes();
            Vector uidList = new Vector();
            for ( int i=0; i<nodes.length; i++ )
            {
                MessageNode node = nodes[i];
                ColumbaHeader header = node.getHeader();
                Object uid = header.get("columba.pop3uid");
                //Object uid = message.getPop3Uid();
                if ( uid == null ) System.out.println("-------------------uid is null");
                uidList.add( uid );
            }

            PopServer popserver = getPopServer();
            popserver.delete( uidList );
        }
        else if ( command.equals( closeAction.getActionCommand() ) )
        {
            System.out.println("close");

            frame.setVisible( false );
        }
        else if ( command.equals( threadedViewAction.getActionCommand() ) )
        {
            headerTableViewer.toggleThreadedView();
            headerTableViewer.updateTable();
        }

    }



}
