package org.columba.gui.pop3.util;

import javax.swing.JPanel;


import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import java.awt.dnd.*;
import java.awt.datatransfer.*;

import java.io.*;
import javax.swing.JTree;


import org.columba.main.*;
import org.columba.config.*;
import org.columba.folder.*;
import org.columba.gui.util.*;
import org.columba.pop3.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class ManageInfoPanel extends JPanel
{

    private JLabel label;

    private int exists;
    private int alreadyFetched;

    private ImageIcon image1;

    private PopServer popServer;

    private MainInterface mainInterface;

    public ManageInfoPanel( MainInterface mainInterface )
    {
        this.mainInterface = mainInterface;


        image1 = ImageLoader.getImageIcon("tree.local", "Host24" );


        initComponents();
    }

    public void setPopServer( PopServer server )
    {
        this.popServer = server;
        AccountItem accountItem = popServer.getAccountItem();
        PopItem popItem = accountItem.getPopItem();
        IdentityItem identityItem = accountItem.getIdentityItem();

        label.setText( accountItem.getName()+ "  (" + identityItem.getAddress()+ ")" );

    }
    public void initComponents()
    {
        removeAll();

        GridBagLayout gridbagLayout = new GridBagLayout();
        setLayout( gridbagLayout );
        GridBagConstraints gridbagConstraints = new GridBagConstraints();;

        setLayout( gridbagLayout );

        setBackground( UIManager.getColor("controlShadow") );



        gridbagConstraints.gridwidth = GridBagConstraints.RELATIVE;
        gridbagConstraints.gridx = 0;
        gridbagConstraints.weightx = 0.5;
        Box box = Box.createHorizontalBox();
        gridbagLayout.setConstraints( box, gridbagConstraints );
        add( box );

        Font font = mainInterface.columbaTheme.getControlTextFont();
          //font = font.deriveFont( font.BOLD );
        int size = font.getSize();
        font = font.deriveFont( font.BOLD, size+2 );


        label = new JLabel("Total: Unseen:");
        label.setForeground( Color.white );
        label.setBorder( BorderFactory.createEmptyBorder( 2,2,2,2 ) );
        label.setFont( font );
        label.setIconTextGap( 10 );
        label.setIcon(image1);
        label.setText("Folder");

        gridbagConstraints.gridwidth = GridBagConstraints.REMAINDER;
        gridbagConstraints.gridx = 1;
        gridbagConstraints.insets = new Insets( 0, 0, 0, 20 );
        gridbagConstraints.anchor = GridBagConstraints.EAST;
        gridbagLayout.setConstraints( label, gridbagConstraints );

        add( label );

        setBorder( UIManager.getBorder("FolderInfoPanel.border") );
    }


    public void updateUI()
    {
        super.updateUI();
        setBorder( UIManager.getBorder("FolderInfoPanel.border") );
    }

    public void resetRenderer()
    {
        initComponents();
    }



}