package org.columba.gui.statusbar;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;


import org.columba.gui.util.*;
import org.columba.main.*;
import org.columba.config.*;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */
public class ImageSequenceTimer extends JPanel implements ActionListener
{
    private javax.swing.Timer timer;
    private ImageIcon[] images;
    private ImageIcon restImage;
    private int frameNumber;
    private int frameCount;

    private MainInterface mainInterface;
    private static int DELAY=100;

    private int width;
    private int height;

    public ImageSequenceTimer( MainInterface mainInterface )
    {
	this.mainInterface = mainInterface;

        timer = new javax.swing.Timer( DELAY, this );
        timer.setInitialDelay(0);
        timer.setCoalesce(true);
        	

        init();

    }

    protected void initDefault()
    {
	frameCount = 30;
        frameNumber = 1;

	width = 36;
	height = 36;

	setPreferredSize( new Dimension(width,height) );
        setMinimumSize( new Dimension(width,height) );
        setMaximumSize( new Dimension(width,height) );

        images = new ImageIcon[frameCount];

        images[0] = ImageLoader.getImageIcon("org/columba/images/001.png");
        images[1] = ImageLoader.getImageIcon("org/columba/images/002.png");
        images[2] = ImageLoader.getImageIcon("org/columba/images/003.png");
        images[3] = ImageLoader.getImageIcon("org/columba/images/004.png");
        images[4] = ImageLoader.getImageIcon("org/columba/images/005.png");
        images[5] = ImageLoader.getImageIcon("org/columba/images/006.png");
        images[6] = ImageLoader.getImageIcon("org/columba/images/007.png");
        images[7] = ImageLoader.getImageIcon("org/columba/images/008.png");
        images[8] = ImageLoader.getImageIcon("org/columba/images/009.png");
        images[9] = ImageLoader.getImageIcon("org/columba/images/010.png");
        images[10] = ImageLoader.getImageIcon("org/columba/images/011.png");
        images[11] = ImageLoader.getImageIcon("org/columba/images/012.png");
        images[12] = ImageLoader.getImageIcon("org/columba/images/013.png");
        images[13] = ImageLoader.getImageIcon("org/columba/images/014.png");
        images[14] = ImageLoader.getImageIcon("org/columba/images/015.png");
        images[15] = ImageLoader.getImageIcon("org/columba/images/016.png");
        images[16] = ImageLoader.getImageIcon("org/columba/images/017.png");
        images[17] = ImageLoader.getImageIcon("org/columba/images/018.png");
        images[18] = ImageLoader.getImageIcon("org/columba/images/019.png");
        images[19] = ImageLoader.getImageIcon("org/columba/images/021.png");
        images[20] = ImageLoader.getImageIcon("org/columba/images/021.png");
        images[21] = ImageLoader.getImageIcon("org/columba/images/022.png");
        images[22] = ImageLoader.getImageIcon("org/columba/images/023.png");
        images[23] = ImageLoader.getImageIcon("org/columba/images/024.png");
        images[24] = ImageLoader.getImageIcon("org/columba/images/025.png");
        images[25] = ImageLoader.getImageIcon("org/columba/images/026.png");
        images[26] = ImageLoader.getImageIcon("org/columba/images/027.png");
        images[27] = ImageLoader.getImageIcon("org/columba/images/028.png");
        images[28] = ImageLoader.getImageIcon("org/columba/images/029.png");
        images[29] = ImageLoader.getImageIcon("org/columba/images/030.png");

        restImage = ImageLoader.getImageIcon("org/columba/images/rest.png");
    }

    protected void init()
    {
	ThemeItem item = mainInterface.themeItem;
	String pulsator = item.getPulsator();

	if ( pulsator.toLowerCase().equals("default") ) initDefault();
	else
        {
	    File zipFile = new File( mainInterface.config.configDirectory
				     +"/pulsators/"+pulsator+".jar" );	    

	    String zipFileEntry = new String(pulsator+"/pulsator.properties");
	    //System.out.println("zipfileentry:"+zipFileEntry );
	    
	    Properties properties = ImageLoader.loadProperties( zipFile, zipFileEntry );

	    String frameCountStr = (String) properties.getProperty("count");
	    frameCount = Integer.parseInt(frameCountStr);

	    String widthStr = (String) properties.getProperty("width");
	    width = Integer.parseInt(widthStr);

	    String heightStr = (String) properties.getProperty("height");
	    height = Integer.parseInt(heightStr);

	    setPreferredSize( new Dimension(width,height) );
	    setMinimumSize( new Dimension(width,height) );
	    setMaximumSize( new Dimension(width,height) );

	    images = new ImageIcon[frameCount];
	    for ( int i=0; i<frameCount; i++ )
	    {
		String istr = ( new Integer(i) ).toString();
		String image = (String) properties.getProperty(istr);
		
		zipFile = new File( mainInterface.config.configDirectory
				     +"/pulsators/"+pulsator+".jar" );	    

		zipFileEntry = new String(pulsator+"/"+image);
		
		//System.out.println("zuifileentry:"+zipFileEntry);
		images[i] = new ImageIcon( ImageLoader.loadImage(zipFile, zipFileEntry) );
	    }

	    String image = (String) properties.getProperty("rest");
	    zipFileEntry = new String(pulsator+"/"+image);

	    restImage = new ImageIcon( ImageLoader.loadImage(zipFile, zipFileEntry) );
	}       

    }

    public void start()
    {
        if ( !timer.isRunning() ) timer.start();
    }

    public void stop()
    {
        if ( timer.isRunning() ) timer.stop();

        frameNumber=0;

        repaint();
    }

    public void actionPerformed( ActionEvent ev )
    {
        String action = ev.getActionCommand();

        frameNumber++;

        repaint();
    }


    public void paintComponent( Graphics g )
    {
        super.paintComponent(g);

        if ( timer.isRunning() )
           g.drawImage( images[ frameNumber % frameCount ].getImage(), 0, 0, this );
        else
          g.drawImage( restImage.getImage(), 0, 0, width, height, this );

    }


}
