// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.statusbar;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;

import org.columba.gui.action.*;
import org.columba.util.SwingWorker;
import org.columba.gui.util.*;

import java.util.Vector;


public class StatusBar extends JComponent
{

    private JLabel label;
    private JProgressBar progressBar;
    //private JButton button;
    //private JButton cancelButton;


    private boolean cancel;
    private SwingWorker swingWorker = null;

    static public MouseHandler mouseHandler;

    private JButton left, right;

    private Border border;
    private JPanel leftPanel;
    private JPanel rightPanel;
    private JPanel mainRightPanel;
    private JButton taskButton;
    private JPanel leftMainPanel;
    private JButton progressButton;
    private JPanel middleRightPanel;
    private JPanel middleLeftPanel;
    private JPanel mainMiddlePanel;
    private JPanel rightRightPanel;


    public StatusBar()
        {

	    //setPreferredSize( new java.awt.Dimension( getWidth(),28) );


            setLayout( new BorderLayout() );

            setBorder( BorderFactory.createEmptyBorder( 2,2,2,2 ) );
	    

            //border = UIManager.getBorder( "StatusBar.border" );


            leftMainPanel = new JPanel();
            leftMainPanel.setLayout( new BorderLayout() );

            leftPanel = new JPanel();
            leftPanel.setLayout( new BorderLayout() );
            leftPanel.setBorder( BorderFactory.createEtchedBorder() );

            taskButton = new JButton("Tasks: 0");
            taskButton.setRolloverEnabled( true );
	    taskButton.setBorder( BorderFactory.createEmptyBorder( 2,2,2,2 ) );

            //taskButton.setBorder( UIManager.getBorder( "ToolBarButton.border" ) );

            //taskButton.setMargin( new Insets(2,2,2,2) );

              //taskButton.setEnabled( false );

            leftPanel.add( taskButton, BorderLayout.CENTER );

            leftMainPanel.add( leftPanel, BorderLayout.WEST );

              //setBorder( new StatusBarBorder(true) );

	    rightPanel = new JPanel();
            rightPanel.setBorder( BorderFactory.createEtchedBorder() );

	    BoxLayout boxLayout = new BoxLayout( rightPanel, BoxLayout.X_AXIS);
	    rightPanel.setLayout( boxLayout );
              //rightPanel.setBorder( new CTableBorder(false) );

            label = new JLabel("");	    
	    label.setAlignmentX( Component.LEFT_ALIGNMENT );

	    rightPanel.add( Box.createRigidArea(new Dimension(10,0)) );

            rightPanel.add(label);

	    rightPanel.add( Box.createRigidArea(new Dimension(10,0)) );

            leftMainPanel.add( rightPanel, BorderLayout.CENTER );


	    add( leftMainPanel, BorderLayout.CENTER );


            mainRightPanel = new JPanel();
              //mainRightPanel.setBorder( border );
            mainRightPanel.setLayout( new BoxLayout( mainRightPanel, BoxLayout.X_AXIS) );


            middleLeftPanel = new JPanel();
	    //BoxLayout boxLayout3 = new BoxLayout( middleLeftPanel, BoxLayout.X_AXIS);
            //middleLeftPanel.setLayout( boxLayout3 );
	    middleLeftPanel.setLayout( new BorderLayout() );
	    middleLeftPanel.setBorder( BorderFactory.createEtchedBorder() );
            //middleLeftPanel.setBorder( border );

	    progressButton = new JButton("");
	    
	    progressButton.setBorder( BorderFactory.createEmptyBorder( 2,2,2,2 ) );
            //progressButton.setBorder( UIManager.getBorder( "ToolBarButton.border" ) );
            progressButton.setRolloverEnabled( true );
	    
            progressButton.setEnabled( false );
            progressButton.setToolTipText("Auto Mail Checking Status Notification");

	    middleLeftPanel.add( progressButton, BorderLayout.CENTER );




            mainMiddlePanel = new JPanel();
            BoxLayout boxLayout5 = new BoxLayout( mainMiddlePanel, BoxLayout.X_AXIS);
            mainMiddlePanel.setLayout( boxLayout5 );
	    //mainMiddlePanel.setBorder( BorderFactory.createEtchedBorder() );

            mainMiddlePanel.add( middleLeftPanel );

            middleRightPanel = new JPanel();
	    //BoxLayout boxLayout4 = new BoxLayout( middleRightPanel, BoxLayout.X_AXIS);
            //middleRightPanel.setLayout( boxLayout4 );
	    middleRightPanel.setLayout( new BorderLayout() );
            //middleRightPanel.setBorder( border );
	    middleRightPanel.setBorder( BorderFactory.createEtchedBorder() );

            left = new JButton("<");
	    left.setBorder( BorderFactory.createEmptyBorder( 2,2,2,2 ) );
            //left.setBorder( UIManager.getBorder( "ToolBarButton.border" ) );
            left.setRolloverEnabled( true );
            left.setActionCommand("LEFT");

            left.setEnabled( false );


            right = new JButton(">");
            right.setEnabled( false );
            right.setRolloverEnabled( true );
	    right.setBorder( BorderFactory.createEmptyBorder( 2,2,2,2 ) );
            //right.setBorder( UIManager.getBorder( "ToolBarButton.border" ) );
            right.setActionCommand("RIGHT");

            middleRightPanel.add( left, BorderLayout.WEST );
	    middleRightPanel.add( Box.createRigidArea(new Dimension(2,0)), BorderLayout.CENTER );
	    middleRightPanel.add( right, BorderLayout.EAST );




            mainMiddlePanel.add( middleRightPanel );






            mainRightPanel.add( mainMiddlePanel );


	    rightRightPanel = new JPanel();
	    //BoxLayout boxLayout2 = new BoxLayout( rightRightPanel, BoxLayout.X_AXIS);
	    //rightRightPanel.setLayout( boxLayout2 );
            rightRightPanel.setLayout( new BorderLayout() );
	    rightRightPanel.setBorder( BorderFactory.createEtchedBorder() );
	    //rightRightPanel.setBorder( border );

	    rightRightPanel.setAlignmentX( Component.RIGHT_ALIGNMENT );
              //rightRightPanel.setBorder( new CTableBorder(false) );

            //Dimension dim = progressButton.getPreferredSize();
            //dim.setSize( 5, dim.getHeight() );

	    //rightRightPanel.add( Box.createRigidArea( dim ) );

	    progressBar = new JProgressBar(0,100);
	    progressBar.setAlignmentX( Component.RIGHT_ALIGNMENT );
            progressBar.setAlignmentY( Component.CENTER_ALIGNMENT );
	    //progressBar.setBorder( BorderFactory.createEmptyBorder( 2,2,2,2 ) );
            progressBar.setStringPainted( true );
            progressBar.setBorderPainted( false );
            progressBar.setValue(0);

	    rightRightPanel.add(progressBar, BorderLayout.CENTER);



	    //rightRightPanel.add( Box.createRigidArea(new Dimension(5,0)) );

	    mainRightPanel.add( rightRightPanel );

            add( mainRightPanel, BorderLayout.EAST );


	    mouseHandler = new MouseHandler( label );


        }

    public void enableMailCheck(boolean b )
    {
        if ( b == true )
        {
            progressButton.setIcon( ImageLoader.getImageIcon("receivesend16", "SendMail16") );
            progressButton.setEnabled(true);
        }
        else
        {
            progressButton.setIcon( ImageLoader.getImageIcon("receivesend16", "SendMail16") );
            progressButton.setEnabled(false);
        }
    }


    public void initActions( ActionListener listener )
    {
        left.addActionListener( listener );
        right.addActionListener( listener );
        //FIXME
        /*
        button.addActionListener( listener );
        */
    }



    public JProgressBar getProgressBar()
    {
        return progressBar;
    }


    public void setTaskCount( int i )
    {
        final int n = i;

        Runnable run = new Runnable()
             {
                 public void run()
                 {
                      taskButton.setText("Tasks: "+ n );
                 }
             };
             try
             {
                if ( !SwingUtilities.isEventDispatchThread() )
                   SwingUtilities.invokeAndWait(run);
                else
                   SwingUtilities.invokeLater(run);

             }
             catch( Exception ex )
             {
             }

    }



    public void setText( String s )
    {
        final String str = s;

        Runnable run = new Runnable()
             {
                 public void run()
                 {
                       label.setText( str );
                 }
             };
             try
             {
                if ( !SwingUtilities.isEventDispatchThread() )
                   SwingUtilities.invokeAndWait(run);
                else
                   SwingUtilities.invokeLater(run);

             }
             catch( Exception ex )
             {
             }

    }


    public void setMaximum( int i )
    {
        final int n = i;

        Runnable run = new Runnable()
             {
                 public void run()
                 {
                      getProgressBar().setMaximum( n );
                 }
             };
             try
             {
                if ( !SwingUtilities.isEventDispatchThread() )
                   SwingUtilities.invokeAndWait(run);
                else
                   SwingUtilities.invokeLater(run);

             }
             catch( Exception ex )
             {
             }

    }


    public void setValue( int i )
    {
        final int n = i;

        Runnable run = new Runnable()
             {
                 public void run()
                 {
                      getProgressBar().setValue( n );
                 }
             };
             try
             {
                if ( !SwingUtilities.isEventDispatchThread() )
                   SwingUtilities.invokeAndWait(run);
                else
                   SwingUtilities.invokeLater(run);

             }
             catch( Exception ex )
             {
             }

    }

    public int getValue()
    {
        return getProgressBar().getValue();
    }

    public JButton getLeftButton()
    {
        return left;
    }

    public JButton getRightButton()
    {
        return right;
    }


    public JButton getCancelButton()
    {
        //FIXME
        return null;
        /*
        return button;
        */
    }

    public JButton getBusyButton()
    {
        return progressButton;
    }




    public static MouseAdapter getHandler()
    {
	return mouseHandler;
    }


    private class MouseHandler extends MouseAdapter
    {

        private JLabel label;

        public MouseHandler(JLabel label)  {
            setLabel(label);
        }

        public void setLabel(JLabel label)  {
            this.label = label;
        }

        public void mouseEntered(MouseEvent evt)  {
            if (evt.getSource() instanceof AbstractButton)  {
                AbstractButton button = (AbstractButton)evt.getSource();
                Action action = button.getAction(); // getAction is new in JDK 1.3
                if (action != null)  {
                    String message = (String)action.getValue(Action.LONG_DESCRIPTION);
                    label.setText(message);
                }
            }
        }
    }






    public void updateUI()
    {
        super.updateUI();

	/*
        border = UIManager.getBorder( "StatusBar.border" );

        rightRightPanel.setBorder( border );
        rightPanel.setBorder( border );
        leftPanel.setBorder( border );
        middleLeftPanel.setBorder( border );
        middleRightPanel.setBorder( border );

        Border b = UIManager.getBorder( "ToolBarButton.border" );

        left.setBorder( b );
        right.setBorder( b );


        progressButton.setBorder( b );
        taskButton.setBorder( b );


        left.setRolloverEnabled( true );
        right.setRolloverEnabled( true );

        progressButton.setRolloverEnabled( true );
        taskButton.setRolloverEnabled( true );
	*/
    }


}





