// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.statusbar;


import javax.swing.Timer;
import java.awt.event.*;


class WorkerItem
{
    private Thread thread;
    private int number;
    private String text;
    private int maximum;
    private int value;
    private boolean cancel;

    private Timer timer;

    private boolean allowed;

    private int priority;

    private final static int TWO_SECONDS = 2000;

    public WorkerItem( Thread t, int i, int priority )
    {
        thread = t;
        number = i;
        cancel = false;
	this.priority = priority;

        allowed = false;

        timer = new Timer( TWO_SECONDS,
                           new ActionListener()
                           {
                              public void actionPerformed( ActionEvent e )
                              {
                                  allowed = true;
                              }
                           }
                          );
    }


    public int getPriority()
    {
	return priority;
    }


    public boolean isAllowed()
    {
        return allowed;
    }


    public void setAllowed( boolean b )
    {
        allowed = b;
    }

    public void setThread( Thread t )
    {
        thread = t;
    }

    public void setCancel( boolean b )
    {
        cancel = b;
    }

    public boolean getCancel()
    {
        return cancel;
    }

    public void setNumber( int i )
    {
        number = i;
    }

    public int getNumber()
    {
        return number;
    }

    public Thread getThread()
    {
        return thread;
    }

    public void setText( String s )
    {
        this.text = s;
    }


    public String getText()
    {
        return text;
    }

    public void setProgressBarMaximum( int m )
    {
        maximum = m;
    }

    public int getProgressBarMaximum()
    {
        return maximum;
    }

    public void setProgressBarValue( int v )
    {
        if ( v<=getProgressBarMaximum() )
           value = v;
    }

    public int getProgressBarValue()
    {
        return value;
    }


}
