package org.columba.gui.themes.contrastcolumba;

import javax.swing.*;
import javax.swing.plaf.basic.*;
import javax.swing.plaf.metal.*;
import javax.swing.plaf.*;

import java.awt.*;

public class ContrastColumbaScrollBarUI extends BasicScrollBarUI
{
      
    public static ComponentUI createUI( JComponent c )
    {
        return new ContrastColumbaScrollBarUI();
    }

      
    protected JButton createDecreaseButton( int orientation )
    {
        return new ContrastColumbaArrowButton( orientation );    
    }


    protected JButton createIncreaseButton( int orientation )
    {
        return new ContrastColumbaArrowButton( orientation );
    }

      
    protected void paintThumb(Graphics g, JComponent c, Rectangle thumbBounds)  
    {
	if(thumbBounds.isEmpty() || !scrollbar.isEnabled())	{
	    return;
	}

        int w = thumbBounds.width;
        int h = thumbBounds.height;		

	g.translate(thumbBounds.x, thumbBounds.y);

        drawFlush3DBorder( g, 1,1, w-2, h-2 );
        
	g.translate(-thumbBounds.x, -thumbBounds.y);
    }

    protected void paintTrack( Graphics g, JComponent c, Rectangle trackBounds )
    {
        int w=c.getWidth();
        int h=c.getHeight();
        
        g.setColor( MetalLookAndFeel.getControlDarkShadow() );
        g.drawLine( 0, 0, 0, h-1 );
        g.drawLine( 0,0,w-1,0 );

        g.setColor( MetalLookAndFeel.getControlHighlight() );
        g.drawLine( 1,h-1, w-1,h-1 );
        g.drawLine( w-1,1, w-1, h-1 );
    }
    
    protected void drawFlush3DBorder(Graphics g, int x, int y, int w, int h)
    {
        g.translate( x, y);
        
        g.setColor( MetalLookAndFeel.getControlDarkShadow() );
        g.drawLine( w-2, 2, w-2, h-2 );
        g.drawLine( 2,h-2, w-2, h-2 );
        
        g.setColor( Color.black );
        g.drawLine( w-1, 0, w-1, h-1 );
        g.drawLine( 0, h-1, w-1, h-1 );
        
        
        g.setColor( MetalLookAndFeel.getControlHighlight() );
        g.drawLine( 0,0, w-2,0 );
        g.drawLine( 0,0, 0, h-2 );
                

        g.translate( -x, -y);
    }
      
}






