package org.columba.gui.themes.thincolumba;

import javax.swing.*;
import java.awt.*;
import javax.swing.plaf.*;
import javax.swing.plaf.metal.*;
import org.columba.gui.util.*;

import javax.swing.border.*;


public class ThinColumbaButtonBorder extends AbstractBorder implements UIResource
{

    protected static Insets borderInsets = new Insets( 4, 4, 4, 4 );
      
    public void paintBorder(Component c, Graphics g, int x, int y, int w, int h)
    {
        JButton button = (JButton) c;
        ButtonModel model = button.getModel();

                      
        if ( model.isEnabled() )
        {
            if ( model.isPressed() && model.isArmed() )
            {
                  //drawRolloverBorder( g, x, y, w, h, true );
                ThinColumbaUtil.drawPressed3DBorder( g, x, y, w, h );
            }
            else
            {
                  
                if ( button.isRolloverEnabled() )
                {
       
                    
                    if ( model.isRollover() )
                    {
                        ThinColumbaUtil.drawRolloverBorder( g, x, y, w, h );
                    }
                    
                }
                else
                {
                    if (button.isDefaultButton())
                    {
                        ThinColumbaUtil.drawDefaultButtonBorder( g, x, y, w, h, button.hasFocus() && false);
                    } else
                    {
                        ThinColumbaUtil.drawButtonBorder( g, x, y, w, h, button.hasFocus() && false);
                    }
                                        
                }
                
            }
        } else
        { // disabled state
              //drawDisabledBorder( g, x, y, w-1, h-1 );
        }
        
    }
    
    public Insets getBorderInsets( Component c ) {
        return borderInsets;
    }


    }










