package org.columba.gui.themes.thincolumba;

import javax.swing.*;
import javax.swing.plaf.basic.*;
import javax.swing.plaf.metal.*;
import javax.swing.plaf.*;

import java.awt.*;

public class ThinColumbaScrollBarUI extends BasicScrollBarUI
{
      
    public static ComponentUI createUI( JComponent c )
    {
        return new ThinColumbaScrollBarUI();
    }

      
    protected JButton createDecreaseButton( int orientation )
    {
        return new ThinColumbaArrowButton( orientation );    
    }


    protected JButton createIncreaseButton( int orientation )
    {
        return new ThinColumbaArrowButton( orientation );
    }

    protected void paintThumb(Graphics g, JComponent c, Rectangle thumbBounds)  
    {
	if(thumbBounds.isEmpty() || !scrollbar.isEnabled())	{
	    return;
	}

        int w = thumbBounds.width;
        int h = thumbBounds.height;		

	g.translate(thumbBounds.x, thumbBounds.y);

        drawFlush3DBorder( g, 0,0, w, h );
        
	g.translate(-thumbBounds.x, -thumbBounds.y);
    }

    protected void drawFlush3DBorder(Graphics g, int x, int y, int w, int h)
    {
        g.translate( x, y);
        g.setColor( MetalLookAndFeel.getControlDarkShadow() );
        g.drawLine( w-1, 1, w-1, h-1 );
        g.drawLine( 1,h-1, w-1, h-1 );

        g.setColor( MetalLookAndFeel.getControlHighlight() );
        g.drawLine( 1,1, w-1,1 );
        g.drawLine( 1,1, 1, h-1 );
        

        g.translate( -x, -y);
    }
}

