package org.columba.gui.themes.thincolumba;

import javax.swing.*;
import java.awt.*;
import javax.swing.plaf.*;
import javax.swing.plaf.metal.*;
import org.columba.gui.util.*;

import javax.swing.border.*;


public class ThinColumbaToolBarButtonBorder extends AbstractBorder implements UIResource
{

    protected static Insets borderInsets = new Insets( 4, 4, 4, 4 );
      
    public void paintBorder(Component c, Graphics g, int x, int y, int w, int h)
    {
      
        
        
        JButton button = (JButton) c;
        ButtonModel model = button.getModel();

        if ( model.isEnabled() )
        {
            if ( model.isPressed() && model.isArmed() )
            {
                  //drawRolloverBorder( g, x, y, w, h, true );
                  //ThinColumbaUtil.drawPressed3DBorder( g, x, y, w, h );
                drawPressed3DBorder( g, x, y, w, h  );
                
                
            }
            else
            {

                
                if ( button.isRolloverEnabled() )
                {
       
                    
                    if ( model.isRollover() )
                    {
                     
                        ThinColumbaUtil.drawRolloverBorder( g, x, y, w, h );
                        
                        
                    }
                    
                }
                else
                {
                    if (button.isDefaultButton())
                    {
                          //ThinColumbaUtil.drawDefaultButtonBorder( g, x, y, w, h, button.hasFocus() && false);
                    } else
                    {
                          //ThinColumbaUtil.drawButtonBorder( g, x, y, w, h, button.hasFocus() && false);
                    }
                                        
                }
                
            }
        } else
        { // disabled state
              //drawDisabledBorder( g, x, y, w-1, h-1 );
        }
    }
    
    public Insets getBorderInsets( Component c )
    {
        return borderInsets;
    }
    
    private void drawPressed3DBorder(Graphics g, int x, int y, int w, int h)
    {
        g.translate( x, y);

        g.setColor( MetalLookAndFeel.getControlDarkShadow() );
        g.drawRect( 0,0,w-1,h-1 );
        
        g.setColor( MetalLookAndFeel.getControlHighlight() );
        g.drawLine( w-2, 2, w-2, h-2 );
        g.drawLine( 2,h-2, w-2, h-2 );
        
        g.setColor( MetalLookAndFeel.getControlDarkShadow() );
        
        g.drawLine( w-1, 0, w-1, h-1 );
        g.drawLine( 0, h-1, w-1, h-1 );

        g.translate( -x, -y);
    }
}










