package org.columba.gui.tree.action;

import org.columba.gui.tree.*;


import javax.swing.*;
import javax.swing.tree.*;
import java.awt.event.*;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class FolderTreeMouseListener extends MouseAdapter
{
    private TreeViewer treeViewer;

    public FolderTreeMouseListener( TreeViewer treeViewer )
    {
        this.treeViewer = treeViewer;
    }

    protected JPopupMenu getPopupMenu()
    {
        return treeViewer.getPopupMenu();
    }

	// Use PopUpTrigger in both mousePressed and mouseReleasedMethods due to
	// different handling of *nix and windows

    public void mousePressed(MouseEvent e)
    {
         if ( e.isPopupTrigger() )
            {
                java.awt.Point point = e.getPoint();
                TreePath path = treeViewer.getFolderTree().getTree().getClosestPathForLocation( point.x, point.y );

                treeViewer.getFolderTree().getTree().clearSelection();
                treeViewer.getFolderTree().getTree().addSelectionPath( path );

                treeViewer.getActionListener().changeActions();


                getPopupMenu().show(e.getComponent(), e.getX(), e.getY());
            }

    }

    public void mouseReleased(MouseEvent e)
    {
         if ( e.isPopupTrigger() )
            {
                java.awt.Point point = e.getPoint();
                TreePath path = treeViewer.getFolderTree().getTree().getClosestPathForLocation( point.x, point.y );

                treeViewer.getFolderTree().getTree().clearSelection();
                treeViewer.getFolderTree().getTree().addSelectionPath( path );

                treeViewer.getActionListener().changeActions();


                getPopupMenu().show(e.getComponent(), e.getX(), e.getY());
            }
    }

    public void mouseClicked(MouseEvent e)
    {
        if ( e.getClickCount() == 1 )
        {
            treeViewer.selectFolder();
        }
        else if ( e.getClickCount() == 2 )
        {
            treeViewer.expandImapRootFolder();
        }

    }

    /*
    private void maybeShowPopup(MouseEvent e)
    {
        if (e.isPopupTrigger())
        {
            getPopupMenu().show(e.getComponent(),
                       e.getX(), e.getY());
        }
    }
    */
}