package org.columba.gui.tree.menu;

import org.columba.gui.tree.*;
import org.columba.gui.tree.action.*;
import org.columba.gui.statusbar.*;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class FolderTreeMenu
{
    private JPopupMenu popup;
    private TreeViewer treeViewer;

    public FolderTreeMenu( TreeViewer treeViewer )
    {
        this.treeViewer = treeViewer;

        initContextMenu();
    }

    public JPopupMenu getPopupMenu()
    {
        return popup;
    }

    protected FolderTreeActionListener getActionListener()
    {
        return treeViewer.getActionListener();
    }

     protected void initContextMenu()
        {

	    popup  = new JPopupMenu();


	    MouseAdapter handler = StatusBar.getHandler();
            org.columba.gui.util.CMenuItem menuItem;

	    menuItem = new org.columba.gui.util.CMenuItem(getActionListener().addAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
            menuItem = new org.columba.gui.util.CMenuItem(getActionListener().addVirtualAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );


	    menuItem =  new org.columba.gui.util.CMenuItem(getActionListener().renameAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
	    menuItem =  new org.columba.gui.util.CMenuItem(getActionListener().removeAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
            popup.addSeparator();
            menuItem =  new org.columba.gui.util.CMenuItem(getActionListener().moveupAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
            menuItem =  new org.columba.gui.util.CMenuItem(getActionListener().movedownAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
	    popup.addSeparator();
	    menuItem =  new org.columba.gui.util.CMenuItem(getActionListener().expungeAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
	    menuItem =  new org.columba.gui.util.CMenuItem(getActionListener().emptyAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
	    menuItem =  new org.columba.gui.util.CMenuItem(getActionListener().compactAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
            popup.addSeparator();

            menuItem =  new org.columba.gui.util.CMenuItem(getActionListener().applyFilterAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
            menuItem =  new org.columba.gui.util.CMenuItem(getActionListener().filterPreferencesAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
	    popup.addSeparator();
	    
	        menuItem =  new org.columba.gui.util.CMenuItem(getActionListener().subscribeAction);
	    menuItem.addMouseListener( handler );
	    popup.add( menuItem );
	    

        }

}