// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package org.columba.gui.tree.util;

import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import javax.swing.tree.*;
import java.util.*;

import org.columba.gui.*;
import org.columba.gui.util.*;
import org.columba.folder.*;
import org.columba.config.*;
import org.columba.gui.tree.*;

public class FolderTreeCellRenderer
	extends DefaultTreeCellRenderer //extends JLabel implements TreeCellRenderer
{
	Border unselectedBorder = null;
	Border selectedBorder = null;
	boolean isBordered = true;
	boolean bool;
	ImageIcon image;

	private ImageIcon image1;
	private ImageIcon image2;
	private ImageIcon image3;
	private ImageIcon image4;
	private ImageIcon image5;
	private ImageIcon image6;
	private ImageIcon image7;
	private ImageIcon image8;
	private ImageIcon image9;
	private ImageIcon image10;

	

	private Font plainFont, boldFont;


	public FolderTreeCellRenderer(boolean bool)
	{
		super();
		
		this.bool = bool;

		

		boldFont = UIManager.getFont("Tree.font");
		boldFont = boldFont.deriveFont(Font.BOLD);
		plainFont = UIManager.getFont("Tree.font");

		image1 = ImageLoader.getImageIcon("folder", "folder1");
		image2 = ImageLoader.getImageIcon("localhost", "Host16");

	

		image9 = ImageLoader.getImageIcon("remotehost", "WebComponent16");
		image10 = ImageLoader.getImageIcon("virtualfolder", "Zoom16");

	}

	public Component getTreeCellRendererComponent(
		JTree tree,
		Object value,
		boolean isSelected,
		boolean expanded,
		boolean leaf,
		int row,
		boolean hasFocus)
	{

		super.getTreeCellRendererComponent(
			tree,
			value,
			isSelected,
			expanded,
			leaf,
			row,
			hasFocus);

		Folder folder = (Folder) value;

		if (folder != null)
		{

			if (folder.getMessageFolderInfo().getRecent() > 0)
			{
				setFont(boldFont);
			}
			else
			{
				setFont(plainFont);
			}
		}
		else
		{
			setFont(plainFont);
		}

		FolderItem item = folder.getFolderItem();

		if (item != null)
		{
			int uid = item.getUid();

			String name;

			//name = folder.getName();

			name = item.getName();

			if (folder != null)
			{
				if (folder.getMessageFolderInfo().getUnseen() > 0)
					name = name + " (" + folder.getMessageFolderInfo().getUnseen() + ") ";

			}

			setText(name);

			if (item.getType().equals("virtual"))
			{
				setIcon(image10);
			}
			else if (
				(item.getType().equals("imaproot")) && (item.isMessageFolder() == false))
			{
				setIcon(image9);
			}
			else if (item.getAccessRights().equals("system"))
			{
				if (name.equals(ResourceLoader.getString("tree/mail","localfolders")))
					setIcon(image2);
				else
					setIcon(image1);

			}
			else
			{
				setIcon(image1);

			}
		}

		return this;
	}

}