// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.tree.util;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;


import org.columba.message.*;
import org.columba.gui.tree.*;
import org.columba.main.*;
import org.columba.config.*;
import org.columba.folder.*;



public class SelectFolderDialog extends JDialog implements ActionListener, TreeSelectionListener
{
    private String name;

    //private MainInterface mainInterface;

    private boolean bool = false;

    //public SelectFolderTree tree;

    private JTree tree;

    private JButton[] buttons;

    private TreeViewer treeViewer;

    private Folder selectedFolder;

    private JFrame frame;

    public SelectFolderDialog( JFrame frame, TreeViewer treeViewer)
    {

        super( frame, "Select Folder", true );

        //this.mainInterface = mainInterface;
        this.treeViewer = treeViewer;
        this.frame = frame;

        name = new String("name");


        init();

    }


    public void init()
    {
        buttons = new JButton[3];

        JLabel label2 = new JLabel("Select Folder");

        buttons[0] = new JButton("Cancel");
        buttons[0].setActionCommand("CANCEL");
	buttons[0].setDefaultCapable(true);
        buttons[1] = new JButton("Ok");
        buttons[1].setEnabled( false );
        buttons[1].setActionCommand("OK");
        buttons[2] = new JButton("New Subfolder...");
        buttons[2].setActionCommand("NEW");
        buttons[2].setEnabled( false );



        getRootPane().setDefaultButton(buttons[1]);


        //tree = new SelectFolderTree( mainInterface, mainInterface.config.getFolderConfig().getRootNode()  );
        //tree.getTree().addTreeSelectionListener( this );

        JPanel panel = new JPanel();
        panel.setBorder( BorderFactory.createEmptyBorder( 10,10,10,10 ) );
        panel.setLayout( new BorderLayout() );


        getContentPane().setLayout( new BorderLayout() );

          //getContentPane().setLayout( new BoxLayout( getContentPane() , BoxLayout.Y_AXIS ) );


          //getContentPane().add(  Box.createRigidArea( new java.awt.Dimension(0,10) )  );

        JPanel centerPanel = new JPanel();
        centerPanel.setBorder( javax.swing.BorderFactory.createTitledBorder(
            javax.swing.BorderFactory.createEtchedBorder(),
            " Choose Folder ")

        		       );
        centerPanel.setLayout( new BorderLayout() );

        tree = new JTree( treeViewer.getModel() );
        tree.putClientProperty("JTree.lineStyle", "Angled");
        tree.setShowsRootHandles( true );
        tree.setRootVisible(false);
        tree.addTreeSelectionListener( this  );
        FolderTreeCellRenderer renderer = new FolderTreeCellRenderer( true );
        tree.setCellRenderer(renderer);

        JPanel treePanel = new JPanel();
        treePanel.setBorder( BorderFactory.createEmptyBorder( 10,10,10,10 ));
        treePanel.setLayout(new BorderLayout());
        JScrollPane treePane = new JScrollPane( tree );
        treePanel.add( treePane, BorderLayout.CENTER );
        centerPanel.add( treePanel, BorderLayout.CENTER );

        panel.add( centerPanel, BorderLayout.CENTER );

          //getContentPane().add(  Box.createRigidArea( new java.awt.Dimension(0,10) )  );


        JPanel lowerpanel = new JPanel();
        lowerpanel.setLayout( new BoxLayout( lowerpanel, BoxLayout.X_AXIS ) );
        lowerpanel.setBorder( BorderFactory.createEmptyBorder( 10,0,10,0 ) );

        lowerpanel.add( Box.createHorizontalGlue() );
          //lowerpanel.add(  Box.createRigidArea( new java.awt.Dimension(20,0) )  );
        lowerpanel.add( buttons[0] );
        lowerpanel.add(  Box.createRigidArea( new java.awt.Dimension(10,0) )  );
        lowerpanel.add( Box.createHorizontalGlue() );
        lowerpanel.add( buttons[2] );
        lowerpanel.add( Box.createHorizontalGlue() );
        lowerpanel.add(  Box.createRigidArea( new java.awt.Dimension(10,0) )  );
        lowerpanel.add( buttons[1] );
          //lowerpanel.add(  Box.createRigidArea( new java.awt.Dimension(20,0) )  );
        lowerpanel.add( Box.createHorizontalGlue() );


        panel.add( lowerpanel, BorderLayout.SOUTH  );


        getContentPane().add( panel, BorderLayout.CENTER );

          //getContentPane().add(  Box.createRigidArea( new java.awt.Dimension(0,10) )  );


        for ( int i=0; i<3; i++ )
        {
            buttons[i].addActionListener( this );
        }


        pack();

        java.awt.Dimension dim = getPreferredSize();

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

        setLocation(screenSize.width/2 - dim.width/2, screenSize.height/2 - dim.height/2);
	
	setVisible(true);
    }


    public boolean success()
    {
        return bool;

    }

    public Folder getSelectedFolder()
    {
        return selectedFolder;
    }

    public int getUid()
    {
      /*
        FolderTreeNode node = tree.getSelectedNode();

        FolderItem item = node.getFolderItem();
*/
        return 101;


        //return item.getUid();

    }


    public void actionPerformed(ActionEvent e)
    {
        String action = e.getActionCommand();

        if  ( action.equals("OK") )
        {
              //name = textField.getText();

            bool = true;

            dispose();
        }
        else if ( action.equals("CANCEL") )
        {
            bool = false;

            dispose();
        }
        else if ( action.equals("NEW" ) )
        {

            EditFolderDialog dialog = treeViewer.getEditFolderDialog( "New Folder" );
            dialog.showDialog();

            String name;

            if ( dialog.success() == true )
            {
                  // ok pressed
                name = dialog.getName();
            }
            else
            {
                  // cancel pressed
                return;
            }

            treeViewer.getFolderTree().addUserFolder( getSelectedFolder(), name );

            //TreeNodeEvent updateEvent2 = new TreeNodeEvent( getSelectedFolder(), TreeNodeEvent.STRUCTURE_CHANGED );
            //treeViewer.mainInterface.crossbar.fireTreeNodeChanged(updateEvent2);

            //FIXME

            /*
            FolderTreeNode parent = tree.getSelectedNode();
                                //FolderItem parentItem = parent.getItem();

            AdapterNode adapterNode = mainInterface.config.getFolderConfig().addFolderNode( parent.getNode() , name, "user", "true","columba", "true", "true", "true", -1 );

            FolderItem item = mainInterface.config.getFolderConfig().getFolderItem( adapterNode );
            if ( item == null )
            {
                System.out.println("failed");
            }
*/
            //FIXME

            /*
            FolderTreeNode child = new FolderTreeNode( item, adapterNode );
            tree.getFolderTree().add( parent, child );

            AdapterNode parentNode = parent.getNode();
            AdapterNode uidNode = parentNode.getChild("uid");
            String uidString = uidNode.getValue();
            int uid = Integer.parseInt( uidString );

            FolderTreeNode mainParent = mainInterface.treeViewer.getFolderTreeNode( uid );



            mainInterface.treeViewer.getFolderTree().add(
                mainParent, child );



            Object[] nodeList = child.getPath();
            TreeNodeList list = new TreeNodeList();
            for ( int j=1; j<nodeList.length; j++)
            {
                TreeNode n = (TreeNode) nodeList[j];
                list.add( n.toString() );
                System.out.println("path: "+n.toString() );

            }

            ColumbaFolder folder = new ColumbaFolder( list, item.getUid(), mainInterface );
            child.setFolder( folder );

            */
        }


    }



    /*
    public String getTreePath()
    {

        FolderTreeNode node = tree.getSelectedNode();
        String item;
        StringBuffer buf = new StringBuffer();
        TreeNode[] nodeList = node.getPath();

        for ( int i=1; i<nodeList.length; i++)
        {
            node = (FolderTreeNode) nodeList[i];
            item = node.toString();
            buf.append( "/" );
            buf.append( item );

            System.out.println("node: "+ buf.toString());
        }

        return buf.toString();

    }
*/
      /******************************* tree selection listener ********************************/



    public void valueChanged(TreeSelectionEvent e)
    {

        Folder node = (Folder)
            tree.getLastSelectedPathComponent();
        if (node == null) return;

        selectedFolder = node;

        FolderItem item = node.getFolderItem();

        if ( item.isAddAllowed() )
        {
            buttons[1].setEnabled( true );
        }
        else
        {
            buttons[1].setEnabled( false );
        }

        if ( item.isSubfolderAllowed() )
        {
            buttons[2].setEnabled( true );
        }
        else
        {
            buttons[2].setEnabled( false );
        }


    }

}
