// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.util;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;


import org.columba.message.*;
import org.columba.main.*;
import org.columba.gui.util.*;

public class AboutDialog
{

    private MainInterface mainInterface;
    private JDialog dialog;
    private boolean bool = false;
    private JTextField textField;



    public AboutDialog( MainInterface mainInterface )
    {
        this.mainInterface = mainInterface;

	showDialog();
    }


    public void showDialog()
    {

        JButton okButton = new JButton("Ok");
        okButton.setActionCommand( "OK" );


        ImageIcon image = ImageLoader.getImageIcon("", "splash");
        JLabel label = new JLabel( image );
        label.setBorder( BorderFactory.createEmptyBorder( 5,5,5,5 ) );


        JPanel panel = new JPanel();
        Border border = BorderFactory.createEtchedBorder( 1 );

        panel.setLayout( new BorderLayout() );
        panel.add( label, BorderLayout.CENTER );

        JPanel authorPanel = new JPanel();
        //authorPanel.setBorder( BorderFactory.createEmptyBorder( 5,5,5,5 ) );
        authorPanel.setBorder( BorderFactory.createTitledBorder( border, " Contacts") );
        GridBagLayout layout = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
        authorPanel.setLayout( layout );

        JLabel authorLabel = new JLabel("Authors:");
        //Font font = mainInterface.columbaTheme.getControlTextFont();
	Font font = UIManager.getFont("Label.font");
        if ( font != null )
        {
            font = font.deriveFont( Font.BOLD );
            authorLabel.setFont( font );
        }
        c.gridx = 0;
        c.gridy = 0;
        c.anchor = GridBagConstraints.WEST;
        layout.setConstraints(authorLabel, c);
        authorPanel.add( authorLabel );

        c.gridx = 1;
        c.gridy = 0;
        c.anchor = GridBagConstraints.WEST;
        Component box = Box.createRigidArea( new Dimension( 10,10 ) );
        layout.setConstraints(box, c);
        authorPanel.add( box );


        AddressLabel a1 = new AddressLabel( mainInterface, "Frederik Dietz <fdietz@users.sourceforge.net>" );
        c.gridx = 2;
        c.gridy = 0;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints(a1, c);
        authorPanel.add( a1 );

        AddressLabel a2 = new AddressLabel( mainInterface, "Timo Stich <tstich@users.sourceforge.net>" );
        c.gridx = 2;
        c.gridy = 1;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints(a2, c);
        authorPanel.add( a2 );




        JLabel websiteLabel = new JLabel("Website:");
        websiteLabel.setFont( font );
        c = new GridBagConstraints();
        c.gridx = 0;
        c.gridy = 2;
        c.anchor = GridBagConstraints.WEST;
        layout.setConstraints(websiteLabel, c);
        authorPanel.add( websiteLabel );


        UrlLabel websiteUrl = new UrlLabel(mainInterface, "http://columba.sourceforge.net");
        websiteLabel.setFont( font );
        c.gridx = 2;
        c.gridy = 2;
        c.anchor = GridBagConstraints.WEST;
        c.gridwidth = GridBagConstraints.REMAINDER;
        layout.setConstraints(websiteUrl, c);
        authorPanel.add( websiteUrl );

        panel.add( authorPanel, BorderLayout.SOUTH );

        layout = new GridBagLayout();
        c = new GridBagConstraints();

        dialog = DialogStore.getDialog("About...  v"+org.columba.main.MainInterface.version);
        dialog.getContentPane().setLayout( layout );
	dialog.getRootPane().setDefaultButton( okButton );


        c.gridx=0;
        c.gridy=0;
        c.gridwidth = 1;
        c.weightx = 1;
        c.insets = new Insets(10,10,0,10);
        c.anchor = GridBagConstraints.CENTER;
        layout.setConstraints( panel, c);



        c.gridx=0;
        c.gridy=1;
        c.gridwidth = 1;
        c.weightx = 1;
        c.insets = new Insets(10,10,10,10);
        c.anchor = GridBagConstraints.CENTER;
        layout.setConstraints( okButton, c);

        dialog.getContentPane().add( panel );
        dialog.getContentPane().add( okButton );

        dialog.pack();


        java.awt.Dimension dim = dialog.getPreferredSize();

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

        dialog.setLocation(screenSize.width/2 - dim.width/2, screenSize.height/2 - dim.height/2);


        okButton.addActionListener(
            new ActionListener()
                {
                    public void actionPerformed(ActionEvent e)
                    {
                        String action = e.getActionCommand();

                        if  ( action.equals("OK") )
                        {

                            bool = true;

                            dialog.dispose();
                        }
                    }
                }

            );


        dialog.setVisible(true);
    }

    public boolean success()
    {
        return bool;

    }



}
