// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package org.columba.gui.util;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

import org.columba.gui.addressbook.util.*;
import org.columba.config.*;
import org.columba.main.*;
import org.columba.gui.composer.*;
import org.columba.folder.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class AddressLabel extends JPanel implements MouseListener//, ActionListener
{
    private String address;
    private JLabel[] list = new JLabel[3];

    private AddressbookXmlConfig addressbookXmlConfig;
    private JFrame frame;

    private JPopupMenu popup;
    private JMenuItem menuItem;

    private MainInterface mainInterface;
    public AddressLabel( MainInterface mainInterface, String str )
    {
        super();
        this.mainInterface = mainInterface;
        this.frame = mainInterface.mainFrame;
        this.addressbookXmlConfig = mainInterface.config.getAddressbookConfig();

        setLayout( new BoxLayout( this, BoxLayout.X_AXIS ) );
        setBorder( null );
        this.address = str;

        parse();

        UrlController controller = new UrlController( mainInterface );

        if ( list[1] != null )
        {
            controller.setAddress( list[1].getText() );
            popup = controller.createContactMenu( list[1].getText() );
        }
        else
        {
            controller.setAddress( address );
            popup = controller.createContactMenu( address );
        }

        /*
        popup = new JPopupMenu();
        menuItem = new JMenuItem("Add Contact to Addressbook");
        menuItem.addActionListener(this);
        menuItem.setActionCommand("CONTACT");
        popup.add(menuItem);
        if ( list[1] != null )
        {
           menuItem = new JMenuItem("Compose Message for "+ list[1].getText() );
        }
        else
           menuItem = new JMenuItem("Compose Message for "+ address );
        menuItem.setActionCommand("COMPOSE");
        menuItem.addActionListener(this);
        popup.add(menuItem);
        */

    }

    protected void parse()
    {
        int index1 = address.indexOf("<");
        int index2 = address.indexOf(">");

        if ( index1 != -1 )
        {
            String str = address.substring( 0, index1+1 );
            list[0] = new JLabel( str );
            add( list[0] );

            str = address.substring( index1+1, index2 );
            list[1] = new LinkLabel( str );
            list[1].addMouseListener( this );
            add( list[1] );

            str = address.substring( index2, address.length() );
            list[2] = new JLabel( str );
            add( list[2] );
        }
        else //if ( address.indexOf("@") != -1 )
        {
            String str = address;

            int index = str.indexOf(",");
            if ( index != -1 )
            {
                // we got this from headerfieldtree
                list[0] = new JLabel();
                add( list[0] );

                list[1] = new LinkLabel( str.substring(0, index) );
                list[1].addMouseListener( this );
                add( list[1] );

                list[2] = new JLabel( str.substring(index, str.length() ) );
                add( list[2] );
            }
            else
            {
                list[0] = new JLabel();
                add( list[0] );

                list[1] = new LinkLabel( str );
                list[1].addMouseListener( this );
                add( list[1] );
            }

        }


    }

    public void setIcon( ImageIcon icon )
    {
        //list[2].setHorizontalTextPosition( JLabel.LEADING );
        if ( list[0] != null )
           list[0].setIcon( icon );
    }



    public void mouseClicked( MouseEvent e )
    {
        System.out.println("clicked");

        Point point = e.getPoint();

        popup.show( e.getComponent(),
                    e.getX(), e.getY() );



    }

    public void mouseEntered( MouseEvent e )
    {}

    public void mouseExited( MouseEvent e )
    {}

    public void mousePressed( MouseEvent e )
    {}

    public void mouseReleased( MouseEvent e )
    {}



}