// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


/* -*-mode: java; compile-command:"javac CButton.java -classpath ../"; -*- */

package org.columba.gui.util;

import org.columba.gui.action.*;
import org.columba.gui.themes.*;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;



public class CButton extends JButton
{
    String buttonText;

    static boolean WITH_ICON = true;
    static boolean WITH_TEXT = true;
    static boolean ALIGNMENT = true;





    public CButton( BasicAction a )
    {
	super( a );

        if ( ( WITH_ICON == true ) &&
             ( WITH_TEXT == true ) &&
            ( ALIGNMENT == true ) )
        {

            setVerticalTextPosition( SwingConstants.BOTTOM );
            setHorizontalTextPosition( SwingConstants.CENTER );
            setIcon( a.getLargeIcon() );
            //setMargin( new Insets(2,4,2,4) );
            setText( " " +a.getName()+ " " );

            //setRolloverEnabled( true );

            //setBorder( UIManager.getBorder("ToolBarButton.border") );
        }
        else if ( ( WITH_ICON == true ) &&
             ( WITH_TEXT == true ) &&
            ( ALIGNMENT == false ) )
        {
            setVerticalTextPosition( SwingConstants.CENTER );
            setHorizontalTextPosition( SwingConstants.RIGHT );
            setIcon( a.getSmallIcon() );
            //setMargin( new Insets(2,4,2,4) );
            setText( " " +a.getName()+ " " );

            //setRolloverEnabled( true );

            //setBorder( UIManager.getBorder("ToolBarButton.border") );
        }
        else if ( ( WITH_ICON == true ) &&
             ( WITH_TEXT == false ) )
        {

            setIcon( a.getLargeIcon() );
            setText(null);
            //setMargin( new Insets(2,4,2,4) );
            //setText( " " +a.getName()+ " " );

            //setRolloverEnabled( true );

            //setBorder( UIManager.getBorder("ToolBarButton.border") );
        }
    }

    /*
    public void updateUI()
    {
        super.updateUI();


        setBorder( UIManager.getBorder("ToolBarButton.border") );

        setRolloverEnabled( true );
    }
    */

}


