// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.util;

import org.columba.gui.action.*;
import org.columba.message.*;
import org.columba.main.*;
import org.columba.gui.mainframe.*;
import org.columba.gui.mainframe.action.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class CheckButton extends JPanel implements ActionListener
{
    private String text;
    private ImageIcon icon;
    
    private JButton button;
    private PullButton pull;
    
    private JPopupMenu menu;
    private MainInterface mainInterface;
    
    
    public CheckButton(String str, ImageIcon image, MainInterface mainInterface)
        {
            super();
            this.text = str;
            this.icon = image;
            this.mainInterface = mainInterface;
            
            
            initComponents();
            
        }    

    public void initComponents()
    {
          /*
        setMaximumSize( new Dimension( 55,55 ) );
        setMinimumSize( new Dimension( 55,55 ) );
        setPreferredSize( new Dimension( 55,55 ) );
          */

        setLayout( new BoxLayout( this, BoxLayout.X_AXIS) );
        
        
        button = new JButton();
        button.setIcon( icon );
        button.setText( text );
        button.setVerticalTextPosition( SwingConstants.BOTTOM );
        button.setHorizontalTextPosition( SwingConstants.CENTER );
        button.setMargin( new Insets(2,2,2,2) );
        button.setMaximumSize( new Dimension( 110,55 ) );
        button.setMinimumSize( new Dimension( 110,55 ) );
        button.setPreferredSize( new Dimension( 110,55 ) );
        button.setActionCommand("RECEIVE_SEND");
        button.addActionListener( new MainActionListener( mainInterface ) );
        button.setRolloverEnabled( true );
        
        
        add( button );
        

          
        pull = new PullButton();
          //pull.setIcon( new PullIcon() );
        pull.setMargin( new Insets(2,2,2,2) );
        int height;

        Dimension d = button.getPreferredSize();
        height = d.height;
        
        pull.setMaximumSize( new Dimension( 15,55 ) );
        pull.setMinimumSize( new Dimension( 15,55 ) );
        pull.setPreferredSize( new Dimension( 15,55 ) );
        pull.addActionListener( this );
        pull.setActionCommand("MENU");

        
        add( pull );
        


        menu = new JPopupMenu();

        JMenuItem item = new JMenuItem("Receive and Send Messages");
        item.setActionCommand("RECEIVE_SEND");
        item.addActionListener( new MainActionListener( mainInterface ) );
        menu.add( item );
        
        menu.addSeparator();
        
        item = new JMenuItem("Receive new Messages");
        item.setAccelerator( KeyStroke.getKeyStroke( KeyEvent.VK_T, ActionEvent.CTRL_MASK ) );
        item.setActionCommand("RECEIVE");
        item.addActionListener( new MainActionListener( mainInterface ) );
        menu.add( item );
        
        item = new JMenuItem("Send Unsent Message Now", ImageLoader.getImageIcon("org/columba/images/SendMail16.gif") );
        item.setActionCommand("SEND");
        item.addActionListener( new MainActionListener( mainInterface ) );
        menu.add( item );
        
        
        
    }

    public void actionPerformed(ActionEvent e)
    {
	String action  = e.getActionCommand();

        if ( action.equals("MENU") )
        {
            menu.show( this, 0, getHeight() );
            
        }
        
    }
    


}


