// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package org.columba.gui.util;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

 public class PGPPassphraseDialog implements ActionListener
{
    private char[] password;

    //private JFrame frame;
    private JDialog dialog;
    private boolean bool = false;
    private JPasswordField passwordTextField;
    private JTextField loginTextField;
    private JCheckBox checkbox;
    private JLabel checkLabel;

    private String user;
    private boolean save;



    public PGPPassphraseDialog( String id, boolean save)
    {
	showDialog( id, save );
    }


    public void showDialog(String id, boolean save)
    {
        this.user = user;
        this.save = save;
        JButton[] buttons = new JButton[2];

        //JLabel hostLabel = new JLabel("Server: "+host);
        JLabel idLabel = new JLabel("User Id: "+ id );
        //JLabel loginLabel = new JLabel("Login:");
        JLabel passwordLabel = new JLabel("Password:");

        buttons[0] = new JButton("Cancel");
        buttons[0].addActionListener( this );
        buttons[0].setActionCommand( "CANCEL" );

        buttons[1] = new JButton("Ok");
        buttons[1].addActionListener( this );
        buttons[1].setActionCommand( "OK" );
       	buttons[1].setDefaultCapable(true);
	buttons[1].setSelected(true);
        passwordTextField = new JPasswordField(15);
        passwordTextField.setMaximumSize( new java.awt.Dimension( 150,25) );
        //loginTextField = new JTextField(user, 15);
        //loginTextField.setMaximumSize( new java.awt.Dimension( 150,25) );
        //checkLabel = new JLabel("Remember Password");
        checkbox = new JCheckBox( "Remember Password for the remainder of this session" );
        if ( save )
            checkbox.setSelected( true );
        else
            checkbox.setSelected( false );

        dialog = DialogStore.getDialog();
        dialog.getContentPane().setLayout( new BoxLayout( dialog.getContentPane(), BoxLayout.Y_AXIS ) );

        JPanel centerPanel = new JPanel();
        centerPanel.setLayout( new BoxLayout( centerPanel, BoxLayout.Y_AXIS ) );
        centerPanel.setBorder( BorderFactory.createEmptyBorder(10,10,10,10) );
        //TitledBorder etched = javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), " Login ");
	//centerPanel.setBorder( etched );

        centerPanel.add( Box.createRigidArea( new java.awt.Dimension(0,5) ) );

        JPanel panel = new JPanel();
        panel.setLayout( new BoxLayout( panel, BoxLayout.X_AXIS ) );
        panel.add( idLabel );
        centerPanel.add( panel );

        centerPanel.add( Box.createRigidArea( new java.awt.Dimension(0,5) ) );

        /*
        panel = new JPanel();
        panel.setLayout( new BoxLayout( panel, BoxLayout.X_AXIS ) );
        panel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );
        panel.add( loginLabel );
        panel.add( Box.createHorizontalGlue() );
        panel.add( loginTextField );
        panel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );
        centerPanel.add( panel );

        centerPanel.add( Box.createRigidArea( new java.awt.Dimension(0,5) ) );
        */

        panel = new JPanel();
        panel.setLayout( new BoxLayout( panel, BoxLayout.X_AXIS ) );
        panel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );
        panel.add( passwordLabel );
        panel.add( Box.createHorizontalGlue() );
        panel.add( passwordTextField );
        panel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );
        centerPanel.add( panel );

        centerPanel.add( Box.createRigidArea( new java.awt.Dimension(0,5) ) );

        panel = new JPanel();
        panel.setLayout( new BoxLayout( panel, BoxLayout.X_AXIS ) );
        panel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );
        panel.add( checkbox );

        panel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );
          /*
            panel.add( checkLabel );
          */
        centerPanel.add( panel );

        centerPanel.add( Box.createRigidArea( new java.awt.Dimension(0,5) ) );

        dialog.getContentPane().add( centerPanel );

        dialog.getContentPane().add( Box.createRigidArea( new java.awt.Dimension(0,10) ) );

        panel = new JPanel();
        panel.setLayout( new BoxLayout( panel, BoxLayout.X_AXIS ) );
        panel.add( Box.createRigidArea( new java.awt.Dimension(50,0) ) );
        panel.add( buttons[0] );
        panel.add( Box.createHorizontalGlue() );
        panel.add( buttons[1] );
        panel.add( Box.createRigidArea( new java.awt.Dimension(50,0) ) );
        dialog.getContentPane().add( panel );

        dialog.getContentPane().add( Box.createRigidArea( new java.awt.Dimension(0,20) ) );

        dialog.setSize( new Dimension( 300,200) );

	dialog.getRootPane().setDefaultButton(buttons[1]);

        dialog.show();

        java.awt.Dimension dim = new Dimension( 400,200 ) ;

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

        dialog.setLocation(screenSize.width/2 - dim.width/2, screenSize.height/2 - dim.height/2);


    }

    public char[] getPassword()
    {
        return password;
    }

    public boolean success()
    {
        return bool;

    }

    public boolean getSave()
    {
        return save;
    }


    public void actionPerformed(ActionEvent e)
    {
	String action  = e.getActionCommand();

	if  ( action.equals("OK") )
        {
            password = passwordTextField.getPassword();

            //user = loginTextField.getText();

            if ( checkbox.isSelected() )
                save = true;
            else
                save = false;


            bool = true;

            dialog.dispose();
        }
        else if ( action.equals("CANCEL") )
        {
            bool = false;

            dialog.dispose();
        }

    }


}

