// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.gui.util;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.Vector;


public class PasswordDialog implements ActionListener
{
    private char[] password;
    private JFrame frame;
    private JDialog dialog;
    private boolean bool = false;
    private JPasswordField passwordTextField;
    private JTextField loginTextField;
    private JCheckBox checkbox;
    private JLabel checkLabel;

    private String user;
    private boolean save;

	private JComboBox loginMethodComboBox;
	String loginMethod;

    public PasswordDialog()
    {

    }


    public void showDialog(String host, String user, String password, Vector methods, String loginMethod, boolean save)
    {
        this.user = user;
        this.save = save;
        JButton[] buttons = new JButton[2];

        JLabel hostLabel = new JLabel("Server: "+host);
        JLabel loginLabel = new JLabel("Login:");
        JLabel passwordLabel = new JLabel("Password:");
        
        JLabel loginMethodLabel = new JLabel("Login Method:");
        
        loginMethodComboBox = new JComboBox( methods );
       	loginMethodComboBox.setSelectedItem(loginMethod);
        

        buttons[0] = new JButton("Cancel");
        buttons[0].addActionListener( this );
        buttons[0].setActionCommand( "CANCEL" );

        buttons[1] = new JButton("Ok");
        buttons[1].addActionListener( this );
        buttons[1].setActionCommand( "OK" );
       	buttons[1].setDefaultCapable(true);
		buttons[1].setSelected(true);
		
        passwordTextField = new JPasswordField(password, 20);
        //passwordTextField.setMaximumSize( new java.awt.Dimension( 150,25) );
        loginTextField = new JTextField(user, 20);
        //loginTextField.setMaximumSize( new java.awt.Dimension( 150,25) );
        //checkLabel = new JLabel("Save Password");
        
        checkbox = new JCheckBox( "Store password in configuration file" );
        if ( save )
            checkbox.setSelected( true );
        else
            checkbox.setSelected( false );

        dialog = new JDialog( frame, true );
        //dialog.getContentPane().setLayout( new BoxLayout( dialog.getContentPane(), BoxLayout.Y_AXIS ) );
		dialog.getContentPane().setLayout( new BorderLayout() );
		
        JPanel centerPanel = new JPanel();
	centerPanel.setLayout( new BorderLayout() );
        //centerPanel.setLayout( new BoxLayout( centerPanel, BoxLayout.Y_AXIS ) );
        centerPanel.setBorder( BorderFactory.createEmptyBorder(5,5,5,5) );
        
        /*
        TitledBorder etched = javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), " Login ");
	centerPanel.setBorder( etched );
		*/
		
		JPanel panel = new JPanel();
		TitledBorder etched = javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), " Information ");
		panel.setBorder( etched );
		panel.setLayout( new BorderLayout() );
		
		JPanel leftInformationPanel = new JPanel();
		leftInformationPanel.setBorder( BorderFactory.createEmptyBorder(0,5,5,5) );
		leftInformationPanel.setLayout( new GridLayout( 0,1,50,5 ) );
		panel.add( leftInformationPanel, BorderLayout.CENTER );
		
		JPanel rightInformationPanel = new JPanel();
		rightInformationPanel.setLayout( new GridLayout( 0,1,50,5 ) );
		rightInformationPanel.setBorder( BorderFactory.createEmptyBorder(0,5,5,5) );
		panel.add( rightInformationPanel, BorderLayout.EAST );
		
		
		leftInformationPanel.add( loginLabel );
		rightInformationPanel.add( loginTextField );
		leftInformationPanel.add( passwordLabel );
		rightInformationPanel.add( passwordTextField );
		
		//centerPanel.add( Box.createRigidArea( new java.awt.Dimension(0,5) ) );
		
	
		centerPanel.add( panel, BorderLayout.NORTH );
	
		/*	
        JPanel panel = new JPanel();
        panel.setLayout( new BoxLayout( panel, BoxLayout.X_AXIS ) );
        panel.add( hostLabel );
        centerPanel.add( panel );
		*/
		
		//centerPanel.add( Box.createRigidArea( new java.awt.Dimension(0,5) ) );


		panel = new JPanel();
		
		etched = javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createEtchedBorder(), " Security ");
		panel.setBorder( etched );
		
        JPanel securityPanel = new JPanel();
	securityPanel.setLayout( new BorderLayout() );
        //securityPanel.setLayout( new BoxLayout( securityPanel, BoxLayout.Y_AXIS ) );
	//securityPanel.setLayout( new GridLayout(2,1) );
        //securityPanel.setAlignmentX(1);
        //securityPanel.add( Box.createRigidArea( new java.awt.Dimension(0,5) ) );               
        
        JPanel loginMethodPanel = new JPanel();
	//loginMethodPanel.setAlignmentX(1);
	//loginMethodPanel.setAlignmentY(0);
        loginMethodPanel.setLayout( new BoxLayout( loginMethodPanel, BoxLayout.X_AXIS ) );
        //loginMethodPanel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );
        loginMethodPanel.add( loginMethodLabel );
        loginMethodPanel.add( Box.createRigidArea( new java.awt.Dimension(10,0) ) );
        loginMethodPanel.add( loginMethodComboBox );  
	loginMethodPanel.add( Box.createHorizontalGlue() );
        //loginMethodPanel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );
          
        securityPanel.add( loginMethodPanel, BorderLayout.NORTH );
        
        //securityPanel.add( Box.createRigidArea( new java.awt.Dimension(0,5) ) );
        
        JPanel passwordPanel = new JPanel();
	//passwordPanel.setAlignmentX(1);
	//passwordPanel.setAlignmentY(0);
        passwordPanel.setLayout( new BoxLayout( passwordPanel, BoxLayout.X_AXIS ) );
        //passwordPanel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );
        passwordPanel.add( checkbox );
        //passwordPanel.add( Box.createRigidArea( new java.awt.Dimension(5,0) ) );
        passwordPanel.add( Box.createHorizontalGlue() );
        
        securityPanel.add( passwordPanel, BorderLayout.CENTER );
        
        
          
        panel.add( securityPanel );
        
        centerPanel.add( panel, BorderLayout.CENTER );
        
        

        //centerPanel.add( Box.createRigidArea( new java.awt.Dimension(0,5) ) );
        

        dialog.getContentPane().add( centerPanel, BorderLayout.CENTER );

 
 		JPanel bottomPanel = new JPanel();
 		bottomPanel.setLayout( new BorderLayout() );
 		
        JPanel buttonPanel = new JPanel();
        buttonPanel.setBorder( BorderFactory.createEmptyBorder(5,5,5,5) );
        buttonPanel.setLayout( new GridLayout( 1,2,10,0 ) );
        buttonPanel.add( buttons[0] );
        buttonPanel.add( buttons[1] ); 
        
        bottomPanel.add( buttonPanel, BorderLayout.EAST );
        
        dialog.getContentPane().add( bottomPanel, BorderLayout.SOUTH );

    
        
        dialog.pack();

		dialog.getRootPane().setDefaultButton(buttons[1]);

        

        java.awt.Dimension dim = new Dimension( 300,200 ) ;

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();

        dialog.setLocation(screenSize.width/2 - dim.width/2, screenSize.height/2 - dim.height/2);

		dialog.show();
    }

    public char[] getPassword()
    {
        return password;
    }

    public boolean success()
    {
        return bool;

    }

    public boolean getSave()
    {
        return save;
    }

    public String getUser()
    {
        return user;
    }

	public String getLoginMethod()
	{
		return loginMethod;
	}

    public void actionPerformed(ActionEvent e)
    {
	String action  = e.getActionCommand();

	if  ( action.equals("OK") )
        {
            password = passwordTextField.getPassword();

            user = loginTextField.getText();

            if ( checkbox.isSelected() )
                save = true;
            else
                save = false;
                
			loginMethod = (String) loginMethodComboBox.getSelectedItem();
			
            bool = true;

            dialog.dispose();
        }
        else if ( action.equals("CANCEL") )
        {
            bool = false;

            dialog.dispose();
        }

    }


}
