package org.columba.gui.util;

import org.columba.main.*;
import org.columba.gui.composer.*;
import org.columba.config.*;
import org.columba.parser.*;
import org.columba.gui.addressbook.util.*;
import org.columba.gui.message.*;
import org.columba.gui.mimetype.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class UrlController implements ActionListener
{

    private MainInterface mainInterface;

    private String address;
    private String link;


    public UrlController( MainInterface mainInterface )
    {
        this.mainInterface = mainInterface;

    }

    public JPopupMenu createContactMenu( String contact )
    {
        JPopupMenu popup = new JPopupMenu();
        JMenuItem menuItem = new JMenuItem("Add Contact to Addressbook");
        menuItem.addActionListener( this );
        menuItem.setActionCommand("CONTACT");
        popup.add(menuItem);
        menuItem = new JMenuItem("Compose Message for "+ contact );
        menuItem.setActionCommand("COMPOSE");
        menuItem.addActionListener( this );
        popup.add(menuItem);

        return popup;
    }

    public JPopupMenu createLinkMenu()
    {
        JPopupMenu popup = new JPopupMenu();
        JMenuItem menuItem = new JMenuItem("Open");
        menuItem.addActionListener( this );
        menuItem.setActionCommand("OPEN");
        popup.add(menuItem);
        menuItem = new JMenuItem("Open with..." );
        menuItem.setActionCommand("OPEN_WITH");
        menuItem.addActionListener( this );
        popup.add(menuItem);
        popup.addSeparator();
        menuItem = new JMenuItem("Open with internal browser" );
        menuItem.setActionCommand("OPEN_WITHINTERNALBROWSER");
        menuItem.addActionListener( this );
        popup.add(menuItem);

        return popup;
    }

    public void setAddress( String s )
    {
        this.address = s;
    }

    public String getAddress()
    {
        return address;
    }

    public String getLink()
    {
        return link;
    }

    public void setLink( String s )
    {
        this.link = s;
    }

    protected DocumentOperator getDocumentOperator()
    {
        return mainInterface.messageViewer.getDocumentOperator();
    }

    public void compose( String address )
    {
        ComposerFrame composer = new ComposerFrame( mainInterface );

        try
        {
            composer.setTo( getAddress(), new String(""), new String("") );
        }
        catch ( Exception ex )
        {}
    }

    public void contact( String address )
    {
        AdapterNode node = mainInterface.config.getAddressbookConfig().addContact( address );

        EditContactDialog dialog = new EditContactDialog(
                                                              mainInterface.config.getAddressbookConfig(),
                                                              node );
        //dialog.showDialog();
    }

    public void open( String url )
    {
        MimeTypeViewer viewer = new MimeTypeViewer( mainInterface );
        viewer.openUrl( url );
    }

    public void openWith( String url )
    {
         MimeTypeViewer viewer = new MimeTypeViewer( mainInterface );
         viewer.openWithUrl( url );
    }

    public void openWithBrowser( String url )
    {
        MimeTypeViewer viewer = new MimeTypeViewer( mainInterface );
        viewer.openWithBrowserUrl( url );

        /*
        boolean b = getDocumentOperator().enableViewer( DocumentOperator.HTML );
            mainInterface.messageViewer.update(b);

            HtmlViewer viewer = (HtmlViewer) getDocumentOperator().getViewer( DocumentOperator.HTML );

            //System.out.println("link: "+getLink() );

            if ( viewer != null )
            {
                try
                {
                    viewer.setPage( link );
                }
                catch ( Exception ex )
                {
                    ex.printStackTrace();
                    if ( ex instanceof java.net.UnknownHostException )
                    {
                        JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                           "Unknown host exception: "+ex.getMessage() );
                    }
                    else
                    {
                        JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                           "Browser exception: "+ex.getMessage() );
                    }
                }
            }
        */

    }

    public void actionPerformed( ActionEvent e )
    {
        String action  = e.getActionCommand();


        if ( action.equals("COMPOSE") )
        {
            compose( getAddress() );
        }
        else if ( action.equals("CONTACT") )
        {
            contact( getAddress() );
        }
        else if ( action.equals("OPEN") )
        {
            open( getLink() );
        }
        else if ( action.equals("OPEN_WITH") )
        {
            openWith( getLink() );
        }
        else if ( action.equals("OPEN_WITHINTERNALBROWSER") )
        {
            openWithBrowser( getLink() );
        }
    }
}