package org.columba.gui.util;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;


import org.columba.parser.*;
import org.columba.main.MainInterface;
import org.columba.gui.message.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class UrlLabel extends JLabel implements MouseListener//, ActionListener
{
    private JPopupMenu popup;
    private JMenuItem menuItem;

    private MainInterface mainInterface;

    boolean entered = false;
    boolean mousehover;

    private DocumentOperator documentOperator;

    public UrlLabel( MainInterface mainInterface, String str )
    {
        super( str );
        this.mainInterface = mainInterface;

        documentOperator = mainInterface.messageViewer.getDocumentOperator();
        addMouseListener( this );


        setForeground( Color.blue );

        mousehover = false;


        /*
        popup = new JPopupMenu();
        menuItem = new JMenuItem("Open");
        menuItem.addActionListener( this );
        menuItem.setActionCommand("OPEN");
        popup.add(menuItem);
        menuItem = new JMenuItem("Open with..." );
        menuItem.setActionCommand("OPEN_WITH");
        menuItem.addActionListener( this );
        popup.add(menuItem);
        popup.addSeparator();
        menuItem = new JMenuItem("Open with internal browser" );
        menuItem.setActionCommand("OPEN_WITHINTERNALBROWSER");
        menuItem.addActionListener( this );
        popup.add(menuItem);
        */
        UrlController controller = new UrlController( mainInterface );
        controller.setLink( str );
        popup = controller.createLinkMenu();
    }


    public void mouseClicked( MouseEvent e )
    {
        System.out.println("clicked");

        Point point = e.getPoint();

        popup.show( e.getComponent(),
                    e.getX(), e.getY() );
    }

    public void mouseEntered( MouseEvent e )
    {
        setCursor( new Cursor( Cursor.HAND_CURSOR ) );
        entered = true;

        if ( mousehover == true )
           repaint();
    }

    public void mouseExited( MouseEvent e )
    {
        setCursor( new Cursor( Cursor.DEFAULT_CURSOR ) );
        entered = false;

        if ( mousehover == true )
           repaint();
    }

    public void mousePressed( MouseEvent e )
    {
    }

    public void mouseReleased( MouseEvent e )
    {}



    public void paint( Graphics g )
    {
        super.paint( g );

        if ( ( entered == true ) || ( mousehover == false ) )
        {
            Rectangle r = g.getClipBounds();

            g.drawLine(0,
                     r.height - this.getFontMetrics(this.getFont()).getDescent(),
                     this.getFontMetrics(this.getFont()).stringWidth(this.getText()),
                     r.height - this.getFontMetrics(this.getFont()).getDescent());
        }

    }


    /*
    public void actionPerformed( ActionEvent e )
    {

        String action = e.getActionCommand();

        if ( action.equals("OPEN") )
        {
            boolean save = false;
                String viewer;
                ChooseViewerDialog viewerDialog;

                viewer = MimeRouter.getViewer( "text", "html" );
                if( viewer == null )
                {

                    viewerDialog = new ChooseViewerDialog(mainInterface.mainFrame,
                                                          "text",
                                                          "html",
                                                          save);

                    viewer = viewerDialog.getViewer();
                    save = viewerDialog.saveViewer();

                    if(save) MimeRouter.setViewer( "text", "html", viewer );
                }

                try
                {
                    Runtime.getRuntime().exec( viewer+" "+getText() );
                }
                catch( IOException ex )
                {
                    ex.printStackTrace();
                    JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                   "Error: "+ex.getMessage() );
                }
        }
        else if ( action.equals("OPEN_WITH") )
        {
            boolean save = false;
                String viewer;
                ChooseViewerDialog viewerDialog;



                    viewerDialog = new ChooseViewerDialog(mainInterface.mainFrame,
                                                          "text",
                                                          "html",
                                                          save);

                    viewer = viewerDialog.getViewer();
                    save = viewerDialog.saveViewer();

                    if(save) MimeRouter.setViewer( "text", "html", viewer );


                try
                {
                    Runtime.getRuntime().exec( viewer+" "+getText() );
                }
                catch( IOException ex )
                {
                    ex.printStackTrace();
                    JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                   "Error: "+ex.getMessage() );
                }
        }
        else if ( action.equals("OPEN_WITHINTERNALBROWSER") )
        {
            boolean b = documentOperator.enableViewer( documentOperator.HTML );
            mainInterface.messageViewer.update(b);

            HtmlViewer viewer = (HtmlViewer) documentOperator.getViewer( DocumentOperator.HTML );

            //System.out.println("link: "+getLink() );

            if ( viewer != null )
            {
                try
                {
                    viewer.setPage( getText() );
                }
                catch ( Exception ex )
                {
                    ex.printStackTrace();
                    if ( ex instanceof java.net.UnknownHostException )
                    {
                        JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                           "Unknown host exception: "+ex.getMessage() );
                    }
                    else
                    {
                        JOptionPane.showMessageDialog( mainInterface.mainFrame,
                                                           "Browser exception: "+ex.getMessage() );
                    }
                }
            }

        }

    }
    */
}