package org.columba.main;

import org.columba.folder.*;
import org.columba.folder.virtual.*;
import org.columba.folder.imap.*;
import org.columba.pop3.*;
import org.columba.message.*;
import org.columba.util.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Enumeration;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class ExitWorker extends SwingWorker
{
    private MainInterface mainInterface;

    private JProgressBar bar;

    private int value=0;
    private int count=0;

    public ExitWorker( MainInterface mainInterface )
    {
        this.mainInterface = mainInterface;


    }


    public Object construct()
    {
        showDialog();

        mainInterface.mainFrame.saveWindowPosition();
        mainInterface.headerTableViewer.saveColumnConfig();

        mainInterface.mainFrame.setVisible(false);

        mainInterface.config.saveConfiguration();

        initProgressBar();

        savePop3();
        saveAllFolders();

        System.exit(0);

        unregister();

        return null;
    }

    public void savePop3()
    {
        PopServer server;
        for ( int i=0; i < mainInterface.popServerCollection.count(); i++ )
        {
            server = mainInterface.popServerCollection.get( i );
            server.save();
            bar.setValue( value++ );
        }
    }

    public void showDialog()
    {
        JFrame dialog = new JFrame("Saving Folders...");
        //JButton label = new JButton("Saving Folders...");
        //dialog.getContentPane().setLayout( new BorderLayout() );
        //dialog.getContentPane().add( label, BorderLayout.CENTER );
        //dialog.getContentPane().add( label );
        bar = new JProgressBar();
        bar.setValue(0);
        bar.setStringPainted( true );

        dialog.getContentPane().add( bar, BorderLayout.CENTER );
        dialog.pack();

        java.awt.Dimension dim = new Dimension( 300,50 ) ;
        dialog.setSize( dim );
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        dialog.setLocation(screenSize.width/2 - dim.width/2, screenSize.height/2 - dim.height/2);

        dialog.setVisible( true );

        /*
        dialog.addWindowListener(
                new WindowAdapter()
                    {
                        public void windowClosing(WindowEvent e)
                            {

                                System.exit(0);

                            }
                    }
                );
        */
    }

    protected void initProgressBar()
    {
        Folder rootFolder = (Folder) mainInterface.treeViewer.getFolderTree().getRootFolder() ;
        int c = getFolderCount( rootFolder );

        int result = c+mainInterface.popServerCollection.count();
        bar.setMaximum( result );

        //System.out.println("folder count: "+ result );

        bar.setValue( value++ );
    }

    protected int getFolderCount( Folder parent )
    {

        for (Enumeration e = parent.children() ; e.hasMoreElements() ;)
        {
            Folder child = (Folder) e.nextElement();

            getFolderCount( child );

            if ( child.getChanged() == true )
               count++;
        }

        return count;
    }

    public void saveAllFolders()
    {

        Folder rootFolder = (Folder) mainInterface.treeViewer.getFolderTree().getRootFolder() ;


        //timer.start();
        saveFolder( rootFolder );

    }

    public void saveFolder( Folder parentFolder )
    {

        int count = parentFolder.getChildCount();
        Folder child;
        Folder folder;



        for (Enumeration e = parentFolder.children() ; e.hasMoreElements() ;)
        {

            child = (Folder) e.nextElement();

            if ( child != null )
		{
                    if ( child instanceof VirtualFolder )
                    {
                    }
                    if ( child instanceof ImapFolder )
                    {
                        if ( child.getChanged() == true )
                        {
                            bar.setValue( value++ );
                            try
                            {
                                //child.expunge();
                                child.save();
                            }
                            catch ( Exception ex )
                            {
                                System.out.println("Error while saving folder: "+ ex.getMessage() );
				ex.printStackTrace();
                            }

                        }
                    }
                    else
                    {


                        if ( child.getChanged() == true )
                        {
                            bar.setValue( value++ );

                            try
                          {
                            child.unmarkRecent();
                          }
                          catch ( Exception ex )
                          {
                            ex.printStackTrace();
                          }

                        Object[] uids = child.getUids();



                        for ( int i=0; i<uids.length; i++ )
                        {



                            try
                            {
                                Message message = child.uidGet( uids[i] );
                                Flags flags = message.getFlags();
                                boolean expunged = flags.getDeleted();

                                if ( expunged == true )
                                {
                                    Object recents[] = new Object[1];
                                    recents[0] = uids[i];

                                    child.workerViewRemove( recents );
                                    child.workerRemove( uids[i] );
                                }
                            }
                            catch ( Exception ex )
                            {
                                //System.out.println("Exception: "+ ex.getMessage() );
                                ex.printStackTrace();
                            }

                        }

                            try
                            {
                                child.save();
                            }
                            catch ( Exception ex )
                            {
                                System.out.println("Error while saving folder: "+ ex.getMessage() );
				ex.printStackTrace();
                            }

                        }

                    }

		}

            saveFolder( child );

        }


    }




}
