// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.main;

import org.columba.config.*;
import org.columba.gui.attachment.*;
import org.columba.gui.header.*;
import org.columba.gui.tree.*;
import org.columba.gui.tree.util.*;
import org.columba.gui.message.*;
import org.columba.gui.mainframe.*;
import org.columba.gui.util.*;
import org.columba.gui.action.*;
import org.columba.pop3.*;
import org.columba.gui.statusbar.*;
import org.columba.gui.themes.*;
import org.columba.folder.*;
import org.columba.pgp.*;
import org.columba.parser.*;

import java.util.Locale;
import java.util.ResourceBundle;
import javax.swing.plaf.metal.MetalLookAndFeel;

public class MainInterface
{
	public static String version = "0.9.8";
	
	
    public Config config;
    public HeaderTableViewer headerTableViewer;
    public AttachmentViewer attachmentViewer;
    public MessageViewer messageViewer;
    public TreeViewer treeViewer;
    public MainFrame mainFrame;
    public PopServerCollection popServerCollection;
    public StatusBar statusBar;
    public Locale currentLocale;
    //public ResourceBundle guiLabels, headerLabels;
    public GlobalActionCollection globalActionCollection;
    public DefaultCTheme columbaTheme;
    public FolderInfoPanel folderInfoPanel;

    //public String mainFontName;
    //public int mainFontSize;
    //public String textFontName;
    //public int textFontSize;
    public Crossbar crossbar;

    public HeaderTableItem headerTableItem;
    public WindowItem mainFrameWindowItem;
    public WindowItem composerWindowItem;
    public ThemeItem themeItem;

    public MetalLookAndFeel lookAndFeel;

    public TaskManager taskManager;

    public PGPController pgpController;

    public ImageSequenceTimer imageSequenceTimer;

    public MainInterface()
    {}

}










