// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.message;

import java.util.Vector;


public class HeaderList
{
    Vector headers;
    Vector uids;
    Vector flags;

    public HeaderList()
    {
	headers = new Vector();
	uids = new Vector();
    }

    public void add( ColumbaHeader header, Object uid )
    {
	headers.add( header );
	uids.add( uid );
    }

    public int count()
    {
	return headers.size();
    }

    public ColumbaHeader getHeader( int index )
    {
	return (ColumbaHeader)headers.get(index);
    }

    public Object getUid( int index )
    {
	return uids.get( index );
    }

    public ColumbaHeader get( int i )
    {
        return (ColumbaHeader) headers.get(i);
    }

    public void remove( Object uid )
    {
	int index = uids.indexOf( uid );

	uids.remove( index );
	headers.remove( index );
	
    }

    public ColumbaHeader uidgetHeader( Object uid )
    {
	int index = uids.indexOf( uid );
	if( index == -1 ) return null;
	return (ColumbaHeader)headers.get( index );
    }

}



