// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.message;

import java.util.Date;

public class Message
{
    protected ColumbaHeader header;
    protected MimePartCollection mimePartCollection;
    protected String rawString;
    protected String bodyText;
    protected MimePart bodyPart;




    public Message()
        {
            header = new ColumbaHeader();
            mimePartCollection = new MimePartCollection();



        }

    public Message( ColumbaHeader header )
    {
	this.header = header;
        mimePartCollection = new MimePartCollection();

    }


    public void setBodyPart( MimePart body )
    {
	bodyPart = body;
    }
    
    public MimePart getBodyPart()
    {
	return bodyPart;
    }

    public String getRawString()
    {
        return rawString;
    }

    public void setRawString(String rawString)
    {
        this.rawString = rawString;
    }

    public ColumbaHeader getHeader()
    {
        return header;
    }

    public void setHeader( ColumbaHeader h)
    {
	header = h;
    }

    public int getSize()
    {
        Integer sizeInt = (Integer) getHeader().get("columba.size");

        return sizeInt.intValue();
    }


    public Flags getFlags()
    {
        return getHeader().getFlags();
    }

    public void setUID( Object o )
    {
        if ( o != null )
           header.set("columba.uid", o );
        else
           header.set("columba.uid", new String("") );

        //uid = o;
    }

    public Object getUID()
    {
        return header.get("columba.uid");
    }


    public void addMimePart( MimePart a )
    {
        mimePartCollection.add( a );
    }



    public MimePart getMimePart( int number )
    {
        return mimePartCollection.get(number);

    }

    public int getMimePartCount()
    {
        return mimePartCollection.count();
    }


    public MimePartCollection getMimePartCollection()
    {
        return mimePartCollection;
    }

    public void setMimePartCollection( MimePartCollection ac )
    {
        mimePartCollection = ac;
    }

	/*
    public String toString()
    {
	Rfc822Header header = getHeader();
	if ( header == null ) return "";

	String subject = (String) header.get("Subject");
	if ( subject == null ) return "";

	return subject;
    }
    */

    public void setBodyText( String body )
    {
	bodyText = body;
    }

    public String getBodyText()
    {
	return bodyText;
    }

    public void freeMemory()
    {
	// Delete everything but the Header
	bodyText = null;
	rawString = null;
	mimePartCollection = null;
    }

    public Object clone()
    {
        Message message = new Message();

        message.setHeader(  (ColumbaHeader) header.clone() );

        message.setRawString( new String( getRawString() ) );

        return message;
    }



}



