// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.message;

import java.io.*;

import org.columba.coder.*;
import org.columba.folder.Folder;

public class MimePart
{
    private MimeHeader mimeHeader;
    private String body;
    private Message subMessage;
    private File file;
    //private Reader source;
    private Folder pFolder;
      //private int pIndex;
    private Object pUid;

    public MimePart()
        {
            mimeHeader = new MimeHeader();
        }

	public MimePart(MimeHeader header)
	{
		mimeHeader = header;
		body = null;
		subMessage = null;
		file = null;
		//source = null;
	}

    public MimePart(MimeHeader header, String input, Message message)
    {
        mimeHeader = header;
        body = input;
        subMessage = message;
        file = null;
    }


    public MimePart( MimeHeader header, File file )
    {
        mimeHeader = header;
        body = null;
        this.file = file;
    }

    public MimePart( MimeHeader header, Reader source )
    {
        mimeHeader = header;
        body = null;
        //this.source = source;
    }

	/*
    public void setSource( Reader s )
    {
        source = s;
    }

    public Reader getSource()
    {
	return source;
    }
    */

      /*
    public MimePart( Folder pf, int pi )
    {
        mimeHeader = new MimeHeader( "back", "back" );
        pFolder = pf;
        pIndex = pi;
    }
      */

    public MimePart( Folder pf, Object pi )
    {
        mimeHeader = new MimeHeader( "back", "back" );
        pFolder = pf;
          //pIndex = pi;
        pUid = pi;

    }

    public void setBody( String s )
    {
        body = s;
    }

    public void setFile( File f )
    {
        file = f;
    }

    public MimeHeader getHeader()
    {
        return mimeHeader;
    }

    public void setHeader( MimeHeader h )
    {
        mimeHeader = h;
    }


    public String getBody()
    {
        return body;
    }

    public Message getSubmessage()
    {
        return subMessage;
    }

    public String getName()
    {
        String result;

        if( file != null) return file.getName();

        result = mimeHeader.getDispositionParameter("filename");
        if( result != null ) return result;

        result = mimeHeader.getContentParameter("name");
        if( result != null ) return result;

        result = mimeHeader.getContentType() + " / "+ mimeHeader.getContentSubtype();
        return result;
    }

    public Folder getParentFolder()
    {
        return pFolder;
    }

    public Object getParentUid()
    {
        return pUid;
    }


    public File getFile()
    {
        String filename;

        if( file == null) {
            filename = mimeHeader.getDispositionParameter("filename");
            if( filename == null) {
                filename = mimeHeader.getContentParameter("name");
            }
            if(filename!= null) {
                file = new File( filename );
            }
        }

        return file;
    }

    public String composeToString()
    {
        StringBuffer output = new StringBuffer();
        Encoder encoder;

        output.append( mimeHeader.getHeader() );
        output.append("\n");

        StringWriter buffer = new StringWriter();
        encoder = CoderRouter.getEncoder(mimeHeader.contentTransferEncoding);

		/*
		if ( source !=  null )
        	encoder.setupEncoder( source , buffer );
        */
        
        if ( body != null )
        {
        	encoder.setupEncoder( new StringReader(body) , buffer );

        	encoder.run();
        }
        

        output.append( buffer.toString() );

        return output.toString();
    }
}



