// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.message;

import java.util.Vector;


public class MimePartCollection
{
    Vector list;    
    
    public MimePartCollection()
        {
            list = new Vector();
        }

    public MimePartCollection(MimePart first)
        {
            list = new Vector();
            list.addElement(first);
        }
    
    public Vector getVector()
        {
            return list;   
        }
    
    
    public MimePart get(int number)
        {
            if ( (number>list.size()-1) || ( number<0 ) )
                return null;
            else
                return (MimePart) list.elementAt(number);
            
        }
    
    public boolean exists(int number)
        {
            if ( (number>=0) && (number<list.size()) )
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    
    
    public void remove(int number)
        {
            list.remove(number);
            
        }
    
    
    public void add(MimePart attachment)
        {
            list.addElement(attachment);
        }
    
    public void insert(int index, MimePart attachment)
        {
            list.insertElementAt(attachment, index);
        }
    
    public int count()
        {
            return list.size();
        }
    
    public void clear()
        {
            list.clear();
        }

    public void add(MimePartCollection acol)
    {
        if( acol != null) 
            list.addAll( acol.getVector() );
    }
    
    
}
