// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

package org.columba.parser;



import org.columba.message.*;
import org.columba.coder.*;
import org.columba.pgp.*;
import org.columba.config.*;

import java.io.*;
import java.util.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class MimeMultipartEncryptedParser extends MimeTypeParser
{


    public MimePartCollection parse(MimeHeader header, String input)
    {
        return null;
    }



    public MimePartCollection parseDecrypt(String input)
    {

        if ( input.length() == 0 ) return new MimePartCollection();

        MimePartCollection attachments = new MimePartCollection();
        Vector parts;
        MimeParser mimeParser = new MimeParser();
        int startPos, endPos;

        parts = new Vector();


        startPos = input.indexOf( "\n--" );
        endPos = input.indexOf( "\n", startPos+1 );
        //System.out.println("charat: "+ input.charAt(endPos-1) );

        //if ( input.charAt(endPos-1) == '"' ) endPos-=2;


        String startBound = input.substring( startPos, endPos+1 );
        String endBound =  input.substring( startPos, endPos )+"--";

        //System.out.println("startbound: "+ startBound );
        //System.out.println("endbound: "+ endBound );

        startPos = input.indexOf(startBound)+startBound.length();
        endPos = input.indexOf( startBound, startPos+1 );

        while( endPos != -1 ) {

               //System.out.println("part added: "+ input.substring( startPos, endPos ) );

            parts.add( input.substring( startPos, endPos ) );
            startPos = endPos + startBound.length();
            endPos = input.indexOf(startBound,startPos);
        }

        endPos = input.indexOf(endBound,startPos);

        if( endPos == -1 ) endPos = input.length()-1;


        parts.add( input.substring( startPos, endPos ) );

          // Bearbeitung der Multiparts

        int size = parts.size();

        for(int i=0; i<size; i++) {
            System.out.println("add part: "+ i );
            attachments.add( mimeParser.parse( (String) (parts.get(i)) ) );
            System.out.println("part body:\n"+ attachments.get(i).getBody() );
        }

        return attachments;
    }
}