// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


/** Document the purpose of this class.
 *
 * @version 1.0
 * @author Timo Stich
 */

package org.columba.parser;

import java.io.*;
import org.columba.message.*;
import org.columba.coder.*;
import java.util.*;

public class MimeMultipartParser extends MimeTypeParser
{
    
    public MimePartCollection parse(MimeHeader header, String input)
    {
        MimePartCollection attachments = new MimePartCollection();
        Vector parts;
        MimeParser mimeParser = new MimeParser();
        int startPos, endPos;
        String bound = (String) header.contentParameter.get("boundary");

        String startBound = new String("--"+bound+"\n");
        String endBound = new String("--"+bound+"--");

        parts = new Vector();

          // Aufteilen der Message in die einzelnen Multiparts

        startPos = input.indexOf(startBound)+startBound.length();
        endPos = input.indexOf(startBound,startPos);

        while( endPos != -1 ) {
            parts.add( input.substring( startPos, endPos ) );
            startPos = endPos + startBound.length();
            endPos = input.indexOf(startBound,startPos);
        }

        endPos = input.indexOf(endBound,startPos);
        if( endPos == -1 ) endPos = input.length()-1;
        
        parts.add( input.substring( startPos, endPos ) );

          // Bearbeitung der Multiparts

        int size = parts.size();

        for(int i=0; i<size; i++) {
            attachments.add( mimeParser.parse( (String) (parts.get(i)) ) );
        }
        
        return attachments;
    }
}

