// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


/** Document the purpose of this class.
 *
 * @version 1.0
 * @author Timo Stich
 */

package org.columba.parser;

import java.io.*;
import org.columba.message.*;
import org.columba.coder.*;

public class MimeTextParser extends MimeTypeParser
{
    public MimePartCollection parse(MimeHeader header, String input )
    {
        MimePartCollection output = new MimePartCollection();
        StringWriter out = new StringWriter();
        Decoder decoder;

        decoder = CoderRouter.getDecoder( header.contentTransferEncoding );
        decoder.setupDecoder( new StringReader( input ), out );
        decoder.run();

        output.add( new MimePart( header, out.toString(), null ) );
        
        return output;
    }
}
