package org.columba.pop3;

import org.columba.main.MainInterface;
import org.columba.protocol.*;
import org.columba.gui.util.*;
import org.columba.folder.*;

import java.util.Vector;
import javax.swing.*;
/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class AuthenticateWorker extends DefaultWorker
{
    protected boolean login;
    protected PasswordDialog dialog;

    public void init( Operator root, Operation op )
    {
        super.init( root, op);
    }

   

	public void login() throws Exception {
		String password = new String("");
		String user = new String("");
		String method = new String("");
		boolean save = false;

		while ((login == false) && (getCancel() == false)) {
			if (item.getPassword().length() == 0) {
				dialog = new PasswordDialog();
				
				Vector loginMethods = new Vector();
				loginMethods.add( new String("USER") );
				loginMethods.add( new String("APOP") );
				
				dialog.showDialog(
					item.getHost(),
					item.getUser(),
					item.getPassword(),
					loginMethods,
					item.getLoginMethod(),
					item.isSavePassword());

				char[] name;

				if (dialog.success() == true) {
					// ok pressed
					name = dialog.getPassword();
					password = new String(name);
					user = dialog.getUser();
					save = dialog.getSave();
					method = dialog.getLoginMethod();

					//System.out.println("pass:<"+password+">");
					setCancel(false);
				} else {
					// cancel pressed
					setCancel(true);
				}
			} else {
				password = item.getPassword();
				user = item.getUser();
				save = item.isSavePassword();
				method = item.getLoginMethod();
			}

			if (getCancel() == false) {
				//System.out.println("trying to login");
				setText(popServer.getFolderName() + " : Login...");
				//stopTimer();

				startTimer();
				// authenticate

				pop3Connection.openPort();
				
				pop3Connection.setLoginMethod( method );
				login = pop3Connection.login(user, password);
				stopTimer();

				if (login == false)
				{
					JOptionPane.showMessageDialog(popServer.getFrame(), "Authorization failed!");
					if ( dialog != null )
						item.setUser(dialog.getUser());
				}
				item.setPassword("");
				

			}

		}

		if (login) {
			item.setUser(user);
			item.setSavePassword(save);
			item.setLoginMethod( method );

			if (save) {

				// save plain text password in config file
				// this is a security risk !!!
				item.setPassword(password);
			}
		}
	}

    public void logout() throws Exception
    {
        if ( login == true )
        {
            setText( popServer.getFolderName() +  " : Logout..." );
            startTimer();
            pop3Connection.logoff();
            pop3Connection.close();
            stopTimer();
        }
    }

    public Object construct()
    {

        try
        {
            openPort();

            login();
            logout();
        }
        catch ( Exception ex )
        {
            ex.printStackTrace();
        }

        unregister();
	return null;
    }
}
