package org.columba.pop3;

import org.columba.main.MainInterface;
import org.columba.message.*;
import org.columba.parser.*;
import org.columba.folder.*;
import org.columba.gui.util.*;

import java.util.Vector;
import java.net.UnknownHostException;
import java.util.Date;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class ManageFetchWorker extends FetchMessageWorker {

       //protected Vector fetchResult;
       //protected Folder folder;
       //protected Message m;


    public void init( Operator root, Operation op )
    {
        super.init( root, op);


        this.folder = pop3Op.source;

    }


    private int getIndex( String uid, UIDList list )
    {
        for ( int i=0; i<list.count(); i++ )
        {
            String serverUID = (String) list.get(i);
            if ( serverUID == null ) System.out.println("uid is null");

            //System.out.println("server message uid: "+ serverUID );
            if ( uid.equals( serverUID ) )
            {
                //System.out.println("local uid exists remotely");
                return (i+1);
            }
        }
        return -1;
    }


    public void fetchList() throws Exception
    {
        //Vector taskList = new Vector( pop3Op.uidList );

        setText( popServer.getFolderName() + " : UIDL..." );

        //getUIDList();



        //pop3Op.channel.setTransVolume( (pop3Op.uidList.length) );

        //System.out.println("writer volume: "+ (pop3Op.uidList.length) );

        setProgressBarMaximum( pop3Op.uidList.length );

        boolean b = false;
        for ( int i=0; i<pop3Op.uidList.length; i++ )
        {
            try
            {
            setProgressBarValue( i );

            String uidstr = (String) pop3Op.uidList[i];

            if ( existsRemotely( uidstr, 0, uids ) )
            {
                System.out.println("uids: "+ uidstr );

                int index = getIndex( uidstr, uids );
                b = fetchMessage( index );

		if ( getCancel() == true )
                    {
                        b=false;
                        break;
                    }

		    Object uid = tempFolder.add( m, m.getRawString() );
		    Object [] uids = new Object[1];
		    uids[0]=uid;

		    Channel channel = new Channel( 1, 1 );
		    FolderOperation sendOp = new FolderOperation( Operation.SEND, 0,
							          uids,
							          tempFolder, channel );
		    sendOp.destructive = true;
		    tempFolder.getOperator().addOp( sendOp );
		    
		    //Folder destFolder = folder;

		    System.out.println("folder source: "+pop3Op.source);

		     FolderOperation inboxOp = new FolderOperation( Operation.RECEIVE_POP3,
								    0,
								    pop3Op.source,
								    channel);
		     pop3Op.source.getOperator().addOp( inboxOp );

            }
            }
            catch( Exception ex )
            {
				if ( ex instanceof UnknownHostException )
        	{
        		Exception e = new Exception("Unknown host: "+ex.getMessage()+
        									"\nAre you  online?" );
        		NotifyDialog dialog = new NotifyDialog( mainInterface );
        		dialog.showDialog( e );
        	}
        	else
        	{
	    		ExceptionDialog dialog = new ExceptionDialog( mainInterface );
	    		dialog.showDialog( ex );
        	}
        	
		    	setCancel(true);
		    	b=false;
                ex.printStackTrace();
            }


            if ( b==false ) break;
        }

        // if fetch operation was cancelled
            // do not cleanly logout
            // just close the socket
            if ( b==false ) login = false;
    }


     public Object construct()
    {
        System.out.println("Starting ManageRemoveWorker Worker...");

        try
        {
            openPort();

            login();

            check();

	    getUIDList();

            fetchList();


            // if fetch operation was cancelled
            // do not cleanly logout
            // just close the socket
            if ( login == false )
            {
               closePort();
            }
            else
                logout();


        }
        catch ( Exception ex )
        {
	    ExceptionDialog dialog = new ExceptionDialog( mainInterface );
	    dialog.showDialog( ex );
            ex.printStackTrace();
        }

        popServer.enableActions(true);
        popServer.getFrame().getHeaderTableViewer().updateTable();

        unregister();
	return null;
    }


}
