package org.columba.pop3;



import org.columba.main.MainInterface;
import org.columba.message.*;
import org.columba.folder.*;
import org.columba.gui.util.*;


import java.util.Vector;
import java.util.Arrays;
import java.net.UnknownHostException;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class ManageRemoveWorker extends SynchronizeMessageWorker {

       //protected UIDList uidList;
       //protected Vector messageSizes;


    public void init( Operator root, Operation op )
    {
        super.init( root, op);
    }

    public void removeList() throws Exception
    {      
        
	Object[] indexList = createIndexList( pop3Op.uidList, uids );

	Arrays.sort( indexList );

        setProgressBarMaximum( indexList.length );

        for ( int i=indexList.length-1; i>=0; i-- )
        {
            setProgressBarValue( i );	    
            Integer index = (Integer) indexList[i];

	    //System.out.println("index:"+index);
	    
	    
            pop3Connection.deleteMessage( index.intValue() );
            popServer.getMessageCollection().remove( index.intValue()-1 );            
	    
        }

    }

    // take uids and transform them to server index 
	protected static Object[] createIndexList(Object[] pop3List, UIDList list)
	{
		Vector v = new Vector();

		for (int i = 0; i < pop3List.length; i++)
		{
			String uid = (String) pop3List[i];

			if (existsRemotely(uid, 0, list))
			{
				int index = getIndex(uid, list);
				v.add(new Integer(index));
			}
		}

		return v.toArray();
	}


     private static int getIndex( String uid, UIDList list )
    {
        for ( int i=0; i<list.count(); i++ )
        {
            String serverUID = (String) list.get(i);
            if ( serverUID == null ) System.out.println("uid is null");

            //System.out.println("server message uid: "+ serverUID );
            if ( uid.equals( serverUID ) )
            {
                //System.out.println("local uid exists remotely");
                return (i+1);
            }
        }
        return -1;
    }



     public Object construct()
    {
        System.out.println("Starting ManageRemoveWorker Worker...");

        try
        {
            openPort();

            login();

            check();

	    getUIDList();

            removeList();

            logout();
            /*
            // if fetch operation was cancelled
            // do not cleanly logout
            // just close the socket
            if ( login == false )
            {
               closePort();
               pop3Op.channel.cancel();
            }
            */


        }
        catch ( Exception ex )
        {
        	if ( ex instanceof UnknownHostException )
        	{
        		Exception e = new Exception("Unknown host: "+ex.getMessage()+
        									"\nAre you  online?" );
        		NotifyDialog dialog = new NotifyDialog( mainInterface );
        		dialog.showDialog( e );
        	}
        	else
        	{
	    		ExceptionDialog dialog = new ExceptionDialog( mainInterface );
	    		dialog.showDialog( ex );
        	}
        	
		    	setCancel(true);
		    	
               
            
	    
            ex.printStackTrace();
        }


        popServer.enableActions(true);
        popServer.getFrame().getHeaderTableViewer().updateTable();

        unregister();
	return null;
    }
}
