// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


package org.columba.pop3;

import java.util.Vector;

import org.columba.message.*;
import org.columba.main.*;
import org.columba.config.*;
import org.columba.gui.pop3.*;
import org.columba.folder.*;
import org.columba.folder.pop3.*;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;


import org.columba.gui.action.*;

public class PopServerCollection //implements ActionListener
{
    private Vector serverList;
    private MainInterface mainInterface;
    private PopServer popServer;
      //public BasicAction fetchAction;

    public PopServerCollection( MainInterface mainInterface )
    {
        this.mainInterface = mainInterface;
        serverList = new Vector();

        AccountList list = mainInterface.config.getAccountList();

        for ( int i=0; i<list.count(); i++ )
        {
            AccountItem accountItem = list.get( i );
            if ( accountItem.isPopAccount() )
            {

                  //PopItem popItem = accountItem.getPopItem();

                  //popItem.setFolderName( accountItem.getName() );
                //System.out.println("name: "+ accountItem.getName() );
                add( accountItem );
            }
        }


          /*
            fetchAction = new BasicAction(
            mainInterface.guiLabels.getString("menu_file_fetchall"),
            "Get Msg",
            mainInterface.guiLabels.getString("menu_file_fetchall"),
            "FETCH",
            "WebComponent16.gif",  "WebComponent24.gif",
            'C',
            KeyStroke.getKeyStroke( KeyEvent.VK_T, ActionEvent.CTRL_MASK )
            );
            fetchAction.addActionListener( this );
          */

    }

    public void add( AccountItem item )
    {
        PopServer server = new PopServer( mainInterface, item );
        Pop3Operator op = new Pop3Operator(mainInterface);
        op.start();
        server.setOperator( op );

        serverList.add( server );
    }

    public PopServer uidGet( int uid )
    {
        int index = getIndex( uid );

        if ( index != -1 )
           return get( index );
        else
           return null;
    }

    public PopServer get( int index )
    {
        return (PopServer) serverList.get( index );
    }

    public int count()
    {
        return serverList.size();
    }

    public void enableMailCheckIcon()
    {
        boolean hit = false;

        for ( int i=0; i< count(); i++)
        {
            PopServer server = get(i);
            PopItem item = server.getPopItem();
            if ( item.isMailCheck() == true ) hit = true;
        }

        if ( hit==true )
        {
            mainInterface.statusBar.enableMailCheck(true);
        }
        else
        {
            mainInterface.statusBar.enableMailCheck(false);
        }

    }

    public void fetchAllServers()
    {
        for ( int i=0; i< count(); i++)
        {
            PopServer server = get(i);
            PopItem item = server.getPopItem();
            boolean b = ( new Boolean( item.getExclude() ) ).booleanValue();

            if ( ( server.checkAction.isEnabled() ) && ( b == false ) )
                fetchAll( i, false );
        }
    }


    public boolean fetchAll( int index, boolean mailcheck )
    {
        return get(index).fetchAll(mailcheck);
    }

    /*
    public void fetchSelectedMessages( int count, int[] selection )
    {
        for ( int i=count-1; i>=0; i--)
        {
            fetch( selection[i] );
        }
        System.out.println("fetched selected messages");
    }

    public void removeSelectedMessages( int count, int[] selection )
    {
        for ( int i=count-1; i>=0; i--)
        {
            remove( selection[i] );
        }
        System.out.println("removed selected messages");
    }
    */


    /*
    public void fetch( int message )
    {
        popServer.fetch( message );
    }
    */

    public void synchronize()
    {
        popServer.synchronize();
    }

    /*
    public void remove( int message )
    {
        popServer.remove( message );
    }
    */


    public void removePopServer( int uid )
    {
	int index = getIndex( uid );
	if ( index == -1 ) System.out.println("could not find popserver");
	else
	    serverList.remove( index );
    }

    public int getIndex( int uid )
    {
        PopServer server;
        int number;
        PopItem item;
        for ( int i=0; i < count(); i++ )
        {
            server = get( i);
            number = server.getUid();

            if ( number == uid )
            {
                return i;
            }
        }
        return -1;
    }

    public void loadAll()
    {
        PopServer server;
        for ( int i=0; i < count(); i++ )
        {
            server = get( i );
            server.load();
        }
    }

    /*
    public void saveAll()
    {
        PopServer server;
        for ( int i=0; i < count(); i++ )
        {
            server = get( i );
            server.save();
        }
    }
    */

    public PopServer getSelected()
    {
        return popServer;
    }


      /*
    public void actionPerformed(ActionEvent e)
    {
	String action  = e.getActionCommand();

	if ( action.equals("FETCH") )
        {
            for ( int i=0; i < count(); i++ )
            {
                popServer = get( i);
		boolean result = fetchAll( i );

            }
        }
    }
      */










}
