package org.columba.pop3;



import org.columba.main.MainInterface;
import org.columba.message.*;
import org.columba.folder.*;
import org.columba.parser.*;
import org.columba.gui.util.*;

import java.util.Date;
import java.util.Vector;
import java.net.UnknownHostException;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class SynchronizeHeaderWorker extends CheckWorker {

    //protected UIDList uids;
       protected Vector messageSizes;



    public void init( Operator root, Operation op )
    {
        super.init( root, op);
    }



     private boolean existsLocally( String serverUid, int startIndex )
    {
        //System.out.println("server message uid: "+ serverUid );

        for ( int i=startIndex; i<popServer.getHeaderList().count(); i++ )
        {
            ColumbaHeader header = popServer.getHeaderList().get(i);
            String str = (String) header.get("columba.pop3uid");
            //String str = (String) message.getPop3Uid();
            //System.out.println("local message uid: "+ str );
            if ( serverUid.equals(str) )
            {
                //System.out.println("server uid exists locally");
                return true;
            }
        }

        return false;
    }

    private boolean existsRemotely( String localUid, int startIndex, UIDList uidList )
    {
        //System.out.println("local message uid: "+ localUid );

        for ( int i=startIndex; i<uidList.count(); i++ )
        {
            //System.out.println("index: "+ i);
            String serverUID = (String) uidList.get(i);
            if ( serverUID == null ) System.out.println("uid is null");

            //System.out.println("server message uid: "+ serverUID );

            if ( localUid.equals( serverUID ) )
            {
                System.out.println("local uid exists remotely");
                return true;
            }
        }

        return false;
    }


     public void synchronize() throws Exception
    {
	setText( popServer.getFolderName() + " : UIDL...");

          // get UIDL from serer
	String result = new String();
	result = pop3Connection.getUIDL( this );
          // the UIDList class parses the string an generates a vector of UID's


	uids = new UIDList( result );

        //if ( popServer.getPopItem().isLimit() )

        messageSizes = pop3Connection.getMessageSizes();

	/*
	if ( ( popServer.getHeaderList().count() == 0) || ( popServer.getPopItem().isLeaveMessage() == false ) )
        */

	if ( popServer.getHeaderList().count() == 0 )
	{
            setProgressBarMaximum( totalMessages );
              // we have not downloaded some messsages since now, go fetch all messages from server
            for( int i=1; i<=totalMessages; i++ )
            {

                if ( getCancel()==true ) break;

                setProgressBarValue( i );

                  // fetch message number i
                fetchMessageHeader( i );
            }
        }
	else
        {
              // this is not the first time we downloaded messages, we have to synchronize local cache with server
            String localUID=null;
            String serverUID=null;
            ColumbaHeader header = null;
            //Message message = null;
            boolean localCacheEmpty = false;

            

            for ( int i=0; i<popServer.getHeaderList().count(); i++ )
            {

                header = popServer.getHeaderList().get( i );
                if ( header == null ) System.out.println("header is null");

                //header = message.getHeader();
                localUID = (String) header.get("columba.pop3uid");
                //localUID = (String) message.getPop3Uid();
                if ( localUID == null ) System.out.println("local uid is null");

                if ( existsRemotely( localUID, 0, uids ) )
                {
                    // local uid exists on server, leave it like this
                }
                else
                {
                    // local uid does not exist on server, remove uid
                    try
                    {
                        // shall we better  use uid-remove ?
                        //popServer.getHeaderList().remove( i );
                        popServer.getMessageCollection().remove( i );

                        //System.out.println("removed local uid: "+ localUID + " with index: "+ ( i ) );
                    }
                    catch( Exception e )
                    {
                        System.out.println( "error while removeing: "+ e.getMessage() );
                    }

                }
            }

	    setProgressBarMaximum( uids.count() );

            for ( int i=0; i<uids.count(); i++ )
            {
                setProgressBarValue( i+1 );

                serverUID = (String) uids.get(i);

                if ( existsLocally( serverUID, 0 ) )
                {
                    // server uid already exists
                }
                else
                {
                    // new message found

                    //shall we better use uid-fetchheader instead?
                    fetchMessageHeader( i+1 );
                    //fetchMessage( serverUID );

                    //System.out.println("added remote uid: "+ serverUID+" with index: "+(i+1) );
                }
            }

        }
    }


    private void fetchMessageHeader( int number ) throws Exception
    {
        String rawString = new String();
        ColumbaHeader h;
        Rfc822Parser parser = new Rfc822Parser();
        boolean attach;


        setText( popServer.getFolderName() + " : Fetching headers... " );

	System.out.println("fetching header: "+number);

        rawString = pop3Connection.getMessageHeader(number);

        //System.out.println("fetching message number: "+number);

        h =  parser.parseHeader( rawString ) ;

        //Message m = new Message( header );
        //ColumbaHeader h = m.get;


        //m.setPop3Uid( (String) uidList.get( number-1 ) );
        h.set("columba.pop3uid", (String) uids.get( number-1 ) );

        h.set("columba.flags.recent", new Boolean(true) );

        /*
	Flags flags = new Flags();
	flags.setRecent( false );
	m.setFlags( flags );
        */


        int octetString;
        /*
        if ( messageSizes == null )
	   octetString = pop3Connection.getSize();
        else
        */

        octetString = ( (Integer) messageSizes.get( number-1 ) ).intValue();

        int size=-1;

        size = Math.round( octetString / 1024 );

        if ( size == 0 ) size = 1;
        h.set("columba.size", new Integer(size) );
	//m.setSize( size );


        h.set("columba.host", item.getHost() );
        //m.setHost( item.getHost() );

        Date date = DateParser.parseString( (String) h.get( "Date" ) );
        h.set("columba.date", date );
        //m.setDate( date );


	String shortFrom = (String) h.get("From");
	if ( shortFrom != null )
	    {
		if ( shortFrom.indexOf("<") != -1 )
                {
		    shortFrom = shortFrom.substring(0, shortFrom.indexOf("<") );
                    if ( shortFrom.length() > 0 )
                    {
                        if ( shortFrom.startsWith("\"") )
                            shortFrom = shortFrom.substring(1, shortFrom.length()-1 );
                        if ( shortFrom.endsWith("\"") )
                            shortFrom = shortFrom.substring(0, shortFrom.length()-1 );
                    }

                }
		else
		    shortFrom = shortFrom;

		//m.setShortFrom( shortFrom );
                h.set("columba.from", shortFrom);
	    }
	else
	    {
		//m.setShortFrom("");
                h.set("columba.from", new String("") );
	    }

        String priority=(String) h.get("X-Priority");
        if ( priority != null )
        {
            int prio=-1;

            if ( priority.indexOf("1") != -1 )
            {
                prio=1;

            }
            else if ( priority.indexOf("2") != -1 )
            {
                prio=2;
            }
            else if ( priority.indexOf("3") != -1 )
            {
                prio=3;
            }
            else if ( priority.indexOf("4") != -1 )
            {
                prio=4;
            }
            else if ( priority.indexOf("5") != -1 )
            {
                prio=5;
            }

            //m.setPriority( prio );
            h.set("columba.priority", new Integer(prio) );
        }
        else
        {
            h.set("columba.priority",new Integer(3) );
            //m.setPriority( 3 );
        }


	String attachment = (String)  h.get("Content-Type");
	if ( attachment != null )
            {
                attachment = attachment.toLowerCase();

                if ( attachment.indexOf("multipart") != -1 )
                {
                    h.set("columba.attachment", new Boolean(true) );
                    //m.setAttachment(true);
                }
                else
                {
                    h.set("columba.attachment", new Boolean(false) );
                    //m.setAttachment(false);
                }
	    }
	else
            {
                h.set("columba.attachment", new Boolean(false) );
		//m.setAttachment(false);
            }



        popServer.getMessageCollection().add( new Message(h) );
        //popServer.getHeaderList().add( h );
    }


    public Object construct()
    {
        System.out.println("Starting SynchronizeHeaderWorker Worker...");

        try
        {
            openPort();

            login();

            check();

            synchronize();

            logout();
            /*
            // if fetch operation was cancelled
            // do not cleanly logout
            // just close the socket
            if ( login == false )
            {
               closePort();
               pop3Op.channel.cancel();
            }
            */

        }
        catch ( Exception ex )
        {
        	if ( ex instanceof UnknownHostException )
        	{
        		Exception e = new Exception("Unknown host: "+ex.getMessage()+
        									"\nAre you  online?" );
        		NotifyDialog dialog = new NotifyDialog( mainInterface );
        		dialog.showDialog( e );
        	}
        	else
        	{
	    		ExceptionDialog dialog = new ExceptionDialog( mainInterface );
	    		dialog.showDialog( ex );
        	}
        
            ex.printStackTrace();
        }

        popServer.enableActions(true);
        popServer.getFrame().getHeaderTableViewer().updateTable();


        unregister();
	return null;
    }





}
