package org.columba.pop3;



import org.columba.main.MainInterface;
import org.columba.message.*;
import org.columba.folder.*;

import java.util.Vector;
import java.util.Enumeration;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class SynchronizeMessageWorker extends CheckWorker {

    //protected UIDList uids;
       protected Vector messageSizes;

       /*
    public SynchronizeMessageWorker(MainInterface mainInterface, PopServer server) {
        super( mainInterface, server );

    }
    */

    public void init( Operator root, Operation op )
    {
        super.init( root, op);
    }

    /*
    public SynchronizeMessageWorker()
    {
        super();
    }
    */
    public void getUIDList() throws Exception
    {
        setText( popServer.getFolderName() + " : UIDL...");

          // get UIDL from serer
	String result = new String();
	result = pop3Connection.getUIDL(this);
          // the UIDList class parses the string an generates a vector of UID's


	uids = new UIDList( result );
    }

    protected boolean existsLocally( String uid, int startIndex )
    {
        for ( int i=startIndex; i<popServer.getMessageCollection().count(); i++ )
        {
            Message message = popServer.getMessageCollection().get(i);
            ColumbaHeader header = message.getHeader();
            //String str = (String) message.getPop3Uid();
            String str = (String) header.get("columba.pop3uid");
            //System.out.println("local message uid: "+ str );
            if ( uid.equals(str) )
            {
                //System.out.println("popServer uid exists locally");

                return true;


            }
        }

        return false;
    }

    protected static boolean existsRemotely( String uid, int startIndex, UIDList uidList )
    {
        for ( int i=startIndex; i<uidList.count(); i++ )
        {
            String serverUID = (String) uidList.get(i);
            if ( serverUID == null ) System.out.println("uid is null");

            //System.out.println("server message uid: "+ serverUID );
            if ( uid.equals( serverUID ) )
            {
                //System.out.println("local uid exists remotely");
                return true;
            }
        }

        return false;
    }

	public Vector synchronize() throws Exception
	{
		Vector resultList = new Vector();

		getUIDList();

		messageSizes = pop3Connection.getMessageSizes();

		if (messageSizes == null)
			throw new Exception("messageSize == null");

		/*
		if ( ( popServer.getMessageCollection().count() == 0) || ( popServer.getPopItem().isLeaveMessage() == false ) )
		*/

		if (popServer.getMessageCollection().count() == 0)
		{

			setProgressBarMaximum(calculateTotalSize(uids));

			System.out.println("total messages:"+totalMessages);
			
			// we have not downloaded some messsages since now, go fetch all messages from server
			for (int i = 1; i <= totalMessages; i++)
			{
				if (getCancel() == true)
					break;

				boolean limit = getLimit(i);

				if (limit == true)
				{
					// fetch message number i
					//fetchMessage( i );
					resultList.add(new Integer(i));
				}
			}
		}
		else
		{
			// this is not the first time we downloaded messages, we have to synchronize local cache with server
			String localUID = null;
			String serverUID = null;
			ColumbaHeader header = null;
			Message message = null;
			boolean localCacheEmpty = false;

			for (int i = 0; i < popServer.getMessageCollection().count(); i++)
			 //for (Enumeration e = popServer.getMessageCollection().getEnumeration() ; e.hasMoreElements() ;) 
			{
				if (getCancel() == true)
					break;

				message = popServer.getMessageCollection().get(i);
				//message = (Message) e.nextElement();
				header = message.getHeader();
				localUID = (String) header.get("columba.pop3uid");
				//localUID = (String) message.getPop3Uid();

				if (existsRemotely(localUID, 0, uids))
				{
					// local uid exists on server, leave it like this
				}
				else
				{
					// local uid does not exist on server, remove uid
					try
					{
						// shall we better  use uid-remove ?
						//popServer.getMessageCollection().uidRemove(localUID);
						popServer.getMessageCollection().remove(i);
						i--;

						//System.out.println("removed local uid: "+ localUID );
					}
					catch (Exception ex)
					{
						System.out.println("error while removeing: " + ex.getMessage());
					}

				}
			}

			int totalSize = calculateSize(uids);
			setProgressBarMaximum(totalSize);

			for (int i = 0; i < uids.count(); i++)
			{
				if (getCancel() == true)
					break;

				serverUID = (String) uids.get(i);

				if (existsLocally(serverUID, 0))
				{
					// server uid already exists
					//Message m = popServer.getMessageCollection().get(i);
					Message m = popServer.getMessageCollection().pop3UidGet(serverUID);
					header = m.getHeader();
					Boolean bool = (Boolean) header.get("columba.fetchstate");
					boolean alreadyFetched = bool.booleanValue();

					if (!alreadyFetched)
					{
						boolean limit = getLimit(i + 1);

						if (limit == true)
						{					
							//resultList.add(new Integer(i + 1));
							int index = popServer.getMessageCollection().indexOf(serverUID);
							if ( index!=-1 )
								resultList.add( new Integer(index+1) );
						}
					}

				}
				else
				{
					// new message found

					boolean limit = getLimit(i + 1);

					if (limit == true)
					{
						//shall we better use uid-fetchheader instead?
						//boolean b = fetchMessage( i+1 );
						resultList.add(new Integer(i + 1));

						//if ( b == false ) return false;

						//System.out.println("added remote uid: "+ serverUID );
					}
				}
			}

		}

		return resultList;
	}


    protected boolean getLimit( int number )
    {
        //System.out.println("-------------------------->getLimit()");

        if ( popServer.getPopItem().isLimit() == true )
        {
            // download only if size < download limit
            String limitString = popServer.getPopItem().getDownloadLimit();
            Integer limitInt = new Integer( limitString );

            int downloadLimit = limitInt.intValue();

            int actMessageSize = ( (Integer) messageSizes.get( number-1 ) ).intValue();
            actMessageSize = Math.round( actMessageSize / 1024 );

            //System.out.println("limit: "+ downloadLimit );
            //System.out.println("size: "+ actMessageSize );

            if ( actMessageSize > downloadLimit ) return false;
        }

        return true;
    }

     protected int calculateTotalSize( UIDList uidList ) throws Exception
    {
        int size = 0;
        String serverUID;
        ColumbaHeader header;

       // System.out.println("calculate size");

        for ( int i=0; i<uidList.count(); i++ )
            {
                boolean limit = getLimit( i+1 );

                    if ( limit == true )
                    {
                        int actMessageSize = ( (Integer) messageSizes.get( i ) ).intValue();

                       // System.out.println("+"+actMessageSize );
                        size += actMessageSize;
                    }


            }

        //System.out.println("total size: "+ size);

        return size;
    }


	protected int calculateSize(UIDList uidList) throws Exception
	{
		int size = 0;
		String serverUID;
		ColumbaHeader header;

		// System.out.println("calculate size");

		for (int i = 0; i < uidList.count(); i++)
		{
			serverUID = (String) uidList.get(i);

			if (existsLocally(serverUID, 0))
			{
				// server uid already exists
				//Message m = popServer.getMessageCollection().get(i);
				Message m = popServer.getMessageCollection().pop3UidGet(serverUID);
				if (m == null)
					continue;

				header = m.getHeader();
				Boolean bool = (Boolean) header.get("columba.fetchstate");
				boolean alreadyFetched = bool.booleanValue();

				if (!alreadyFetched)
				{
					boolean limit = getLimit(i + 1);

					if (limit == true)
					{
						int actMessageSize = ((Integer) messageSizes.get(i)).intValue();
						//actMessageSize = Math.round( actMessageSize / 1024 );
						// System.out.println("+"+actMessageSize );
						size += actMessageSize;
					}
				}

			}
			else
			{
				// new message found

				boolean limit = getLimit(i + 1);

				if (limit == true)
				{
					if (messageSizes == null)
						System.out.println("------------>messagesizes==null");
					Integer sizeInt = (Integer) messageSizes.get(i);
					int actMessageSize = sizeInt.intValue();
					//actMessageSize = Math.round( actMessageSize / 1024 );
					// System.out.println("+"+actMessageSize );
					size += actMessageSize;
				}
			}
		}

		//System.out.println("total size: "+ size);

		return size;
	}
}
